(function() {
  "use strict";
  try {
    if (typeof document != "undefined") {
      var elementStyle = document.createElement("style");
      elementStyle.appendChild(document.createTextNode(`button {
  cursor: pointer !important;
}

#jsonforms-wrapper {
  max-width: calc(100% - 47px);
}

.jsonforms-dispatch-container,
.spectrum-array-item-header,
div[class^='spectrum-Textfield'] {
  width: 100%;
}

.spectrum-array-item-name {
  text-align: left;
  width: 100%;
  font-weight: 600;
  padding-left: var(
    --spectrum-actionbutton-text-padding-x,
    var(--spectrum-global-dimension-size-150)
  );
  padding-right: var(
    --spectrum-actionbutton-text-padding-x,
    var(--spectrum-global-dimension-size-150)
  );
  box-sizing: border-box !important;
}

/* Checks if it has a .spectrum-array-item-path, and adds a negative margin */
button:has(.spectrum-array-item-path) .spectrum-array-item-name {
  margin-top: -6px;
}

.spectrum-array-item-path {
  padding-left: var(
    --spectrum-actionbutton-text-padding-x,
    var(--spectrum-global-dimension-size-150)
  );
  padding-right: var(
    --spectrum-actionbutton-text-padding-x,
    var(--spectrum-global-dimension-size-150)
  );
  margin-bottom: 4px;
  box-sizing: border-box !important;
  width: 100%;
  text-align: left;
}

.spectrum-array-item-preview-image {
  aspect-ratio: 1/1;
  object-fit: cover;
  margin-right: 10px;
  margin-left: 2px;
}

.spectrum-array-item-number {
  --spectrum-array-item-number-size: 1.2rem;

  display: flex;
  align-items: center;
  justify-content: center;
  width: var(--spectrum-array-item-number-size);
  height: var(--spectrum-array-item-number-size);
  border-radius: 50%;
  overflow: hidden;
  line-height: var(--spectrum-array-item-number-size);
  font-size: 0.75em;
  font-weight: 500;
  text-align: center;
  color: var(--spectrum-tooltip-text-color, var(--spectrum-global-color-static-white));
  flex-shrink: 0;
  background-color: var(
    --spectrum-tooltip-background-color,
    var(--spectrum-global-color-static-gray-700)
  ) !important;
}

.grabbable {
  display: flex;
  width: 50px;
  background-color: transparent;
  fill: var(--spectrum-actionbutton-icon-color, var(--spectrum-alias-icon-color));
  border-radius: var(
    --spectrum-actionbutton-quiet-border-radius,
    var(--spectrum-alias-border-radius-regular)
  );
  border-color: transparent;
  margin: -5px -12px -5px 0px;
  touch-action: none;
  min-width: 34px;
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -khtml-user-select: none; /* Konqueror HTML */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently supported by Chrome, Edge, Opera and Firefox */
  outline: none;
}

.grabcursor {
  cursor: move !important; /* fallback if grab cursor is unsupported */
  cursor: grab !important;
  cursor: -webkit-grab !important;
  cursor: -moz-grab !important;
  cursor: -o-grab !important;
  cursor: -ms-grab !important;
}

/* Apply a "closed-hand" cursor during drag operation. */
.grabcursor:active {
  cursor: grabbing !important;
  cursor: -webkit-grabbing !important;
  cursor: -moz-grabbing !important;
  cursor: -o-grabbing !important;
  cursor: -ms-grabbing !important;
}

.arrow-icon {
  padding: 6px 0px;
}

.grabbable:focus-visible {
  box-shadow: 0 0 0 1px
    var(
      --spectrum-actionbutton-quiet-border-color-key-focus,
      var(--spectrum-alias-border-color-focus)
    );
  border-color: var(
    --spectrum-actionbutton-quiet-border-color-key-focus,
    var(--spectrum-alias-border-color-focus)
  );
  border-width: var(--spectrum-actionbutton-border-size, var(--spectrum-alias-border-size-thin));
}

.animated-modal-item.animated-modal-item-div.detailed-view {
  background-color: var(--spectrum-global-color-gray-100);
  top: 0;
  z-index: 9000;
  width: 95%;
  min-height: 100%;
  height: 100%;
  flex-grow: 1;
  position: absolute;
  background-color: var(--spectrum-global-color-gray-100);
  overflow-x: hidden;
  overflow-y: auto;

  border-left-color: var(
    --spectrum-alias-border-color-dark,
    var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
  );
  border-left-width: var(--spectrum-alias-border-size-thin);
  border-left-style: solid;
}
.animated-modal-item.animated-modal-item-div.detailed-view
  > .jsonforms-dispatch-wrapper
  > .spectrum-array-item-header {
  position: sticky;
  width: 100%;
  padding: 10px 13px 10px 13px;
  margin-top: -12px;
  top: -12px;
  left: 0;

  background-color: var(--spectrum-global-color-gray-100);
  z-index: 1;
  border-bottom-color: var(
    --spectrum-alias-border-color-dark,
    var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
  );
  border-bottom-width: var(--spectrum-alias-border-size-thin);
  border-bottom-style: solid;
}

.modal-element,
.array-item-content {
  margin-left: var(--spectrum-global-dimension-size-250, var(--spectrum-alias-size-250)) !important;
  margin-right: var(
    --spectrum-global-dimension-size-250,
    var(--spectrum-alias-size-250)
  ) !important;
  margin-top: 12px !important;
}

.jsonforms-dispatch-container .array-item-content {
  margin-left: 0 !important;
  margin-right: 0 !important;
  margin-top: 0px !important;
}

.animated-modal-item.animated-modal-item-div.detailed-view
  > .jsonforms-dispatch-wrapper
  > div.spectrum-array-item-header {
  top: 0;
  width: calc(100% - 26px);
}

.list-array-item:has(.jsonforms-dispatch-wrapper) {
  display: flex;
  flex-direction: column;
}

.jsonforms-dispatch-wrapper {
  display: flex;
  flex-direction: column;
  width: 100%;
}

.jsonforms-dispatch-wrapper:not(:has(section)) > .array-item-content {
  margin: var(--spectrum-global-dimension-size-160, var(--spectrum-alias-size-160));
  border: 2px solid transparent;
}

[class^='spectrum-Tabs_'] {
  margin: var(--spectrum-global-dimension-size-160, var(--spectrum-alias-size-160));
}

section section,
section [class^='spectrum-Tabs_'] {
  margin: 0;
}

.animated-modal-item.dark-background {
  background-color: rgba(0, 0, 0, 1);
  opacity: 0.2;
  z-index: 8000;
  position: absolute;
  top: 0;
  left: 0;
  height: 100%;
  width: 95%;
}

.animated-modal-item.animated-modal-wrapper {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  overflow-x: hidden;
  overflow-y: auto;
}

#jsonforms-array-wrapper {
  overflow-x: hidden;
  overflow-y: auto;
}

/* Just for the Playground */
.App-Form {
  min-height: 80vh;
  position: relative;
  overflow-x: hidden;
  overflow-y: auto;
}

.jsonforms-dispatch-container label {
  display: none;
}

.jsonforms-dispatch-container section {
  margin: 0 0 0 10px !important;
}

.list-array-item {
  background-color: var(--spectrum-global-color-gray-100);
  padding: 10px !important;
  min-height: 62px !important;
  display: flex;
  align-items: center;
}

.list-array-item:not(:has(.jsonforms-dispatch-wrapper)) {
  height: 62px !important;
}

.list-array-item.no-accordion {
  padding: 8px 12px !important;
}
.list-array-item.no-accordion [class^='spectrum-FieldLabel_'] {
  display: none;
}

.disabledMovement {
  cursor: not-allowed !important;
}

.keyboard-movement {
  fill: var(
    --spectrum-actionbutton-quiet-border-color-key-focus,
    var(--spectrum-alias-border-color-focus)
  );
}
@media (hover: none) and (pointer: coarse) {
  .keyboard-movement {
    fill: inherit;
  }
}

.grabbable .keyboard-user,
.keyboard-user .mouse-drag-handle {
  display: none;
}

.keyboard-user .keyboard-user,
.pointer-user .mouse-user {
  display: flex;
  fill: var(--spectrum-actionbutton-icon-color, var(--spectrum-alias-icon-color));
}

.keyboard-user .keyboard-user {
  fill: currentColor;
}

.add-item {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 62px;
  cursor: pointer;
  background-color: var(--spectrum-global-color-gray-100);
  outline: none;
  padding: 0;
  margin: 0 0 10px 0;
  border-radius: var(--spectrum-alias-border-radius-medium) !important;
  border: 1px dashed
    var(
      --spectrum-alias-border-color-dark,
      var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
    ) !important;
}

.add-item:focus {
  outline: none;
}

.add-item:focus-visible {
  outline: none;
  border: 2px solid
    var(
      --spectrum-actionbutton-quiet-border-color-key-focus,
      var(--spectrum-alias-border-color-focus)
    ) !important;
  box-shadow: none;
}

.drag-and-drop-wrapper {
  display: flex;
  flex-direction: column;
  gap: 8px;
  margin-bottom: 8px;
  position: relative;
  touch-action: none;
  transform-origin: 50% 50% 0px;
}

.drag-and-drop-item {
  touch-action: none;
  transform-origin: 50% 50% 0px;
  width: 100%;
}

.add-container {
  align-items: center;
  display: flex;
  justify-content: center;
  position: absolute;
  width: 100%;
  width: 100%;
  z-index: 80 !important;
}

.add-container:before {
  content: '';
  position: absolute;
  top: 50%;
  left: 0;
  border-top: 3px solid
    var(
      --spectrum-actionbutton-quiet-border-color-key-focus,
      var(--spectrum-alias-border-color-focus)
    );
  background: var(
    --spectrum-actionbutton-quiet-border-color-key-focus,
    var(--spectrum-alias-border-color-focus)
  );
  width: 100%;
  transform: translateY(-50%);
}

.add-container,
.add-container button {
  opacity: 0;
  transition: 0.5s opacity ease-in-out;
}
.add-container:hover,
.add-container:hover button {
  opacity: 1;
  transition-delay: 0.8s;
}
.add-container:focus-within,
.add-container:focus-within button {
  opacity: 1;
}

.add-container button {
  z-index: 81 !important;
}

/* List with Detail */
.list-with-detail-master-item-row[aria-selected='true'] {
  background-color: var(--spectrum-global-color-gray-200);
}

.list-with-detail-master-item-number {
  --list-with-detail-master-item-number-size: 1.2rem;

  display: flex;
  align-items: center;
  justify-content: center;
  width: var(--list-with-detail-master-item-number-size);
  height: var(--list-with-detail-master-item-number-size);
  border-radius: 50%;
  overflow: hidden;
  line-height: var(--list-with-detail-master-item-number-size);
  font-size: 0.75em;
  font-weight: 500;
  text-align: center;
  background-color: var(
    --spectrum-tooltip-background-color,
    var(--spectrum-global-color-static-gray-700)
  );
  color: var(--spectrum-tooltip-text-color, var(--spectrum-global-color-static-white));
}

[aria-selected='true'] .list-with-detail-master-item-number {
  background-color: var(--spectrum-global-color-gray-900);
  color: var(--spectrum-tooltip-text-color, var(--spectrum-global-color-static-white));
}

/* TipTap */
.ProseMirror {
  background-color: var(
    --spectrum-textfield-background-color,
    var(--spectrum-global-color-gray-50)
  );
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
  box-sizing: border-box;
  border: var(--spectrum-textfield-border-size, var(--spectrum-alias-border-size-thin)) solid;
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
  border-radius: 0 0
    var(--spectrum-textfield-border-radius, var(--spectrum-alias-border-radius-regular))
    var(--spectrum-textfield-border-radius, var(--spectrum-alias-border-radius-regular));
  height: auto;
  max-height: 45vh;
  overflow-x: hidden;
  overflow-y: auto;
  width: auto;
  min-height: 129px;
  padding: 3px var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) 5px
    calc(var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) - 1px);
  text-indent: 0;
  vertical-align: top;
  font-size: var(--spectrum-textfield-text-size, var(--spectrum-alias-font-size-default));
  line-height: var(
    --spectrum-textfield-text-line-height,
    var(--spectrum-alias-body-text-line-height)
  );
  text-overflow: ellipsis;
  outline: 0;
}

.ProseMirror > * {
  margin: 0;
}

.no-toolbar > .ProseMirror {
  border-radius: var(
    --spectrum-textfield-border-radius,
    var(--spectrum-alias-border-radius-regular)
  ) !important;
}

.ProseMirror-focused {
  border-color: var(
    --spectrum-textfield-border-color-down,
    var(--spectrum-alias-border-color-mouse-focus)
  );
}

.keyboard-user .ProseMirror-focused {
  border-width: 2px;
}

.tiptap-toolbar {
  border-radius: var(
      --spectrum-textfield-border-radius,
      var(--spectrum-alias-border-radius-regular)
    )
    var(--spectrum-textfield-border-radius, var(--spectrum-alias-border-radius-regular)) 0 0 !important;
  border-bottom: none !important;
}

.last-toolbar-button {
  margin-right: 8px;
}

.read-only > .ProseMirror {
  background-color: var(
    --spectrum-textfield-background-color-disabled,
    var(--spectrum-global-color-gray-200)
  );
  color: var(--spectrum-textfield-text-color-disabled, var(--spectrum-alias-text-color-disabled));
  -webkit-text-fill-color: var(
    --spectrum-textfield-text-color-disabled,
    var(--spectrum-alias-text-color-disabled)
  );
}

.read-only.no-toolbar > .ProseMirror {
  border-color: var(
    --spectrum-textfield-border-color-disabled,
    var(--spectrum-alias-border-color-transparent)
  );
}

/* CodeMirror */
.spectrum-codemirror {
  background-color: var(
    --spectrum-textfield-background-color,
    var(--spectrum-global-color-gray-50)
  );
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
  box-sizing: border-box;
  border: var(--spectrum-textfield-border-size, var(--spectrum-alias-border-size-thin)) solid;
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
  border-radius: var(
    --spectrum-textfield-border-radius,
    var(--spectrum-alias-border-radius-regular)
  );
  height: auto;
  min-height: 30px;
  max-height: 45vh;
  overflow-x: hidden;
  overflow-y: auto;
  width: auto;
  padding: 0 3px var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) 5px
    calc(var(--spectrum-textfield-padding-x, var(--spectrum-global-dimension-size-150)) - 1px);
  text-indent: 0;
  vertical-align: top;
  font-size: var(--spectrum-textfield-text-size, var(--spectrum-alias-font-size-default));
  line-height: var(
    --spectrum-textfield-text-line-height,
    var(--spectrum-alias-body-text-line-height)
  );
  outline: 0;
}

.cm-gutters,
.cm-gutter {
  min-height: 28px !important;
  height: 100% !important;
  padding-bottom: 2.5px !important;
}

.cm-content {
  padding: 5px 0 !important;
}

.spectrum-codemirror:focus-within {
  border-color: var(
    --spectrum-textfield-border-color-down,
    var(--spectrum-alias-border-color-mouse-focus)
  ) !important;
  border: var(--spectrum-textfield-border-size, var(--spectrum-alias-border-size-thin)) solid;
  border-radius: var(
    --spectrum-textfield-border-radius,
    var(--spectrum-alias-border-radius-regular)
  );
}

.spectrum-label {
  font-size: var(--spectrum-fieldlabel-text-size, var(--spectrum-global-dimension-font-size-75));
  font-weight: var(
    --spectrum-fieldlabel-text-font-weight,
    var(--spectrum-global-font-weight-regular)
  );
  position: relative;
  top: 3px;
  color: var(--spectrum-fieldlabel-text-color, var(--spectrum-alias-label-text-color));
  padding: var(--spectrum-fieldlabel-padding-top, var(--spectrum-global-dimension-size-50)) 0
    var(--spectrum-fieldlabel-padding-bottom, var(--spectrum-global-dimension-size-65));
  vertical-align: top;
  box-sizing: border-box;
}

.spectrum-codemirror > .cm-editor {
  background-color: var(
    --spectrum-textfield-background-color,
    var(--spectrum-global-color-gray-50)
  );
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
}

.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-gutters {
  background-color: var(
    --spectrum-fieldbutton-background-color-down,
    var(--spectrum-global-color-gray-200)
  );
  border-color: var(
    --spectrum-fieldbutton-border-color-down,
    var(--spectrum-alias-border-color-down)
  );
  color: var(--spectrum-textfield-text-color, var(--spectrum-alias-text-color));
}

.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-content > .cm-activeLine,
.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-gutters > .cm-gutter > .cm-activeLineGutter {
  background-color: var(
    --spectrum-table-row-background-color-selected-hover,
    var(--spectrum-alias-highlight-selected-hover)
  ) !important;
}

/* Creates a Zebra Layout */
.spectrum-codemirror > .cm-editor > .cm-scroller > .cm-content > div:nth-child(even) {
  background-color: var(
    --spectrum-table-row-background-color-hover,
    var(--spectrum-alias-highlight-hover)
  );
}

.read-only,
.spectrum-codemirror.read-only > .cm-editor > .cm-scroller {
  background-color: var(
    --spectrum-textfield-background-color-disabled,
    var(--spectrum-global-color-gray-200)
  );
  color: var(--spectrum-textfield-text-color-disabled, var(--spectrum-alias-text-color-disabled));
  -webkit-text-fill-color: var(
    --spectrum-textfield-text-color-disabled,
    var(--spectrum-alias-text-color-disabled)
  );
  border-color: var(
    --spectrum-textfield-border-color-disabled,
    var(--spectrum-alias-border-color-transparent)
  );
}

.spectrum-codemirror.read-only,
.spectrum-codemirror.read-only > .cm-editor > .cm-scroller {
  background-color: var(
    --spectrum-textfield-background-color-disabled,
    var(--spectrum-global-color-gray-200)
  );
  color: var(--spectrum-textfield-text-color-disabled, var(--spectrum-alias-text-color-disabled));
  -webkit-text-fill-color: var(
    --spectrum-textfield-text-color-disabled,
    var(--spectrum-alias-text-color-disabled)
  );
  border-color: var(
    --spectrum-textfield-border-color-disabled,
    var(--spectrum-alias-border-color-transparent)
  );
}

.spectrum-codemirror.read-only > .cm-editor > .cm-scroller > .cm-content > .cm-activeLine,
.spectrum-codemirror.read-only
  > .cm-editor
  > .cm-scroller
  > .cm-gutters
  > .cm-gutter
  > .cm-activeLineGutter {
  background-color: transparent !important;
}

.keyboard-user .spectrum-codemirror:focus-within {
  border-width: 2px;
  border-color: var(--spectrum-textfield-border-color, var(--spectrum-alias-border-color));
}

/* SpectrumCategorizationStepper */
.categorization-stepper {
  counter-reset: categorization-step-number;
}

.categorization-stepper div[role='tab'] {
  counter-increment: categorization-step-number;
}

.categorization-stepper div[role='tab'] > span:before {
  --categorization-stepper-number-size: 1.2rem;

  display: inline-block;
  width: var(--categorization-stepper-number-size);
  height: var(--categorization-stepper-number-size);
  border-radius: 50%;
  margin-right: 0.4rem;
  overflow: hidden;
  content: counter(categorization-step-number);
  text-align: center;
  vertical-align: middle;
  line-height: var(--categorization-stepper-number-size);
  font-size: 0.75em;
  font-weight: 500;
  background-color: var(--spectrum-global-color-gray-500);
  color: var(--spectrum-global-color-gray-200);
}

.categorization-stepper div[role='tab'][aria-selected='true'] > span:before {
  background-color: var(--spectrum-global-color-gray-900);
  color: var(--spectrum-global-color-gray-100);
}

.animated-modal-item.animated-modal-item-div.detailed-view > .spectrum-array-item-header {
  position: sticky;
  width: 100%;
  padding: 10px 13px 10px 13px;
  margin-top: -12px;
  top: -12px;
  left: 0;

  background-color: var(--spectrum-global-color-gray-100);
  z-index: 1;
  border-bottom-color: var(
    --spectrum-alias-border-color-dark,
    var(--spectrum-global-color-dark, var(--spectrum-semantic-dark-color-border))
  );
  border-bottom-width: var(--spectrum-alias-border-size-thin);
  border-bottom-style: solid;
}

/* InputText */
.assetpicker-button {
  min-width: min-content !important;
  /* margin-top: 25px !important; */
  margin-left: 5px !important;
}

.assetpicker-button-bottom {
  min-width: min-content !important;
  margin-top: 5px !important;
  margin-right: 3px !important;
}

div:has(> div[id^='#/'][hidden]) {
  display: none !important;
}
div:has(> div.jsonForms-hidden[hidden]) {
  display: none !important;
}

.arrowContainer {
  padding: 3px 7px;
}

/* Spinner Test */
@keyframes loadingSpinnerKeyframes1 {
  0% {
    transform: rotate(90deg);
  }
  1.69% {
    transform: rotate(72.3deg);
  }
  3.39% {
    transform: rotate(55.5deg);
  }
  5.08% {
    transform: rotate(40.3deg);
  }
  6.78% {
    transform: rotate(25deg);
  }
  8.47% {
    transform: rotate(10.6deg);
  }
  10.17%,
  11.86%,
  13.56%,
  15.25%,
  16.95%,
  18.64%,
  20.34%,
  22.03%,
  23.73%,
  25.42%,
  27.12%,
  28.81%,
  30.51%,
  32.2%,
  33.9%,
  35.59%,
  37.29%,
  38.98%,
  40.68% {
    transform: rotate(0);
  }
  42.37% {
    transform: rotate(5.3deg);
  }
  44.07% {
    transform: rotate(13.4deg);
  }
  45.76% {
    transform: rotate(20.6deg);
  }
  47.46% {
    transform: rotate(29deg);
  }
  49.15% {
    transform: rotate(36.5deg);
  }
  50.85% {
    transform: rotate(42.6deg);
  }
  52.54% {
    transform: rotate(48.8deg);
  }
  54.24% {
    transform: rotate(54.2deg);
  }
  55.93% {
    transform: rotate(59.4deg);
  }
  57.63% {
    transform: rotate(63.2deg);
  }
  59.32% {
    transform: rotate(67.2deg);
  }
  61.02% {
    transform: rotate(70.8deg);
  }
  62.71% {
    transform: rotate(73.8deg);
  }
  64.41% {
    transform: rotate(76.2deg);
  }
  66.1% {
    transform: rotate(78.7deg);
  }
  67.8% {
    transform: rotate(80.6deg);
  }
  69.49% {
    transform: rotate(82.6deg);
  }
  71.19% {
    transform: rotate(83.7deg);
  }
  72.88% {
    transform: rotate(85deg);
  }
  74.58% {
    transform: rotate(86.3deg);
  }
  76.27% {
    transform: rotate(87deg);
  }
  77.97% {
    transform: rotate(87.7deg);
  }
  79.66% {
    transform: rotate(88.3deg);
  }
  81.36% {
    transform: rotate(88.6deg);
  }
  83.05%,
  84.75% {
    transform: rotate(89.2deg);
  }
  86.44% {
    transform: rotate(89.5deg);
  }
  88.14% {
    transform: rotate(89.9deg);
  }
  89.83% {
    transform: rotate(89.7deg);
  }
  91.53% {
    transform: rotate(90.1deg);
  }
  93.22% {
    transform: rotate(90.2deg);
  }
  94.92% {
    transform: rotate(90.1deg);
  }
  96.61% {
    transform: rotate(90deg);
  }
  98.31% {
    transform: rotate(89.8deg);
  }
  100% {
    transform: rotate(90deg);
  }
}
@keyframes loadingSpinnerKeyframes2 {
  0%,
  1.69%,
  3.39%,
  5.08%,
  6.78%,
  8.47% {
    transform: rotate(180deg);
  }
  10.17% {
    transform: rotate(179.2deg);
  }
  11.86% {
    transform: rotate(164deg);
  }
  13.56% {
    transform: rotate(151.8deg);
  }
  15.25% {
    transform: rotate(140.8deg);
  }
  16.95% {
    transform: rotate(130.3deg);
  }
  18.64% {
    transform: rotate(120.4deg);
  }
  20.34% {
    transform: rotate(110.8deg);
  }
  22.03% {
    transform: rotate(101.6deg);
  }
  23.73% {
    transform: rotate(93.5deg);
  }
  25.42% {
    transform: rotate(85.4deg);
  }
  27.12% {
    transform: rotate(78.1deg);
  }
  28.81% {
    transform: rotate(71.2deg);
  }
  30.51% {
    transform: rotate(89.1deg);
  }
  32.2% {
    transform: rotate(105.5deg);
  }
  33.9% {
    transform: rotate(121.3deg);
  }
  35.59% {
    transform: rotate(135.5deg);
  }
  37.29% {
    transform: rotate(148.4deg);
  }
  38.98% {
    transform: rotate(161deg);
  }
  40.68% {
    transform: rotate(173.5deg);
  }
  100%,
  42.37%,
  44.07%,
  45.76%,
  47.46%,
  49.15%,
  50.85%,
  52.54%,
  54.24%,
  55.93%,
  57.63%,
  59.32%,
  61.02%,
  62.71%,
  64.41%,
  66.1%,
  67.8%,
  69.49%,
  71.19%,
  72.88%,
  74.58%,
  76.27%,
  77.97%,
  79.66%,
  81.36%,
  83.05%,
  84.75%,
  86.44%,
  88.14%,
  89.83%,
  91.53%,
  93.22%,
  94.92%,
  96.61%,
  98.31% {
    transform: rotate(180deg);
  }
}

@keyframes loadingSpinnerRotateKeyframes {
  0% {
    transform: rotate(-90deg);
  }
  100% {
    transform: rotate(270deg);
  }
}

.loadingSpinner,
.loadingSpinner .loadingSpinnerActiveTrack,
.loadingSpinner .loadingSpinnerTrack {
  width: 64px;
  height: 64px;
  border-radius: 64px;
  box-sizing: border-box;
}
.loadingSpinner .loadingSpinnerActiveTrack1,
.loadingSpinner .loadingSpinnerActiveTrack2 {
  height: 64px;
}
.loadingSpinner {
  display: inline-block;
  position: relative;
}
.loadingSpinnerActiveTracks {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
.loadingSpinnerActiveTrack {
  border-color: #1373e6;
}
.loadingSpinnerTrack {
  border-color: #e6e6e6;
}
.loadingSpinnerActiveSubTrack1,
.loadingSpinnerActiveSubTrack2,
.loadingSpinnerActiveTrack1,
.loadingSpinnerActiveTrack2 {
  overflow: hidden;
  transform-origin: 100% center;
  transform: rotate(180deg);
}
.loadingSpinnerActiveTrack1,
.loadingSpinnerActiveTrack2 {
  width: 50%;
  position: absolute;
}
.loadingSpinner .loadingSpinnerActiveTrack,
.loadingSpinner .loadingSpinnerTrack {
  border-style: solid;
  border-width: 4px;
}
.loadingSpinner .loadingSpinnerActiveTracks {
  will-change: transform;
  transform: translateZ(0);
  animation: 1s cubic-bezier(0.25, 0.78, 0.48, 0.89) infinite loadingSpinnerRotateKeyframes;
  transform-origin: center;
}
.loadingSpinner .loadingSpinnerActiveSubTrack1,
.loadingSpinner .loadingSpinnerActiveSubTrack2 {
  will-change: transform;
  transform: translateZ(0);
  animation: 1s linear infinite loadingSpinnerKeyframes1;
}
.loadingSpinner .loadingSpinnerActiveSubTrack2 {
  animation: 1s linear infinite loadingSpinnerKeyframes2;
}`));
      document.head.appendChild(elementStyle);
    }
  } catch (e) {
    console.error("vite-plugin-css-injected-by-js", e);
  }
})();
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _breadcrumbs, _copy, copy_fn;
import { jsx, jsxs, Fragment } from "react/jsx-runtime";
import { getAjv, resolveSchema, Actions, rankWith, isObjectControl, findUISchema, Generate, createCombinatorRenderInfos, createDefaultValue, isOneOfControl, composePaths, Resolve, getData, Helpers, and, uiTypeIs, schemaMatches, hasType, isAnyOfControl, isDescriptionHidden, optionIs, isAllOfControl, findMatchingUISchema, isVisible, categorizationHasCategory, isControl, isBooleanControl, isEnumControl, isIntegerControl, isNumberControl, isRangeControl, isMultiLineControl, isStringControl, NOT_APPLICABLE, isOneOfEnumControl, schemaTypeIs, or, isDateControl, isDateTimeControl, isTimeControl, computeLabel } from "@jsonforms/core";
import { useJsonForms, withJsonFormsContext, ctxToArrayControlProps, ctxDispatchToControlProps, withJsonFormsDetailProps, JsonFormsDispatch, ctxToControlProps, withJsonFormsAnyOfProps, withJsonFormsControlProps, withJsonFormsAllOfProps, withJsonFormsLayoutProps, withJsonFormsCellProps, withJsonFormsEnumCellProps, withJsonFormsEnumProps, DispatchCell, withJsonFormsOneOfEnumProps, withJsonFormsMultiEnumProps, withJsonFormsMasterListItemProps, withJsonFormsArrayLayoutProps } from "@jsonforms/react";
import { DialogContainer, Dialog, Heading, Divider, Content, ButtonGroup, Button, View, ContextualHelp, Text, ToggleButton, Checkbox, Flex, TextField, ActionButton, useProvider, defaultTheme, Provider, TooltipTrigger, Tooltip, ActionMenu, Item, Picker, Tabs, TabList, TabPanels, DialogTrigger, Switch, Grid, NumberField, MenuTrigger, Menu, TagGroup, ComboBox, Slider, TextArea, RadioGroup, Radio } from "@adobe/react-spectrum";
import get from "lodash/get";
import set from "lodash/set";
import equal from "fast-deep-equal";
import * as React from "react";
import React__default, { useMemo, useContext, createElement, useState } from "react";
import ReactDom from "react-dom";
import { useSpring, easings, animated } from "react-spring";
import ReactFocusLock from "react-focus-lock";
import ArrayKeyedMap from "array-keyed-map";
import isEqual from "lodash/isEqual";
import debounce from "lodash/debounce";
import isEmpty$1 from "lodash/isEmpty";
import { produce } from "immer";
import merge from "lodash/merge";
import Add from "@spectrum-icons/workflow/Add";
import ArrowDown from "@spectrum-icons/workflow/ArrowDown";
import ArrowUp from "@spectrum-icons/workflow/ArrowUp";
import Asset from "@spectrum-icons/workflow/Asset";
import ChevronDown from "@spectrum-icons/workflow/ChevronDown";
import ChevronUp from "@spectrum-icons/workflow/ChevronUp";
import Close from "@spectrum-icons/workflow/Close";
import Delete from "@spectrum-icons/workflow/Delete";
import DragHandle from "@spectrum-icons/workflow/DragHandle";
import Duplicate from "@spectrum-icons/workflow/Duplicate";
import Edit from "@spectrum-icons/workflow/Edit";
import "@spectrum-icons/workflow/FolderOpen";
import FolderSearch from "@spectrum-icons/workflow/FolderSearch";
import "@spectrum-icons/workflow/Link";
import OpenIn from "@spectrum-icons/workflow/OpenIn";
import Properties from "@spectrum-icons/workflow/Properties";
import Redo from "@spectrum-icons/workflow/Redo";
import "@spectrum-icons/workflow/Star";
import "@spectrum-icons/workflow/StarOutline";
import TableAdd from "@spectrum-icons/workflow/TableAdd";
import TableColumnAddLeft from "@spectrum-icons/workflow/TableColumnAddLeft";
import TableColumnAddRight from "@spectrum-icons/workflow/TableColumnAddRight";
import TableColumnRemoveCenter from "@spectrum-icons/workflow/TableColumnRemoveCenter";
import TableEdit from "@spectrum-icons/workflow/TableEdit";
import TableMergeCells from "@spectrum-icons/workflow/TableMergeCells";
import TableRowAddBottom from "@spectrum-icons/workflow/TableRowAddBottom";
import TableRowAddTop from "@spectrum-icons/workflow/TableRowAddTop";
import TableRowRemoveCenter from "@spectrum-icons/workflow/TableRowRemoveCenter";
import TableRowSplit from "@spectrum-icons/workflow/TableRowSplit";
import TagBold from "@spectrum-icons/workflow/TagBold";
import TagItalic from "@spectrum-icons/workflow/TagItalic";
import TagUnderline from "@spectrum-icons/workflow/TagUnderline";
import TextAlignCenter from "@spectrum-icons/workflow/TextAlignCenter";
import TextAlignJustify from "@spectrum-icons/workflow/TextAlignJustify";
import TextAlignLeft from "@spectrum-icons/workflow/TextAlignLeft";
import TextAlignRight from "@spectrum-icons/workflow/TextAlignRight";
import TextBulleted from "@spectrum-icons/workflow/TextBulleted";
import TextNumbered from "@spectrum-icons/workflow/TextNumbered";
import TextStrikethrough from "@spectrum-icons/workflow/TextStrikethrough";
import TextSubscript from "@spectrum-icons/workflow/TextSubscript";
import TextSuperscript from "@spectrum-icons/workflow/TextSuperscript";
import Undo from "@spectrum-icons/workflow/Undo";
import { DatePicker, TimeField } from "@react-spectrum/datepicker";
import startCase from "lodash/startCase";
import { get as get$1 } from "lodash";
import { useDrag } from "@use-gesture/react";
import { useSprings, useSpringRef, animated as animated$1 } from "@react-spring/web";
import { parseDate, today, getLocalTimeZone, toZoned, now, parseAbsoluteToLocal, parseDateTime, parseTime } from "@internationalized/date";
import { useEditor, EditorContent } from "@tiptap/react";
import Document from "@tiptap/extension-document";
import Focus from "@tiptap/extension-focus";
import Highlight from "@tiptap/extension-highlight";
import Image from "@tiptap/extension-image";
import Link from "@tiptap/extension-link";
import Subscript from "@tiptap/extension-subscript";
import Superscript from "@tiptap/extension-superscript";
import Text$1 from "@tiptap/extension-text";
import TextAlign from "@tiptap/extension-text-align";
import TypographyExtension from "@tiptap/extension-typography";
import UnderlineExtension from "@tiptap/extension-underline";
import { Blockquote } from "@tiptap/extension-blockquote";
import { Bold } from "@tiptap/extension-bold";
import { BulletList } from "@tiptap/extension-bullet-list";
import { Code } from "@tiptap/extension-code";
import { CodeBlock } from "@tiptap/extension-code-block";
import { Dropcursor } from "@tiptap/extension-dropcursor";
import { HardBreak } from "@tiptap/extension-hard-break";
import { History } from "@tiptap/extension-history";
import { HorizontalRule } from "@tiptap/extension-horizontal-rule";
import { Italic } from "@tiptap/extension-italic";
import { ListItem } from "@tiptap/extension-list-item";
import { OrderedList } from "@tiptap/extension-ordered-list";
import { Strike } from "@tiptap/extension-strike";
import { Node, mergeAttributes, Mark } from "@tiptap/core";
import { Heading as Heading$1 } from "@tiptap/extension-heading";
import { Paragraph } from "@tiptap/extension-paragraph";
import { TextStyle } from "@tiptap/extension-text-style";
import Table from "@tiptap/extension-table";
import TableCell from "@tiptap/extension-table-cell";
import TableHeader from "@tiptap/extension-table-header";
import TableRow from "@tiptap/extension-table-row";
import CodeMirror from "@uiw/react-codemirror";
import { json, jsonParseLinter } from "@codemirror/lang-json";
import { linter, lintGutter } from "@codemirror/lint";
import maxBy from "lodash/maxBy";
import isArray from "lodash/isArray";
function DeleteDialog({
  cancelBtnText = "Cancel",
  confirmBtnText = "Delete",
  contentText = "Are you sure you wish to delete this item?",
  deleteModalOpen,
  headingText = "Delete Item?",
  onPressEndHandler,
  onPressStartHandler,
  setDeleteModalOpen
}) {
  return /* @__PURE__ */ jsx(DialogContainer, { onDismiss: () => setDeleteModalOpen(false), children: deleteModalOpen && /* @__PURE__ */ jsxs(Dialog, { children: [
    /* @__PURE__ */ jsx(Heading, { children: headingText }),
    /* @__PURE__ */ jsx(Divider, {}),
    /* @__PURE__ */ jsx(Content, { children: contentText }),
    /* @__PURE__ */ jsxs(ButtonGroup, { children: [
      /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: () => setDeleteModalOpen(false), children: cancelBtnText }),
      /* @__PURE__ */ jsx(
        Button,
        {
          autoFocus: true,
          variant: "cta",
          onPressStart: onPressStartHandler,
          onPressEnd: onPressEndHandler,
          children: confirmBtnText
        }
      )
    ] })
  ] }) });
}
const withAjvProps = (Component) => (props) => {
  const ctx = useJsonForms();
  const ajv = getAjv({ jsonforms: { ...ctx } });
  return /* @__PURE__ */ jsx(Component, { ...props, ajv });
};
const findAllCFsWithGivenPathRecursive = (obj, _path, result) => {
  if (obj) {
    if (obj._path === _path && obj._model) {
      result.push(obj);
    }
    for (const value of Object.values(obj)) {
      if (typeof value === "object") {
        findAllCFsWithGivenPathRecursive(value, _path, result);
      }
    }
  }
};
const findAllItemsWithGivenPath = (data, _path) => {
  const result = [];
  findAllCFsWithGivenPathRecursive(data, _path, result);
  return result;
};
const allCopiesUpdater = (jsonPath, newData) => (data) => {
  if (equal(newData, get(data, jsonPath))) {
    return data;
  }
  const jsonPathSegments = jsonPath.split(".");
  let i = jsonPathSegments.length - 1;
  let changedCfPath = void 0;
  while (i >= 0) {
    const contentFragmentModelUnderJsonPath = get(data, [
      ...jsonPathSegments.slice(0, i),
      "_model"
    ]);
    if (contentFragmentModelUnderJsonPath) {
      changedCfPath = get(data, [...jsonPathSegments.slice(0, i), "_path"]);
      break;
    }
    --i;
  }
  if (i >= 0) {
    for (const item of findAllItemsWithGivenPath(data, changedCfPath)) {
      set(item, jsonPathSegments.slice(i, jsonPathSegments.length), newData);
      if (item._edited) {
        item._edited.add(jsonPathSegments[i]);
      } else {
        item._edited = /* @__PURE__ */ new Set([jsonPathSegments[i]]);
      }
    }
  } else {
    set(data, jsonPath, newData);
  }
  return data;
};
const allCopiesReducer = (jsonPath, reducer) => (data) => {
  const jsonPathSegments = jsonPath.split(".");
  let i = jsonPathSegments.length - 1;
  let changedCfPath = void 0;
  while (i >= 0) {
    changedCfPath = get(data, [...jsonPathSegments.slice(0, i), "_path"]);
    if (changedCfPath) {
      break;
    }
    --i;
  }
  if (i >= 0) {
    for (const item of findAllItemsWithGivenPath(data, changedCfPath)) {
      set(
        item,
        jsonPathSegments.slice(i, jsonPathSegments.length),
        reducer(get(item, jsonPathSegments.slice(i, jsonPathSegments.length)))
      );
      if (item._edited) {
        item._edited.add(jsonPathSegments[i]);
      } else {
        item._edited = /* @__PURE__ */ new Set([jsonPathSegments[i]]);
      }
    }
  } else {
    set(data, jsonPath, reducer(get(data, jsonPath)));
  }
  return data;
};
const arrayStrictlyExtendsPrefix = (prefix, array) => {
  if (array.length <= prefix.length)
    return false;
  for (let i = 0; i < prefix.length; ++i) {
    if (prefix[i] !== array[i]) {
      return false;
    }
  }
  return true;
};
const arrayExtendsPrefix = (prefix, array) => {
  if (array.length < prefix.length)
    return false;
  for (let i = 0; i < prefix.length; ++i) {
    if (prefix[i] !== array[i]) {
      return false;
    }
  }
  return true;
};
const _Breadcrumbs = class _Breadcrumbs {
  constructor(data = []) {
    __privateAdd(this, _copy);
    __privateAdd(this, _breadcrumbs, new ArrayKeyedMap());
    for (const { path, name, usesDetailedView } of data) {
      __privateGet(this, _breadcrumbs).set(path.split("."), {
        name: name || null,
        usesDetailedView: usesDetailedView || false
      });
    }
  }
  get(path) {
    return __privateGet(this, _breadcrumbs).get(path.split("."));
  }
  addBreadcrumb({ path, name, crxPath, usesDetailedView }) {
    const explodedPath = path.split(".");
    const existingBreadcrumb = __privateGet(this, _breadcrumbs).get(explodedPath);
    if (path && name !== (existingBreadcrumb == null ? void 0 : existingBreadcrumb.name) && !(existingBreadcrumb && !name)) {
      if (crxPath) {
        window.postMessage(
          {
            type: "breadcrumb-added",
            crxPath
          },
          "*"
        );
      }
      const result = __privateMethod(this, _copy, copy_fn).call(this);
      __privateGet(result, _breadcrumbs).set(explodedPath, {
        name,
        usesDetailedView: usesDetailedView ?? false
      });
      return result;
    } else {
      return this;
    }
  }
  deleteBreadcrumb(path) {
    const explodedPath = path.split(".");
    if (__privateGet(this, _breadcrumbs).get(explodedPath) !== void 0) {
      const result = __privateMethod(this, _copy, copy_fn).call(this);
      __privateGet(result, _breadcrumbs).delete(explodedPath);
      return result;
    } else {
      return this;
    }
  }
  truncateBreadcrumbsAtParent(path) {
    const parentPath = path.slice(0, path.lastIndexOf("."));
    return this.truncateBreadcrumbs(parentPath);
  }
  truncateBreadcrumbsAndDelete(path) {
    if (__privateGet(this, _breadcrumbs).hasPrefix(path.split("."))) {
      return this.truncateBreadcrumbs(path).deleteBreadcrumb(path);
    } else {
      return this;
    }
  }
  truncateBreadcrumbsAndAdd(path) {
    return this.leavePrefixesOnly(path).addBreadcrumb({ path, name: null });
  }
  truncateBreadcrumbs(path) {
    const explodedPath = path.split(".");
    const keysLongerThanPath = [...__privateGet(this, _breadcrumbs).keys()].filter(
      (breadcrumbPath) => arrayStrictlyExtendsPrefix(explodedPath, breadcrumbPath)
    );
    if (keysLongerThanPath.length) {
      const result = new _Breadcrumbs();
      const entriesLeft = [...__privateGet(this, _breadcrumbs).entries()].filter(
        ([breadcrumbPath, _]) => !arrayStrictlyExtendsPrefix(explodedPath, breadcrumbPath)
      );
      for (const [key, value] of entriesLeft) {
        __privateGet(result, _breadcrumbs).set(key, value);
      }
      return result;
    } else {
      return this;
    }
  }
  leavePrefixesOnly(path) {
    const explodedPath = (path == null ? void 0 : path.split(".")) || [];
    const nonPrefixes = [...__privateGet(this, _breadcrumbs).keys()].filter(
      (breadcrumbPath) => !arrayExtendsPrefix(breadcrumbPath, explodedPath)
    );
    if (nonPrefixes.length) {
      const result = new _Breadcrumbs();
      const entriesLeft = [...__privateGet(this, _breadcrumbs).entries()].filter(
        ([breadcrumbPath, _]) => arrayExtendsPrefix(breadcrumbPath, explodedPath)
      );
      for (const [key, value] of entriesLeft) {
        __privateGet(result, _breadcrumbs).set(key, value);
      }
      return result;
    } else {
      return this;
    }
  }
  clear() {
    return new _Breadcrumbs();
  }
  hasPrefix(path) {
    return Boolean(path) && __privateGet(this, _breadcrumbs).hasPrefix(path.split("."));
  }
  has(path) {
    return __privateGet(this, _breadcrumbs).has(path.split("."));
  }
  keys() {
    return [...__privateGet(this, _breadcrumbs).keys()].map((pathSegements) => pathSegements.join("."));
  }
  entries() {
    return [...__privateGet(this, _breadcrumbs).entries()].map((item) => {
      const [pathSegments, { name, usesDetailedView }] = item;
      return [pathSegments.join("."), { name, usesDetailedView }];
    });
  }
  optimisticLongestPath() {
    var _a;
    return (_a = [...__privateGet(this, _breadcrumbs).keys()].at(-1)) == null ? void 0 : _a.join(".");
  }
};
_breadcrumbs = new WeakMap();
_copy = new WeakSet();
copy_fn = function() {
  const result = new _Breadcrumbs();
  __privateSet(result, _breadcrumbs, __privateGet(this, _breadcrumbs));
  return result;
};
let Breadcrumbs = _Breadcrumbs;
const BreadcrumbsContext = React__default.createContext({
  breadcrumbs: new Breadcrumbs(),
  addBreadcrumb: () => {
  },
  deleteBreadcrumb: () => {
  },
  truncateBreadcrumbs: () => {
  },
  truncateBreadcrumbsAndDelete: () => {
  },
  truncateBreadcrumbsAndAdd: () => {
  },
  truncateBreadcrumbsAtParent: () => {
  },
  resetBreadcrumbs: () => {
  }
});
const useBreadcrumbs = () => {
  const breadcrumbsContext = React__default.useContext(BreadcrumbsContext);
  if (breadcrumbsContext === void 0) {
    throw new Error("useBreadcrumbs must be used within a BreadcrumbsProvider");
  }
  return breadcrumbsContext;
};
const BreadcrumbsProvider = ({ children }) => {
  const [breadcrumbs, setBreadcrumbs] = React__default.useState(new Breadcrumbs());
  const addBreadcrumb = React__default.useCallback(
    (breadcrumb) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.addBreadcrumb(breadcrumb));
    },
    [setBreadcrumbs]
  );
  const deleteBreadcrumb = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.deleteBreadcrumb(path));
    },
    [setBreadcrumbs]
  );
  const resetBreadcrumbs = React__default.useCallback(
    (data) => {
      setBreadcrumbs(new Breadcrumbs(data));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbs = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbs(path));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbsAtParent = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbsAtParent(path));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbsAndDelete = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbsAndDelete(path));
    },
    [setBreadcrumbs]
  );
  const truncateBreadcrumbsAndAdd = React__default.useCallback(
    (path) => {
      setBreadcrumbs((breadcrumbs2) => breadcrumbs2.truncateBreadcrumbsAndAdd(path));
    },
    [setBreadcrumbs]
  );
  return /* @__PURE__ */ jsx(
    BreadcrumbsContext.Provider,
    {
      value: {
        breadcrumbs,
        addBreadcrumb,
        deleteBreadcrumb,
        resetBreadcrumbs,
        truncateBreadcrumbs,
        truncateBreadcrumbsAtParent,
        truncateBreadcrumbsAndDelete,
        truncateBreadcrumbsAndAdd
      },
      children
    }
  );
};
const ANIMATION_DURATION = 700;
const ModalItemAnimationWrapper = ({
  children,
  elements,
  enableDetailedView = true,
  expanded,
  setExpanded,
  header,
  isAnimating,
  path,
  setIsAnimating
}) => {
  const { breadcrumbs } = useBreadcrumbs();
  const breadcrumbEntries = breadcrumbs.entries();
  const [firstOpen, setFirstOpen] = React__default.useState(true);
  const [isBlackoutHovered, setIsBlackoutHovered] = React__default.useState(false);
  const jsonFormWrapper = document.getElementById("jsonforms-wrapper") || document.getElementsByClassName("App-Form")[0];
  const addToZIndex = 2 * Math.round(((path == null ? void 0 : path.split(".").length) ?? 1) / 2);
  const openPosition = breadcrumbEntries.findIndex(
    (item) => {
      return item[0].startsWith(path);
    }
  );
  let nrOfNonDetailViewPaths = breadcrumbEntries.filter(
    (breadcrumbItem) => !breadcrumbItem[1].usesDetailedView
  ).length;
  let nrOfNonDetailViewPathsBeforeCurrent = breadcrumbEntries.slice(0, openPosition).filter((breadcrumbItem) => !breadcrumbItem[1].usesDetailedView).length;
  const positionFromEnd = breadcrumbEntries.length - openPosition;
  const leftOffset = 2.5 * (positionFromEnd - nrOfNonDetailViewPaths + nrOfNonDetailViewPathsBeforeCurrent);
  const onStartFunction = () => {
    setIsAnimating(true);
  };
  const onRestFunction = () => {
    var _a, _b;
    setIsAnimating(false);
    if (((_b = (_a = document == null ? void 0 : document.documentElement) == null ? void 0 : _a.className) == null ? void 0 : _b.includes("keyboard-user")) && expanded && firstOpen) {
      setFirstOpen(false);
      focusFirstUsableInput();
    } else if (!expanded && !firstOpen) {
      setFirstOpen(true);
    }
  };
  const [slideAnim] = useSpring(
    () => ({
      config: {
        duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : ANIMATION_DURATION,
        easing: easings.easeOutQuart
      },
      left: expanded ? isBlackoutHovered ? `${15 - leftOffset}%` : `${10 - leftOffset}%` : "100%",
      onRest: () => onRestFunction(),
      onStart: () => onStartFunction()
    }),
    [expanded, isBlackoutHovered, breadcrumbEntries]
  );
  const [darkenAnim] = useSpring(
    () => ({
      config: {
        duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 400,
        easing: easings.easeInOutCubic
      },
      opacity: leftOffset >= 0 ? expanded ? 0.5 : 0 : 0,
      display: expanded ? "block" : "collapse"
    }),
    [expanded]
  );
  const childrenContent = (expanded2, isAnimating2, elements2, children2) => {
    if (expanded2 || isAnimating2) {
      if (elements2) {
        return /* @__PURE__ */ jsxs(View, { UNSAFE_className: "jsonforms-dispatch-wrapper", children: [
          header,
          /* @__PURE__ */ jsx(Content, { UNSAFE_className: "modal-element", children: elements2 })
        ] });
      } else if (children2) {
        return children2;
      }
    }
    return null;
  };
  return ReactDom.createPortal(
    /* @__PURE__ */ jsx(
      ReactFocusLock,
      {
        className: "spectrum-detailed-view-dialog-wrapper",
        disabled: !expanded,
        returnFocus: true,
        as: "div",
        autoFocus: false,
        shards: [
          document.getElementById("debug-menu-button"),
          document.getElementById("cf-editor-breadcrumbs"),
          ...document.querySelectorAll("*[class^='spectrum-Popover']")
        ],
        whiteList: (node) => {
          if ([...document.querySelectorAll("#jsonforms-wrapper")].some((foundNode) => foundNode.contains(node)) || // prettier-ignore
          [...document.querySelectorAll("#debug-wrapper")].some((foundNode) => foundNode.contains(node)) || // prettier-ignore
          [...document.querySelectorAll("#cf-editor-breadcrumbs")].some((foundNode) => foundNode.contains(node)) || // prettier-ignore
          [...document.querySelectorAll("#debug-menu-button")].some((foundNode) => foundNode.contains(node))) {
            return true;
          }
          return false;
        },
        children: /* @__PURE__ */ jsxs(
          "div",
          {
            className: `animated-modal-item animated-modal-wrapper ${expanded || isAnimating ? "expanded" : ""}`,
            "data-editor-path": path,
            style: {
              visibility: expanded || isAnimating ? "visible" : "collapse"
            },
            children: [
              /* @__PURE__ */ jsx(
                animated.div,
                {
                  className: `animated-modal-item animated-modal-item-div ${enableDetailedView ? "detailed-view" : ""} ${expanded ? "dark-expanded" : ""} ${isAnimating ? "isAnimating" : ""}`,
                  style: enableDetailedView ? {
                    left: slideAnim == null ? void 0 : slideAnim.left,
                    zIndex: 8001 + addToZIndex,
                    width: `${95 - leftOffset}%`
                  } : {},
                  children: childrenContent(expanded, isAnimating, elements, children)
                }
              ),
              /* @__PURE__ */ jsx(
                animated.div,
                {
                  className: `animated-modal-item dark-background ${expanded ? "dark-expanded" : ""} ${isAnimating ? "isAnimating" : ""}`,
                  onClick: () => expanded && setExpanded(false, enableDetailedView),
                  onMouseEnter: () => setIsBlackoutHovered(true),
                  onMouseLeave: () => setIsBlackoutHovered(false),
                  style: {
                    opacity: darkenAnim.opacity,
                    display: darkenAnim.display,
                    zIndex: 8e3 + addToZIndex,
                    cursor: expanded ? "pointer" : "default"
                  }
                }
              )
            ]
          }
        )
      }
    ),
    jsonFormWrapper || document.getElementById("root") || document.getElementById("__next") || document.body
  );
};
const areEqual = (prevProps, nextProps) => {
  return get(prevProps, "renderers.length") === get(nextProps, "renderers.length") && get(prevProps, "cells.length") === get(nextProps, "cells.length") && get(prevProps, "uischemas.length") === get(nextProps, "uischemas.length") && get(prevProps, "schema") === get(nextProps, "schema") && isEqual(get(prevProps, "uischema"), get(nextProps, "uischema")) && get(prevProps, "path") === get(nextProps, "path");
};
const circularReferenceReplacer = () => {
  const paths = /* @__PURE__ */ new Map();
  const finalPaths = /* @__PURE__ */ new Map();
  let root = null;
  return function(field, value) {
    const p = paths.get(this) + "/" + field;
    const isComplex = value === Object(value);
    if (isComplex)
      paths.set(value, p);
    const existingPath = finalPaths.get(value) || "";
    const path = p.replace(/undefined\/\/?/, "");
    let val = existingPath ? { $ref: `#/${existingPath}` } : value;
    if (!root) {
      root = value;
    } else if (val === root) {
      val = { $ref: "#/" };
    }
    if (!existingPath && isComplex)
      finalPaths.set(value, path);
    return val;
  };
};
const cssToObject = (cssString) => {
  let cssObject = {};
  let cssProperties = cssString.split(";");
  cssProperties.forEach((property) => {
    if (property.trim()) {
      let [name, value] = property.split(":");
      cssObject[name.trim()] = value.trim();
    }
  });
  return cssObject;
};
const objectToCss = (cssObject) => {
  let cssString = "";
  if (!cssObject) {
    return cssString;
  }
  Object.keys(cssObject).forEach((key) => {
    cssString += `${key}: ${cssObject[key]}; `;
  });
  return cssString.trim();
};
const dataEditorPath = (pathId) => ({ "data-editor-path": pathId });
const useDebouncedChange = (handleChange, defaultValue, data, path) => {
  const timeout2 = 250;
  const [input, setInput] = React__default.useState(data ?? defaultValue);
  const debouncedUpdate = React__default.useCallback(
    debounce((newValue) => {
      handleChange(path, newValue);
      if ({}.VITE_EDIT_MODE === "true") {
        newValue && window.postMessage(`debounceUpdate:${path}`);
      }
    }, timeout2),
    [handleChange, path, timeout2]
  );
  React__default.useEffect(() => {
    setInput(data ?? defaultValue);
    debouncedUpdate(input);
  }, []);
  const onChange = React__default.useCallback(
    (value) => {
      setInput(value ?? defaultValue);
      debouncedUpdate(value);
    },
    [debouncedUpdate]
  );
  const onClear = React__default.useCallback(() => {
    setInput(defaultValue);
    handleChange(path, void 0);
  }, [defaultValue, handleChange, path]);
  return [input, onChange, onClear];
};
function dkuHandlePointer() {
  document.documentElement.classList.add("pointer-user");
  document.documentElement.classList.remove("keyboard-user");
  window.removeEventListener("mousedown", dkuHandlePointer, true);
  window.removeEventListener("touchstart", dkuHandlePointer, true);
  window.addEventListener("keydown", dkuHandleKeyboard, true);
}
function dkuHandleKeyboard(e) {
  if (e instanceof KeyboardEvent && e.key === "Tab") {
    document.documentElement.classList.add("keyboard-user");
    document.documentElement.classList.remove("pointer-user");
    window.removeEventListener("keydown", dkuHandleKeyboard, true);
    window.addEventListener("mousedown", dkuHandlePointer, true);
    window.addEventListener("touchstart", dkuHandlePointer, true);
  }
}
class DetectKeyboardUser {
  constructor() {
    this.init();
  }
  init() {
    document.documentElement.classList.add("pointer-user");
    window.addEventListener("touchstart", dkuHandleKeyboard, true);
    window.addEventListener("keydown", dkuHandleKeyboard, true);
  }
  destroy() {
    document.documentElement.classList.remove("pointer-user");
    document.documentElement.classList.remove("keyboard-user");
  }
  refresh() {
    this.destroy();
    this.init();
  }
}
const width = screen.availWidth;
const height = screen.availHeight;
function checkIfUserIsOnMobileDevice($userAgent) {
  if ($userAgent.includes("mobi") || $userAgent.includes("tablet")) {
    return true;
  }
  if ($userAgent.includes("android")) {
    if (height > width && width < 800) {
      return true;
    }
    if (width > height && height < 800) {
      return true;
    }
  }
  return false;
}
const ErrorIndicator = ({ errors }) => {
  return /* @__PURE__ */ jsxs(ContextualHelp, { variant: "info", children: [
    /* @__PURE__ */ jsx(Heading, { children: "Error" }),
    /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: errors }) })
  ] });
};
const findValue = (obj, key) => {
  if (!obj || !key) {
    return void 0;
  }
  if (Array.isArray(key)) {
    for (const k of key) {
      const result = findValue(obj, k);
      if (result) {
        return result;
      }
    }
    return void 0;
  }
  if (obj[key]) {
    return obj[key];
  }
  for (const prop in obj) {
    if (obj.hasOwnProperty(prop)) {
      if (typeof obj[prop] === "object") {
        const result = findValue(obj[prop], key);
        if (result) {
          return result;
        }
      }
    }
  }
};
const useFocus = () => {
  const [focused, setFocused] = React__default.useState(false);
  const onFocus = React__default.useCallback(() => setFocused(true), []);
  const onBlur = React__default.useCallback(() => setFocused(false), []);
  return [focused, onFocus, onBlur];
};
const INPUTS_THAT_SHOULD_AUTOFOCUS_QUERY = "div:not([class='add-container']) > button, div:not([class^='spectrum-TabsPanel-collapseWrapper']) input, div:not([class^='spectrum-TabsPanel-collapseWrapper']) select, textarea, [tabindex]:not([tabindex='-1'])";
const focusFirstUsableInput = () => {
  const arrayItemWrapper = [
    ...document.querySelectorAll(
      ".jsonforms-dispatch-wrapper > .modal-element, .modal-element, .jsonforms-dispatch-wrapper > .array-item-content"
    )
  ].pop();
  if (arrayItemWrapper) {
    const tabPanel = arrayItemWrapper.querySelector("div[class^='spectrum-TabsPanel-tabpanel'][role='tabpanel'] div[class^='spectrum-TabsPanel-tabpanel'][role='tabpanel']:not([aria-labelledby='undefined-tab-undefined'])") || // prettier-ignore
    arrayItemWrapper.querySelector("div[class^='spectrum-TabsPanel-tabpanel'][role='tabpanel']:not([aria-labelledby='undefined-tab-undefined'])");
    if (tabPanel) {
      tabPanel.querySelectorAll(INPUTS_THAT_SHOULD_AUTOFOCUS_QUERY)[0].focus();
    } else {
      arrayItemWrapper.querySelectorAll(INPUTS_THAT_SHOULD_AUTOFOCUS_QUERY)[0].focus();
    }
  }
};
const hasPositiveOption = (optionName) => (uischema) => {
  if (isEmpty$1(uischema)) {
    return false;
  }
  const options = uischema.options;
  return !isEmpty$1(options) && options[optionName];
};
function isEmpty(obj) {
  return [Object, Array].includes((obj || {}).constructor) && !Object.keys(obj || {}).length;
}
const isoDateRegExp = new RegExp(
  /(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z))|(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d([+-][0-2]\d:[0-5]\d|Z))|(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d([+-][0-2]\d:[0-5]\d|Z))/
);
const isISODate = (date) => {
  return isoDateRegExp.test(date);
};
const lengthErrorMessage = (minLength, maxLength) => {
  if (minLength && maxLength) {
    return `Must be between ${minLength} and ${maxLength} characters`;
  } else if (minLength) {
    if (minLength === 1) {
      return "Must be at least 1 character";
    }
    return `Must be at least ${minLength} characters`;
  } else if (maxLength) {
    return `Must not be longer than ${maxLength} characters`;
  }
};
function LoadingSpinner() {
  return /* @__PURE__ */ jsxs("div", { className: "loadingSpinner", children: [
    /* @__PURE__ */ jsx("div", { className: "loadingSpinnerTrack" }),
    /* @__PURE__ */ jsxs("div", { className: "loadingSpinnerActiveTracks", children: [
      /* @__PURE__ */ jsx("div", { className: "loadingSpinnerActiveTrack1", children: /* @__PURE__ */ jsx("div", { className: "loadingSpinnerActiveSubTrack1", children: /* @__PURE__ */ jsx("div", { className: "loadingSpinnerActiveTrack" }) }) }),
      /* @__PURE__ */ jsx("div", { className: "loadingSpinnerActiveTrack2", children: /* @__PURE__ */ jsx("div", { className: "loadingSpinnerActiveSubTrack2", children: /* @__PURE__ */ jsx("div", { className: "loadingSpinnerActiveTrack" }) }) })
    ] })
  ] });
}
const resolveSubSchemas = (schema, rootSchema, keyword) => {
  const schemas = schema[keyword];
  if (schemas.findIndex((e) => e.$ref !== void 0) !== -1) {
    return {
      ...schema,
      [keyword]: schema[keyword].map(
        (e) => e.$ref ? resolveSchema(rootSchema, e.$ref, rootSchema) : e
      )
    };
  }
  return schema;
};
const settings = {
  toolTipDelay: 500
};
const emailPattern = /(?:[a-z0-9+!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z]{2,}\b/i;
const telPattern = /^\+?[0-9]{3,}$/;
const urlPattern = /^(ftp|http|https):\/\/[^ "]+$/i;
const textPattern = /^[\w\s]+$/i;
const isValidPattern = (value, pattern) => {
  switch (pattern) {
    case void 0:
      return true;
    case "email":
      return emailPattern.test(value);
    case "tel":
      return telPattern.test(value);
    case "url":
      return urlPattern.test(value);
    case "password":
    case "search":
    case "text":
      return textPattern.test(value);
    default:
      return new RegExp(pattern).test(value);
  }
};
const isValidCheck = (inputText, data, minLength, maxLength, _isValid, customFormat, format) => {
  const value = inputText ?? data;
  const valueLength = (value == null ? void 0 : value.length) ?? 0;
  if (isValidPattern(inputText, customFormat ?? format) && valueLength >= minLength || maxLength && valueLength <= maxLength) {
    return true;
  }
  return false;
};
const patternErrorMessage = (value, pattern, minLength, maxLength) => {
  const valueLength = value.length;
  let errorMessage1 = void 0;
  let errorMessage2 = void 0;
  if (valueLength < minLength || maxLength && valueLength > maxLength) {
    errorMessage1 = lengthErrorMessage(minLength, maxLength);
  }
  if (pattern && !isValidPattern(value, pattern)) {
    if (pattern === "email" || pattern === "tel" || pattern === "url" || pattern === "password" || pattern === "search" || pattern === "text") {
      errorMessage2 = `Invalid format, should match format for ${pattern}`;
    } else {
      errorMessage2 = `Invalid format, should match RegEx format ${pattern}`;
    }
  }
  if (errorMessage1 && errorMessage2) {
    return `${errorMessage2} and ${errorMessage1.charAt(0).toLowerCase() + errorMessage1.slice(1)}`;
  }
  return errorMessage1 || errorMessage2;
};
const valueErrorMessage = (minValue, maxValue) => {
  if (minValue && maxValue) {
    return `Must be between ${minValue} and ${maxValue}`;
  } else if (minValue) {
    return `Must be at least ${minValue}`;
  } else if (maxValue) {
    return `Must not be more than ${maxValue}`;
  }
};
const withHandleChange = (Component) => function WithHandleChange(props) {
  const ctx = useJsonForms();
  const dispatch = ctx.dispatch;
  const handleChange = React__default.useCallback(
    (path, data) => {
      if (dispatch) {
        dispatch(
          Actions.update("", (currentData) => produce(currentData, allCopiesUpdater(path, data)))
        );
      }
    },
    [dispatch]
  );
  return /* @__PURE__ */ jsx(Component, { ...props, handleChange });
};
const withDataReduce = (Component) => function WithDataReduce(props) {
  const ctx = useJsonForms();
  const dispatch = ctx.dispatch;
  const dataReduce = React__default.useCallback(
    (path, reducer) => {
      if (dispatch) {
        dispatch(
          Actions.update(
            "",
            (currentData) => produce(currentData, allCopiesReducer(path, reducer))
          )
        );
      }
    },
    [dispatch]
  );
  return /* @__PURE__ */ jsx(Component, { ...props, dataReduce });
};
const ctxDispatchToArrayControlProps = (dispatch) => ({
  ...ctxDispatchToControlProps(dispatch)
});
const withContextToArrayControlProps = (Component) => ({ ctx, props }) => {
  const stateProps = ctxToArrayControlProps(ctx, props);
  const dispatchProps = ctxDispatchToArrayControlProps(ctx.dispatch);
  return /* @__PURE__ */ jsx(Component, { ...props, ...stateProps, ...dispatchProps });
};
const withJsonFormsArrayControlProps = (Component, memoize = true) => withJsonFormsContext(withContextToArrayControlProps(memoize ? React__default.memo(Component) : Component));
const ContextualHelpComponent = (uischema, schema, config) => {
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const contextualHelp = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.contextualHelp) ?? (schema == null ? void 0 : schema.fieldDescription);
  if (!contextualHelp) {
    return void 0;
  }
  return /* @__PURE__ */ jsxs(ContextualHelp, { variant: (contextualHelp == null ? void 0 : contextualHelp.variant) === "help" ? "help" : "info", children: [
    (contextualHelp == null ? void 0 : contextualHelp.title) && /* @__PURE__ */ jsx(Heading, { children: contextualHelp == null ? void 0 : contextualHelp.title }),
    /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: (schema == null ? void 0 : schema.fieldDescription) ?? (contextualHelp == null ? void 0 : contextualHelp.content) }) })
  ] });
};
const InputBooleanButton = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const autoFocus = !!appliedUiSchemaOptions.focus;
    let [isSelected, setSelected] = React__default.useState(data ?? (schema == null ? void 0 : schema.default) ?? false);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    React__default.useEffect(() => {
      handleChange(path, isSelected);
    }, [isSelected]);
    return /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          "aria-label": label ? void 0 : path,
          autoFocus,
          id,
          isDisabled: enabled === void 0 ? false : !enabled,
          isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isSelected,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          onChange: setSelected,
          staticColor: appliedUiSchemaOptions.staticColor ?? false,
          width: width2,
          ...dataEditorPath(path),
          children: label
        }
      ),
      appliedUiSchemaOptions.description ? /* @__PURE__ */ jsx("div", { style: { fontStyle: "italic" }, children: appliedUiSchemaOptions.description }) : null,
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const InputCheckbox = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    let [isSelected, setSelected] = React__default.useState(data ?? (schema == null ? void 0 : schema.default) ?? false);
    React__default.useEffect(() => {
      handleChange(path, isSelected);
    }, [isSelected]);
    return /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx(
        Checkbox,
        {
          autoFocus: appliedUiSchemaOptions.focus,
          id,
          isDisabled: enabled === void 0 ? false : !enabled,
          isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
          isRequired: required,
          isSelected,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          onChange: setSelected,
          validationState: isValid ? "valid" : "invalid",
          value: data ?? (schema == null ? void 0 : schema.default),
          width: width2,
          ...dataEditorPath(path),
          children: label
        }
      ),
      appliedUiSchemaOptions.description ? /* @__PURE__ */ jsx("div", { style: { fontStyle: "italic" }, children: appliedUiSchemaOptions.description }) : null,
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const RenderersConfigContext = React__default.createContext({
  externalizePath: (path) => path,
  getAemCfEditorUrl: (path) => path,
  getAssetDetails: async (path, previousAssetDetails) => Object.assign({}, previousAssetDetails, { _path: path })
});
const RenderersConfigContextProvider = (props) => {
  const dku = new DetectKeyboardUser();
  React__default.useEffect(() => {
    dku.init();
  }, []);
  const value = useMemo(
    () => ({
      externalizePath: props.externalizePath,
      getAemCfEditorUrl: props.getAemCfEditorUrl,
      getAssetDetails: props.getAssetDetails
    }),
    [props.externalizePath, props.getAemCfEditorUrl, props.getAssetDetails]
  );
  return /* @__PURE__ */ jsx(RenderersConfigContext.Provider, { value, children: props.children });
};
const useRenderersConfig = () => useContext(RenderersConfigContext);
const CUSTOM_PICKER_OPEN = "customPicker:open";
const CUSTOM_PICKER_RETURN = "customPicker:return";
const ASSET_PICKER_OPEN = "assetPicker:open";
const ASSET_PICKER_RETURN = "assetPicker:return";
const INSERT_NEW_EDITABLE_COMPONENT = "insertNewEditableComponent";
const timeout = 250;
const InputContentReference = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    //   isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a, _b;
    const [videoError, setVideoError] = React__default.useState(false);
    const [loading, setLoading] = React__default.useState(true);
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const minLength = (schema == null ? void 0 : schema.minLength) ?? appliedUiSchemaOptions.minLength ?? (required ? 1 : 0);
    const maxLength = (schema == null ? void 0 : schema.maxLength) ?? appliedUiSchemaOptions.maxLength;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const format = appliedUiSchemaOptions.format ?? void 0;
    const customFormat = appliedUiSchemaOptions.customFormat ?? void 0;
    const { externalizePath, getAssetDetails } = useRenderersConfig();
    const [input, setInput] = React__default.useState((data == null ? void 0 : data._path) ?? "");
    const debouncedUpdate = React__default.useCallback(
      debounce(async (newAssetPath) => {
        const newAssetDetails = await getAssetDetails(newAssetPath, data);
        handleChange(path, newAssetDetails);
        if ({}.VITE_EDIT_MODE === "true") {
          newAssetPath && window.postMessage(`debounceUpdate:${path}`);
        }
      }, timeout),
      [handleChange, getAssetDetails, data, path]
    );
    const onChange = React__default.useCallback(
      (newAssetPath) => {
        setInput(newAssetPath ?? "");
        debouncedUpdate(newAssetPath);
      },
      [debouncedUpdate]
    );
    const acceptedMimeTypes = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.acceptedMimeTypes) ?? [];
    const previewMedia = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.previewMedia) ?? false;
    const previewMediaSuffix = typeof (data == null ? void 0 : data._path) === "string" ? (_b = data == null ? void 0 : data._path) == null ? void 0 : _b.substring(((_a = data == null ? void 0 : data._path) == null ? void 0 : _a.lastIndexOf(".")) + 1) : false;
    const rootPath = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.rootPath) ?? "/content/dam";
    const assetPickerOpen = React__default.useCallback(() => {
      const message = {
        type: ASSET_PICKER_OPEN,
        acceptedMimeTypes,
        selectedPath: data._path,
        rootPath,
        current: {
          path
        }
      };
      window.postMessage(message, "*");
    }, [path, data]);
    React__default.useEffect(() => {
      const messageHandler = (e) => {
        var _a2, _b2, _c;
        if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) === ASSET_PICKER_RETURN && ((_c = (_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.current) == null ? void 0 : _c.path) === path) {
          onChange(e.data.data);
        }
      };
      window.addEventListener("message", messageHandler);
      return () => {
        window.removeEventListener("message", messageHandler);
      };
    }, [path]);
    React__default.useEffect(() => {
      setVideoError(false);
      setLoading(true);
    }, [data == null ? void 0 : data._path]);
    return /* @__PURE__ */ jsxs(View, { width: "100%", children: [
      /* @__PURE__ */ jsxs(
        Flex,
        {
          direction: "row",
          alignItems: "stretch",
          flex: "auto inherit",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          children: [
            /* @__PURE__ */ jsx(
              TextField,
              {
                "aria-label": label ? label : "textfield",
                autoFocus: appliedUiSchemaOptions.focus,
                contextualHelp: ContextualHelpComponent(uischema, schema, config),
                description: appliedUiSchemaOptions.description ?? false,
                errorMessage: appliedUiSchemaOptions.errorMessage ?? patternErrorMessage(
                  data == null ? void 0 : data._path,
                  customFormat ?? format,
                  minLength,
                  maxLength ?? void 0
                ),
                id: id && `${id}-input`,
                inputMode: appliedUiSchemaOptions.inputMode ?? "none",
                isDisabled: enabled === void 0 ? false : !enabled,
                isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
                isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
                isRequired: required,
                label,
                labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
                labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
                maxLength: appliedUiSchemaOptions.maxLength ?? void 0,
                minLength: appliedUiSchemaOptions.minLength ?? void 0,
                necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
                onChange,
                pattern: appliedUiSchemaOptions.pattern ?? customFormat ?? format ?? void 0,
                type: appliedUiSchemaOptions.format ?? "text",
                validationState: "valid",
                value: input,
                width: width2,
                ...dataEditorPath(path)
              }
            ),
            /* @__PURE__ */ jsx(
              ActionButton,
              {
                onPress: assetPickerOpen,
                "aria-label": "Asset Picker",
                UNSAFE_className: "assetpicker-button",
                marginTop: label ? "size-300" : "size-0",
                children: /* @__PURE__ */ jsx(Asset, { size: "S" })
              }
            )
          ]
        }
      ),
      previewMedia ? previewMediaSuffix === "mp4" || previewMediaSuffix === "ogg" || previewMediaSuffix === "webm" ? /* @__PURE__ */ jsxs(
        "video",
        {
          controls: videoError ? false : true,
          src: externalizePath == null ? void 0 : externalizePath(data == null ? void 0 : data._path),
          width: 200,
          style: { marginTop: 10 },
          onError: () => setVideoError(true),
          poster: videoError ? "https://jenkinselite.com/wp-content/uploads/2018/11/no_media.png" : void 0,
          children: [
            'Sorry, but the Media "',
            data == null ? void 0 : data._path,
            `" couldn't be displayed.`
          ]
        }
      ) : /* @__PURE__ */ jsxs(Fragment, { children: [
        /* @__PURE__ */ jsx(
          "div",
          {
            style: {
              display: loading ? "flex" : "none",
              height: "100%",
              width: "200px",
              justifyContent: "center",
              alignItems: "center",
              paddingTop: "8px"
            },
            children: /* @__PURE__ */ jsx(LoadingSpinner, {})
          }
        ),
        /* @__PURE__ */ jsx(
          "img",
          {
            src: externalizePath == null ? void 0 : externalizePath(data == null ? void 0 : data._path),
            alt: `Preview of ${data == null ? void 0 : data._path}`,
            width: 200,
            style: { marginTop: 10, display: loading ? "none" : "block" },
            onError: (e) => {
              e.currentTarget.src = "https://jenkinselite.com/wp-content/uploads/2018/11/no_media.png";
            },
            onLoad: () => setLoading(false)
          }
        )
      ] }) : null
    ] });
  }
);
const styles = "";
const SpectrumProvider = (props) => {
  const { children } = props;
  const parentProvider = useProvider();
  const theme = parentProvider ? parentProvider.theme : defaultTheme;
  return /* @__PURE__ */ jsx(Provider, { ...props, theme, id: "SpectrumInputControlProvider", children });
};
const calculateLimit$1 = (value) => {
  if (value === "today") {
    return today(getLocalTimeZone());
  } else if (value) {
    return parseDate(value);
  }
};
const InputDate = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = appliedUiSchemaOptions.maxValue;
    let minValue = appliedUiSchemaOptions.minValue;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const onChange = React__default.useCallback(
      (calendarDate) => {
        handleChange(path, calendarDate.toString());
      },
      [handleChange, path]
    );
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(SpectrumProvider, { width: width2, locale: appliedUiSchemaOptions.locale ?? "gregory", children: /* @__PURE__ */ jsx(
      DatePicker,
      {
        "aria-label": label ?? "Date picker",
        autoFocus: appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(calculateLimit$1(minValue), calculateLimit$1(maxValue)),
        granularity: "day",
        hideTimeZone: appliedUiSchemaOptions.hideTimeZone ?? true,
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        maxValue: calculateLimit$1(maxValue),
        maxVisibleMonths: appliedUiSchemaOptions.maxVisibleMonths ?? 1,
        maxWidth: "100%",
        minValue: calculateLimit$1(minValue),
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        showFormatHelpText: appliedUiSchemaOptions.showFormatHelpText ?? false,
        value: data ? parseDate(data) : null,
        width: width2,
        ...dataEditorPath(path)
      }
    ) });
  }
);
const calculateLimit = (value, suffix) => {
  if (value === "now") {
    return now(getLocalTimeZone());
  } else if ((value == null ? void 0 : value.length) > 10) {
    return parseAbsoluteToLocal(value);
  } else if ((value == null ? void 0 : value.length) === 10) {
    return parseDateTime(value + suffix);
  } else {
    return void 0;
  }
};
const calculateMin = (value) => calculateLimit(value, "T00:00:00");
const calculateMax = (value) => calculateLimit(value, "T23:59:59");
const InputDateTime = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = appliedUiSchemaOptions.maxValue;
    let minValue = appliedUiSchemaOptions.minValue;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const onChange = React__default.useCallback(
      (zonedDateTime) => {
        handleChange(
          path,
          toZoned(zonedDateTime, getLocalTimeZone()).toString().replace(/\[.*\]$/, "")
        );
      },
      [handleChange, path]
    );
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        if (schema.default === "now") {
          onChange(now(getLocalTimeZone()));
        } else {
          handleChange(path, schema.default);
        }
      }
    }, [schema == null ? void 0 : schema.default]);
    let value = null;
    if (data) {
      try {
        value = parseAbsoluteToLocal(data);
      } catch (error) {
        console.warn(error);
      }
    }
    return /* @__PURE__ */ jsx(SpectrumProvider, { width: width2, locale: appliedUiSchemaOptions.locale ?? "gregory", children: /* @__PURE__ */ jsx(
      DatePicker,
      {
        "aria-label": label ?? "DateTime",
        autoFocus: (uischema == null ? void 0 : uischema.options) && ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.focus),
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(calculateMin(minValue), calculateMax(maxValue)),
        granularity: appliedUiSchemaOptions.granularity ?? "minute",
        hideTimeZone: appliedUiSchemaOptions.hideTimeZone ?? true,
        hourCycle: appliedUiSchemaOptions.hourCycle,
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        maxValue: calculateMin(minValue),
        maxVisibleMonths: appliedUiSchemaOptions.maxVisibleMonths ?? 1,
        minValue: calculateMax(maxValue),
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        showFormatHelpText: appliedUiSchemaOptions.showFormatHelpText ?? false,
        value,
        width: width2,
        ...dataEditorPath(path)
      }
    ) });
  }
);
const SpectrumObjectRenderer = ({
  cells,
  enabled,
  label,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas = [],
  visible
}) => {
  const detailUiSchema = findUISchema(
    uischemas,
    schema,
    uischema.scope,
    path,
    "Group",
    uischema,
    rootSchema
  );
  if (isEmpty(path)) {
    detailUiSchema.type = "VerticalLayout";
  } else {
    detailUiSchema.label = startCase(label);
  }
  return /* @__PURE__ */ jsx(
    JsonFormsDispatch,
    {
      cells,
      enabled,
      path,
      renderers,
      schema,
      uischema: detailUiSchema,
      visible
    }
  );
};
const SpectrumObjectControlTester = rankWith(2, isObjectControl);
const SpectrumObjectRenderer$1 = withJsonFormsDetailProps(withHandleChange(SpectrumObjectRenderer));
const AddItemButton = ({
  path,
  addItemHandler
}) => {
  return /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
    /* @__PURE__ */ jsx(
      ActionButton,
      {
        onPress: addItemHandler,
        isQuiet: true,
        "aria-label": "add a new item",
        UNSAFE_className: "add-item",
        ...dataEditorPath(`addItem-${path}`),
        children: /* @__PURE__ */ jsx(Add, { "aria-label": "Add a new Item", size: "L" })
      }
    ),
    /* @__PURE__ */ jsx(Tooltip, { children: "Add a new Item" })
  ] });
};
const buttonUpStyle = { position: "absolute", marginTop: "-5px" };
const buttonDownStyle = { position: "absolute", marginTop: "15px" };
const SortButtons = React__default.memo(
  ({
    autoFocus,
    dataLength,
    disabled,
    grabbedIndex,
    index,
    move,
    path,
    upOrDown
  }) => {
    const userIsOnMobileDevice = checkIfUserIsOnMobileDevice(
      navigator.userAgent.toLowerCase()
    );
    React__default.useEffect(() => {
      if (autoFocus) {
        const button = document.getElementById(`${path}_${grabbedIndex}_${upOrDown}_button`);
        if (button) {
          button.focus();
        }
      }
    }, [autoFocus]);
    const moveUp = React__default.useCallback(() => move("up", index), [move, index]);
    const moveDown = React__default.useCallback(() => move("down", index), [move, index]);
    return /* @__PURE__ */ jsxs(Flex, { direction: "column", children: [
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            id: `${path}_${index}_up_button`,
            isQuiet: true,
            onPress: moveUp,
            "aria-label": `move-item-${path}.${index}-up`,
            marginX: "size-10",
            UNSAFE_style: buttonUpStyle,
            UNSAFE_className: `${userIsOnMobileDevice ? "arrow-icon" : null} ${index <= 0 || disabled ? "disabledMovement" : null}`,
            isDisabled: index <= 0 || disabled,
            height: "size-325",
            children: /* @__PURE__ */ jsx(ArrowUp, { "aria-label": "ArrowUp", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: "Move upwards" })
      ] }),
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            id: `${path}_${index}_down_button`,
            isQuiet: true,
            onPress: moveDown,
            "aria-label": `move-item-${path}.${index}-down`,
            marginX: "size-10",
            UNSAFE_style: buttonDownStyle,
            UNSAFE_className: `${userIsOnMobileDevice ? "arrow-icon" : null} ${index >= dataLength - 1 || disabled ? "disabledMovement" : ""}`,
            isDisabled: index >= dataLength - 1 || disabled,
            height: "size-325",
            children: /* @__PURE__ */ jsx(ArrowDown, { "aria-label": "ArrowDown", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: "Move downwards" })
      ] })
    ] });
  }
);
const SortIcons = React__default.memo(
  ({
    dataLength,
    disabled,
    grabbedIndex,
    index,
    keyboardClass,
    move,
    onBlur,
    onFocus,
    onKeyDown,
    onMouseEnter,
    onMouseLeave,
    onTouchMove,
    path,
    sortableHandleRef,
    uischema,
    upOrDown,
    onGrab
  }) => {
    var _a;
    const sortMode = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.sortMode) ?? "DragAndDrop";
    const isKeyboardUser = document.documentElement.classList.contains("keyboard-user");
    React__default.useEffect(() => {
      if (isKeyboardUser && grabbedIndex === index) {
        const button = document.getElementById(`${path}_${grabbedIndex}_button`);
        if (button) {
          button.focus();
        }
      }
    }, [isKeyboardUser, grabbedIndex]);
    const onFocusCallback = React__default.useCallback(() => onFocus(index), [onFocus, index]);
    const onKeyDownCallback = React__default.useCallback(
      (e) => onKeyDown(e, index),
      [onKeyDown, index]
    );
    const onMouseEnterCallback = React__default.useCallback(
      () => onMouseEnter(index),
      [onMouseEnter, index]
    );
    const onTouchMoveCallback = React__default.useCallback(() => onTouchMove(index), [onTouchMove, index]);
    return /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx(Divider, { orientation: "vertical", size: "M", marginStart: "size-100" }),
      sortMode === "arrows" ? /* @__PURE__ */ jsx(
        "div",
        {
          className: `arrowContainer grabbable ${disabled ? "disabledMovement" : ""}`,
          onBlur,
          onFocus: onFocusCallback,
          onKeyDown: onKeyDownCallback,
          onKeyUp: onKeyDownCallback,
          onMouseEnter: onMouseEnterCallback,
          onMouseLeave,
          onTouchMove: onTouchMoveCallback,
          ref: sortableHandleRef,
          children: /* @__PURE__ */ jsx(
            SortButtons,
            {
              autoFocus: isKeyboardUser && grabbedIndex === index,
              dataLength,
              disabled,
              grabbedIndex,
              index,
              move,
              path,
              uischema,
              upOrDown
            }
          )
        }
      ) : /* @__PURE__ */ jsxs(
        "button",
        {
          disabled,
          ref: sortableHandleRef,
          id: `${path}_${index}_button`,
          className: `grabbable ${disabled ? "disabledMovement" : ""}`,
          onFocus: onFocusCallback,
          onBlur: isKeyboardUser ? onBlur : void 0,
          onMouseEnter: onMouseEnterCallback,
          onMouseLeave,
          onMouseDown: () => onGrab(index),
          onMouseUp: () => onGrab(null),
          onTouchMove: onTouchMoveCallback,
          onKeyDown: onKeyDownCallback,
          children: [
            /* @__PURE__ */ jsx(
              ArrowUp,
              {
                "aria-label": "Arrow Up",
                size: "S",
                alignSelf: "center",
                width: "100%",
                UNSAFE_className: keyboardClass === "keyboardUp" && index === grabbedIndex ? "keyboard-movement" : "keyboard-user"
              }
            ),
            /* @__PURE__ */ jsx(
              ArrowDown,
              {
                "aria-label": "Arrow Down",
                size: "S",
                alignSelf: "center",
                width: "100%",
                UNSAFE_className: keyboardClass === "keyboardDown" && index === grabbedIndex ? "keyboard-movement" : "keyboard-user"
              }
            ),
            /* @__PURE__ */ jsx(
              DragHandle,
              {
                "aria-label": "Drag and Drop Handle",
                size: "L",
                alignSelf: "center",
                width: "100%",
                UNSAFE_className: "mouse-drag-handle"
              }
            )
          ]
        }
      )
    ] });
  }
);
let indexOfFittingSchemaObject = {};
function swap(array, moveIndex, toIndex) {
  const item = array[moveIndex];
  const length = array.length;
  const diff = moveIndex - toIndex;
  if (diff > 0) {
    return [
      ...array.slice(0, toIndex),
      item,
      ...array.slice(toIndex, moveIndex),
      ...array.slice(moveIndex + 1, length)
    ];
  } else if (diff < 0) {
    const targetIndex = toIndex + 1;
    return [
      ...array.slice(0, moveIndex),
      ...array.slice(moveIndex + 1, targetIndex),
      item,
      ...array.slice(targetIndex, length)
    ];
  }
  return array;
}
function clamp(number, lower, upper) {
  number = +number;
  lower = +lower;
  upper = +upper;
  lower = lower === lower ? lower : 0;
  upper = upper === upper ? upper : 0;
  if (number === number) {
    number = number <= upper ? number : upper;
    number = number >= lower ? number : lower;
  }
  return number;
}
const getTextAreaLabel = (textAreaObject, uischema) => {
  var _a;
  if (typeof ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.detail) !== "object") {
    return null;
  }
  const tempEl = document.createElement("div");
  tempEl.innerHTML = textAreaObject == null ? void 0 : textAreaObject.html;
  const firstElement = tempEl.firstChild;
  const firstText = firstElement == null ? void 0 : firstElement.firstChild;
  return firstText == null ? void 0 : firstText.textContent;
};
const SpectrumItemHeader = ({
  childData,
  childLabel,
  customPickerEnabled,
  duplicateItem,
  enableDetailedView,
  expanded,
  index = 0,
  isDetailedViewHeader,
  jsonFormsDispatch,
  path,
  removeItem,
  replaceItem,
  setExpanded,
  uischema,
  sortableHandleProps
}) => {
  var _a, _b, _c, _d, _e, _f, _g;
  const sortableHandle = React__default.useMemo(
    () => /* @__PURE__ */ jsx(
      SortIcons,
      {
        dataLength: sortableHandleProps.dataLength,
        disabled: sortableHandleProps.disabled,
        grabbedIndex: sortableHandleProps.grabbedIndex,
        index,
        keyboardClass: sortableHandleProps.keyboardClass,
        move: sortableHandleProps.move,
        onBlur: sortableHandleProps.onBlur,
        onFocus: sortableHandleProps.onFocus,
        onKeyDown: sortableHandleProps.onKeyDown,
        onMouseEnter: sortableHandleProps.onMouseEnter,
        onMouseLeave: sortableHandleProps.onMouseLeave,
        onTouchMove: sortableHandleProps.onTouchMove,
        path,
        sortableHandleRef: sortableHandleProps.sortableHandleRef,
        uischema,
        upOrDown: sortableHandleProps.upOrDown,
        onGrab: sortableHandleProps.setGrabbedIndex
      }
    ),
    [sortableHandleProps, index, path, uischema]
  );
  const { getAemCfEditorUrl } = useRenderersConfig();
  const [deleteModalOpen, setDeleteModalOpen] = React__default.useState(false);
  const replaceActionHandler = React__default.useCallback(() => {
    replaceItem(index);
  }, [index]);
  const showItemNumber = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.showItemNumber) ?? false;
  const pathFilter = (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.pathFilter;
  const aemPath = childData == null ? void 0 : childData._path;
  let displayPath = "";
  if (typeof pathFilter === "string") {
    displayPath = (aemPath == null ? void 0 : aemPath.replace(pathFilter, "")) || "";
  } else {
    displayPath = (aemPath == null ? void 0 : aemPath.split("/").slice(3).join("/")) || "";
    if (displayPath) {
      displayPath = `/${displayPath}`;
    }
  }
  const [durationBeforeDelete, setDurationBeforeDelete] = React__default.useState(0);
  const onPressStartHandler = () => {
    if (expanded) {
      setExpanded(false, enableDetailedView);
      setDurationBeforeDelete(700);
    }
  };
  const onPressEndHandler = () => {
    setDeleteModalOpen(false);
    setTimeout(() => {
      removeItem(index);
    }, durationBeforeDelete);
  };
  const aemUrl = getAemCfEditorUrl ? getAemCfEditorUrl(aemPath) : void 0;
  const actionMenuItems = React__default.useMemo(
    () => [
      { key: "delete", name: "Remove", icon: /* @__PURE__ */ jsx(Delete, { size: "S" }) },
      duplicateItem && { key: "duplicate", name: "Duplicate", icon: /* @__PURE__ */ jsx(Duplicate, { size: "S" }) },
      aemPath && aemUrl && { key: "openaem", name: "Open in AEM", icon: /* @__PURE__ */ jsx(OpenIn, { size: "S" }) }
    ],
    [duplicateItem]
  );
  const actionMenuTriggered = React__default.useCallback(
    (key) => {
      switch (key) {
        case "delete":
          setDeleteModalOpen(true);
          break;
        case "duplicate":
          duplicateItem && duplicateItem(index);
          break;
        case "openaem":
          window.open(aemUrl, "_blank");
      }
    },
    [setDeleteModalOpen, duplicateItem, index]
  );
  const imageSrc = typeof ((_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.dataAsImage) === "number" && childData ? Object.values(childData)[(_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.dataAsImage] : findValue(childData, (_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.dataAsImage) ?? void 0;
  const itemPathStyle = {
    position: "absolute",
    direction: "rtl",
    opacity: 0.7,
    bottom: -8,
    left: 0,
    fontSize: "12px",
    height: 18,
    textOverflow: "ellipsis",
    overflow: "hidden",
    whiteSpace: "nowrap"
  };
  return /* @__PURE__ */ jsx(
    View,
    {
      "aria-selected": expanded,
      UNSAFE_className: "spectrum-array-item-header",
      UNSAFE_style: expanded ? { zIndex: 50 } : {},
      children: /* @__PURE__ */ jsxs(Flex, { direction: "row", margin: "size-50", justifyContent: "space-between", alignItems: "center", children: [
        showItemNumber && /* @__PURE__ */ jsx(View, { UNSAFE_className: "spectrum-array-item-number", children: /* @__PURE__ */ jsx(Text, { children: index + 1 }) }),
        imageSrc && /* @__PURE__ */ jsx(
          "img",
          {
            src: imageSrc,
            height: isDetailedViewHeader ? "45" : "50",
            alt: "Preview Picture",
            className: "spectrum-array-item-preview-image",
            style: {
              marginTop: isDetailedViewHeader ? "10px" : "0px"
            }
          }
        ),
        ((_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.noAccordion) ? /* @__PURE__ */ jsx(View, { UNSAFE_className: "jsonforms-dispatch-container", children: jsonFormsDispatch }) : /* @__PURE__ */ jsxs(
          ActionButton,
          {
            flex: "1 1 auto",
            isQuiet: true,
            onPress: () => setExpanded(!expanded, enableDetailedView),
            "aria-label": `expand-item-${childLabel}`,
            ...dataEditorPath(`${path}.${index}`),
            children: [
              aemPath && displayPath ? /* @__PURE__ */ jsxs(Text, { UNSAFE_style: itemPathStyle, UNSAFE_className: "spectrum-array-item-path", children: [
                "‎",
                displayPath
              ] }) : null,
              /* @__PURE__ */ jsx(
                Text,
                {
                  UNSAFE_className: "spectrum-array-item-name",
                  UNSAFE_style: {
                    transform: aemPath && displayPath ? "translateY(-20%)" : ""
                  },
                  children: childLabel
                }
              )
            ]
          }
        ),
        /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsxs(Flex, { gap: "size-0", children: [
          /* @__PURE__ */ jsx(
            ActionMenu,
            {
              align: "end",
              items: actionMenuItems,
              onAction: actionMenuTriggered,
              isQuiet: true,
              children: (item) => /* @__PURE__ */ jsxs(Item, { textValue: `${item == null ? void 0 : item.name}-item-${childLabel}`, children: [
                /* @__PURE__ */ jsx(Text, { children: item == null ? void 0 : item.name }),
                (item == null ? void 0 : item.icon) ?? null
              ] }, item == null ? void 0 : item.key)
            }
          ),
          customPickerEnabled && /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
            /* @__PURE__ */ jsx(
              ActionButton,
              {
                onPress: replaceActionHandler,
                isQuiet: true,
                "aria-label": `change-reference-${childLabel}`,
                children: /* @__PURE__ */ jsx(FolderSearch, { "aria-label": "Change Reference", size: "S" })
              }
            ),
            /* @__PURE__ */ jsx(Tooltip, { children: "Change Content Fragment Reference" })
          ] }),
          ((_g = uischema == null ? void 0 : uischema.options) == null ? void 0 : _g.noAccordion) ? null : /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
            /* @__PURE__ */ jsx(
              ActionButton,
              {
                onPress: () => setExpanded(!expanded, enableDetailedView),
                isQuiet: true,
                "aria-label": `expand-item-${childLabel}`,
                ...dataEditorPath(`${path}.${index}-iconButton`),
                children: expanded ? enableDetailedView ? /* @__PURE__ */ jsx(Close, { "aria-label": "Close", size: "S" }) : /* @__PURE__ */ jsx(ChevronUp, { "aria-label": "Collapse", size: "S" }) : enableDetailedView ? /* @__PURE__ */ jsx(Edit, { "aria-label": "Edit", size: "S" }) : /* @__PURE__ */ jsx(ChevronDown, { "aria-label": "Expand", size: "S" })
              }
            ),
            /* @__PURE__ */ jsx(Tooltip, { children: expanded ? enableDetailedView ? "Close" : "Collapse" : enableDetailedView ? "Edit" : "Expand" })
          ] }),
          sortableHandle && (!enableDetailedView || enableDetailedView && !expanded) && /* @__PURE__ */ jsx(Fragment, { children: sortableHandle }),
          /* @__PURE__ */ jsx(
            DeleteDialog,
            {
              deleteModalOpen,
              onPressEndHandler: () => onPressEndHandler(),
              onPressStartHandler: () => onPressStartHandler(),
              setDeleteModalOpen
            }
          )
        ] }) })
      ] })
    }
  );
};
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function commonjsRequire(path) {
  throw new Error('Could not dynamically require "' + path + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}
var jsonata$1 = { exports: {} };
(function(module, exports) {
  (function(f) {
    {
      module.exports = f();
    }
  })(function() {
    return function() {
      function r(e, n, t) {
        function o(i2, f) {
          if (!n[i2]) {
            if (!e[i2]) {
              var c = "function" == typeof commonjsRequire && commonjsRequire;
              if (!f && c)
                return c(i2, true);
              if (u)
                return u(i2, true);
              var a = new Error("Cannot find module '" + i2 + "'");
              throw a.code = "MODULE_NOT_FOUND", a;
            }
            var p = n[i2] = { exports: {} };
            e[i2][0].call(p.exports, function(r2) {
              var n2 = e[i2][1][r2];
              return o(n2 || r2);
            }, p, p.exports, r, e, n, t);
          }
          return n[i2].exports;
        }
        for (var u = "function" == typeof commonjsRequire && commonjsRequire, i = 0; i < t.length; i++)
          o(t[i]);
        return o;
      }
      return r;
    }()({ 1: [function(require2, module2, exports2) {
      const utils = require2("./utils");
      const dateTime = function() {
        const stringToArray = utils.stringToArray;
        const few = [
          "Zero",
          "One",
          "Two",
          "Three",
          "Four",
          "Five",
          "Six",
          "Seven",
          "Eight",
          "Nine",
          "Ten",
          "Eleven",
          "Twelve",
          "Thirteen",
          "Fourteen",
          "Fifteen",
          "Sixteen",
          "Seventeen",
          "Eighteen",
          "Nineteen"
        ];
        const ordinals = [
          "Zeroth",
          "First",
          "Second",
          "Third",
          "Fourth",
          "Fifth",
          "Sixth",
          "Seventh",
          "Eighth",
          "Ninth",
          "Tenth",
          "Eleventh",
          "Twelfth",
          "Thirteenth",
          "Fourteenth",
          "Fifteenth",
          "Sixteenth",
          "Seventeenth",
          "Eighteenth",
          "Nineteenth"
        ];
        const decades = ["Twenty", "Thirty", "Forty", "Fifty", "Sixty", "Seventy", "Eighty", "Ninety", "Hundred"];
        const magnitudes = ["Thousand", "Million", "Billion", "Trillion"];
        function numberToWords(value, ordinal) {
          var lookup = function(num, prev, ord) {
            var words2 = "";
            if (num <= 19) {
              words2 = (prev ? " and " : "") + (ord ? ordinals[num] : few[num]);
            } else if (num < 100) {
              const tens = Math.floor(num / 10);
              const remainder = num % 10;
              words2 = (prev ? " and " : "") + decades[tens - 2];
              if (remainder > 0) {
                words2 += "-" + lookup(remainder, false, ord);
              } else if (ord) {
                words2 = words2.substring(0, words2.length - 1) + "ieth";
              }
            } else if (num < 1e3) {
              const hundreds = Math.floor(num / 100);
              const remainder = num % 100;
              words2 = (prev ? ", " : "") + few[hundreds] + " Hundred";
              if (remainder > 0) {
                words2 += lookup(remainder, true, ord);
              } else if (ord) {
                words2 += "th";
              }
            } else {
              var mag = Math.floor(Math.log10(num) / 3);
              if (mag > magnitudes.length) {
                mag = magnitudes.length;
              }
              const factor = Math.pow(10, mag * 3);
              const mant = Math.floor(num / factor);
              const remainder = num - mant * factor;
              words2 = (prev ? ", " : "") + lookup(mant, false, false) + " " + magnitudes[mag - 1];
              if (remainder > 0) {
                words2 += lookup(remainder, true, ord);
              } else if (ord) {
                words2 += "th";
              }
            }
            return words2;
          };
          var words = lookup(value, false, ordinal);
          return words;
        }
        const wordValues = {};
        few.forEach(function(word, index) {
          wordValues[word.toLowerCase()] = index;
        });
        ordinals.forEach(function(word, index) {
          wordValues[word.toLowerCase()] = index;
        });
        decades.forEach(function(word, index) {
          const lword = word.toLowerCase();
          wordValues[lword] = (index + 2) * 10;
          wordValues[lword.substring(0, word.length - 1) + "ieth"] = wordValues[lword];
        });
        wordValues.hundredth = 100;
        magnitudes.forEach(function(word, index) {
          const lword = word.toLowerCase();
          const val = Math.pow(10, (index + 1) * 3);
          wordValues[lword] = val;
          wordValues[lword + "th"] = val;
        });
        function wordsToNumber(text) {
          const parts = text.split(/,\s|\sand\s|[\s\\-]/);
          const values = parts.map((part) => wordValues[part]);
          let segs = [0];
          values.forEach((value) => {
            if (value < 100) {
              let top = segs.pop();
              if (top >= 1e3) {
                segs.push(top);
                top = 0;
              }
              segs.push(top + value);
            } else {
              segs.push(segs.pop() * value);
            }
          });
          const result = segs.reduce((a, b) => a + b, 0);
          return result;
        }
        const romanNumerals = [
          [1e3, "m"],
          [900, "cm"],
          [500, "d"],
          [400, "cd"],
          [100, "c"],
          [90, "xc"],
          [50, "l"],
          [40, "xl"],
          [10, "x"],
          [9, "ix"],
          [5, "v"],
          [4, "iv"],
          [1, "i"]
        ];
        const romanValues = { "M": 1e3, "D": 500, "C": 100, "L": 50, "X": 10, "V": 5, "I": 1 };
        function decimalToRoman(value) {
          for (var index = 0; index < romanNumerals.length; index++) {
            const numeral = romanNumerals[index];
            if (value >= numeral[0]) {
              return numeral[1] + decimalToRoman(value - numeral[0]);
            }
          }
          return "";
        }
        function romanToDecimal(roman) {
          var decimal = 0;
          var max = 1;
          for (var i = roman.length - 1; i >= 0; i--) {
            const digit = roman[i];
            const value = romanValues[digit];
            if (value < max) {
              decimal -= value;
            } else {
              max = value;
              decimal += value;
            }
          }
          return decimal;
        }
        function decimalToLetters(value, aChar) {
          var letters = [];
          var aCode = aChar.charCodeAt(0);
          while (value > 0) {
            letters.unshift(String.fromCharCode((value - 1) % 26 + aCode));
            value = Math.floor((value - 1) / 26);
          }
          return letters.join("");
        }
        function lettersToDecimal(letters, aChar) {
          var aCode = aChar.charCodeAt(0);
          var decimal = 0;
          for (var i = 0; i < letters.length; i++) {
            decimal += (letters.charCodeAt(letters.length - i - 1) - aCode + 1) * Math.pow(26, i);
          }
          return decimal;
        }
        function formatInteger(value, picture) {
          if (typeof value === "undefined") {
            return void 0;
          }
          value = Math.floor(value);
          const format = analyseIntegerPicture(picture);
          return _formatInteger(value, format);
        }
        const formats = {
          DECIMAL: "decimal",
          LETTERS: "letters",
          ROMAN: "roman",
          WORDS: "words",
          SEQUENCE: "sequence"
        };
        const tcase = {
          UPPER: "upper",
          LOWER: "lower",
          TITLE: "title"
        };
        function _formatInteger(value, format) {
          let formattedInteger;
          const negative = value < 0;
          value = Math.abs(value);
          switch (format.primary) {
            case formats.LETTERS:
              formattedInteger = decimalToLetters(value, format.case === tcase.UPPER ? "A" : "a");
              break;
            case formats.ROMAN:
              formattedInteger = decimalToRoman(value);
              if (format.case === tcase.UPPER) {
                formattedInteger = formattedInteger.toUpperCase();
              }
              break;
            case formats.WORDS:
              formattedInteger = numberToWords(value, format.ordinal);
              if (format.case === tcase.UPPER) {
                formattedInteger = formattedInteger.toUpperCase();
              } else if (format.case === tcase.LOWER) {
                formattedInteger = formattedInteger.toLowerCase();
              }
              break;
            case formats.DECIMAL:
              formattedInteger = "" + value;
              var padLength = format.mandatoryDigits - formattedInteger.length;
              if (padLength > 0) {
                var padding = new Array(padLength + 1).join("0");
                formattedInteger = padding + formattedInteger;
              }
              if (format.zeroCode !== 48) {
                formattedInteger = stringToArray(formattedInteger).map((code) => {
                  return String.fromCodePoint(code.codePointAt(0) + format.zeroCode - 48);
                }).join("");
              }
              if (format.regular) {
                const n = Math.floor((formattedInteger.length - 1) / format.groupingSeparators.position);
                for (let ii = n; ii > 0; ii--) {
                  const pos = formattedInteger.length - ii * format.groupingSeparators.position;
                  formattedInteger = formattedInteger.substr(0, pos) + format.groupingSeparators.character + formattedInteger.substr(pos);
                }
              } else {
                format.groupingSeparators.reverse().forEach((separator) => {
                  const pos = formattedInteger.length - separator.position;
                  formattedInteger = formattedInteger.substr(0, pos) + separator.character + formattedInteger.substr(pos);
                });
              }
              if (format.ordinal) {
                var suffix123 = { "1": "st", "2": "nd", "3": "rd" };
                var lastDigit = formattedInteger[formattedInteger.length - 1];
                var suffix = suffix123[lastDigit];
                if (!suffix || formattedInteger.length > 1 && formattedInteger[formattedInteger.length - 2] === "1") {
                  suffix = "th";
                }
                formattedInteger = formattedInteger + suffix;
              }
              break;
            case formats.SEQUENCE:
              throw {
                code: "D3130",
                value: format.token
              };
          }
          if (negative) {
            formattedInteger = "-" + formattedInteger;
          }
          return formattedInteger;
        }
        const decimalGroups = [48, 1632, 1776, 1984, 2406, 2534, 2662, 2790, 2918, 3046, 3174, 3302, 3430, 3558, 3664, 3792, 3872, 4160, 4240, 6112, 6160, 6470, 6608, 6784, 6800, 6992, 7088, 7232, 7248, 42528, 43216, 43264, 43472, 43504, 43600, 44016, 65296];
        function analyseIntegerPicture(picture) {
          const format = {
            type: "integer",
            primary: formats.DECIMAL,
            case: tcase.LOWER,
            ordinal: false
          };
          let primaryFormat, formatModifier;
          const semicolon = picture.lastIndexOf(";");
          if (semicolon === -1) {
            primaryFormat = picture;
          } else {
            primaryFormat = picture.substring(0, semicolon);
            formatModifier = picture.substring(semicolon + 1);
            if (formatModifier[0] === "o") {
              format.ordinal = true;
            }
          }
          switch (primaryFormat) {
            case "A":
              format.case = tcase.UPPER;
            case "a":
              format.primary = formats.LETTERS;
              break;
            case "I":
              format.case = tcase.UPPER;
            case "i":
              format.primary = formats.ROMAN;
              break;
            case "W":
              format.case = tcase.UPPER;
              format.primary = formats.WORDS;
              break;
            case "Ww":
              format.case = tcase.TITLE;
              format.primary = formats.WORDS;
              break;
            case "w":
              format.primary = formats.WORDS;
              break;
            default: {
              let zeroCode = null;
              let mandatoryDigits = 0;
              let optionalDigits = 0;
              let groupingSeparators = [];
              let separatorPosition = 0;
              const formatCodepoints = stringToArray(primaryFormat).map((c) => c.codePointAt(0)).reverse();
              formatCodepoints.forEach((codePoint) => {
                let digit = false;
                for (let ii = 0; ii < decimalGroups.length; ii++) {
                  const group = decimalGroups[ii];
                  if (codePoint >= group && codePoint <= group + 9) {
                    digit = true;
                    mandatoryDigits++;
                    separatorPosition++;
                    if (zeroCode === null) {
                      zeroCode = group;
                    } else if (group !== zeroCode) {
                      throw {
                        code: "D3131"
                      };
                    }
                    break;
                  }
                }
                if (!digit) {
                  if (codePoint === 35) {
                    separatorPosition++;
                    optionalDigits++;
                  } else {
                    groupingSeparators.push({
                      position: separatorPosition,
                      character: String.fromCodePoint(codePoint)
                    });
                  }
                }
              });
              if (mandatoryDigits > 0) {
                format.primary = formats.DECIMAL;
                format.zeroCode = zeroCode;
                format.mandatoryDigits = mandatoryDigits;
                format.optionalDigits = optionalDigits;
                const regularRepeat = function(separators) {
                  if (separators.length === 0) {
                    return 0;
                  }
                  const sepChar = separators[0].character;
                  for (let ii = 1; ii < separators.length; ii++) {
                    if (separators[ii].character !== sepChar) {
                      return 0;
                    }
                  }
                  const indexes = separators.map((separator) => separator.position);
                  const gcd = function(a, b) {
                    return b === 0 ? a : gcd(b, a % b);
                  };
                  const factor = indexes.reduce(gcd);
                  for (let index = 1; index <= indexes.length; index++) {
                    if (indexes.indexOf(index * factor) === -1) {
                      return 0;
                    }
                  }
                  return factor;
                };
                const regular = regularRepeat(groupingSeparators);
                if (regular > 0) {
                  format.regular = true;
                  format.groupingSeparators = {
                    position: regular,
                    character: groupingSeparators[0].character
                  };
                } else {
                  format.regular = false;
                  format.groupingSeparators = groupingSeparators;
                }
              } else {
                format.primary = formats.SEQUENCE;
                format.token = primaryFormat;
              }
            }
          }
          return format;
        }
        const defaultPresentationModifiers = {
          Y: "1",
          M: "1",
          D: "1",
          d: "1",
          F: "n",
          W: "1",
          w: "1",
          X: "1",
          x: "1",
          H: "1",
          h: "1",
          P: "n",
          m: "01",
          s: "01",
          f: "1",
          Z: "01:01",
          z: "01:01",
          C: "n",
          E: "n"
        };
        function analyseDateTimePicture(picture) {
          var spec = [];
          const format = {
            type: "datetime",
            parts: spec
          };
          const addLiteral = function(start2, end) {
            if (end > start2) {
              let literal = picture.substring(start2, end);
              literal = literal.split("]]").join("]");
              spec.push({ type: "literal", value: literal });
            }
          };
          var start = 0, pos = 0;
          while (pos < picture.length) {
            if (picture.charAt(pos) === "[") {
              if (picture.charAt(pos + 1) === "[") {
                addLiteral(start, pos);
                spec.push({ type: "literal", value: "[" });
                pos += 2;
                start = pos;
                continue;
              }
              addLiteral(start, pos);
              start = pos;
              pos = picture.indexOf("]", start);
              if (pos === -1) {
                throw {
                  code: "D3135"
                };
              }
              let marker = picture.substring(start + 1, pos);
              marker = marker.split(/\s+/).join("");
              var def = {
                type: "marker",
                component: marker.charAt(0)
                // 1. The component specifier is always present and is always a single letter.
              };
              var comma = marker.lastIndexOf(",");
              var presMod;
              if (comma !== -1) {
                const widthMod = marker.substring(comma + 1);
                const dash = widthMod.indexOf("-");
                let min, max;
                const parseWidth = function(wm) {
                  if (typeof wm === "undefined" || wm === "*") {
                    return void 0;
                  } else {
                    return parseInt(wm);
                  }
                };
                if (dash === -1) {
                  min = widthMod;
                } else {
                  min = widthMod.substring(0, dash);
                  max = widthMod.substring(dash + 1);
                }
                const widthDef = {
                  min: parseWidth(min),
                  max: parseWidth(max)
                };
                def.width = widthDef;
                presMod = marker.substring(1, comma);
              } else {
                presMod = marker.substring(1);
              }
              if (presMod.length === 1) {
                def.presentation1 = presMod;
              } else if (presMod.length > 1) {
                var lastChar = presMod.charAt(presMod.length - 1);
                if ("atco".indexOf(lastChar) !== -1) {
                  def.presentation2 = lastChar;
                  if (lastChar === "o") {
                    def.ordinal = true;
                  }
                  def.presentation1 = presMod.substring(0, presMod.length - 1);
                } else {
                  def.presentation1 = presMod;
                }
              } else {
                def.presentation1 = defaultPresentationModifiers[def.component];
              }
              if (typeof def.presentation1 === "undefined") {
                throw {
                  code: "D3132",
                  value: def.component
                };
              }
              if (def.presentation1[0] === "n") {
                def.names = tcase.LOWER;
              } else if (def.presentation1[0] === "N") {
                if (def.presentation1[1] === "n") {
                  def.names = tcase.TITLE;
                } else {
                  def.names = tcase.UPPER;
                }
              } else if ("YMDdFWwXxHhmsf".indexOf(def.component) !== -1) {
                var integerPattern = def.presentation1;
                if (def.presentation2) {
                  integerPattern += ";" + def.presentation2;
                }
                def.integerFormat = analyseIntegerPicture(integerPattern);
                if (def.width && def.width.min !== void 0) {
                  if (def.integerFormat.mandatoryDigits < def.width.min) {
                    def.integerFormat.mandatoryDigits = def.width.min;
                  }
                }
                if ("YMD".indexOf(def.component) !== -1) {
                  def.n = -1;
                  if (def.width && def.width.max !== void 0) {
                    def.n = def.width.max;
                    def.integerFormat.mandatoryDigits = def.n;
                  } else {
                    var w = def.integerFormat.mandatoryDigits + def.integerFormat.optionalDigits;
                    if (w >= 2) {
                      def.n = w;
                    }
                  }
                }
              }
              if (def.component === "Z" || def.component === "z") {
                def.integerFormat = analyseIntegerPicture(def.presentation1);
              }
              spec.push(def);
              start = pos + 1;
            }
            pos++;
          }
          addLiteral(start, pos);
          return format;
        }
        const days = ["", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday"];
        const months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
        const millisInADay = 1e3 * 60 * 60 * 24;
        const startOfFirstWeek = function(ym) {
          const jan1 = Date.UTC(ym.year, ym.month);
          var dayOfJan1 = new Date(jan1).getUTCDay();
          if (dayOfJan1 === 0) {
            dayOfJan1 = 7;
          }
          return dayOfJan1 > 4 ? jan1 + (8 - dayOfJan1) * millisInADay : jan1 - (dayOfJan1 - 1) * millisInADay;
        };
        const yearMonth = function(year, month) {
          return {
            year,
            month,
            nextMonth: function() {
              return month === 11 ? yearMonth(year + 1, 0) : yearMonth(year, month + 1);
            },
            previousMonth: function() {
              return month === 0 ? yearMonth(year - 1, 11) : yearMonth(year, month - 1);
            },
            nextYear: function() {
              return yearMonth(year + 1, month);
            },
            previousYear: function() {
              return yearMonth(year - 1, month);
            }
          };
        };
        const deltaWeeks = function(start, end) {
          return (end - start) / (millisInADay * 7) + 1;
        };
        const getDateTimeFragment = (date, component) => {
          let componentValue;
          switch (component) {
            case "Y":
              componentValue = date.getUTCFullYear();
              break;
            case "M":
              componentValue = date.getUTCMonth() + 1;
              break;
            case "D":
              componentValue = date.getUTCDate();
              break;
            case "d": {
              const today2 = Date.UTC(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate());
              const firstJan = Date.UTC(date.getUTCFullYear(), 0);
              componentValue = (today2 - firstJan) / millisInADay + 1;
              break;
            }
            case "F":
              componentValue = date.getUTCDay();
              if (componentValue === 0) {
                componentValue = 7;
              }
              break;
            case "W": {
              const thisYear = yearMonth(date.getUTCFullYear(), 0);
              const startOfWeek1 = startOfFirstWeek(thisYear);
              const today2 = Date.UTC(thisYear.year, date.getUTCMonth(), date.getUTCDate());
              let week = deltaWeeks(startOfWeek1, today2);
              if (week > 52) {
                const startOfFollowingYear = startOfFirstWeek(thisYear.nextYear());
                if (today2 >= startOfFollowingYear) {
                  week = 1;
                }
              } else if (week < 1) {
                const startOfPreviousYear = startOfFirstWeek(thisYear.previousYear());
                week = deltaWeeks(startOfPreviousYear, today2);
              }
              componentValue = Math.floor(week);
              break;
            }
            case "w": {
              const thisMonth = yearMonth(date.getUTCFullYear(), date.getUTCMonth());
              const startOfWeek1 = startOfFirstWeek(thisMonth);
              const today2 = Date.UTC(thisMonth.year, thisMonth.month, date.getUTCDate());
              let week = deltaWeeks(startOfWeek1, today2);
              if (week > 4) {
                const startOfFollowingMonth = startOfFirstWeek(thisMonth.nextMonth());
                if (today2 >= startOfFollowingMonth) {
                  week = 1;
                }
              } else if (week < 1) {
                const startOfPreviousMonth = startOfFirstWeek(thisMonth.previousMonth());
                week = deltaWeeks(startOfPreviousMonth, today2);
              }
              componentValue = Math.floor(week);
              break;
            }
            case "X": {
              const thisYear = yearMonth(date.getUTCFullYear(), 0);
              const startOfISOYear = startOfFirstWeek(thisYear);
              const endOfISOYear = startOfFirstWeek(thisYear.nextYear());
              const now2 = date.getTime();
              if (now2 < startOfISOYear) {
                componentValue = thisYear.year - 1;
              } else if (now2 >= endOfISOYear) {
                componentValue = thisYear.year + 1;
              } else {
                componentValue = thisYear.year;
              }
              break;
            }
            case "x": {
              const thisMonth = yearMonth(date.getUTCFullYear(), date.getUTCMonth());
              const startOfISOMonth = startOfFirstWeek(thisMonth);
              const nextMonth = thisMonth.nextMonth();
              const endOfISOMonth = startOfFirstWeek(nextMonth);
              const now2 = date.getTime();
              if (now2 < startOfISOMonth) {
                componentValue = thisMonth.previousMonth().month + 1;
              } else if (now2 >= endOfISOMonth) {
                componentValue = nextMonth.month + 1;
              } else {
                componentValue = thisMonth.month + 1;
              }
              break;
            }
            case "H":
              componentValue = date.getUTCHours();
              break;
            case "h":
              componentValue = date.getUTCHours();
              componentValue = componentValue % 12;
              if (componentValue === 0) {
                componentValue = 12;
              }
              break;
            case "P":
              componentValue = date.getUTCHours() >= 12 ? "pm" : "am";
              break;
            case "m":
              componentValue = date.getUTCMinutes();
              break;
            case "s":
              componentValue = date.getUTCSeconds();
              break;
            case "f":
              componentValue = date.getUTCMilliseconds();
              break;
            case "Z":
            case "z":
              break;
            case "C":
              componentValue = "ISO";
              break;
            case "E":
              componentValue = "ISO";
              break;
          }
          return componentValue;
        };
        let iso8601Spec = null;
        function formatDateTime(millis, picture, timezone) {
          var offsetHours = 0;
          var offsetMinutes = 0;
          if (typeof timezone !== "undefined") {
            const offset = parseInt(timezone);
            offsetHours = Math.floor(offset / 100);
            offsetMinutes = offset % 100;
          }
          var formatComponent = function(date, markerSpec) {
            var componentValue = getDateTimeFragment(date, markerSpec.component);
            if ("YMDdFWwXxHhms".indexOf(markerSpec.component) !== -1) {
              if (markerSpec.component === "Y") {
                if (markerSpec.n !== -1) {
                  componentValue = componentValue % Math.pow(10, markerSpec.n);
                }
              }
              if (markerSpec.names) {
                if (markerSpec.component === "M" || markerSpec.component === "x") {
                  componentValue = months[componentValue - 1];
                } else if (markerSpec.component === "F") {
                  componentValue = days[componentValue];
                } else {
                  throw {
                    code: "D3133",
                    value: markerSpec.component
                  };
                }
                if (markerSpec.names === tcase.UPPER) {
                  componentValue = componentValue.toUpperCase();
                } else if (markerSpec.names === tcase.LOWER) {
                  componentValue = componentValue.toLowerCase();
                }
                if (markerSpec.width && componentValue.length > markerSpec.width.max) {
                  componentValue = componentValue.substring(0, markerSpec.width.max);
                }
              } else {
                componentValue = _formatInteger(componentValue, markerSpec.integerFormat);
              }
            } else if (markerSpec.component === "f") {
              componentValue = _formatInteger(componentValue, markerSpec.integerFormat);
            } else if (markerSpec.component === "Z" || markerSpec.component === "z") {
              const offset = offsetHours * 100 + offsetMinutes;
              if (markerSpec.integerFormat.regular) {
                componentValue = _formatInteger(offset, markerSpec.integerFormat);
              } else {
                const numDigits = markerSpec.integerFormat.mandatoryDigits;
                if (numDigits === 1 || numDigits === 2) {
                  componentValue = _formatInteger(offsetHours, markerSpec.integerFormat);
                  if (offsetMinutes !== 0) {
                    componentValue += ":" + formatInteger(offsetMinutes, "00");
                  }
                } else if (numDigits === 3 || numDigits === 4) {
                  componentValue = _formatInteger(offset, markerSpec.integerFormat);
                } else {
                  throw {
                    code: "D3134",
                    value: numDigits
                  };
                }
              }
              if (offset >= 0) {
                componentValue = "+" + componentValue;
              }
              if (markerSpec.component === "z") {
                componentValue = "GMT" + componentValue;
              }
              if (offset === 0 && markerSpec.presentation2 === "t") {
                componentValue = "Z";
              }
            }
            return componentValue;
          };
          let formatSpec;
          if (typeof picture === "undefined") {
            if (iso8601Spec === null) {
              iso8601Spec = analyseDateTimePicture("[Y0001]-[M01]-[D01]T[H01]:[m01]:[s01].[f001][Z01:01t]");
            }
            formatSpec = iso8601Spec;
          } else {
            formatSpec = analyseDateTimePicture(picture);
          }
          const offsetMillis = (60 * offsetHours + offsetMinutes) * 60 * 1e3;
          const dateTime2 = new Date(millis + offsetMillis);
          let result = "";
          formatSpec.parts.forEach(function(part) {
            if (part.type === "literal") {
              result += part.value;
            } else {
              result += formatComponent(dateTime2, part);
            }
          });
          return result;
        }
        function generateRegex(formatSpec) {
          var matcher = {};
          if (formatSpec.type === "datetime") {
            matcher.type = "datetime";
            matcher.parts = formatSpec.parts.map(function(part) {
              var res = {};
              if (part.type === "literal") {
                res.regex = part.value.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
              } else if (part.component === "Z" || part.component === "z") {
                let separator;
                if (!Array.isArray(part.integerFormat.groupingSeparators)) {
                  separator = part.integerFormat.groupingSeparators;
                }
                res.regex = "";
                if (part.component === "z") {
                  res.regex = "GMT";
                }
                res.regex += "[-+][0-9]+";
                if (separator) {
                  res.regex += separator.character + "[0-9]+";
                }
                res.parse = function(value) {
                  if (part.component === "z") {
                    value = value.substring(3);
                  }
                  let offsetHours = 0, offsetMinutes = 0;
                  if (separator) {
                    offsetHours = Number.parseInt(value.substring(0, value.indexOf(separator.character)));
                    offsetMinutes = Number.parseInt(value.substring(value.indexOf(separator.character) + 1));
                  } else {
                    const numdigits = value.length - 1;
                    if (numdigits <= 2) {
                      offsetHours = Number.parseInt(value);
                    } else {
                      offsetHours = Number.parseInt(value.substring(0, 3));
                      offsetMinutes = Number.parseInt(value.substring(3));
                    }
                  }
                  return offsetHours * 60 + offsetMinutes;
                };
              } else if (part.integerFormat) {
                part.integerFormat.n = part.n;
                res = generateRegex(part.integerFormat);
              } else {
                res.regex = "[a-zA-Z]+";
                var lookup = {};
                if (part.component === "M" || part.component === "x") {
                  months.forEach(function(name, index) {
                    if (part.width && part.width.max) {
                      lookup[name.substring(0, part.width.max)] = index + 1;
                    } else {
                      lookup[name] = index + 1;
                    }
                  });
                } else if (part.component === "F") {
                  days.forEach(function(name, index) {
                    if (index > 0) {
                      if (part.width && part.width.max) {
                        lookup[name.substring(0, part.width.max)] = index;
                      } else {
                        lookup[name] = index;
                      }
                    }
                  });
                } else if (part.component === "P") {
                  lookup = { "am": 0, "AM": 0, "pm": 1, "PM": 1 };
                } else {
                  throw {
                    code: "D3133",
                    value: part.component
                  };
                }
                res.parse = function(value) {
                  return lookup[value];
                };
              }
              res.component = part.component;
              return res;
            });
          } else {
            matcher.type = "integer";
            const isUpper = formatSpec.case === tcase.UPPER;
            let occurrences;
            if (formatSpec.n && formatSpec.n > 0) {
              if (formatSpec.optionalDigits === 0) {
                occurrences = `{${formatSpec.n}}`;
              } else {
                occurrences = `{${formatSpec.n - formatSpec.optionalDigits},${formatSpec.n}}`;
              }
            } else {
              occurrences = "+";
            }
            switch (formatSpec.primary) {
              case formats.LETTERS:
                matcher.regex = isUpper ? "[A-Z]+" : "[a-z]+";
                matcher.parse = function(value) {
                  return lettersToDecimal(value, isUpper ? "A" : "a");
                };
                break;
              case formats.ROMAN:
                matcher.regex = isUpper ? "[MDCLXVI]+" : "[mdclxvi]+";
                matcher.parse = function(value) {
                  return romanToDecimal(isUpper ? value : value.toUpperCase());
                };
                break;
              case formats.WORDS:
                matcher.regex = "(?:" + Object.keys(wordValues).concat("and", "[\\-, ]").join("|") + ")+";
                matcher.parse = function(value) {
                  return wordsToNumber(value.toLowerCase());
                };
                break;
              case formats.DECIMAL:
                matcher.regex = `[0-9]${occurrences}`;
                if (formatSpec.ordinal) {
                  matcher.regex += "(?:th|st|nd|rd)";
                }
                matcher.parse = function(value) {
                  let digits = value;
                  if (formatSpec.ordinal) {
                    digits = value.substring(0, value.length - 2);
                  }
                  if (formatSpec.regular) {
                    digits = digits.split(",").join("");
                  } else {
                    formatSpec.groupingSeparators.forEach((sep) => {
                      digits = digits.split(sep.character).join("");
                    });
                  }
                  if (formatSpec.zeroCode !== 48) {
                    digits = digits.split("").map((char) => String.fromCodePoint(char.codePointAt(0) - formatSpec.zeroCode + 48)).join("");
                  }
                  return parseInt(digits);
                };
                break;
              case formats.SEQUENCE:
                throw {
                  code: "D3130",
                  value: formatSpec.token
                };
            }
          }
          return matcher;
        }
        function parseInteger(value, picture) {
          if (typeof value === "undefined") {
            return void 0;
          }
          const formatSpec = analyseIntegerPicture(picture);
          const matchSpec = generateRegex(formatSpec);
          const result = matchSpec.parse(value);
          return result;
        }
        function parseDateTime2(timestamp, picture) {
          const formatSpec = analyseDateTimePicture(picture);
          const matchSpec = generateRegex(formatSpec);
          const fullRegex = "^" + matchSpec.parts.map((part) => "(" + part.regex + ")").join("") + "$";
          const matcher = new RegExp(fullRegex, "i");
          var info = matcher.exec(timestamp);
          if (info !== null) {
            const dmA = 161;
            const dmB = 130;
            const dmC = 84;
            const dmD = 72;
            const tmA = 23;
            const tmB = 47;
            const components = {};
            for (let i = 1; i < info.length; i++) {
              const mpart = matchSpec.parts[i - 1];
              if (mpart.parse) {
                components[mpart.component] = mpart.parse(info[i]);
              }
            }
            if (Object.getOwnPropertyNames(components).length === 0) {
              return void 0;
            }
            let mask = 0;
            const shift = (bit) => {
              mask <<= 1;
              mask += bit ? 1 : 0;
            };
            const isType = (type) => {
              return !(~type & mask) && !!(type & mask);
            };
            "YXMxWwdD".split("").forEach((part) => shift(components[part]));
            const dateA = isType(dmA);
            const dateB = !dateA && isType(dmB);
            const dateC = isType(dmC);
            const dateD = !dateC && isType(dmD);
            mask = 0;
            "PHhmsf".split("").forEach((part) => shift(components[part]));
            const timeA = isType(tmA);
            const timeB = !timeA && isType(tmB);
            const dateComps = dateB ? "YD" : dateC ? "XxwF" : dateD ? "XWF" : "YMD";
            const timeComps = timeB ? "Phmsf" : "Hmsf";
            const comps = dateComps + timeComps;
            const now2 = this.environment.timestamp;
            let startSpecified = false;
            let endSpecified = false;
            comps.split("").forEach((part) => {
              if (typeof components[part] === "undefined") {
                if (startSpecified) {
                  components[part] = "MDd".indexOf(part) !== -1 ? 1 : 0;
                  endSpecified = true;
                } else {
                  components[part] = getDateTimeFragment(now2, part);
                }
              } else {
                startSpecified = true;
                if (endSpecified) {
                  throw {
                    code: "D3136"
                  };
                }
              }
            });
            if (components.M > 0) {
              components.M -= 1;
            } else {
              components.M = 0;
            }
            if (dateB) {
              const firstJan = Date.UTC(components.Y, 0);
              const offsetMillis = (components.d - 1) * 1e3 * 60 * 60 * 24;
              const derivedDate = new Date(firstJan + offsetMillis);
              components.M = derivedDate.getUTCMonth();
              components.D = derivedDate.getUTCDate();
            }
            if (dateC) {
              throw {
                code: "D3136"
              };
            }
            if (dateD) {
              throw {
                code: "D3136"
              };
            }
            if (timeB) {
              components.H = components.h === 12 ? 0 : components.h;
              if (components.P === 1) {
                components.H += 12;
              }
            }
            var millis = Date.UTC(components.Y, components.M, components.D, components.H, components.m, components.s, components.f);
            if (components.Z || components.z) {
              millis -= (components.Z || components.z) * 60 * 1e3;
            }
            return millis;
          }
        }
        var iso8601regex = new RegExp("^\\d{4}(-[01]\\d)*(-[0-3]\\d)*(T[0-2]\\d:[0-5]\\d:[0-5]\\d)*(\\.\\d+)?([+-][0-2]\\d:?[0-5]\\d|Z)?$");
        function toMillis(timestamp, picture) {
          if (typeof timestamp === "undefined") {
            return void 0;
          }
          if (typeof picture === "undefined") {
            if (!iso8601regex.test(timestamp)) {
              throw {
                stack: new Error().stack,
                code: "D3110",
                value: timestamp
              };
            }
            return Date.parse(timestamp);
          } else {
            return parseDateTime2.call(this, timestamp, picture);
          }
        }
        function fromMillis(millis, picture, timezone) {
          if (typeof millis === "undefined") {
            return void 0;
          }
          return formatDateTime.call(this, millis, picture, timezone);
        }
        return {
          formatInteger,
          parseInteger,
          fromMillis,
          toMillis
        };
      }();
      module2.exports = dateTime;
    }, { "./utils": 6 }], 2: [function(require2, module2, exports2) {
      (function(global2) {
        (function() {
          var utils = require2("./utils");
          const functions = (() => {
            var isNumeric = utils.isNumeric;
            var isArrayOfStrings = utils.isArrayOfStrings;
            var isArrayOfNumbers = utils.isArrayOfNumbers;
            var createSequence = utils.createSequence;
            var isSequence = utils.isSequence;
            var isFunction = utils.isFunction;
            var isLambda = utils.isLambda;
            var isPromise = utils.isPromise;
            var getFunctionArity = utils.getFunctionArity;
            var deepEquals = utils.isDeepEqual;
            var stringToArray = utils.stringToArray;
            function sum(args) {
              if (typeof args === "undefined") {
                return void 0;
              }
              var total = 0;
              args.forEach(function(num) {
                total += num;
              });
              return total;
            }
            function count(args) {
              if (typeof args === "undefined") {
                return 0;
              }
              return args.length;
            }
            function max(args) {
              if (typeof args === "undefined" || args.length === 0) {
                return void 0;
              }
              return Math.max.apply(Math, args);
            }
            function min(args) {
              if (typeof args === "undefined" || args.length === 0) {
                return void 0;
              }
              return Math.min.apply(Math, args);
            }
            function average(args) {
              if (typeof args === "undefined" || args.length === 0) {
                return void 0;
              }
              var total = 0;
              args.forEach(function(num) {
                total += num;
              });
              return total / args.length;
            }
            function string(arg, prettify = false) {
              if (typeof arg === "undefined") {
                return void 0;
              }
              var str;
              if (typeof arg === "string") {
                str = arg;
              } else if (isFunction(arg)) {
                str = "";
              } else if (typeof arg === "number" && !isFinite(arg)) {
                throw {
                  code: "D3001",
                  value: arg,
                  stack: new Error().stack
                };
              } else {
                var space = prettify ? 2 : 0;
                if (Array.isArray(arg) && arg.outerWrapper) {
                  arg = arg[0];
                }
                str = JSON.stringify(arg, function(key, val) {
                  return typeof val !== "undefined" && val !== null && val.toPrecision && isNumeric(val) ? Number(val.toPrecision(15)) : val && isFunction(val) ? "" : val;
                }, space);
              }
              return str;
            }
            function substring(str, start, length2) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var strArray = stringToArray(str);
              var strLength = strArray.length;
              if (strLength + start < 0) {
                start = 0;
              }
              if (typeof length2 !== "undefined") {
                if (length2 <= 0) {
                  return "";
                }
                var end = start >= 0 ? start + length2 : strLength + start + length2;
                return strArray.slice(start, end).join("");
              }
              return strArray.slice(start).join("");
            }
            function substringBefore(str, chars) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var pos = str.indexOf(chars);
              if (pos > -1) {
                return str.substr(0, pos);
              } else {
                return str;
              }
            }
            function substringAfter(str, chars) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var pos = str.indexOf(chars);
              if (pos > -1) {
                return str.substr(pos + chars.length);
              } else {
                return str;
              }
            }
            function lowercase(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              return str.toLowerCase();
            }
            function uppercase(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              return str.toUpperCase();
            }
            function length(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              return stringToArray(str).length;
            }
            function trim(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var result = str.replace(/[ \t\n\r]+/gm, " ");
              if (result.charAt(0) === " ") {
                result = result.substring(1);
              }
              if (result.charAt(result.length - 1) === " ") {
                result = result.substring(0, result.length - 1);
              }
              return result;
            }
            function pad(str, width2, char) {
              if (typeof str === "undefined") {
                return void 0;
              }
              if (typeof char === "undefined" || char.length === 0) {
                char = " ";
              }
              var result;
              var padLength = Math.abs(width2) - length(str);
              if (padLength > 0) {
                var padding = new Array(padLength + 1).join(char);
                if (char.length > 1) {
                  padding = substring(padding, 0, padLength);
                }
                if (width2 > 0) {
                  result = str + padding;
                } else {
                  result = padding + str;
                }
              } else {
                result = str;
              }
              return result;
            }
            async function evaluateMatcher(matcher, str) {
              var result = matcher.apply(this, [str]);
              if (isPromise(result)) {
                result = await result;
              }
              if (result && !(typeof result.start === "number" || result.end === "number" || Array.isArray(result.groups) || isFunction(result.next))) {
                throw {
                  code: "T1010",
                  stack: new Error().stack
                };
              }
              return result;
            }
            async function contains(str, token) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var result;
              if (typeof token === "string") {
                result = str.indexOf(token) !== -1;
              } else {
                var matches = await evaluateMatcher(token, str);
                result = typeof matches !== "undefined";
              }
              return result;
            }
            async function match(str, regex, limit) {
              if (typeof str === "undefined") {
                return void 0;
              }
              if (limit < 0) {
                throw {
                  stack: new Error().stack,
                  value: limit,
                  code: "D3040",
                  index: 3
                };
              }
              var result = createSequence();
              if (typeof limit === "undefined" || limit > 0) {
                var count2 = 0;
                var matches = await evaluateMatcher(regex, str);
                if (typeof matches !== "undefined") {
                  while (typeof matches !== "undefined" && (typeof limit === "undefined" || count2 < limit)) {
                    result.push({
                      match: matches.match,
                      index: matches.start,
                      groups: matches.groups
                    });
                    matches = await evaluateMatcher(matches.next);
                    count2++;
                  }
                }
              }
              return result;
            }
            async function replace(str, pattern, replacement, limit) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var self2 = this;
              if (pattern === "") {
                throw {
                  code: "D3010",
                  stack: new Error().stack,
                  value: pattern,
                  index: 2
                };
              }
              if (limit < 0) {
                throw {
                  code: "D3011",
                  stack: new Error().stack,
                  value: limit,
                  index: 4
                };
              }
              var replacer;
              if (typeof replacement === "string") {
                replacer = function(regexMatch) {
                  var substitute = "";
                  var position2 = 0;
                  var index2 = replacement.indexOf("$", position2);
                  while (index2 !== -1 && position2 < replacement.length) {
                    substitute += replacement.substring(position2, index2);
                    position2 = index2 + 1;
                    var dollarVal = replacement.charAt(position2);
                    if (dollarVal === "$") {
                      substitute += "$";
                      position2++;
                    } else if (dollarVal === "0") {
                      substitute += regexMatch.match;
                      position2++;
                    } else {
                      var maxDigits;
                      if (regexMatch.groups.length === 0) {
                        maxDigits = 1;
                      } else {
                        maxDigits = Math.floor(Math.log(regexMatch.groups.length) * Math.LOG10E) + 1;
                      }
                      index2 = parseInt(replacement.substring(position2, position2 + maxDigits), 10);
                      if (maxDigits > 1 && index2 > regexMatch.groups.length) {
                        index2 = parseInt(replacement.substring(position2, position2 + maxDigits - 1), 10);
                      }
                      if (!isNaN(index2)) {
                        if (regexMatch.groups.length > 0) {
                          var submatch = regexMatch.groups[index2 - 1];
                          if (typeof submatch !== "undefined") {
                            substitute += submatch;
                          }
                        }
                        position2 += index2.toString().length;
                      } else {
                        substitute += "$";
                      }
                    }
                    index2 = replacement.indexOf("$", position2);
                  }
                  substitute += replacement.substring(position2);
                  return substitute;
                };
              } else {
                replacer = replacement;
              }
              var result = "";
              var position = 0;
              if (typeof limit === "undefined" || limit > 0) {
                var count2 = 0;
                if (typeof pattern === "string") {
                  var index = str.indexOf(pattern, position);
                  while (index !== -1 && (typeof limit === "undefined" || count2 < limit)) {
                    result += str.substring(position, index);
                    result += replacement;
                    position = index + pattern.length;
                    count2++;
                    index = str.indexOf(pattern, position);
                  }
                  result += str.substring(position);
                } else {
                  var matches = await evaluateMatcher(pattern, str);
                  if (typeof matches !== "undefined") {
                    while (typeof matches !== "undefined" && (typeof limit === "undefined" || count2 < limit)) {
                      result += str.substring(position, matches.start);
                      var replacedWith = replacer.apply(self2, [matches]);
                      if (isPromise(replacedWith)) {
                        replacedWith = await replacedWith;
                      }
                      if (typeof replacedWith === "string") {
                        result += replacedWith;
                      } else {
                        throw {
                          code: "D3012",
                          stack: new Error().stack,
                          value: replacedWith
                        };
                      }
                      position = matches.start + matches.match.length;
                      count2++;
                      matches = await evaluateMatcher(matches.next);
                    }
                    result += str.substring(position);
                  } else {
                    result = str;
                  }
                }
              } else {
                result = str;
              }
              return result;
            }
            function base64encode(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var btoa = typeof window !== "undefined" ? (
                /* istanbul ignore next */
                window.btoa
              ) : function(str2) {
                return new global2.Buffer.from(str2, "binary").toString("base64");
              };
              return btoa(str);
            }
            function base64decode(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var atob = typeof window !== "undefined" ? (
                /* istanbul ignore next */
                window.atob
              ) : function(str2) {
                return new global2.Buffer.from(str2, "base64").toString("binary");
              };
              return atob(str);
            }
            function encodeUrlComponent(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var returnVal;
              try {
                returnVal = encodeURIComponent(str);
              } catch (e) {
                throw {
                  code: "D3140",
                  stack: new Error().stack,
                  value: str,
                  functionName: "encodeUrlComponent"
                };
              }
              return returnVal;
            }
            function encodeUrl(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var returnVal;
              try {
                returnVal = encodeURI(str);
              } catch (e) {
                throw {
                  code: "D3140",
                  stack: new Error().stack,
                  value: str,
                  functionName: "encodeUrl"
                };
              }
              return returnVal;
            }
            function decodeUrlComponent(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var returnVal;
              try {
                returnVal = decodeURIComponent(str);
              } catch (e) {
                throw {
                  code: "D3140",
                  stack: new Error().stack,
                  value: str,
                  functionName: "decodeUrlComponent"
                };
              }
              return returnVal;
            }
            function decodeUrl(str) {
              if (typeof str === "undefined") {
                return void 0;
              }
              var returnVal;
              try {
                returnVal = decodeURI(str);
              } catch (e) {
                throw {
                  code: "D3140",
                  stack: new Error().stack,
                  value: str,
                  functionName: "decodeUrl"
                };
              }
              return returnVal;
            }
            async function split(str, separator, limit) {
              if (typeof str === "undefined") {
                return void 0;
              }
              if (limit < 0) {
                throw {
                  code: "D3020",
                  stack: new Error().stack,
                  value: limit,
                  index: 3
                };
              }
              var result = [];
              if (typeof limit === "undefined" || limit > 0) {
                if (typeof separator === "string") {
                  result = str.split(separator, limit);
                } else {
                  var count2 = 0;
                  var matches = await evaluateMatcher(separator, str);
                  if (typeof matches !== "undefined") {
                    var start = 0;
                    while (typeof matches !== "undefined" && (typeof limit === "undefined" || count2 < limit)) {
                      result.push(str.substring(start, matches.start));
                      start = matches.end;
                      matches = await evaluateMatcher(matches.next);
                      count2++;
                    }
                    if (typeof limit === "undefined" || count2 < limit) {
                      result.push(str.substring(start));
                    }
                  } else {
                    result.push(str);
                  }
                }
              }
              return result;
            }
            function join(strs, separator) {
              if (typeof strs === "undefined") {
                return void 0;
              }
              if (typeof separator === "undefined") {
                separator = "";
              }
              return strs.join(separator);
            }
            function formatNumber(value, picture, options) {
              if (typeof value === "undefined") {
                return void 0;
              }
              var defaults = {
                "decimal-separator": ".",
                "grouping-separator": ",",
                "exponent-separator": "e",
                "infinity": "Infinity",
                "minus-sign": "-",
                "NaN": "NaN",
                "percent": "%",
                "per-mille": "‰",
                "zero-digit": "0",
                "digit": "#",
                "pattern-separator": ";"
              };
              var properties = defaults;
              if (typeof options !== "undefined") {
                Object.keys(options).forEach(function(key) {
                  properties[key] = options[key];
                });
              }
              var decimalDigitFamily = [];
              var zeroCharCode = properties["zero-digit"].charCodeAt(0);
              for (var ii = zeroCharCode; ii < zeroCharCode + 10; ii++) {
                decimalDigitFamily.push(String.fromCharCode(ii));
              }
              var activeChars = decimalDigitFamily.concat([properties["decimal-separator"], properties["exponent-separator"], properties["grouping-separator"], properties.digit, properties["pattern-separator"]]);
              var subPictures = picture.split(properties["pattern-separator"]);
              if (subPictures.length > 2) {
                throw {
                  code: "D3080",
                  stack: new Error().stack
                };
              }
              var splitParts = function(subpicture) {
                var prefix = function() {
                  var ch;
                  for (var ii2 = 0; ii2 < subpicture.length; ii2++) {
                    ch = subpicture.charAt(ii2);
                    if (activeChars.indexOf(ch) !== -1 && ch !== properties["exponent-separator"]) {
                      return subpicture.substring(0, ii2);
                    }
                  }
                }();
                var suffix = function() {
                  var ch;
                  for (var ii2 = subpicture.length - 1; ii2 >= 0; ii2--) {
                    ch = subpicture.charAt(ii2);
                    if (activeChars.indexOf(ch) !== -1 && ch !== properties["exponent-separator"]) {
                      return subpicture.substring(ii2 + 1);
                    }
                  }
                }();
                var activePart = subpicture.substring(prefix.length, subpicture.length - suffix.length);
                var mantissaPart, exponentPart, integerPart, fractionalPart;
                var exponentPosition = subpicture.indexOf(properties["exponent-separator"], prefix.length);
                if (exponentPosition === -1 || exponentPosition > subpicture.length - suffix.length) {
                  mantissaPart = activePart;
                  exponentPart = void 0;
                } else {
                  mantissaPart = activePart.substring(0, exponentPosition);
                  exponentPart = activePart.substring(exponentPosition + 1);
                }
                var decimalPosition = mantissaPart.indexOf(properties["decimal-separator"]);
                if (decimalPosition === -1) {
                  integerPart = mantissaPart;
                  fractionalPart = suffix;
                } else {
                  integerPart = mantissaPart.substring(0, decimalPosition);
                  fractionalPart = mantissaPart.substring(decimalPosition + 1);
                }
                return {
                  prefix,
                  suffix,
                  activePart,
                  mantissaPart,
                  exponentPart,
                  integerPart,
                  fractionalPart,
                  subpicture
                };
              };
              var validate = function(parts2) {
                var error2;
                var ii2;
                var subpicture = parts2.subpicture;
                var decimalPos2 = subpicture.indexOf(properties["decimal-separator"]);
                if (decimalPos2 !== subpicture.lastIndexOf(properties["decimal-separator"])) {
                  error2 = "D3081";
                }
                if (subpicture.indexOf(properties.percent) !== subpicture.lastIndexOf(properties.percent)) {
                  error2 = "D3082";
                }
                if (subpicture.indexOf(properties["per-mille"]) !== subpicture.lastIndexOf(properties["per-mille"])) {
                  error2 = "D3083";
                }
                if (subpicture.indexOf(properties.percent) !== -1 && subpicture.indexOf(properties["per-mille"]) !== -1) {
                  error2 = "D3084";
                }
                var valid = false;
                for (ii2 = 0; ii2 < parts2.mantissaPart.length; ii2++) {
                  var ch = parts2.mantissaPart.charAt(ii2);
                  if (decimalDigitFamily.indexOf(ch) !== -1 || ch === properties.digit) {
                    valid = true;
                    break;
                  }
                }
                if (!valid) {
                  error2 = "D3085";
                }
                var charTypes = parts2.activePart.split("").map(function(char) {
                  return activeChars.indexOf(char) === -1 ? "p" : "a";
                }).join("");
                if (charTypes.indexOf("p") !== -1) {
                  error2 = "D3086";
                }
                if (decimalPos2 !== -1) {
                  if (subpicture.charAt(decimalPos2 - 1) === properties["grouping-separator"] || subpicture.charAt(decimalPos2 + 1) === properties["grouping-separator"]) {
                    error2 = "D3087";
                  }
                } else if (parts2.integerPart.charAt(parts2.integerPart.length - 1) === properties["grouping-separator"]) {
                  error2 = "D3088";
                }
                if (subpicture.indexOf(properties["grouping-separator"] + properties["grouping-separator"]) !== -1) {
                  error2 = "D3089";
                }
                var optionalDigitPos = parts2.integerPart.indexOf(properties.digit);
                if (optionalDigitPos !== -1 && parts2.integerPart.substring(0, optionalDigitPos).split("").filter(function(char) {
                  return decimalDigitFamily.indexOf(char) > -1;
                }).length > 0) {
                  error2 = "D3090";
                }
                optionalDigitPos = parts2.fractionalPart.lastIndexOf(properties.digit);
                if (optionalDigitPos !== -1 && parts2.fractionalPart.substring(optionalDigitPos).split("").filter(function(char) {
                  return decimalDigitFamily.indexOf(char) > -1;
                }).length > 0) {
                  error2 = "D3091";
                }
                var exponentExists = typeof parts2.exponentPart === "string";
                if (exponentExists && parts2.exponentPart.length > 0 && (subpicture.indexOf(properties.percent) !== -1 || subpicture.indexOf(properties["per-mille"]) !== -1)) {
                  error2 = "D3092";
                }
                if (exponentExists && (parts2.exponentPart.length === 0 || parts2.exponentPart.split("").filter(function(char) {
                  return decimalDigitFamily.indexOf(char) === -1;
                }).length > 0)) {
                  error2 = "D3093";
                }
                if (error2) {
                  throw {
                    code: error2,
                    stack: new Error().stack
                  };
                }
              };
              var analyse = function(parts2) {
                var getGroupingPositions = function(part, toLeft) {
                  var positions = [];
                  var groupingPosition = part.indexOf(properties["grouping-separator"]);
                  while (groupingPosition !== -1) {
                    var charsToTheRight = (toLeft ? part.substring(0, groupingPosition) : part.substring(groupingPosition)).split("").filter(function(char) {
                      return decimalDigitFamily.indexOf(char) !== -1 || char === properties.digit;
                    }).length;
                    positions.push(charsToTheRight);
                    groupingPosition = parts2.integerPart.indexOf(properties["grouping-separator"], groupingPosition + 1);
                  }
                  return positions;
                };
                var integerPartGroupingPositions = getGroupingPositions(parts2.integerPart);
                var regular = function(indexes) {
                  if (indexes.length === 0) {
                    return 0;
                  }
                  var gcd = function(a, b) {
                    return b === 0 ? a : gcd(b, a % b);
                  };
                  var factor = indexes.reduce(gcd);
                  for (var index = 1; index <= indexes.length; index++) {
                    if (indexes.indexOf(index * factor) === -1) {
                      return 0;
                    }
                  }
                  return factor;
                };
                var regularGrouping = regular(integerPartGroupingPositions);
                var fractionalPartGroupingPositions = getGroupingPositions(parts2.fractionalPart, true);
                var minimumIntegerPartSize = parts2.integerPart.split("").filter(function(char) {
                  return decimalDigitFamily.indexOf(char) !== -1;
                }).length;
                var scalingFactor = minimumIntegerPartSize;
                var fractionalPartArray = parts2.fractionalPart.split("");
                var minimumFactionalPartSize = fractionalPartArray.filter(function(char) {
                  return decimalDigitFamily.indexOf(char) !== -1;
                }).length;
                var maximumFactionalPartSize = fractionalPartArray.filter(function(char) {
                  return decimalDigitFamily.indexOf(char) !== -1 || char === properties.digit;
                }).length;
                var exponentPresent = typeof parts2.exponentPart === "string";
                if (minimumIntegerPartSize === 0 && maximumFactionalPartSize === 0) {
                  if (exponentPresent) {
                    minimumFactionalPartSize = 1;
                    maximumFactionalPartSize = 1;
                  } else {
                    minimumIntegerPartSize = 1;
                  }
                }
                if (exponentPresent && minimumIntegerPartSize === 0 && parts2.integerPart.indexOf(properties.digit) !== -1) {
                  minimumIntegerPartSize = 1;
                }
                if (minimumIntegerPartSize === 0 && minimumFactionalPartSize === 0) {
                  minimumFactionalPartSize = 1;
                }
                var minimumExponentSize = 0;
                if (exponentPresent) {
                  minimumExponentSize = parts2.exponentPart.split("").filter(function(char) {
                    return decimalDigitFamily.indexOf(char) !== -1;
                  }).length;
                }
                return {
                  integerPartGroupingPositions,
                  regularGrouping,
                  minimumIntegerPartSize,
                  scalingFactor,
                  prefix: parts2.prefix,
                  fractionalPartGroupingPositions,
                  minimumFactionalPartSize,
                  maximumFactionalPartSize,
                  minimumExponentSize,
                  suffix: parts2.suffix,
                  picture: parts2.subpicture
                };
              };
              var parts = subPictures.map(splitParts);
              parts.forEach(validate);
              var variables = parts.map(analyse);
              var minus_sign = properties["minus-sign"];
              var zero_digit = properties["zero-digit"];
              var decimal_separator = properties["decimal-separator"];
              var grouping_separator = properties["grouping-separator"];
              if (variables.length === 1) {
                variables.push(JSON.parse(JSON.stringify(variables[0])));
                variables[1].prefix = minus_sign + variables[1].prefix;
              }
              var pic;
              if (value >= 0) {
                pic = variables[0];
              } else {
                pic = variables[1];
              }
              var adjustedNumber;
              if (pic.picture.indexOf(properties.percent) !== -1) {
                adjustedNumber = value * 100;
              } else if (pic.picture.indexOf(properties["per-mille"]) !== -1) {
                adjustedNumber = value * 1e3;
              } else {
                adjustedNumber = value;
              }
              var mantissa, exponent;
              if (pic.minimumExponentSize === 0) {
                mantissa = adjustedNumber;
              } else {
                var maxMantissa = Math.pow(10, pic.scalingFactor);
                var minMantissa = Math.pow(10, pic.scalingFactor - 1);
                mantissa = adjustedNumber;
                exponent = 0;
                while (mantissa < minMantissa) {
                  mantissa *= 10;
                  exponent -= 1;
                }
                while (mantissa > maxMantissa) {
                  mantissa /= 10;
                  exponent += 1;
                }
              }
              var roundedNumber = round(mantissa, pic.maximumFactionalPartSize);
              var makeString = function(value2, dp) {
                var str = Math.abs(value2).toFixed(dp);
                if (zero_digit !== "0") {
                  str = str.split("").map(function(digit) {
                    if (digit >= "0" && digit <= "9") {
                      return decimalDigitFamily[digit.charCodeAt(0) - 48];
                    } else {
                      return digit;
                    }
                  }).join("");
                }
                return str;
              };
              var stringValue = makeString(roundedNumber, pic.maximumFactionalPartSize);
              var decimalPos = stringValue.indexOf(".");
              if (decimalPos === -1) {
                stringValue = stringValue + decimal_separator;
              } else {
                stringValue = stringValue.replace(".", decimal_separator);
              }
              while (stringValue.charAt(0) === zero_digit) {
                stringValue = stringValue.substring(1);
              }
              while (stringValue.charAt(stringValue.length - 1) === zero_digit) {
                stringValue = stringValue.substring(0, stringValue.length - 1);
              }
              decimalPos = stringValue.indexOf(decimal_separator);
              var padLeft = pic.minimumIntegerPartSize - decimalPos;
              var padRight = pic.minimumFactionalPartSize - (stringValue.length - decimalPos - 1);
              stringValue = (padLeft > 0 ? new Array(padLeft + 1).join(zero_digit) : "") + stringValue;
              stringValue = stringValue + (padRight > 0 ? new Array(padRight + 1).join(zero_digit) : "");
              decimalPos = stringValue.indexOf(decimal_separator);
              if (pic.regularGrouping > 0) {
                var groupCount = Math.floor((decimalPos - 1) / pic.regularGrouping);
                for (var group = 1; group <= groupCount; group++) {
                  stringValue = [stringValue.slice(0, decimalPos - group * pic.regularGrouping), grouping_separator, stringValue.slice(decimalPos - group * pic.regularGrouping)].join("");
                }
              } else {
                pic.integerPartGroupingPositions.forEach(function(pos) {
                  stringValue = [stringValue.slice(0, decimalPos - pos), grouping_separator, stringValue.slice(decimalPos - pos)].join("");
                  decimalPos++;
                });
              }
              decimalPos = stringValue.indexOf(decimal_separator);
              pic.fractionalPartGroupingPositions.forEach(function(pos) {
                stringValue = [stringValue.slice(0, pos + decimalPos + 1), grouping_separator, stringValue.slice(pos + decimalPos + 1)].join("");
              });
              decimalPos = stringValue.indexOf(decimal_separator);
              if (pic.picture.indexOf(decimal_separator) === -1 || decimalPos === stringValue.length - 1) {
                stringValue = stringValue.substring(0, stringValue.length - 1);
              }
              if (typeof exponent !== "undefined") {
                var stringExponent = makeString(exponent, 0);
                padLeft = pic.minimumExponentSize - stringExponent.length;
                if (padLeft > 0) {
                  stringExponent = new Array(padLeft + 1).join(zero_digit) + stringExponent;
                }
                stringValue = stringValue + properties["exponent-separator"] + (exponent < 0 ? minus_sign : "") + stringExponent;
              }
              stringValue = pic.prefix + stringValue + pic.suffix;
              return stringValue;
            }
            function formatBase(value, radix) {
              if (typeof value === "undefined") {
                return void 0;
              }
              value = round(value);
              if (typeof radix === "undefined") {
                radix = 10;
              } else {
                radix = round(radix);
              }
              if (radix < 2 || radix > 36) {
                throw {
                  code: "D3100",
                  stack: new Error().stack,
                  value: radix
                };
              }
              var result = value.toString(radix);
              return result;
            }
            function number(arg) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              if (typeof arg === "number") {
                result = arg;
              } else if (typeof arg === "string" && /^-?[0-9]+(\.[0-9]+)?([Ee][-+]?[0-9]+)?$/.test(arg) && !isNaN(parseFloat(arg)) && isFinite(arg)) {
                result = parseFloat(arg);
              } else if (typeof arg === "string" && /^(0[xX][0-9A-Fa-f]+)|(0[oO][0-7]+)|(0[bB][0-1]+)$/.test(arg)) {
                result = Number(arg);
              } else if (arg === true) {
                result = 1;
              } else if (arg === false) {
                result = 0;
              } else {
                throw {
                  code: "D3030",
                  value: arg,
                  stack: new Error().stack,
                  index: 1
                };
              }
              return result;
            }
            function abs(arg) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              result = Math.abs(arg);
              return result;
            }
            function floor(arg) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              result = Math.floor(arg);
              return result;
            }
            function ceil(arg) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              result = Math.ceil(arg);
              return result;
            }
            function round(arg, precision) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              if (precision) {
                var value = arg.toString().split("e");
                arg = +(value[0] + "e" + (value[1] ? +value[1] + precision : precision));
              }
              result = Math.round(arg);
              var diff = result - arg;
              if (Math.abs(diff) === 0.5 && Math.abs(result % 2) === 1) {
                result = result - 1;
              }
              if (precision) {
                value = result.toString().split("e");
                result = +(value[0] + "e" + (value[1] ? +value[1] - precision : -precision));
              }
              if (Object.is(result, -0)) {
                result = 0;
              }
              return result;
            }
            function sqrt(arg) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              if (arg < 0) {
                throw {
                  stack: new Error().stack,
                  code: "D3060",
                  index: 1,
                  value: arg
                };
              }
              result = Math.sqrt(arg);
              return result;
            }
            function power(arg, exp) {
              var result;
              if (typeof arg === "undefined") {
                return void 0;
              }
              result = Math.pow(arg, exp);
              if (!isFinite(result)) {
                throw {
                  stack: new Error().stack,
                  code: "D3061",
                  index: 1,
                  value: arg,
                  exp
                };
              }
              return result;
            }
            function random() {
              return Math.random();
            }
            function boolean(arg) {
              if (typeof arg === "undefined") {
                return void 0;
              }
              var result = false;
              if (Array.isArray(arg)) {
                if (arg.length === 1) {
                  result = boolean(arg[0]);
                } else if (arg.length > 1) {
                  var trues = arg.filter(function(val) {
                    return boolean(val);
                  });
                  result = trues.length > 0;
                }
              } else if (typeof arg === "string") {
                if (arg.length > 0) {
                  result = true;
                }
              } else if (isNumeric(arg)) {
                if (arg !== 0) {
                  result = true;
                }
              } else if (arg !== null && typeof arg === "object") {
                if (Object.keys(arg).length > 0) {
                  result = true;
                }
              } else if (typeof arg === "boolean" && arg === true) {
                result = true;
              }
              return result;
            }
            function not(arg) {
              if (typeof arg === "undefined") {
                return void 0;
              }
              return !boolean(arg);
            }
            function hofFuncArgs(func, arg1, arg2, arg3) {
              var func_args = [arg1];
              var length2 = getFunctionArity(func);
              if (length2 >= 2) {
                func_args.push(arg2);
              }
              if (length2 >= 3) {
                func_args.push(arg3);
              }
              return func_args;
            }
            async function map(arr, func) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              var result = createSequence();
              for (var i = 0; i < arr.length; i++) {
                var func_args = hofFuncArgs(func, arr[i], i, arr);
                var res = await func.apply(this, func_args);
                if (typeof res !== "undefined") {
                  result.push(res);
                }
              }
              return result;
            }
            async function filter(arr, func) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              var result = createSequence();
              for (var i = 0; i < arr.length; i++) {
                var entry = arr[i];
                var func_args = hofFuncArgs(func, entry, i, arr);
                var res = await func.apply(this, func_args);
                if (boolean(res)) {
                  result.push(entry);
                }
              }
              return result;
            }
            async function single(arr, func) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              var hasFoundMatch = false;
              var result;
              for (var i = 0; i < arr.length; i++) {
                var entry = arr[i];
                var positiveResult = true;
                if (typeof func !== "undefined") {
                  var func_args = hofFuncArgs(func, entry, i, arr);
                  var res = await func.apply(this, func_args);
                  positiveResult = boolean(res);
                }
                if (positiveResult) {
                  if (!hasFoundMatch) {
                    result = entry;
                    hasFoundMatch = true;
                  } else {
                    throw {
                      stack: new Error().stack,
                      code: "D3138",
                      index: i
                    };
                  }
                }
              }
              if (!hasFoundMatch) {
                throw {
                  stack: new Error().stack,
                  code: "D3139"
                };
              }
              return result;
            }
            function zip() {
              var result = [];
              var args = Array.prototype.slice.call(arguments);
              var length2 = Math.min.apply(Math, args.map(function(arg) {
                if (Array.isArray(arg)) {
                  return arg.length;
                }
                return 0;
              }));
              for (var i = 0; i < length2; i++) {
                var tuple = args.map((arg) => {
                  return arg[i];
                });
                result.push(tuple);
              }
              return result;
            }
            async function foldLeft(sequence, func, init) {
              if (typeof sequence === "undefined") {
                return void 0;
              }
              var result;
              var arity = getFunctionArity(func);
              if (arity < 2) {
                throw {
                  stack: new Error().stack,
                  code: "D3050",
                  index: 1
                };
              }
              var index;
              if (typeof init === "undefined" && sequence.length > 0) {
                result = sequence[0];
                index = 1;
              } else {
                result = init;
                index = 0;
              }
              while (index < sequence.length) {
                var args = [result, sequence[index]];
                if (arity >= 3) {
                  args.push(index);
                }
                if (arity >= 4) {
                  args.push(sequence);
                }
                result = await func.apply(this, args);
                index++;
              }
              return result;
            }
            function keys(arg) {
              var result = createSequence();
              if (Array.isArray(arg)) {
                var merge3 = {};
                arg.forEach(function(item) {
                  var allkeys = keys(item);
                  allkeys.forEach(function(key) {
                    merge3[key] = true;
                  });
                });
                result = keys(merge3);
              } else if (arg !== null && typeof arg === "object" && !isLambda(arg)) {
                Object.keys(arg).forEach((key) => result.push(key));
              }
              return result;
            }
            function lookup(input, key) {
              var result;
              if (Array.isArray(input)) {
                result = createSequence();
                for (var ii = 0; ii < input.length; ii++) {
                  var res = lookup(input[ii], key);
                  if (typeof res !== "undefined") {
                    if (Array.isArray(res)) {
                      res.forEach((val) => result.push(val));
                    } else {
                      result.push(res);
                    }
                  }
                }
              } else if (input !== null && typeof input === "object") {
                result = input[key];
              }
              return result;
            }
            function append(arg1, arg2) {
              if (typeof arg1 === "undefined") {
                return arg2;
              }
              if (typeof arg2 === "undefined") {
                return arg1;
              }
              if (!Array.isArray(arg1)) {
                arg1 = createSequence(arg1);
              }
              if (!Array.isArray(arg2)) {
                arg2 = [arg2];
              }
              return arg1.concat(arg2);
            }
            function exists(arg) {
              if (typeof arg === "undefined") {
                return false;
              } else {
                return true;
              }
            }
            function spread(arg) {
              var result = createSequence();
              if (Array.isArray(arg)) {
                arg.forEach(function(item) {
                  result = append(result, spread(item));
                });
              } else if (arg !== null && typeof arg === "object" && !isLambda(arg)) {
                for (var key in arg) {
                  var obj = {};
                  obj[key] = arg[key];
                  result.push(obj);
                }
              } else {
                result = arg;
              }
              return result;
            }
            function merge2(arg) {
              if (typeof arg === "undefined") {
                return void 0;
              }
              var result = {};
              arg.forEach(function(obj) {
                for (var prop in obj) {
                  result[prop] = obj[prop];
                }
              });
              return result;
            }
            function reverse(arr) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              if (arr.length <= 1) {
                return arr;
              }
              var length2 = arr.length;
              var result = new Array(length2);
              for (var i = 0; i < length2; i++) {
                result[length2 - i - 1] = arr[i];
              }
              return result;
            }
            async function each(obj, func) {
              var result = createSequence();
              for (var key in obj) {
                var func_args = hofFuncArgs(func, obj[key], key, obj);
                var val = await func.apply(this, func_args);
                if (typeof val !== "undefined") {
                  result.push(val);
                }
              }
              return result;
            }
            function error(message) {
              throw {
                code: "D3137",
                stack: new Error().stack,
                message: message || "$error() function evaluated"
              };
            }
            function assert(condition, message) {
              if (!condition) {
                throw {
                  code: "D3141",
                  stack: new Error().stack,
                  message: message || "$assert() statement failed"
                };
              }
              return void 0;
            }
            function type(value) {
              if (value === void 0) {
                return void 0;
              }
              if (value === null) {
                return "null";
              }
              if (isNumeric(value)) {
                return "number";
              }
              if (typeof value === "string") {
                return "string";
              }
              if (typeof value === "boolean") {
                return "boolean";
              }
              if (Array.isArray(value)) {
                return "array";
              }
              if (isFunction(value)) {
                return "function";
              }
              return "object";
            }
            async function sort(arr, comparator) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              if (arr.length <= 1) {
                return arr;
              }
              var comp;
              if (typeof comparator === "undefined") {
                if (!isArrayOfNumbers(arr) && !isArrayOfStrings(arr)) {
                  throw {
                    stack: new Error().stack,
                    code: "D3070",
                    index: 1
                  };
                }
                comp = async function(a, b) {
                  return a > b;
                };
              } else {
                comp = comparator;
              }
              var merge3 = async function(l, r) {
                var merge_iter = async function(result2, left, right) {
                  if (left.length === 0) {
                    Array.prototype.push.apply(result2, right);
                  } else if (right.length === 0) {
                    Array.prototype.push.apply(result2, left);
                  } else if (await comp(left[0], right[0])) {
                    result2.push(right[0]);
                    await merge_iter(result2, left, right.slice(1));
                  } else {
                    result2.push(left[0]);
                    await merge_iter(result2, left.slice(1), right);
                  }
                };
                var merged = [];
                await merge_iter(merged, l, r);
                return merged;
              };
              var msort = async function(array) {
                if (!Array.isArray(array) || array.length <= 1) {
                  return array;
                } else {
                  var middle = Math.floor(array.length / 2);
                  var left = array.slice(0, middle);
                  var right = array.slice(middle);
                  left = await msort(left);
                  right = await msort(right);
                  return await merge3(left, right);
                }
              };
              var result = await msort(arr);
              return result;
            }
            function shuffle(arr) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              if (arr.length <= 1) {
                return arr;
              }
              var result = new Array(arr.length);
              for (var i = 0; i < arr.length; i++) {
                var j = Math.floor(Math.random() * (i + 1));
                if (i !== j) {
                  result[i] = result[j];
                }
                result[j] = arr[i];
              }
              return result;
            }
            function distinct(arr) {
              if (typeof arr === "undefined") {
                return void 0;
              }
              if (!Array.isArray(arr) || arr.length <= 1) {
                return arr;
              }
              var results = isSequence(arr) ? createSequence() : [];
              for (var ii = 0; ii < arr.length; ii++) {
                var value = arr[ii];
                var includes = false;
                for (var jj = 0; jj < results.length; jj++) {
                  if (deepEquals(value, results[jj])) {
                    includes = true;
                    break;
                  }
                }
                if (!includes) {
                  results.push(value);
                }
              }
              return results;
            }
            async function sift(arg, func) {
              var result = {};
              for (var item in arg) {
                var entry = arg[item];
                var func_args = hofFuncArgs(func, entry, item, arg);
                var res = await func.apply(this, func_args);
                if (boolean(res)) {
                  result[item] = entry;
                }
              }
              if (Object.keys(result).length === 0) {
                result = void 0;
              }
              return result;
            }
            return {
              sum,
              count,
              max,
              min,
              average,
              string,
              substring,
              substringBefore,
              substringAfter,
              lowercase,
              uppercase,
              length,
              trim,
              pad,
              match,
              contains,
              replace,
              split,
              join,
              formatNumber,
              formatBase,
              number,
              floor,
              ceil,
              round,
              abs,
              sqrt,
              power,
              random,
              boolean,
              not,
              map,
              zip,
              filter,
              single,
              foldLeft,
              sift,
              keys,
              lookup,
              append,
              exists,
              spread,
              merge: merge2,
              reverse,
              each,
              error,
              assert,
              type,
              sort,
              shuffle,
              distinct,
              base64encode,
              base64decode,
              encodeUrlComponent,
              encodeUrl,
              decodeUrlComponent,
              decodeUrl
            };
          })();
          module2.exports = functions;
        }).call(this);
      }).call(this, typeof commonjsGlobal !== "undefined" ? commonjsGlobal : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {});
    }, { "./utils": 6 }], 3: [function(require2, module2, exports2) {
      var datetime = require2("./datetime");
      var fn2 = require2("./functions");
      var utils = require2("./utils");
      var parser = require2("./parser");
      var parseSignature = require2("./signature");
      var jsonata2 = function() {
        var isNumeric = utils.isNumeric;
        var isArrayOfStrings = utils.isArrayOfStrings;
        var isArrayOfNumbers = utils.isArrayOfNumbers;
        var createSequence = utils.createSequence;
        var isSequence = utils.isSequence;
        var isFunction = utils.isFunction;
        var isLambda = utils.isLambda;
        var isIterable = utils.isIterable;
        var isPromise = utils.isPromise;
        var getFunctionArity = utils.getFunctionArity;
        var isDeepEqual = utils.isDeepEqual;
        var staticFrame = createFrame(null);
        async function evaluate(expr, input, environment) {
          var result;
          var entryCallback = environment.lookup("__evaluate_entry");
          if (entryCallback) {
            await entryCallback(expr, input, environment);
          }
          switch (expr.type) {
            case "path":
              result = await evaluatePath(expr, input, environment);
              break;
            case "binary":
              result = await evaluateBinary(expr, input, environment);
              break;
            case "unary":
              result = await evaluateUnary(expr, input, environment);
              break;
            case "name":
              result = evaluateName(expr, input);
              break;
            case "string":
            case "number":
            case "value":
              result = evaluateLiteral(expr);
              break;
            case "wildcard":
              result = evaluateWildcard(expr, input);
              break;
            case "descendant":
              result = evaluateDescendants(expr, input);
              break;
            case "parent":
              result = environment.lookup(expr.slot.label);
              break;
            case "condition":
              result = await evaluateCondition(expr, input, environment);
              break;
            case "block":
              result = await evaluateBlock(expr, input, environment);
              break;
            case "bind":
              result = await evaluateBindExpression(expr, input, environment);
              break;
            case "regex":
              result = evaluateRegex(expr);
              break;
            case "function":
              result = await evaluateFunction(expr, input, environment);
              break;
            case "variable":
              result = evaluateVariable(expr, input, environment);
              break;
            case "lambda":
              result = evaluateLambda(expr, input, environment);
              break;
            case "partial":
              result = await evaluatePartialApplication(expr, input, environment);
              break;
            case "apply":
              result = await evaluateApplyExpression(expr, input, environment);
              break;
            case "transform":
              result = evaluateTransformExpression(expr, input, environment);
              break;
          }
          if (Object.prototype.hasOwnProperty.call(expr, "predicate")) {
            for (var ii = 0; ii < expr.predicate.length; ii++) {
              result = await evaluateFilter(expr.predicate[ii].expr, result, environment);
            }
          }
          if (expr.type !== "path" && Object.prototype.hasOwnProperty.call(expr, "group")) {
            result = await evaluateGroupExpression(expr.group, result, environment);
          }
          var exitCallback = environment.lookup("__evaluate_exit");
          if (exitCallback) {
            await exitCallback(expr, input, environment, result);
          }
          if (result && isSequence(result) && !result.tupleStream) {
            if (expr.keepArray) {
              result.keepSingleton = true;
            }
            if (result.length === 0) {
              result = void 0;
            } else if (result.length === 1) {
              result = result.keepSingleton ? result : result[0];
            }
          }
          return result;
        }
        async function evaluatePath(expr, input, environment) {
          var inputSequence;
          if (Array.isArray(input) && expr.steps[0].type !== "variable") {
            inputSequence = input;
          } else {
            inputSequence = createSequence(input);
          }
          var resultSequence;
          var isTupleStream = false;
          var tupleBindings = void 0;
          for (var ii = 0; ii < expr.steps.length; ii++) {
            var step = expr.steps[ii];
            if (step.tuple) {
              isTupleStream = true;
            }
            if (ii === 0 && step.consarray) {
              resultSequence = await evaluate(step, inputSequence, environment);
            } else {
              if (isTupleStream) {
                tupleBindings = await evaluateTupleStep(step, inputSequence, tupleBindings, environment);
              } else {
                resultSequence = await evaluateStep(step, inputSequence, environment, ii === expr.steps.length - 1);
              }
            }
            if (!isTupleStream && (typeof resultSequence === "undefined" || resultSequence.length === 0)) {
              break;
            }
            if (typeof step.focus === "undefined") {
              inputSequence = resultSequence;
            }
          }
          if (isTupleStream) {
            if (expr.tuple) {
              resultSequence = tupleBindings;
            } else {
              resultSequence = createSequence();
              for (ii = 0; ii < tupleBindings.length; ii++) {
                resultSequence.push(tupleBindings[ii]["@"]);
              }
            }
          }
          if (expr.keepSingletonArray) {
            if (Array.isArray(resultSequence) && resultSequence.cons && !resultSequence.sequence) {
              resultSequence = createSequence(resultSequence);
            }
            resultSequence.keepSingleton = true;
          }
          if (expr.hasOwnProperty("group")) {
            resultSequence = await evaluateGroupExpression(expr.group, isTupleStream ? tupleBindings : resultSequence, environment);
          }
          return resultSequence;
        }
        function createFrameFromTuple(environment, tuple) {
          var frame = createFrame(environment);
          for (const prop in tuple) {
            frame.bind(prop, tuple[prop]);
          }
          return frame;
        }
        async function evaluateStep(expr, input, environment, lastStep) {
          var result;
          if (expr.type === "sort") {
            result = await evaluateSortExpression(expr, input, environment);
            if (expr.stages) {
              result = await evaluateStages(expr.stages, result, environment);
            }
            return result;
          }
          result = createSequence();
          for (var ii = 0; ii < input.length; ii++) {
            var res = await evaluate(expr, input[ii], environment);
            if (expr.stages) {
              for (var ss = 0; ss < expr.stages.length; ss++) {
                res = await evaluateFilter(expr.stages[ss].expr, res, environment);
              }
            }
            if (typeof res !== "undefined") {
              result.push(res);
            }
          }
          var resultSequence = createSequence();
          if (lastStep && result.length === 1 && Array.isArray(result[0]) && !isSequence(result[0])) {
            resultSequence = result[0];
          } else {
            result.forEach(function(res2) {
              if (!Array.isArray(res2) || res2.cons) {
                resultSequence.push(res2);
              } else {
                res2.forEach((val) => resultSequence.push(val));
              }
            });
          }
          return resultSequence;
        }
        async function evaluateStages(stages, input, environment) {
          var result = input;
          for (var ss = 0; ss < stages.length; ss++) {
            var stage = stages[ss];
            switch (stage.type) {
              case "filter":
                result = await evaluateFilter(stage.expr, result, environment);
                break;
              case "index":
                for (var ee = 0; ee < result.length; ee++) {
                  var tuple = result[ee];
                  tuple[stage.value] = ee;
                }
                break;
            }
          }
          return result;
        }
        async function evaluateTupleStep(expr, input, tupleBindings, environment) {
          var result;
          if (expr.type === "sort") {
            if (tupleBindings) {
              result = await evaluateSortExpression(expr, tupleBindings, environment);
            } else {
              var sorted = await evaluateSortExpression(expr, input, environment);
              result = createSequence();
              result.tupleStream = true;
              for (var ss = 0; ss < sorted.length; ss++) {
                var tuple = { "@": sorted[ss] };
                tuple[expr.index] = ss;
                result.push(tuple);
              }
            }
            if (expr.stages) {
              result = await evaluateStages(expr.stages, result, environment);
            }
            return result;
          }
          result = createSequence();
          result.tupleStream = true;
          var stepEnv = environment;
          if (tupleBindings === void 0) {
            tupleBindings = input.map((item) => {
              return { "@": item };
            });
          }
          for (var ee = 0; ee < tupleBindings.length; ee++) {
            stepEnv = createFrameFromTuple(environment, tupleBindings[ee]);
            var res = await evaluate(expr, tupleBindings[ee]["@"], stepEnv);
            if (typeof res !== "undefined") {
              if (!Array.isArray(res)) {
                res = [res];
              }
              for (var bb = 0; bb < res.length; bb++) {
                tuple = {};
                Object.assign(tuple, tupleBindings[ee]);
                if (res.tupleStream) {
                  Object.assign(tuple, res[bb]);
                } else {
                  if (expr.focus) {
                    tuple[expr.focus] = res[bb];
                    tuple["@"] = tupleBindings[ee]["@"];
                  } else {
                    tuple["@"] = res[bb];
                  }
                  if (expr.index) {
                    tuple[expr.index] = bb;
                  }
                  if (expr.ancestor) {
                    tuple[expr.ancestor.label] = tupleBindings[ee]["@"];
                  }
                }
                result.push(tuple);
              }
            }
          }
          if (expr.stages) {
            result = await evaluateStages(expr.stages, result, environment);
          }
          return result;
        }
        async function evaluateFilter(predicate, input, environment) {
          var results = createSequence();
          if (input && input.tupleStream) {
            results.tupleStream = true;
          }
          if (!Array.isArray(input)) {
            input = createSequence(input);
          }
          if (predicate.type === "number") {
            var index = Math.floor(predicate.value);
            if (index < 0) {
              index = input.length + index;
            }
            var item = input[index];
            if (typeof item !== "undefined") {
              if (Array.isArray(item)) {
                results = item;
              } else {
                results.push(item);
              }
            }
          } else {
            for (index = 0; index < input.length; index++) {
              var item = input[index];
              var context = item;
              var env = environment;
              if (input.tupleStream) {
                context = item["@"];
                env = createFrameFromTuple(environment, item);
              }
              var res = await evaluate(predicate, context, env);
              if (isNumeric(res)) {
                res = [res];
              }
              if (isArrayOfNumbers(res)) {
                res.forEach(function(ires) {
                  var ii = Math.floor(ires);
                  if (ii < 0) {
                    ii = input.length + ii;
                  }
                  if (ii === index) {
                    results.push(item);
                  }
                });
              } else if (fn2.boolean(res)) {
                results.push(item);
              }
            }
          }
          return results;
        }
        async function evaluateBinary(expr, input, environment) {
          var result;
          var lhs = await evaluate(expr.lhs, input, environment);
          var op = expr.value;
          var evalrhs = async () => await evaluate(expr.rhs, input, environment);
          if (op === "and" || op === "or") {
            try {
              return await evaluateBooleanExpression(lhs, evalrhs, op);
            } catch (err) {
              err.position = expr.position;
              err.token = op;
              throw err;
            }
          }
          var rhs = await evalrhs();
          try {
            switch (op) {
              case "+":
              case "-":
              case "*":
              case "/":
              case "%":
                result = evaluateNumericExpression(lhs, rhs, op);
                break;
              case "=":
              case "!=":
                result = evaluateEqualityExpression(lhs, rhs, op);
                break;
              case "<":
              case "<=":
              case ">":
              case ">=":
                result = evaluateComparisonExpression(lhs, rhs, op);
                break;
              case "&":
                result = evaluateStringConcat(lhs, rhs);
                break;
              case "..":
                result = evaluateRangeExpression(lhs, rhs);
                break;
              case "in":
                result = evaluateIncludesExpression(lhs, rhs);
                break;
            }
          } catch (err) {
            err.position = expr.position;
            err.token = op;
            throw err;
          }
          return result;
        }
        async function evaluateUnary(expr, input, environment) {
          var result;
          switch (expr.value) {
            case "-":
              result = await evaluate(expr.expression, input, environment);
              if (typeof result === "undefined") {
                result = void 0;
              } else if (isNumeric(result)) {
                result = -result;
              } else {
                throw {
                  code: "D1002",
                  stack: new Error().stack,
                  position: expr.position,
                  token: expr.value,
                  value: result
                };
              }
              break;
            case "[":
              result = [];
              let generators = await Promise.all(expr.expressions.map(async (item2, idx) => {
                environment.isParallelCall = idx > 0;
                return [item2, await evaluate(item2, input, environment)];
              }));
              for (let generator of generators) {
                var [item, value] = generator;
                if (typeof value !== "undefined") {
                  if (item.value === "[") {
                    result.push(value);
                  } else {
                    result = fn2.append(result, value);
                  }
                }
              }
              if (expr.consarray) {
                Object.defineProperty(result, "cons", {
                  enumerable: false,
                  configurable: false,
                  value: true
                });
              }
              break;
            case "{":
              result = await evaluateGroupExpression(expr, input, environment);
              break;
          }
          return result;
        }
        function evaluateName(expr, input, environment) {
          return fn2.lookup(input, expr.value);
        }
        function evaluateLiteral(expr) {
          return expr.value;
        }
        function evaluateWildcard(expr, input) {
          var results = createSequence();
          if (Array.isArray(input) && input.outerWrapper && input.length > 0) {
            input = input[0];
          }
          if (input !== null && typeof input === "object") {
            Object.keys(input).forEach(function(key) {
              var value = input[key];
              if (Array.isArray(value)) {
                value = flatten(value);
                results = fn2.append(results, value);
              } else {
                results.push(value);
              }
            });
          }
          return results;
        }
        function flatten(arg, flattened) {
          if (typeof flattened === "undefined") {
            flattened = [];
          }
          if (Array.isArray(arg)) {
            arg.forEach(function(item) {
              flatten(item, flattened);
            });
          } else {
            flattened.push(arg);
          }
          return flattened;
        }
        function evaluateDescendants(expr, input) {
          var result;
          var resultSequence = createSequence();
          if (typeof input !== "undefined") {
            recurseDescendants(input, resultSequence);
            if (resultSequence.length === 1) {
              result = resultSequence[0];
            } else {
              result = resultSequence;
            }
          }
          return result;
        }
        function recurseDescendants(input, results) {
          if (!Array.isArray(input)) {
            results.push(input);
          }
          if (Array.isArray(input)) {
            input.forEach(function(member) {
              recurseDescendants(member, results);
            });
          } else if (input !== null && typeof input === "object") {
            Object.keys(input).forEach(function(key) {
              recurseDescendants(input[key], results);
            });
          }
        }
        function evaluateNumericExpression(lhs, rhs, op) {
          var result;
          if (typeof lhs !== "undefined" && !isNumeric(lhs)) {
            throw {
              code: "T2001",
              stack: new Error().stack,
              value: lhs
            };
          }
          if (typeof rhs !== "undefined" && !isNumeric(rhs)) {
            throw {
              code: "T2002",
              stack: new Error().stack,
              value: rhs
            };
          }
          if (typeof lhs === "undefined" || typeof rhs === "undefined") {
            return result;
          }
          switch (op) {
            case "+":
              result = lhs + rhs;
              break;
            case "-":
              result = lhs - rhs;
              break;
            case "*":
              result = lhs * rhs;
              break;
            case "/":
              result = lhs / rhs;
              break;
            case "%":
              result = lhs % rhs;
              break;
          }
          return result;
        }
        function evaluateEqualityExpression(lhs, rhs, op) {
          var result;
          var ltype = typeof lhs;
          var rtype = typeof rhs;
          if (ltype === "undefined" || rtype === "undefined") {
            return false;
          }
          switch (op) {
            case "=":
              result = isDeepEqual(lhs, rhs);
              break;
            case "!=":
              result = !isDeepEqual(lhs, rhs);
              break;
          }
          return result;
        }
        function evaluateComparisonExpression(lhs, rhs, op) {
          var result;
          var ltype = typeof lhs;
          var rtype = typeof rhs;
          var lcomparable = ltype === "undefined" || ltype === "string" || ltype === "number";
          var rcomparable = rtype === "undefined" || rtype === "string" || rtype === "number";
          if (!lcomparable || !rcomparable) {
            throw {
              code: "T2010",
              stack: new Error().stack,
              value: !(ltype === "string" || ltype === "number") ? lhs : rhs
            };
          }
          if (ltype === "undefined" || rtype === "undefined") {
            return void 0;
          }
          if (ltype !== rtype) {
            throw {
              code: "T2009",
              stack: new Error().stack,
              value: lhs,
              value2: rhs
            };
          }
          switch (op) {
            case "<":
              result = lhs < rhs;
              break;
            case "<=":
              result = lhs <= rhs;
              break;
            case ">":
              result = lhs > rhs;
              break;
            case ">=":
              result = lhs >= rhs;
              break;
          }
          return result;
        }
        function evaluateIncludesExpression(lhs, rhs) {
          var result = false;
          if (typeof lhs === "undefined" || typeof rhs === "undefined") {
            return false;
          }
          if (!Array.isArray(rhs)) {
            rhs = [rhs];
          }
          for (var i = 0; i < rhs.length; i++) {
            if (rhs[i] === lhs) {
              result = true;
              break;
            }
          }
          return result;
        }
        async function evaluateBooleanExpression(lhs, evalrhs, op) {
          var result;
          var lBool = boolize(lhs);
          switch (op) {
            case "and":
              result = lBool && boolize(await evalrhs());
              break;
            case "or":
              result = lBool || boolize(await evalrhs());
              break;
          }
          return result;
        }
        function boolize(value) {
          var booledValue = fn2.boolean(value);
          return typeof booledValue === "undefined" ? false : booledValue;
        }
        function evaluateStringConcat(lhs, rhs) {
          var result;
          var lstr = "";
          var rstr = "";
          if (typeof lhs !== "undefined") {
            lstr = fn2.string(lhs);
          }
          if (typeof rhs !== "undefined") {
            rstr = fn2.string(rhs);
          }
          result = lstr.concat(rstr);
          return result;
        }
        async function evaluateGroupExpression(expr, input, environment) {
          var result = {};
          var groups = {};
          var reduce = input && input.tupleStream ? true : false;
          if (!Array.isArray(input)) {
            input = createSequence(input);
          }
          if (input.length === 0) {
            input.push(void 0);
          }
          for (var itemIndex = 0; itemIndex < input.length; itemIndex++) {
            var item = input[itemIndex];
            var env = reduce ? createFrameFromTuple(environment, item) : environment;
            for (var pairIndex = 0; pairIndex < expr.lhs.length; pairIndex++) {
              var pair = expr.lhs[pairIndex];
              var key = await evaluate(pair[0], reduce ? item["@"] : item, env);
              if (typeof key !== "string" && key !== void 0) {
                throw {
                  code: "T1003",
                  stack: new Error().stack,
                  position: expr.position,
                  value: key
                };
              }
              if (key !== void 0) {
                var entry = { data: item, exprIndex: pairIndex };
                if (groups.hasOwnProperty(key)) {
                  if (groups[key].exprIndex !== pairIndex) {
                    throw {
                      code: "D1009",
                      stack: new Error().stack,
                      position: expr.position,
                      value: key
                    };
                  }
                  groups[key].data = fn2.append(groups[key].data, item);
                } else {
                  groups[key] = entry;
                }
              }
            }
          }
          let generators = await Promise.all(Object.keys(groups).map(async (key2, idx) => {
            let entry2 = groups[key2];
            var context = entry2.data;
            var env2 = environment;
            if (reduce) {
              var tuple = reduceTupleStream(entry2.data);
              context = tuple["@"];
              delete tuple["@"];
              env2 = createFrameFromTuple(environment, tuple);
            }
            environment.isParallelCall = idx > 0;
            return [key2, await evaluate(expr.lhs[entry2.exprIndex][1], context, env2)];
          }));
          for (let generator of generators) {
            var [key, value] = await generator;
            if (typeof value !== "undefined") {
              result[key] = value;
            }
          }
          return result;
        }
        function reduceTupleStream(tupleStream) {
          if (!Array.isArray(tupleStream)) {
            return tupleStream;
          }
          var result = {};
          Object.assign(result, tupleStream[0]);
          for (var ii = 1; ii < tupleStream.length; ii++) {
            for (const prop in tupleStream[ii]) {
              result[prop] = fn2.append(result[prop], tupleStream[ii][prop]);
            }
          }
          return result;
        }
        function evaluateRangeExpression(lhs, rhs) {
          var result;
          if (typeof lhs !== "undefined" && !Number.isInteger(lhs)) {
            throw {
              code: "T2003",
              stack: new Error().stack,
              value: lhs
            };
          }
          if (typeof rhs !== "undefined" && !Number.isInteger(rhs)) {
            throw {
              code: "T2004",
              stack: new Error().stack,
              value: rhs
            };
          }
          if (typeof lhs === "undefined" || typeof rhs === "undefined") {
            return result;
          }
          if (lhs > rhs) {
            return result;
          }
          var size = rhs - lhs + 1;
          if (size > 1e7) {
            throw {
              code: "D2014",
              stack: new Error().stack,
              value: size
            };
          }
          result = new Array(size);
          for (var item = lhs, index = 0; item <= rhs; item++, index++) {
            result[index] = item;
          }
          result.sequence = true;
          return result;
        }
        async function evaluateBindExpression(expr, input, environment) {
          var value = await evaluate(expr.rhs, input, environment);
          environment.bind(expr.lhs.value, value);
          return value;
        }
        async function evaluateCondition(expr, input, environment) {
          var result;
          var condition = await evaluate(expr.condition, input, environment);
          if (fn2.boolean(condition)) {
            result = await evaluate(expr.then, input, environment);
          } else if (typeof expr.else !== "undefined") {
            result = await evaluate(expr.else, input, environment);
          }
          return result;
        }
        async function evaluateBlock(expr, input, environment) {
          var result;
          var frame = createFrame(environment);
          for (var ii = 0; ii < expr.expressions.length; ii++) {
            result = await evaluate(expr.expressions[ii], input, frame);
          }
          return result;
        }
        function evaluateRegex(expr) {
          var re = new jsonata3.RegexEngine(expr.value);
          var closure = function(str, fromIndex) {
            var result;
            re.lastIndex = fromIndex || 0;
            var match = re.exec(str);
            if (match !== null) {
              result = {
                match: match[0],
                start: match.index,
                end: match.index + match[0].length,
                groups: []
              };
              if (match.length > 1) {
                for (var i = 1; i < match.length; i++) {
                  result.groups.push(match[i]);
                }
              }
              result.next = function() {
                if (re.lastIndex >= str.length) {
                  return void 0;
                } else {
                  var next = closure(str, re.lastIndex);
                  if (next && next.match === "") {
                    throw {
                      code: "D1004",
                      stack: new Error().stack,
                      position: expr.position,
                      value: expr.value.source
                    };
                  }
                  return next;
                }
              };
            }
            return result;
          };
          return closure;
        }
        function evaluateVariable(expr, input, environment) {
          var result;
          if (expr.value === "") {
            result = input && input.outerWrapper ? input[0] : input;
          } else {
            result = environment.lookup(expr.value);
          }
          return result;
        }
        async function evaluateSortExpression(expr, input, environment) {
          var result;
          var lhs = input;
          var isTupleSort = input.tupleStream ? true : false;
          var comparator = async function(a, b) {
            var comp = 0;
            for (var index = 0; comp === 0 && index < expr.terms.length; index++) {
              var term = expr.terms[index];
              var context = a;
              var env = environment;
              if (isTupleSort) {
                context = a["@"];
                env = createFrameFromTuple(environment, a);
              }
              var aa = await evaluate(term.expression, context, env);
              context = b;
              env = environment;
              if (isTupleSort) {
                context = b["@"];
                env = createFrameFromTuple(environment, b);
              }
              var bb = await evaluate(term.expression, context, env);
              var atype = typeof aa;
              var btype = typeof bb;
              if (atype === "undefined") {
                comp = btype === "undefined" ? 0 : 1;
                continue;
              }
              if (btype === "undefined") {
                comp = -1;
                continue;
              }
              if (!(atype === "string" || atype === "number") || !(btype === "string" || btype === "number")) {
                throw {
                  code: "T2008",
                  stack: new Error().stack,
                  position: expr.position,
                  value: !(atype === "string" || atype === "number") ? aa : bb
                };
              }
              if (atype !== btype) {
                throw {
                  code: "T2007",
                  stack: new Error().stack,
                  position: expr.position,
                  value: aa,
                  value2: bb
                };
              }
              if (aa === bb) {
                continue;
              } else if (aa < bb) {
                comp = -1;
              } else {
                comp = 1;
              }
              if (term.descending === true) {
                comp = -comp;
              }
            }
            return comp === 1;
          };
          var focus = {
            environment,
            input
          };
          result = await fn2.sort.apply(focus, [lhs, comparator]);
          return result;
        }
        function evaluateTransformExpression(expr, input, environment) {
          var transformer = async function(obj) {
            if (typeof obj === "undefined") {
              return void 0;
            }
            var cloneFunction = environment.lookup("clone");
            if (!isFunction(cloneFunction)) {
              throw {
                code: "T2013",
                stack: new Error().stack,
                position: expr.position
              };
            }
            var result = await apply(cloneFunction, [obj], null, environment);
            var matches = await evaluate(expr.pattern, result, environment);
            if (typeof matches !== "undefined") {
              if (!Array.isArray(matches)) {
                matches = [matches];
              }
              for (var ii = 0; ii < matches.length; ii++) {
                var match = matches[ii];
                var update = await evaluate(expr.update, match, environment);
                var updateType = typeof update;
                if (updateType !== "undefined") {
                  if (updateType !== "object" || update === null || Array.isArray(update)) {
                    throw {
                      code: "T2011",
                      stack: new Error().stack,
                      position: expr.update.position,
                      value: update
                    };
                  }
                  for (var prop in update) {
                    match[prop] = update[prop];
                  }
                }
                if (typeof expr.delete !== "undefined") {
                  var deletions = await evaluate(expr.delete, match, environment);
                  if (typeof deletions !== "undefined") {
                    var val = deletions;
                    if (!Array.isArray(deletions)) {
                      deletions = [deletions];
                    }
                    if (!isArrayOfStrings(deletions)) {
                      throw {
                        code: "T2012",
                        stack: new Error().stack,
                        position: expr.delete.position,
                        value: val
                      };
                    }
                    for (var jj = 0; jj < deletions.length; jj++) {
                      if (typeof match === "object" && match !== null) {
                        delete match[deletions[jj]];
                      }
                    }
                  }
                }
              }
            }
            return result;
          };
          return defineFunction(transformer, "<(oa):o>");
        }
        var chainAST = parser("function($f, $g) { function($x){ $g($f($x)) } }");
        async function evaluateApplyExpression(expr, input, environment) {
          var result;
          var lhs = await evaluate(expr.lhs, input, environment);
          if (expr.rhs.type === "function") {
            result = await evaluateFunction(expr.rhs, input, environment, { context: lhs });
          } else {
            var func = await evaluate(expr.rhs, input, environment);
            if (!isFunction(func)) {
              throw {
                code: "T2006",
                stack: new Error().stack,
                position: expr.position,
                value: func
              };
            }
            if (isFunction(lhs)) {
              var chain = await evaluate(chainAST, null, environment);
              result = await apply(chain, [lhs, func], null, environment);
            } else {
              result = await apply(func, [lhs], null, environment);
            }
          }
          return result;
        }
        async function evaluateFunction(expr, input, environment, applyto) {
          var result;
          var proc = await evaluate(expr.procedure, input, environment);
          if (typeof proc === "undefined" && expr.procedure.type === "path" && environment.lookup(expr.procedure.steps[0].value)) {
            throw {
              code: "T1005",
              stack: new Error().stack,
              position: expr.position,
              token: expr.procedure.steps[0].value
            };
          }
          var evaluatedArgs = [];
          if (typeof applyto !== "undefined") {
            evaluatedArgs.push(applyto.context);
          }
          for (var jj = 0; jj < expr.arguments.length; jj++) {
            const arg = await evaluate(expr.arguments[jj], input, environment);
            if (isFunction(arg)) {
              const closure = async function(...params) {
                return await apply(arg, params, null, environment);
              };
              closure.arity = getFunctionArity(arg);
              evaluatedArgs.push(closure);
            } else {
              evaluatedArgs.push(arg);
            }
          }
          var procName = expr.procedure.type === "path" ? expr.procedure.steps[0].value : expr.procedure.value;
          try {
            if (typeof proc === "object") {
              proc.token = procName;
              proc.position = expr.position;
            }
            result = await apply(proc, evaluatedArgs, input, environment);
          } catch (err) {
            if (!err.position) {
              err.position = expr.position;
            }
            if (!err.token) {
              err.token = procName;
            }
            throw err;
          }
          return result;
        }
        async function apply(proc, args, input, environment) {
          var result;
          result = await applyInner(proc, args, input, environment);
          while (isLambda(result) && result.thunk === true) {
            var next = await evaluate(result.body.procedure, result.input, result.environment);
            if (result.body.procedure.type === "variable") {
              next.token = result.body.procedure.value;
            }
            next.position = result.body.procedure.position;
            var evaluatedArgs = [];
            for (var ii = 0; ii < result.body.arguments.length; ii++) {
              evaluatedArgs.push(await evaluate(result.body.arguments[ii], result.input, result.environment));
            }
            result = await applyInner(next, evaluatedArgs, input, environment);
          }
          return result;
        }
        async function applyInner(proc, args, input, environment) {
          var result;
          try {
            var validatedArgs = args;
            if (proc) {
              validatedArgs = validateArguments(proc.signature, args, input);
            }
            if (isLambda(proc)) {
              result = await applyProcedure(proc, validatedArgs);
            } else if (proc && proc._jsonata_function === true) {
              var focus = {
                environment,
                input
              };
              result = proc.implementation.apply(focus, validatedArgs);
              if (isIterable(result)) {
                result = result.next().value;
              }
              if (isPromise(result)) {
                result = await result;
              }
            } else if (typeof proc === "function") {
              result = proc.apply(input, validatedArgs);
              if (isPromise(result)) {
                result = await result;
              }
            } else {
              throw {
                code: "T1006",
                stack: new Error().stack
              };
            }
          } catch (err) {
            if (proc) {
              if (typeof err.token == "undefined" && typeof proc.token !== "undefined") {
                err.token = proc.token;
              }
              err.position = proc.position;
            }
            throw err;
          }
          return result;
        }
        function evaluateLambda(expr, input, environment) {
          var procedure = {
            _jsonata_lambda: true,
            input,
            environment,
            arguments: expr.arguments,
            signature: expr.signature,
            body: expr.body
          };
          if (expr.thunk === true) {
            procedure.thunk = true;
          }
          procedure.apply = async function(self2, args) {
            return await apply(procedure, args, input, !!self2 ? self2.environment : environment);
          };
          return procedure;
        }
        async function evaluatePartialApplication(expr, input, environment) {
          var result;
          var evaluatedArgs = [];
          for (var ii = 0; ii < expr.arguments.length; ii++) {
            var arg = expr.arguments[ii];
            if (arg.type === "operator" && arg.value === "?") {
              evaluatedArgs.push(arg);
            } else {
              evaluatedArgs.push(await evaluate(arg, input, environment));
            }
          }
          var proc = await evaluate(expr.procedure, input, environment);
          if (typeof proc === "undefined" && expr.procedure.type === "path" && environment.lookup(expr.procedure.steps[0].value)) {
            throw {
              code: "T1007",
              stack: new Error().stack,
              position: expr.position,
              token: expr.procedure.steps[0].value
            };
          }
          if (isLambda(proc)) {
            result = partialApplyProcedure(proc, evaluatedArgs);
          } else if (proc && proc._jsonata_function === true) {
            result = partialApplyNativeFunction(proc.implementation, evaluatedArgs);
          } else if (typeof proc === "function") {
            result = partialApplyNativeFunction(proc, evaluatedArgs);
          } else {
            throw {
              code: "T1008",
              stack: new Error().stack,
              position: expr.position,
              token: expr.procedure.type === "path" ? expr.procedure.steps[0].value : expr.procedure.value
            };
          }
          return result;
        }
        function validateArguments(signature, args, context) {
          if (typeof signature === "undefined") {
            return args;
          }
          var validatedArgs = signature.validate(args, context);
          return validatedArgs;
        }
        async function applyProcedure(proc, args) {
          var result;
          var env = createFrame(proc.environment);
          proc.arguments.forEach(function(param, index) {
            env.bind(param.value, args[index]);
          });
          if (typeof proc.body === "function") {
            result = await applyNativeFunction(proc.body, env);
          } else {
            result = await evaluate(proc.body, proc.input, env);
          }
          return result;
        }
        function partialApplyProcedure(proc, args) {
          var env = createFrame(proc.environment);
          var unboundArgs = [];
          proc.arguments.forEach(function(param, index) {
            var arg = args[index];
            if (arg && arg.type === "operator" && arg.value === "?") {
              unboundArgs.push(param);
            } else {
              env.bind(param.value, arg);
            }
          });
          var procedure = {
            _jsonata_lambda: true,
            input: proc.input,
            environment: env,
            arguments: unboundArgs,
            body: proc.body
          };
          return procedure;
        }
        function partialApplyNativeFunction(native, args) {
          var sigArgs = getNativeFunctionArguments(native);
          sigArgs = sigArgs.map(function(sigArg) {
            return "$" + sigArg.trim();
          });
          var body = "function(" + sigArgs.join(", ") + "){ _ }";
          var bodyAST = parser(body);
          bodyAST.body = native;
          var partial = partialApplyProcedure(bodyAST, args);
          return partial;
        }
        async function applyNativeFunction(proc, env) {
          var sigArgs = getNativeFunctionArguments(proc);
          var args = sigArgs.map(function(sigArg) {
            return env.lookup(sigArg.trim());
          });
          var focus = {
            environment: env
          };
          var result = proc.apply(focus, args);
          if (isPromise(result)) {
            result = await result;
          }
          return result;
        }
        function getNativeFunctionArguments(func) {
          var signature = func.toString();
          var sigParens = /\(([^)]*)\)/.exec(signature)[1];
          var sigArgs = sigParens.split(",");
          return sigArgs;
        }
        function defineFunction(func, signature) {
          var definition = {
            _jsonata_function: true,
            implementation: func
          };
          if (typeof signature !== "undefined") {
            definition.signature = parseSignature(signature);
          }
          return definition;
        }
        async function functionEval(expr, focus) {
          if (typeof expr === "undefined") {
            return void 0;
          }
          var input = this.input;
          if (typeof focus !== "undefined") {
            input = focus;
            if (Array.isArray(input) && !isSequence(input)) {
              input = createSequence(input);
              input.outerWrapper = true;
            }
          }
          try {
            var ast = parser(expr, false);
          } catch (err) {
            populateMessage(err);
            throw {
              stack: new Error().stack,
              code: "D3120",
              value: err.message,
              error: err
            };
          }
          try {
            var result = await evaluate(ast, input, this.environment);
          } catch (err) {
            populateMessage(err);
            throw {
              stack: new Error().stack,
              code: "D3121",
              value: err.message,
              error: err
            };
          }
          return result;
        }
        function functionClone(arg) {
          if (typeof arg === "undefined") {
            return void 0;
          }
          return JSON.parse(fn2.string(arg));
        }
        function createFrame(enclosingEnvironment) {
          var bindings = {};
          return {
            bind: function(name, value) {
              bindings[name] = value;
            },
            lookup: function(name) {
              var value;
              if (bindings.hasOwnProperty(name)) {
                value = bindings[name];
              } else if (enclosingEnvironment) {
                value = enclosingEnvironment.lookup(name);
              }
              return value;
            },
            timestamp: enclosingEnvironment ? enclosingEnvironment.timestamp : null,
            async: enclosingEnvironment ? enclosingEnvironment.async : false,
            isParallelCall: enclosingEnvironment ? enclosingEnvironment.isParallelCall : false,
            global: enclosingEnvironment ? enclosingEnvironment.global : {
              ancestry: [null]
            }
          };
        }
        staticFrame.bind("sum", defineFunction(fn2.sum, "<a<n>:n>"));
        staticFrame.bind("count", defineFunction(fn2.count, "<a:n>"));
        staticFrame.bind("max", defineFunction(fn2.max, "<a<n>:n>"));
        staticFrame.bind("min", defineFunction(fn2.min, "<a<n>:n>"));
        staticFrame.bind("average", defineFunction(fn2.average, "<a<n>:n>"));
        staticFrame.bind("string", defineFunction(fn2.string, "<x-b?:s>"));
        staticFrame.bind("substring", defineFunction(fn2.substring, "<s-nn?:s>"));
        staticFrame.bind("substringBefore", defineFunction(fn2.substringBefore, "<s-s:s>"));
        staticFrame.bind("substringAfter", defineFunction(fn2.substringAfter, "<s-s:s>"));
        staticFrame.bind("lowercase", defineFunction(fn2.lowercase, "<s-:s>"));
        staticFrame.bind("uppercase", defineFunction(fn2.uppercase, "<s-:s>"));
        staticFrame.bind("length", defineFunction(fn2.length, "<s-:n>"));
        staticFrame.bind("trim", defineFunction(fn2.trim, "<s-:s>"));
        staticFrame.bind("pad", defineFunction(fn2.pad, "<s-ns?:s>"));
        staticFrame.bind("match", defineFunction(fn2.match, "<s-f<s:o>n?:a<o>>"));
        staticFrame.bind("contains", defineFunction(fn2.contains, "<s-(sf):b>"));
        staticFrame.bind("replace", defineFunction(fn2.replace, "<s-(sf)(sf)n?:s>"));
        staticFrame.bind("split", defineFunction(fn2.split, "<s-(sf)n?:a<s>>"));
        staticFrame.bind("join", defineFunction(fn2.join, "<a<s>s?:s>"));
        staticFrame.bind("formatNumber", defineFunction(fn2.formatNumber, "<n-so?:s>"));
        staticFrame.bind("formatBase", defineFunction(fn2.formatBase, "<n-n?:s>"));
        staticFrame.bind("formatInteger", defineFunction(datetime.formatInteger, "<n-s:s>"));
        staticFrame.bind("parseInteger", defineFunction(datetime.parseInteger, "<s-s:n>"));
        staticFrame.bind("number", defineFunction(fn2.number, "<(nsb)-:n>"));
        staticFrame.bind("floor", defineFunction(fn2.floor, "<n-:n>"));
        staticFrame.bind("ceil", defineFunction(fn2.ceil, "<n-:n>"));
        staticFrame.bind("round", defineFunction(fn2.round, "<n-n?:n>"));
        staticFrame.bind("abs", defineFunction(fn2.abs, "<n-:n>"));
        staticFrame.bind("sqrt", defineFunction(fn2.sqrt, "<n-:n>"));
        staticFrame.bind("power", defineFunction(fn2.power, "<n-n:n>"));
        staticFrame.bind("random", defineFunction(fn2.random, "<:n>"));
        staticFrame.bind("boolean", defineFunction(fn2.boolean, "<x-:b>"));
        staticFrame.bind("not", defineFunction(fn2.not, "<x-:b>"));
        staticFrame.bind("map", defineFunction(fn2.map, "<af>"));
        staticFrame.bind("zip", defineFunction(fn2.zip, "<a+>"));
        staticFrame.bind("filter", defineFunction(fn2.filter, "<af>"));
        staticFrame.bind("single", defineFunction(fn2.single, "<af?>"));
        staticFrame.bind("reduce", defineFunction(fn2.foldLeft, "<afj?:j>"));
        staticFrame.bind("sift", defineFunction(fn2.sift, "<o-f?:o>"));
        staticFrame.bind("keys", defineFunction(fn2.keys, "<x-:a<s>>"));
        staticFrame.bind("lookup", defineFunction(fn2.lookup, "<x-s:x>"));
        staticFrame.bind("append", defineFunction(fn2.append, "<xx:a>"));
        staticFrame.bind("exists", defineFunction(fn2.exists, "<x:b>"));
        staticFrame.bind("spread", defineFunction(fn2.spread, "<x-:a<o>>"));
        staticFrame.bind("merge", defineFunction(fn2.merge, "<a<o>:o>"));
        staticFrame.bind("reverse", defineFunction(fn2.reverse, "<a:a>"));
        staticFrame.bind("each", defineFunction(fn2.each, "<o-f:a>"));
        staticFrame.bind("error", defineFunction(fn2.error, "<s?:x>"));
        staticFrame.bind("assert", defineFunction(fn2.assert, "<bs?:x>"));
        staticFrame.bind("type", defineFunction(fn2.type, "<x:s>"));
        staticFrame.bind("sort", defineFunction(fn2.sort, "<af?:a>"));
        staticFrame.bind("shuffle", defineFunction(fn2.shuffle, "<a:a>"));
        staticFrame.bind("distinct", defineFunction(fn2.distinct, "<x:x>"));
        staticFrame.bind("base64encode", defineFunction(fn2.base64encode, "<s-:s>"));
        staticFrame.bind("base64decode", defineFunction(fn2.base64decode, "<s-:s>"));
        staticFrame.bind("encodeUrlComponent", defineFunction(fn2.encodeUrlComponent, "<s-:s>"));
        staticFrame.bind("encodeUrl", defineFunction(fn2.encodeUrl, "<s-:s>"));
        staticFrame.bind("decodeUrlComponent", defineFunction(fn2.decodeUrlComponent, "<s-:s>"));
        staticFrame.bind("decodeUrl", defineFunction(fn2.decodeUrl, "<s-:s>"));
        staticFrame.bind("eval", defineFunction(functionEval, "<sx?:x>"));
        staticFrame.bind("toMillis", defineFunction(datetime.toMillis, "<s-s?:n>"));
        staticFrame.bind("fromMillis", defineFunction(datetime.fromMillis, "<n-s?s?:s>"));
        staticFrame.bind("clone", defineFunction(functionClone, "<(oa)-:o>"));
        var errorCodes = {
          "S0101": "String literal must be terminated by a matching quote",
          "S0102": "Number out of range: {{token}}",
          "S0103": "Unsupported escape sequence: \\{{token}}",
          "S0104": "The escape sequence \\u must be followed by 4 hex digits",
          "S0105": "Quoted property name must be terminated with a backquote (`)",
          "S0106": "Comment has no closing tag",
          "S0201": "Syntax error: {{token}}",
          "S0202": "Expected {{value}}, got {{token}}",
          "S0203": "Expected {{value}} before end of expression",
          "S0204": "Unknown operator: {{token}}",
          "S0205": "Unexpected token: {{token}}",
          "S0206": "Unknown expression type: {{token}}",
          "S0207": "Unexpected end of expression",
          "S0208": "Parameter {{value}} of function definition must be a variable name (start with $)",
          "S0209": "A predicate cannot follow a grouping expression in a step",
          "S0210": "Each step can only have one grouping expression",
          "S0211": "The symbol {{token}} cannot be used as a unary operator",
          "S0212": "The left side of := must be a variable name (start with $)",
          "S0213": "The literal value {{value}} cannot be used as a step within a path expression",
          "S0214": "The right side of {{token}} must be a variable name (start with $)",
          "S0215": "A context variable binding must precede any predicates on a step",
          "S0216": "A context variable binding must precede the 'order-by' clause on a step",
          "S0217": "The object representing the 'parent' cannot be derived from this expression",
          "S0301": "Empty regular expressions are not allowed",
          "S0302": "No terminating / in regular expression",
          "S0402": "Choice groups containing parameterized types are not supported",
          "S0401": "Type parameters can only be applied to functions and arrays",
          "S0500": "Attempted to evaluate an expression containing syntax error(s)",
          "T0410": "Argument {{index}} of function {{token}} does not match function signature",
          "T0411": "Context value is not a compatible type with argument {{index}} of function {{token}}",
          "T0412": "Argument {{index}} of function {{token}} must be an array of {{type}}",
          "D1001": "Number out of range: {{value}}",
          "D1002": "Cannot negate a non-numeric value: {{value}}",
          "T1003": "Key in object structure must evaluate to a string; got: {{value}}",
          "D1004": "Regular expression matches zero length string",
          "T1005": "Attempted to invoke a non-function. Did you mean ${{{token}}}?",
          "T1006": "Attempted to invoke a non-function",
          "T1007": "Attempted to partially apply a non-function. Did you mean ${{{token}}}?",
          "T1008": "Attempted to partially apply a non-function",
          "D1009": "Multiple key definitions evaluate to same key: {{value}}",
          "T1010": "The matcher function argument passed to function {{token}} does not return the correct object structure",
          "T2001": "The left side of the {{token}} operator must evaluate to a number",
          "T2002": "The right side of the {{token}} operator must evaluate to a number",
          "T2003": "The left side of the range operator (..) must evaluate to an integer",
          "T2004": "The right side of the range operator (..) must evaluate to an integer",
          "D2005": "The left side of := must be a variable name (start with $)",
          // defunct - replaced by S0212 parser error
          "T2006": "The right side of the function application operator ~> must be a function",
          "T2007": "Type mismatch when comparing values {{value}} and {{value2}} in order-by clause",
          "T2008": "The expressions within an order-by clause must evaluate to numeric or string values",
          "T2009": "The values {{value}} and {{value2}} either side of operator {{token}} must be of the same data type",
          "T2010": "The expressions either side of operator {{token}} must evaluate to numeric or string values",
          "T2011": "The insert/update clause of the transform expression must evaluate to an object: {{value}}",
          "T2012": "The delete clause of the transform expression must evaluate to a string or array of strings: {{value}}",
          "T2013": "The transform expression clones the input object using the $clone() function.  This has been overridden in the current scope by a non-function.",
          "D2014": "The size of the sequence allocated by the range operator (..) must not exceed 1e6.  Attempted to allocate {{value}}.",
          "D3001": "Attempting to invoke string function on Infinity or NaN",
          "D3010": "Second argument of replace function cannot be an empty string",
          "D3011": "Fourth argument of replace function must evaluate to a positive number",
          "D3012": "Attempted to replace a matched string with a non-string value",
          "D3020": "Third argument of split function must evaluate to a positive number",
          "D3030": "Unable to cast value to a number: {{value}}",
          "D3040": "Third argument of match function must evaluate to a positive number",
          "D3050": "The second argument of reduce function must be a function with at least two arguments",
          "D3060": "The sqrt function cannot be applied to a negative number: {{value}}",
          "D3061": "The power function has resulted in a value that cannot be represented as a JSON number: base={{value}}, exponent={{exp}}",
          "D3070": "The single argument form of the sort function can only be applied to an array of strings or an array of numbers.  Use the second argument to specify a comparison function",
          "D3080": "The picture string must only contain a maximum of two sub-pictures",
          "D3081": "The sub-picture must not contain more than one instance of the 'decimal-separator' character",
          "D3082": "The sub-picture must not contain more than one instance of the 'percent' character",
          "D3083": "The sub-picture must not contain more than one instance of the 'per-mille' character",
          "D3084": "The sub-picture must not contain both a 'percent' and a 'per-mille' character",
          "D3085": "The mantissa part of a sub-picture must contain at least one character that is either an 'optional digit character' or a member of the 'decimal digit family'",
          "D3086": "The sub-picture must not contain a passive character that is preceded by an active character and that is followed by another active character",
          "D3087": "The sub-picture must not contain a 'grouping-separator' character that appears adjacent to a 'decimal-separator' character",
          "D3088": "The sub-picture must not contain a 'grouping-separator' at the end of the integer part",
          "D3089": "The sub-picture must not contain two adjacent instances of the 'grouping-separator' character",
          "D3090": "The integer part of the sub-picture must not contain a member of the 'decimal digit family' that is followed by an instance of the 'optional digit character'",
          "D3091": "The fractional part of the sub-picture must not contain an instance of the 'optional digit character' that is followed by a member of the 'decimal digit family'",
          "D3092": "A sub-picture that contains a 'percent' or 'per-mille' character must not contain a character treated as an 'exponent-separator'",
          "D3093": "The exponent part of the sub-picture must comprise only of one or more characters that are members of the 'decimal digit family'",
          "D3100": "The radix of the formatBase function must be between 2 and 36.  It was given {{value}}",
          "D3110": "The argument of the toMillis function must be an ISO 8601 formatted timestamp. Given {{value}}",
          "D3120": "Syntax error in expression passed to function eval: {{value}}",
          "D3121": "Dynamic error evaluating the expression passed to function eval: {{value}}",
          "D3130": "Formatting or parsing an integer as a sequence starting with {{value}} is not supported by this implementation",
          "D3131": "In a decimal digit pattern, all digits must be from the same decimal group",
          "D3132": "Unknown component specifier {{value}} in date/time picture string",
          "D3133": "The 'name' modifier can only be applied to months and days in the date/time picture string, not {{value}}",
          "D3134": "The timezone integer format specifier cannot have more than four digits",
          "D3135": "No matching closing bracket ']' in date/time picture string",
          "D3136": "The date/time picture string is missing specifiers required to parse the timestamp",
          "D3137": "{{{message}}}",
          "D3138": "The $single() function expected exactly 1 matching result.  Instead it matched more.",
          "D3139": "The $single() function expected exactly 1 matching result.  Instead it matched 0.",
          "D3140": "Malformed URL passed to ${{{functionName}}}(): {{value}}",
          "D3141": "{{{message}}}"
        };
        function populateMessage(err) {
          var template = errorCodes[err.code];
          if (typeof template !== "undefined") {
            var message = template.replace(/\{\{\{([^}]+)}}}/g, function() {
              return err[arguments[1]];
            });
            message = message.replace(/\{\{([^}]+)}}/g, function() {
              return JSON.stringify(err[arguments[1]]);
            });
            err.message = message;
          }
        }
        function jsonata3(expr, options) {
          var ast;
          var errors;
          try {
            ast = parser(expr, options && options.recover);
            errors = ast.errors;
            delete ast.errors;
          } catch (err) {
            populateMessage(err);
            throw err;
          }
          var environment = createFrame(staticFrame);
          var timestamp = /* @__PURE__ */ new Date();
          environment.bind("now", defineFunction(function(picture, timezone) {
            return datetime.fromMillis(timestamp.getTime(), picture, timezone);
          }, "<s?s?:s>"));
          environment.bind("millis", defineFunction(function() {
            return timestamp.getTime();
          }, "<:n>"));
          if (options && options.RegexEngine) {
            jsonata3.RegexEngine = options.RegexEngine;
          } else {
            jsonata3.RegexEngine = RegExp;
          }
          return {
            evaluate: async function(input, bindings, callback) {
              if (typeof errors !== "undefined") {
                var err = {
                  code: "S0500",
                  position: 0
                };
                populateMessage(err);
                throw err;
              }
              if (typeof bindings !== "undefined") {
                var exec_env;
                exec_env = createFrame(environment);
                for (var v in bindings) {
                  exec_env.bind(v, bindings[v]);
                }
              } else {
                exec_env = environment;
              }
              exec_env.bind("$", input);
              timestamp = /* @__PURE__ */ new Date();
              exec_env.timestamp = timestamp;
              if (Array.isArray(input) && !isSequence(input)) {
                input = createSequence(input);
                input.outerWrapper = true;
              }
              var it;
              try {
                it = await evaluate(ast, input, exec_env);
                if (typeof callback === "function") {
                  callback(null, it);
                }
                return it;
              } catch (err2) {
                populateMessage(err2);
                throw err2;
              }
            },
            assign: function(name, value) {
              environment.bind(name, value);
            },
            registerFunction: function(name, implementation, signature) {
              var func = defineFunction(implementation, signature);
              environment.bind(name, func);
            },
            ast: function() {
              return ast;
            },
            errors: function() {
              return errors;
            }
          };
        }
        jsonata3.parser = parser;
        return jsonata3;
      }();
      module2.exports = jsonata2;
    }, { "./datetime": 1, "./functions": 2, "./parser": 4, "./signature": 5, "./utils": 6 }], 4: [function(require2, module2, exports2) {
      var parseSignature = require2("./signature");
      const parser = (() => {
        var operators = {
          ".": 75,
          "[": 80,
          "]": 0,
          "{": 70,
          "}": 0,
          "(": 80,
          ")": 0,
          ",": 0,
          "@": 80,
          "#": 80,
          ";": 80,
          ":": 80,
          "?": 20,
          "+": 50,
          "-": 50,
          "*": 60,
          "/": 60,
          "%": 60,
          "|": 20,
          "=": 40,
          "<": 40,
          ">": 40,
          "^": 40,
          "**": 60,
          "..": 20,
          ":=": 10,
          "!=": 40,
          "<=": 40,
          ">=": 40,
          "~>": 40,
          "and": 30,
          "or": 25,
          "in": 40,
          "&": 50,
          "!": 0,
          // not an operator, but needed as a stop character for name tokens
          "~": 0
          // not an operator, but needed as a stop character for name tokens
        };
        var escapes = {
          // JSON string escape sequences - see json.org
          '"': '"',
          "\\": "\\",
          "/": "/",
          "b": "\b",
          "f": "\f",
          "n": "\n",
          "r": "\r",
          "t": "	"
        };
        var tokenizer = function(path) {
          var position = 0;
          var length = path.length;
          var create = function(type, value) {
            var obj = { type, value, position };
            return obj;
          };
          var scanRegex = function() {
            var start = position;
            var depth = 0;
            var pattern;
            var flags;
            var isClosingSlash = function(position2) {
              if (path.charAt(position2) === "/" && depth === 0) {
                var backslashCount = 0;
                while (path.charAt(position2 - (backslashCount + 1)) === "\\") {
                  backslashCount++;
                }
                if (backslashCount % 2 === 0) {
                  return true;
                }
              }
              return false;
            };
            while (position < length) {
              var currentChar = path.charAt(position);
              if (isClosingSlash(position)) {
                pattern = path.substring(start, position);
                if (pattern === "") {
                  throw {
                    code: "S0301",
                    stack: new Error().stack,
                    position
                  };
                }
                position++;
                currentChar = path.charAt(position);
                start = position;
                while (currentChar === "i" || currentChar === "m") {
                  position++;
                  currentChar = path.charAt(position);
                }
                flags = path.substring(start, position) + "g";
                return new RegExp(pattern, flags);
              }
              if ((currentChar === "(" || currentChar === "[" || currentChar === "{") && path.charAt(position - 1) !== "\\") {
                depth++;
              }
              if ((currentChar === ")" || currentChar === "]" || currentChar === "}") && path.charAt(position - 1) !== "\\") {
                depth--;
              }
              position++;
            }
            throw {
              code: "S0302",
              stack: new Error().stack,
              position
            };
          };
          var next = function(prefix) {
            if (position >= length)
              return null;
            var currentChar = path.charAt(position);
            while (position < length && " 	\n\r\v".indexOf(currentChar) > -1) {
              position++;
              currentChar = path.charAt(position);
            }
            if (currentChar === "/" && path.charAt(position + 1) === "*") {
              var commentStart = position;
              position += 2;
              currentChar = path.charAt(position);
              while (!(currentChar === "*" && path.charAt(position + 1) === "/")) {
                currentChar = path.charAt(++position);
                if (position >= length) {
                  throw {
                    code: "S0106",
                    stack: new Error().stack,
                    position: commentStart
                  };
                }
              }
              position += 2;
              currentChar = path.charAt(position);
              return next(prefix);
            }
            if (prefix !== true && currentChar === "/") {
              position++;
              return create("regex", scanRegex());
            }
            if (currentChar === "." && path.charAt(position + 1) === ".") {
              position += 2;
              return create("operator", "..");
            }
            if (currentChar === ":" && path.charAt(position + 1) === "=") {
              position += 2;
              return create("operator", ":=");
            }
            if (currentChar === "!" && path.charAt(position + 1) === "=") {
              position += 2;
              return create("operator", "!=");
            }
            if (currentChar === ">" && path.charAt(position + 1) === "=") {
              position += 2;
              return create("operator", ">=");
            }
            if (currentChar === "<" && path.charAt(position + 1) === "=") {
              position += 2;
              return create("operator", "<=");
            }
            if (currentChar === "*" && path.charAt(position + 1) === "*") {
              position += 2;
              return create("operator", "**");
            }
            if (currentChar === "~" && path.charAt(position + 1) === ">") {
              position += 2;
              return create("operator", "~>");
            }
            if (Object.prototype.hasOwnProperty.call(operators, currentChar)) {
              position++;
              return create("operator", currentChar);
            }
            if (currentChar === '"' || currentChar === "'") {
              var quoteType = currentChar;
              position++;
              var qstr = "";
              while (position < length) {
                currentChar = path.charAt(position);
                if (currentChar === "\\") {
                  position++;
                  currentChar = path.charAt(position);
                  if (Object.prototype.hasOwnProperty.call(escapes, currentChar)) {
                    qstr += escapes[currentChar];
                  } else if (currentChar === "u") {
                    var octets = path.substr(position + 1, 4);
                    if (/^[0-9a-fA-F]+$/.test(octets)) {
                      var codepoint = parseInt(octets, 16);
                      qstr += String.fromCharCode(codepoint);
                      position += 4;
                    } else {
                      throw {
                        code: "S0104",
                        stack: new Error().stack,
                        position
                      };
                    }
                  } else {
                    throw {
                      code: "S0103",
                      stack: new Error().stack,
                      position,
                      token: currentChar
                    };
                  }
                } else if (currentChar === quoteType) {
                  position++;
                  return create("string", qstr);
                } else {
                  qstr += currentChar;
                }
                position++;
              }
              throw {
                code: "S0101",
                stack: new Error().stack,
                position
              };
            }
            var numregex = /^-?(0|([1-9][0-9]*))(\.[0-9]+)?([Ee][-+]?[0-9]+)?/;
            var match = numregex.exec(path.substring(position));
            if (match !== null) {
              var num = parseFloat(match[0]);
              if (!isNaN(num) && isFinite(num)) {
                position += match[0].length;
                return create("number", num);
              } else {
                throw {
                  code: "S0102",
                  stack: new Error().stack,
                  position,
                  token: match[0]
                };
              }
            }
            var name;
            if (currentChar === "`") {
              position++;
              var end = path.indexOf("`", position);
              if (end !== -1) {
                name = path.substring(position, end);
                position = end + 1;
                return create("name", name);
              }
              position = length;
              throw {
                code: "S0105",
                stack: new Error().stack,
                position
              };
            }
            var i = position;
            var ch;
            for (; ; ) {
              ch = path.charAt(i);
              if (i === length || " 	\n\r\v".indexOf(ch) > -1 || Object.prototype.hasOwnProperty.call(operators, ch)) {
                if (path.charAt(position) === "$") {
                  name = path.substring(position + 1, i);
                  position = i;
                  return create("variable", name);
                } else {
                  name = path.substring(position, i);
                  position = i;
                  switch (name) {
                    case "or":
                    case "in":
                    case "and":
                      return create("operator", name);
                    case "true":
                      return create("value", true);
                    case "false":
                      return create("value", false);
                    case "null":
                      return create("value", null);
                    default:
                      if (position === length && name === "") {
                        return null;
                      }
                      return create("name", name);
                  }
                }
              } else {
                i++;
              }
            }
          };
          return next;
        };
        var parser2 = function(source, recover) {
          var node;
          var lexer;
          var symbol_table = {};
          var errors = [];
          var remainingTokens = function() {
            var remaining = [];
            if (node.id !== "(end)") {
              remaining.push({ type: node.type, value: node.value, position: node.position });
            }
            var nxt = lexer();
            while (nxt !== null) {
              remaining.push(nxt);
              nxt = lexer();
            }
            return remaining;
          };
          var base_symbol = {
            nud: function() {
              var err2 = {
                code: "S0211",
                token: this.value,
                position: this.position
              };
              if (recover) {
                err2.remaining = remainingTokens();
                err2.type = "error";
                errors.push(err2);
                return err2;
              } else {
                err2.stack = new Error().stack;
                throw err2;
              }
            }
          };
          var symbol = function(id, bp) {
            var s = symbol_table[id];
            bp = bp || 0;
            if (s) {
              if (bp >= s.lbp) {
                s.lbp = bp;
              }
            } else {
              s = Object.create(base_symbol);
              s.id = s.value = id;
              s.lbp = bp;
              symbol_table[id] = s;
            }
            return s;
          };
          var handleError = function(err2) {
            if (recover) {
              err2.remaining = remainingTokens();
              errors.push(err2);
              var symbol2 = symbol_table["(error)"];
              node = Object.create(symbol2);
              node.error = err2;
              node.type = "(error)";
              return node;
            } else {
              err2.stack = new Error().stack;
              throw err2;
            }
          };
          var advance = function(id, infix2) {
            if (id && node.id !== id) {
              var code;
              if (node.id === "(end)") {
                code = "S0203";
              } else {
                code = "S0202";
              }
              var err2 = {
                code,
                position: node.position,
                token: node.value,
                value: id
              };
              return handleError(err2);
            }
            var next_token = lexer(infix2);
            if (next_token === null) {
              node = symbol_table["(end)"];
              node.position = source.length;
              return node;
            }
            var value = next_token.value;
            var type = next_token.type;
            var symbol2;
            switch (type) {
              case "name":
              case "variable":
                symbol2 = symbol_table["(name)"];
                break;
              case "operator":
                symbol2 = symbol_table[value];
                if (!symbol2) {
                  return handleError({
                    code: "S0204",
                    stack: new Error().stack,
                    position: next_token.position,
                    token: value
                  });
                }
                break;
              case "string":
              case "number":
              case "value":
                symbol2 = symbol_table["(literal)"];
                break;
              case "regex":
                type = "regex";
                symbol2 = symbol_table["(regex)"];
                break;
              default:
                return handleError({
                  code: "S0205",
                  stack: new Error().stack,
                  position: next_token.position,
                  token: value
                });
            }
            node = Object.create(symbol2);
            node.value = value;
            node.type = type;
            node.position = next_token.position;
            return node;
          };
          var expression = function(rbp) {
            var left;
            var t = node;
            advance(null, true);
            left = t.nud();
            while (rbp < node.lbp) {
              t = node;
              advance();
              left = t.led(left);
            }
            return left;
          };
          var terminal = function(id) {
            var s = symbol(id, 0);
            s.nud = function() {
              return this;
            };
          };
          var infix = function(id, bp, led) {
            var bindingPower = bp || operators[id];
            var s = symbol(id, bindingPower);
            s.led = led || function(left) {
              this.lhs = left;
              this.rhs = expression(bindingPower);
              this.type = "binary";
              return this;
            };
            return s;
          };
          var infixr = function(id, bp, led) {
            var s = symbol(id, bp);
            s.led = led;
            return s;
          };
          var prefix = function(id, nud) {
            var s = symbol(id);
            s.nud = nud || function() {
              this.expression = expression(70);
              this.type = "unary";
              return this;
            };
            return s;
          };
          terminal("(end)");
          terminal("(name)");
          terminal("(literal)");
          terminal("(regex)");
          symbol(":");
          symbol(";");
          symbol(",");
          symbol(")");
          symbol("]");
          symbol("}");
          symbol("..");
          infix(".");
          infix("+");
          infix("-");
          infix("*");
          infix("/");
          infix("%");
          infix("=");
          infix("<");
          infix(">");
          infix("!=");
          infix("<=");
          infix(">=");
          infix("&");
          infix("and");
          infix("or");
          infix("in");
          terminal("and");
          terminal("or");
          terminal("in");
          prefix("-");
          infix("~>");
          infixr("(error)", 10, function(left) {
            this.lhs = left;
            this.error = node.error;
            this.remaining = remainingTokens();
            this.type = "error";
            return this;
          });
          prefix("*", function() {
            this.type = "wildcard";
            return this;
          });
          prefix("**", function() {
            this.type = "descendant";
            return this;
          });
          prefix("%", function() {
            this.type = "parent";
            return this;
          });
          infix("(", operators["("], function(left) {
            this.procedure = left;
            this.type = "function";
            this.arguments = [];
            if (node.id !== ")") {
              for (; ; ) {
                if (node.type === "operator" && node.id === "?") {
                  this.type = "partial";
                  this.arguments.push(node);
                  advance("?");
                } else {
                  this.arguments.push(expression(0));
                }
                if (node.id !== ",")
                  break;
                advance(",");
              }
            }
            advance(")", true);
            if (left.type === "name" && (left.value === "function" || left.value === "λ")) {
              this.arguments.forEach(function(arg, index) {
                if (arg.type !== "variable") {
                  return handleError({
                    code: "S0208",
                    stack: new Error().stack,
                    position: arg.position,
                    token: arg.value,
                    value: index + 1
                  });
                }
              });
              this.type = "lambda";
              if (node.id === "<") {
                var sigPos = node.position;
                var depth = 1;
                var sig = "<";
                while (depth > 0 && node.id !== "{" && node.id !== "(end)") {
                  var tok = advance();
                  if (tok.id === ">") {
                    depth--;
                  } else if (tok.id === "<") {
                    depth++;
                  }
                  sig += tok.value;
                }
                advance(">");
                try {
                  this.signature = parseSignature(sig);
                } catch (err2) {
                  err2.position = sigPos + err2.offset;
                  return handleError(err2);
                }
              }
              advance("{");
              this.body = expression(0);
              advance("}");
            }
            return this;
          });
          prefix("(", function() {
            var expressions = [];
            while (node.id !== ")") {
              expressions.push(expression(0));
              if (node.id !== ";") {
                break;
              }
              advance(";");
            }
            advance(")", true);
            this.type = "block";
            this.expressions = expressions;
            return this;
          });
          prefix("[", function() {
            var a = [];
            if (node.id !== "]") {
              for (; ; ) {
                var item = expression(0);
                if (node.id === "..") {
                  var range = { type: "binary", value: "..", position: node.position, lhs: item };
                  advance("..");
                  range.rhs = expression(0);
                  item = range;
                }
                a.push(item);
                if (node.id !== ",") {
                  break;
                }
                advance(",");
              }
            }
            advance("]", true);
            this.expressions = a;
            this.type = "unary";
            return this;
          });
          infix("[", operators["["], function(left) {
            if (node.id === "]") {
              var step = left;
              while (step && step.type === "binary" && step.value === "[") {
                step = step.lhs;
              }
              step.keepArray = true;
              advance("]");
              return left;
            } else {
              this.lhs = left;
              this.rhs = expression(operators["]"]);
              this.type = "binary";
              advance("]", true);
              return this;
            }
          });
          infix("^", operators["^"], function(left) {
            advance("(");
            var terms = [];
            for (; ; ) {
              var term = {
                descending: false
              };
              if (node.id === "<") {
                advance("<");
              } else if (node.id === ">") {
                term.descending = true;
                advance(">");
              } else
                ;
              term.expression = expression(0);
              terms.push(term);
              if (node.id !== ",") {
                break;
              }
              advance(",");
            }
            advance(")");
            this.lhs = left;
            this.rhs = terms;
            this.type = "binary";
            return this;
          });
          var objectParser = function(left) {
            var a = [];
            if (node.id !== "}") {
              for (; ; ) {
                var n = expression(0);
                advance(":");
                var v = expression(0);
                a.push([n, v]);
                if (node.id !== ",") {
                  break;
                }
                advance(",");
              }
            }
            advance("}", true);
            if (typeof left === "undefined") {
              this.lhs = a;
              this.type = "unary";
            } else {
              this.lhs = left;
              this.rhs = a;
              this.type = "binary";
            }
            return this;
          };
          prefix("{", objectParser);
          infix("{", operators["{"], objectParser);
          infixr(":=", operators[":="], function(left) {
            if (left.type !== "variable") {
              return handleError({
                code: "S0212",
                stack: new Error().stack,
                position: left.position,
                token: left.value
              });
            }
            this.lhs = left;
            this.rhs = expression(operators[":="] - 1);
            this.type = "binary";
            return this;
          });
          infix("@", operators["@"], function(left) {
            this.lhs = left;
            this.rhs = expression(operators["@"]);
            if (this.rhs.type !== "variable") {
              return handleError({
                code: "S0214",
                stack: new Error().stack,
                position: this.rhs.position,
                token: "@"
              });
            }
            this.type = "binary";
            return this;
          });
          infix("#", operators["#"], function(left) {
            this.lhs = left;
            this.rhs = expression(operators["#"]);
            if (this.rhs.type !== "variable") {
              return handleError({
                code: "S0214",
                stack: new Error().stack,
                position: this.rhs.position,
                token: "#"
              });
            }
            this.type = "binary";
            return this;
          });
          infix("?", operators["?"], function(left) {
            this.type = "condition";
            this.condition = left;
            this.then = expression(0);
            if (node.id === ":") {
              advance(":");
              this.else = expression(0);
            }
            return this;
          });
          prefix("|", function() {
            this.type = "transform";
            this.pattern = expression(0);
            advance("|");
            this.update = expression(0);
            if (node.id === ",") {
              advance(",");
              this.delete = expression(0);
            }
            advance("|");
            return this;
          });
          var tailCallOptimize = function(expr2) {
            var result;
            if (expr2.type === "function" && !expr2.predicate) {
              var thunk = { type: "lambda", thunk: true, arguments: [], position: expr2.position };
              thunk.body = expr2;
              result = thunk;
            } else if (expr2.type === "condition") {
              expr2.then = tailCallOptimize(expr2.then);
              if (typeof expr2.else !== "undefined") {
                expr2.else = tailCallOptimize(expr2.else);
              }
              result = expr2;
            } else if (expr2.type === "block") {
              var length = expr2.expressions.length;
              if (length > 0) {
                expr2.expressions[length - 1] = tailCallOptimize(expr2.expressions[length - 1]);
              }
              result = expr2;
            } else {
              result = expr2;
            }
            return result;
          };
          var ancestorLabel = 0;
          var ancestorIndex = 0;
          var ancestry = [];
          var seekParent = function(node2, slot) {
            switch (node2.type) {
              case "name":
              case "wildcard":
                slot.level--;
                if (slot.level === 0) {
                  if (typeof node2.ancestor === "undefined") {
                    node2.ancestor = slot;
                  } else {
                    ancestry[slot.index].slot.label = node2.ancestor.label;
                    node2.ancestor = slot;
                  }
                  node2.tuple = true;
                }
                break;
              case "parent":
                slot.level++;
                break;
              case "block":
                if (node2.expressions.length > 0) {
                  node2.tuple = true;
                  slot = seekParent(node2.expressions[node2.expressions.length - 1], slot);
                }
                break;
              case "path":
                node2.tuple = true;
                var index = node2.steps.length - 1;
                slot = seekParent(node2.steps[index--], slot);
                while (slot.level > 0 && index >= 0) {
                  slot = seekParent(node2.steps[index--], slot);
                }
                break;
              default:
                throw {
                  code: "S0217",
                  token: node2.type,
                  position: node2.position
                };
            }
            return slot;
          };
          var pushAncestry = function(result, value) {
            if (typeof value.seekingParent !== "undefined" || value.type === "parent") {
              var slots = typeof value.seekingParent !== "undefined" ? value.seekingParent : [];
              if (value.type === "parent") {
                slots.push(value.slot);
              }
              if (typeof result.seekingParent === "undefined") {
                result.seekingParent = slots;
              } else {
                Array.prototype.push.apply(result.seekingParent, slots);
              }
            }
          };
          var resolveAncestry = function(path) {
            var index = path.steps.length - 1;
            var laststep = path.steps[index];
            var slots = typeof laststep.seekingParent !== "undefined" ? laststep.seekingParent : [];
            if (laststep.type === "parent") {
              slots.push(laststep.slot);
            }
            for (var is = 0; is < slots.length; is++) {
              var slot = slots[is];
              index = path.steps.length - 2;
              while (slot.level > 0) {
                if (index < 0) {
                  if (typeof path.seekingParent === "undefined") {
                    path.seekingParent = [slot];
                  } else {
                    path.seekingParent.push(slot);
                  }
                  break;
                }
                var step = path.steps[index--];
                while (index >= 0 && step.focus && path.steps[index].focus) {
                  step = path.steps[index--];
                }
                slot = seekParent(step, slot);
              }
            }
          };
          var processAST = function(expr2) {
            var result;
            switch (expr2.type) {
              case "binary":
                switch (expr2.value) {
                  case ".":
                    var lstep = processAST(expr2.lhs);
                    if (lstep.type === "path") {
                      result = lstep;
                    } else {
                      result = { type: "path", steps: [lstep] };
                    }
                    if (lstep.type === "parent") {
                      result.seekingParent = [lstep.slot];
                    }
                    var rest = processAST(expr2.rhs);
                    if (rest.type === "function" && rest.procedure.type === "path" && rest.procedure.steps.length === 1 && rest.procedure.steps[0].type === "name" && result.steps[result.steps.length - 1].type === "function") {
                      result.steps[result.steps.length - 1].nextFunction = rest.procedure.steps[0].value;
                    }
                    if (rest.type === "path") {
                      Array.prototype.push.apply(result.steps, rest.steps);
                    } else {
                      if (typeof rest.predicate !== "undefined") {
                        rest.stages = rest.predicate;
                        delete rest.predicate;
                      }
                      result.steps.push(rest);
                    }
                    result.steps.filter(function(step2) {
                      if (step2.type === "number" || step2.type === "value") {
                        throw {
                          code: "S0213",
                          stack: new Error().stack,
                          position: step2.position,
                          value: step2.value
                        };
                      }
                      return step2.type === "string";
                    }).forEach(function(lit) {
                      lit.type = "name";
                    });
                    if (result.steps.filter(function(step2) {
                      return step2.keepArray === true;
                    }).length > 0) {
                      result.keepSingletonArray = true;
                    }
                    var firststep = result.steps[0];
                    if (firststep.type === "unary" && firststep.value === "[") {
                      firststep.consarray = true;
                    }
                    var laststep = result.steps[result.steps.length - 1];
                    if (laststep.type === "unary" && laststep.value === "[") {
                      laststep.consarray = true;
                    }
                    resolveAncestry(result);
                    break;
                  case "[":
                    result = processAST(expr2.lhs);
                    var step = result;
                    var type = "predicate";
                    if (result.type === "path") {
                      step = result.steps[result.steps.length - 1];
                      type = "stages";
                    }
                    if (typeof step.group !== "undefined") {
                      throw {
                        code: "S0209",
                        stack: new Error().stack,
                        position: expr2.position
                      };
                    }
                    if (typeof step[type] === "undefined") {
                      step[type] = [];
                    }
                    var predicate = processAST(expr2.rhs);
                    if (typeof predicate.seekingParent !== "undefined") {
                      predicate.seekingParent.forEach((slot) => {
                        if (slot.level === 1) {
                          seekParent(step, slot);
                        } else {
                          slot.level--;
                        }
                      });
                      pushAncestry(step, predicate);
                    }
                    step[type].push({ type: "filter", expr: predicate, position: expr2.position });
                    break;
                  case "{":
                    result = processAST(expr2.lhs);
                    if (typeof result.group !== "undefined") {
                      throw {
                        code: "S0210",
                        stack: new Error().stack,
                        position: expr2.position
                      };
                    }
                    result.group = {
                      lhs: expr2.rhs.map(function(pair) {
                        return [processAST(pair[0]), processAST(pair[1])];
                      }),
                      position: expr2.position
                    };
                    break;
                  case "^":
                    result = processAST(expr2.lhs);
                    if (result.type !== "path") {
                      result = { type: "path", steps: [result] };
                    }
                    var sortStep = { type: "sort", position: expr2.position };
                    sortStep.terms = expr2.rhs.map(function(terms) {
                      var expression2 = processAST(terms.expression);
                      pushAncestry(sortStep, expression2);
                      return {
                        descending: terms.descending,
                        expression: expression2
                      };
                    });
                    result.steps.push(sortStep);
                    resolveAncestry(result);
                    break;
                  case ":=":
                    result = { type: "bind", value: expr2.value, position: expr2.position };
                    result.lhs = processAST(expr2.lhs);
                    result.rhs = processAST(expr2.rhs);
                    pushAncestry(result, result.rhs);
                    break;
                  case "@":
                    result = processAST(expr2.lhs);
                    step = result;
                    if (result.type === "path") {
                      step = result.steps[result.steps.length - 1];
                    }
                    if (typeof step.stages !== "undefined" || typeof step.predicate !== "undefined") {
                      throw {
                        code: "S0215",
                        stack: new Error().stack,
                        position: expr2.position
                      };
                    }
                    if (step.type === "sort") {
                      throw {
                        code: "S0216",
                        stack: new Error().stack,
                        position: expr2.position
                      };
                    }
                    if (expr2.keepArray) {
                      step.keepArray = true;
                    }
                    step.focus = expr2.rhs.value;
                    step.tuple = true;
                    break;
                  case "#":
                    result = processAST(expr2.lhs);
                    step = result;
                    if (result.type === "path") {
                      step = result.steps[result.steps.length - 1];
                    } else {
                      result = { type: "path", steps: [result] };
                      if (typeof step.predicate !== "undefined") {
                        step.stages = step.predicate;
                        delete step.predicate;
                      }
                    }
                    if (typeof step.stages === "undefined") {
                      step.index = expr2.rhs.value;
                    } else {
                      step.stages.push({ type: "index", value: expr2.rhs.value, position: expr2.position });
                    }
                    step.tuple = true;
                    break;
                  case "~>":
                    result = { type: "apply", value: expr2.value, position: expr2.position };
                    result.lhs = processAST(expr2.lhs);
                    result.rhs = processAST(expr2.rhs);
                    break;
                  default:
                    result = { type: expr2.type, value: expr2.value, position: expr2.position };
                    result.lhs = processAST(expr2.lhs);
                    result.rhs = processAST(expr2.rhs);
                    pushAncestry(result, result.lhs);
                    pushAncestry(result, result.rhs);
                }
                break;
              case "unary":
                result = { type: expr2.type, value: expr2.value, position: expr2.position };
                if (expr2.value === "[") {
                  result.expressions = expr2.expressions.map(function(item) {
                    var value = processAST(item);
                    pushAncestry(result, value);
                    return value;
                  });
                } else if (expr2.value === "{") {
                  result.lhs = expr2.lhs.map(function(pair) {
                    var key = processAST(pair[0]);
                    pushAncestry(result, key);
                    var value = processAST(pair[1]);
                    pushAncestry(result, value);
                    return [key, value];
                  });
                } else {
                  result.expression = processAST(expr2.expression);
                  if (expr2.value === "-" && result.expression.type === "number") {
                    result = result.expression;
                    result.value = -result.value;
                  } else {
                    pushAncestry(result, result.expression);
                  }
                }
                break;
              case "function":
              case "partial":
                result = { type: expr2.type, name: expr2.name, value: expr2.value, position: expr2.position };
                result.arguments = expr2.arguments.map(function(arg) {
                  var argAST = processAST(arg);
                  pushAncestry(result, argAST);
                  return argAST;
                });
                result.procedure = processAST(expr2.procedure);
                break;
              case "lambda":
                result = {
                  type: expr2.type,
                  arguments: expr2.arguments,
                  signature: expr2.signature,
                  position: expr2.position
                };
                var body = processAST(expr2.body);
                result.body = tailCallOptimize(body);
                break;
              case "condition":
                result = { type: expr2.type, position: expr2.position };
                result.condition = processAST(expr2.condition);
                pushAncestry(result, result.condition);
                result.then = processAST(expr2.then);
                pushAncestry(result, result.then);
                if (typeof expr2.else !== "undefined") {
                  result.else = processAST(expr2.else);
                  pushAncestry(result, result.else);
                }
                break;
              case "transform":
                result = { type: expr2.type, position: expr2.position };
                result.pattern = processAST(expr2.pattern);
                result.update = processAST(expr2.update);
                if (typeof expr2.delete !== "undefined") {
                  result.delete = processAST(expr2.delete);
                }
                break;
              case "block":
                result = { type: expr2.type, position: expr2.position };
                result.expressions = expr2.expressions.map(function(item) {
                  var part = processAST(item);
                  pushAncestry(result, part);
                  if (part.consarray || part.type === "path" && part.steps[0].consarray) {
                    result.consarray = true;
                  }
                  return part;
                });
                break;
              case "name":
                result = { type: "path", steps: [expr2] };
                if (expr2.keepArray) {
                  result.keepSingletonArray = true;
                }
                break;
              case "parent":
                result = { type: "parent", slot: { label: "!" + ancestorLabel++, level: 1, index: ancestorIndex++ } };
                ancestry.push(result);
                break;
              case "string":
              case "number":
              case "value":
              case "wildcard":
              case "descendant":
              case "variable":
              case "regex":
                result = expr2;
                break;
              case "operator":
                if (expr2.value === "and" || expr2.value === "or" || expr2.value === "in") {
                  expr2.type = "name";
                  result = processAST(expr2);
                } else if (expr2.value === "?") {
                  result = expr2;
                } else {
                  throw {
                    code: "S0201",
                    stack: new Error().stack,
                    position: expr2.position,
                    token: expr2.value
                  };
                }
                break;
              case "error":
                result = expr2;
                if (expr2.lhs) {
                  result = processAST(expr2.lhs);
                }
                break;
              default:
                var code = "S0206";
                if (expr2.id === "(end)") {
                  code = "S0207";
                }
                var err2 = {
                  code,
                  position: expr2.position,
                  token: expr2.value
                };
                if (recover) {
                  errors.push(err2);
                  return { type: "error", error: err2 };
                } else {
                  err2.stack = new Error().stack;
                  throw err2;
                }
            }
            if (expr2.keepArray) {
              result.keepArray = true;
            }
            return result;
          };
          lexer = tokenizer(source);
          advance();
          var expr = expression(0);
          if (node.id !== "(end)") {
            var err = {
              code: "S0201",
              position: node.position,
              token: node.value
            };
            handleError(err);
          }
          expr = processAST(expr);
          if (expr.type === "parent" || typeof expr.seekingParent !== "undefined") {
            throw {
              code: "S0217",
              token: expr.type,
              position: expr.position
            };
          }
          if (errors.length > 0) {
            expr.errors = errors;
          }
          return expr;
        };
        return parser2;
      })();
      module2.exports = parser;
    }, { "./signature": 5 }], 5: [function(require2, module2, exports2) {
      var utils = require2("./utils");
      const signature = (() => {
        var arraySignatureMapping = {
          "a": "arrays",
          "b": "booleans",
          "f": "functions",
          "n": "numbers",
          "o": "objects",
          "s": "strings"
        };
        function parseSignature(signature2) {
          var position = 1;
          var params = [];
          var param = {};
          var prevParam = param;
          while (position < signature2.length) {
            var symbol = signature2.charAt(position);
            if (symbol === ":") {
              break;
            }
            var next = function() {
              params.push(param);
              prevParam = param;
              param = {};
            };
            var findClosingBracket = function(str, start, openSymbol, closeSymbol) {
              var depth = 1;
              var position2 = start;
              while (position2 < str.length) {
                position2++;
                symbol = str.charAt(position2);
                if (symbol === closeSymbol) {
                  depth--;
                  if (depth === 0) {
                    break;
                  }
                } else if (symbol === openSymbol) {
                  depth++;
                }
              }
              return position2;
            };
            switch (symbol) {
              case "s":
              case "n":
              case "b":
              case "l":
              case "o":
                param.regex = "[" + symbol + "m]";
                param.type = symbol;
                next();
                break;
              case "a":
                param.regex = "[asnblfom]";
                param.type = symbol;
                param.array = true;
                next();
                break;
              case "f":
                param.regex = "f";
                param.type = symbol;
                next();
                break;
              case "j":
                param.regex = "[asnblom]";
                param.type = symbol;
                next();
                break;
              case "x":
                param.regex = "[asnblfom]";
                param.type = symbol;
                next();
                break;
              case "-":
                prevParam.context = true;
                prevParam.contextRegex = new RegExp(prevParam.regex);
                prevParam.regex += "?";
                break;
              case "?":
              case "+":
                prevParam.regex += symbol;
                break;
              case "(":
                var endParen = findClosingBracket(signature2, position, "(", ")");
                var choice = signature2.substring(position + 1, endParen);
                if (choice.indexOf("<") === -1) {
                  param.regex = "[" + choice + "m]";
                } else {
                  throw {
                    code: "S0402",
                    stack: new Error().stack,
                    value: choice,
                    offset: position
                  };
                }
                param.type = "(" + choice + ")";
                position = endParen;
                next();
                break;
              case "<":
                if (prevParam.type === "a" || prevParam.type === "f") {
                  var endPos = findClosingBracket(signature2, position, "<", ">");
                  prevParam.subtype = signature2.substring(position + 1, endPos);
                  position = endPos;
                } else {
                  throw {
                    code: "S0401",
                    stack: new Error().stack,
                    value: prevParam.type,
                    offset: position
                  };
                }
                break;
            }
            position++;
          }
          var regexStr = "^" + params.map(function(param2) {
            return "(" + param2.regex + ")";
          }).join("") + "$";
          var regex = new RegExp(regexStr);
          var getSymbol = function(value) {
            var symbol2;
            if (utils.isFunction(value)) {
              symbol2 = "f";
            } else {
              var type = typeof value;
              switch (type) {
                case "string":
                  symbol2 = "s";
                  break;
                case "number":
                  symbol2 = "n";
                  break;
                case "boolean":
                  symbol2 = "b";
                  break;
                case "object":
                  if (value === null) {
                    symbol2 = "l";
                  } else if (Array.isArray(value)) {
                    symbol2 = "a";
                  } else {
                    symbol2 = "o";
                  }
                  break;
                case "undefined":
                default:
                  symbol2 = "m";
              }
            }
            return symbol2;
          };
          var throwValidationError = function(badArgs, badSig) {
            var partialPattern = "^";
            var goodTo = 0;
            for (var index = 0; index < params.length; index++) {
              partialPattern += params[index].regex;
              var match = badSig.match(partialPattern);
              if (match === null) {
                throw {
                  code: "T0410",
                  stack: new Error().stack,
                  value: badArgs[goodTo],
                  index: goodTo + 1
                };
              }
              goodTo = match[0].length;
            }
            throw {
              code: "T0410",
              stack: new Error().stack,
              value: badArgs[goodTo],
              index: goodTo + 1
            };
          };
          return {
            definition: signature2,
            validate: function(args, context) {
              var suppliedSig = "";
              args.forEach(function(arg) {
                suppliedSig += getSymbol(arg);
              });
              var isValid = regex.exec(suppliedSig);
              if (isValid) {
                var validatedArgs = [];
                var argIndex = 0;
                params.forEach(function(param2, index) {
                  var arg = args[argIndex];
                  var match = isValid[index + 1];
                  if (match === "") {
                    if (param2.context && param2.contextRegex) {
                      var contextType = getSymbol(context);
                      if (param2.contextRegex.test(contextType)) {
                        validatedArgs.push(context);
                      } else {
                        throw {
                          code: "T0411",
                          stack: new Error().stack,
                          value: context,
                          index: argIndex + 1
                        };
                      }
                    } else {
                      validatedArgs.push(arg);
                      argIndex++;
                    }
                  } else {
                    match.split("").forEach(function(single) {
                      if (param2.type === "a") {
                        if (single === "m") {
                          arg = void 0;
                        } else {
                          arg = args[argIndex];
                          var arrayOK = true;
                          if (typeof param2.subtype !== "undefined") {
                            if (single !== "a" && match !== param2.subtype) {
                              arrayOK = false;
                            } else if (single === "a") {
                              if (arg.length > 0) {
                                var itemType = getSymbol(arg[0]);
                                if (itemType !== param2.subtype.charAt(0)) {
                                  arrayOK = false;
                                } else {
                                  var differentItems = arg.filter(function(val) {
                                    return getSymbol(val) !== itemType;
                                  });
                                  arrayOK = differentItems.length === 0;
                                }
                              }
                            }
                          }
                          if (!arrayOK) {
                            throw {
                              code: "T0412",
                              stack: new Error().stack,
                              value: arg,
                              index: argIndex + 1,
                              type: arraySignatureMapping[param2.subtype]
                            };
                          }
                          if (single !== "a") {
                            arg = [arg];
                          }
                        }
                        validatedArgs.push(arg);
                        argIndex++;
                      } else {
                        validatedArgs.push(arg);
                        argIndex++;
                      }
                    });
                  }
                });
                return validatedArgs;
              }
              throwValidationError(args, suppliedSig);
            }
          };
        }
        return parseSignature;
      })();
      module2.exports = signature;
    }, { "./utils": 6 }], 6: [function(require2, module2, exports2) {
      const utils = (() => {
        function isNumeric(n) {
          var isNum = false;
          if (typeof n === "number") {
            isNum = !isNaN(n);
            if (isNum && !isFinite(n)) {
              throw {
                code: "D1001",
                value: n,
                stack: new Error().stack
              };
            }
          }
          return isNum;
        }
        function isArrayOfStrings(arg) {
          var result = false;
          if (Array.isArray(arg)) {
            result = arg.filter(function(item) {
              return typeof item !== "string";
            }).length === 0;
          }
          return result;
        }
        function isArrayOfNumbers(arg) {
          var result = false;
          if (Array.isArray(arg)) {
            result = arg.filter(function(item) {
              return !isNumeric(item);
            }).length === 0;
          }
          return result;
        }
        function createSequence() {
          var sequence = [];
          sequence.sequence = true;
          if (arguments.length === 1) {
            sequence.push(arguments[0]);
          }
          return sequence;
        }
        function isSequence(value) {
          return value.sequence === true && Array.isArray(value);
        }
        function isFunction(arg) {
          return arg && (arg._jsonata_function === true || arg._jsonata_lambda === true) || typeof arg === "function";
        }
        function getFunctionArity(func) {
          var arity = typeof func.arity === "number" ? func.arity : typeof func.implementation === "function" ? func.implementation.length : typeof func.length === "number" ? func.length : func.arguments.length;
          return arity;
        }
        function isLambda(arg) {
          return arg && arg._jsonata_lambda === true;
        }
        var iteratorSymbol = (typeof Symbol === "function" ? Symbol : {}).iterator || "@@iterator";
        function isIterable(arg) {
          return typeof arg === "object" && arg !== null && iteratorSymbol in arg && "next" in arg && typeof arg.next === "function";
        }
        function isDeepEqual(lhs, rhs) {
          if (lhs === rhs) {
            return true;
          }
          if (typeof lhs === "object" && typeof rhs === "object" && lhs !== null && rhs !== null) {
            if (Array.isArray(lhs) && Array.isArray(rhs)) {
              if (lhs.length !== rhs.length) {
                return false;
              }
              for (var ii = 0; ii < lhs.length; ii++) {
                if (!isDeepEqual(lhs[ii], rhs[ii])) {
                  return false;
                }
              }
              return true;
            }
            var lkeys = Object.getOwnPropertyNames(lhs);
            var rkeys = Object.getOwnPropertyNames(rhs);
            if (lkeys.length !== rkeys.length) {
              return false;
            }
            lkeys = lkeys.sort();
            rkeys = rkeys.sort();
            for (ii = 0; ii < lkeys.length; ii++) {
              if (lkeys[ii] !== rkeys[ii]) {
                return false;
              }
            }
            for (ii = 0; ii < lkeys.length; ii++) {
              var key = lkeys[ii];
              if (!isDeepEqual(lhs[key], rhs[key])) {
                return false;
              }
            }
            return true;
          }
          return false;
        }
        function isPromise(arg) {
          return typeof arg === "object" && arg !== null && "then" in arg && typeof arg.then === "function";
        }
        function stringToArray(str) {
          var arr = [];
          for (let char of str) {
            arr.push(char);
          }
          return arr;
        }
        return {
          isNumeric,
          isArrayOfStrings,
          isArrayOfNumbers,
          createSequence,
          isSequence,
          isFunction,
          isLambda,
          isIterable,
          getFunctionArity,
          isDeepEqual,
          stringToArray,
          isPromise
        };
      })();
      module2.exports = utils;
    }, {}] }, {}, [3])(3);
  });
})(jsonata$1);
var jsonataExports = jsonata$1.exports;
const jsonata = /* @__PURE__ */ getDefaultExportFromCjs(jsonataExports);
const jsonataCompiledExpressionCache = /* @__PURE__ */ new Map();
const extractLabelSingle = (data, recipe) => {
  if (recipe.startsWith("jsonata:")) {
    const jsonataExpression = recipe.slice(8);
    let compiledExpression = jsonataCompiledExpressionCache.get(jsonataExpression);
    if (!compiledExpression) {
      compiledExpression = jsonata(jsonataExpression);
      jsonataCompiledExpressionCache.set(jsonataExpression, compiledExpression);
    }
    return compiledExpression.evaluate(data);
  } else {
    return get$1(data, recipe);
  }
};
const extractLabelFallback = (data, recipeFallback) => {
  for (const recipe of recipeFallback) {
    const possibleLabel = extractLabelSingle(data, recipe);
    if (possibleLabel) {
      return possibleLabel;
    }
  }
  return void 0;
};
const extractLabel = (data, recipe) => {
  if (Array.isArray(recipe)) {
    return extractLabelFallback(data, recipe);
  } else {
    return extractLabelSingle(data, recipe);
  }
};
const getLabelProps = (schema) => (schema == null ? void 0 : schema.properties) && Object.entries(schema.properties).filter(([propName, prop]) => {
  return !["_model", "_model_path", "_path", "_variations", "_metadata"].includes(propName) && ["string", "number", "integer"].some((type) => {
    return prop.type === type || Array.isArray(prop.type) && prop.type.includes(type) && prop.type.includes("null") && prop.type.length === 2;
  });
}).map(([propName, _]) => propName);
const isLayout = (uischema) => uischema.hasOwnProperty("elements");
const CombinatorProperties = ({
  combinatorKeyword,
  path,
  schema
}) => {
  const { [combinatorKeyword]: _, ...otherProps } = schema;
  const foundUISchema = Generate.uiSchema(otherProps, "VerticalLayout");
  let isLayoutWithElements = false;
  if (foundUISchema !== null && isLayout(foundUISchema)) {
    isLayoutWithElements = foundUISchema.elements.length > 0;
  }
  if (isLayoutWithElements) {
    return /* @__PURE__ */ jsx(JsonFormsDispatch, { schema: otherProps, path, uischema: foundUISchema });
  }
  return null;
};
const oneOf = "oneOf";
const schemaIndexFromDiscriminator = (schema, oneOfRenderInfos, data) => {
  var _a;
  const discriminatingProperty = (_a = schema.discriminator) == null ? void 0 : _a.propertyName;
  if (discriminatingProperty) {
    const discriminatorValues = oneOfRenderInfos == null ? void 0 : oneOfRenderInfos.map(
      (info) => {
        var _a2, _b;
        return (_b = (_a2 = info.schema.properties) == null ? void 0 : _a2[discriminatingProperty]) == null ? void 0 : _b.const;
      }
    );
    return discriminatorValues == null ? void 0 : discriminatorValues.indexOf(data == null ? void 0 : data[discriminatingProperty]);
  }
  return void 0;
};
const SpectrumOneOfRenderer = React__default.memo(
  ({
    cells,
    data,
    enabled,
    handleChange,
    id,
    path,
    renderers,
    rootSchema,
    schema,
    uischema,
    uischemas,
    visible
  }) => {
    var _a;
    const oneOfRenderInfos = React__default.useMemo(
      () => (schema == null ? void 0 : schema.oneOf) ? createCombinatorRenderInfos(schema == null ? void 0 : schema.oneOf, rootSchema, oneOf, uischema, path, uischemas) : [],
      [schema, rootSchema, uischema, path, uischemas]
    );
    const indexFromDiscriminator = schemaIndexFromDiscriminator(schema, oneOfRenderInfos, data);
    const selectedIndexFunction = () => {
      if (indexFromDiscriminator) {
        return indexFromDiscriminator;
      } else if (indexOfFittingSchemaObject[path]) {
        return indexOfFittingSchemaObject[path];
      } else {
        return 0;
      }
    };
    const [open, setOpen] = React__default.useState(false);
    const [hideTabs, setHideTabs] = React__default.useState(false);
    const [selectedIndex, setSelectedIndex] = React__default.useState(selectedIndexFunction());
    const [newSelectedIndex, setNewSelectedIndex] = React__default.useState(0);
    const className = `spectrum-oneOf-${path}`;
    const handleClose = React__default.useCallback(() => setOpen(false), [setOpen]);
    const openNewTab = React__default.useCallback(
      (newIndex) => {
        if (schema == null ? void 0 : schema.oneOf) {
          const defaultValue = createDefaultValue(schema == null ? void 0 : schema.oneOf[newIndex]);
          if (typeof defaultValue === "object" && Object.keys(defaultValue).length === 0) {
            handleChange(path, void 0);
          } else {
            handleChange(path, defaultValue);
          }
        }
        setSelectedIndex(newIndex);
      },
      [schema, handleChange, path, setSelectedIndex]
    );
    const confirm = React__default.useCallback(() => {
      openNewTab(newSelectedIndex);
      setOpen(false);
    }, [openNewTab, setOpen, newSelectedIndex]);
    const handleTabChange = React__default.useCallback(
      (newOneOfIndex) => {
        newOneOfIndex = Number(newOneOfIndex);
        setNewSelectedIndex(newOneOfIndex);
        if (isEmpty(data)) {
          openNewTab(newOneOfIndex);
        } else {
          setOpen(true);
        }
      },
      [setOpen, setNewSelectedIndex, openNewTab]
    );
    const usePickerInsteadOfTabs = indexOfFittingSchemaObject["OneOfPicker"] === true || ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.OneOfPicker) === true;
    React__default.useEffect(() => {
      var _a2, _b, _c, _d;
      setHideTabs(
        ((_d = (_c = (_b = (_a2 = document.getElementsByClassName(className)[0]) == null ? void 0 : _a2.parentElement) == null ? void 0 : _b.parentElement) == null ? void 0 : _c.parentElement) == null ? void 0 : _d.className) === "array-item-content"
      );
    }, [className]);
    if (!oneOfRenderInfos)
      return null;
    return /* @__PURE__ */ jsxs(View, { isHidden: !visible, UNSAFE_className: className, children: [
      /* @__PURE__ */ jsx(CombinatorProperties, { combinatorKeyword: "oneOf", path, schema }),
      usePickerInsteadOfTabs ? /* @__PURE__ */ jsxs(Fragment, { children: [
        /* @__PURE__ */ jsx(
          Picker,
          {
            "aria-label": "Select",
            "aria-labelledby": "Select",
            isDisabled: enabled === void 0 ? false : !enabled,
            onSelectionChange: handleTabChange,
            selectedKey: String(selectedIndex),
            width: "100%",
            isHidden: hideTabs,
            children: oneOfRenderInfos.map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(Item, { children: oneOfRenderInfo.label }, oneOfIndex))
          }
        ),
        oneOfRenderInfos.filter((_oneOfRenderInfo, oneOfIndex) => oneOfIndex === selectedIndex).map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
          JsonFormsDispatch,
          {
            cells,
            path,
            renderers,
            schema: oneOfRenderInfo.schema,
            uischema: oneOfRenderInfo.uischema
          },
          oneOfIndex
        ) }) }, oneOfIndex))
      ] }) : /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsxs(
        Tabs,
        {
          "aria-label": "Select",
          isDisabled: enabled === void 0 ? false : !enabled,
          selectedKey: String(selectedIndex),
          onSelectionChange: handleTabChange,
          children: [
            /* @__PURE__ */ jsx(TabList, { isHidden: hideTabs, children: oneOfRenderInfos.map((oneOfRenderInfo, oneOfIndex) => /* @__PURE__ */ jsx(Item, { children: oneOfRenderInfo.label }, oneOfIndex)) }),
            /* @__PURE__ */ jsx(TabPanels, { children: oneOfRenderInfos.map((oneOfRenderInfo, oneOfIndex) => {
              return /* @__PURE__ */ jsx(Item, { title: oneOfRenderInfo.label, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
                JsonFormsDispatch,
                {
                  cells,
                  enabled,
                  path,
                  renderers,
                  schema: oneOfRenderInfo.schema,
                  uischema: oneOfRenderInfo.uischema
                },
                oneOfIndex
              ) }) }, oneOfIndex);
            }) })
          ]
        }
      ) }),
      /* @__PURE__ */ jsx(DialogContainer, { onDismiss: handleClose, children: open && /* @__PURE__ */ jsxs(Dialog, { children: [
        /* @__PURE__ */ jsx(Heading, { children: "Clear Form?" }),
        /* @__PURE__ */ jsx(Divider, {}),
        /* @__PURE__ */ jsx(Content, { children: "Your Data will be cleared if you navigate away from this Tab. Do you want to Clear your Form?" }),
        /* @__PURE__ */ jsxs(ButtonGroup, { children: [
          /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: handleClose, children: "Cancel" }),
          /* @__PURE__ */ jsx(
            Button,
            {
              variant: "cta",
              onPress: confirm,
              autoFocus: true,
              id: id && `oneOf-${id}-confirm-yes`,
              children: "Clear Form"
            }
          )
        ] })
      ] }) })
    ] });
  }
);
const SpectrumOneOfRendererTester = (uischema, schema, context) => {
  return isOneOfControl(uischema, schema, context) ? 5 : -1;
};
const withContextToControlProps$1 = (Component) => function WithContextToControlProps({ ctx, props }) {
  const controlProps = ctxToControlProps(ctx, props);
  const dispatchProps = ctxDispatchToControlProps(ctx.dispatch);
  const uischemas = ctx.uischemas;
  return /* @__PURE__ */ jsx(Component, { ...props, ...controlProps, ...dispatchProps, uischemas });
};
const withJsonFormsProps$1 = (Component, memoize = true) => withJsonFormsContext(
  withContextToControlProps$1(memoize ? React__default.memo(Component) : Component)
);
const SpectrumOneOfRenderer$1 = withJsonFormsProps$1(withHandleChange(SpectrumOneOfRenderer));
const SpectrumDnDArrayItemComponentWithBreadcrumbs = (props) => {
  var _a, _b, _c, _d;
  const childPath = composePaths(props.path, `${props.index}`);
  const enableDetailedView = ((_b = (_a = props.uischema) == null ? void 0 : _a.options) == null ? void 0 : _b.enableDetailedView) ?? true;
  const noAccordion = ((_d = (_c = props.uischema) == null ? void 0 : _c.options) == null ? void 0 : _d.noAccordion) ?? false;
  const userIsOnMobileDevice = checkIfUserIsOnMobileDevice(
    navigator.userAgent.toLowerCase()
  );
  const [isAnimating, setIsAnimating] = React__default.useState(false);
  const { breadcrumbs, addBreadcrumb, truncateBreadcrumbsAndDelete } = useBreadcrumbs();
  const expanded = breadcrumbs.hasPrefix(childPath);
  const setExpanded = React__default.useCallback(
    (desiredState, isDetailedView = true) => {
      var _a2;
      if (desiredState) {
        addBreadcrumb({
          path: childPath,
          name: enableDetailedView ? String(props.customLabel || props.childLabel) : null,
          crxPath: (_a2 = props.childData) == null ? void 0 : _a2._path,
          usesDetailedView: isDetailedView
        });
      } else {
        truncateBreadcrumbsAndDelete(childPath);
      }
      if (desiredState === expanded) {
        return;
      }
      if (!userIsOnMobileDevice) {
        setIsAnimating(true);
      }
    },
    [
      expanded,
      props.customLabel,
      props.childLabel,
      enableDetailedView,
      truncateBreadcrumbsAndDelete,
      addBreadcrumb
    ]
  );
  React__default.useEffect(() => {
    if (breadcrumbs.hasPrefix(childPath)) {
      setExpanded(true, enableDetailedView);
    }
  }, [breadcrumbs]);
  return /* @__PURE__ */ jsx(
    SpectrumDnDArrayItemComponent,
    {
      ...{
        childPath,
        enableDetailedView,
        noAccordion,
        isAnimating,
        setIsAnimating,
        expanded,
        setExpanded
      },
      ...props
    }
  );
};
const SpectrumDnDArrayItemComponent = React__default.memo(
  ({
    childPath,
    enableDetailedView,
    noAccordion,
    isAnimating,
    setIsAnimating,
    expanded,
    setExpanded,
    childData,
    childLabel,
    customLabel,
    duplicateItem,
    replaceItemHandler,
    enabled,
    index,
    path,
    removeItem,
    renderers,
    schema,
    uischema,
    uischemas = [],
    sortableHandleProps
  }) => {
    var _a, _b;
    const foundUISchema = React__default.useMemo(
      () => {
        var _a2, _b2;
        return typeof ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.detail) === "object" ? (_b2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b2.detail : findUISchema(uischemas, schema, uischema.scope, path);
      },
      [(_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.detail, uischemas, schema, uischema.scope, path]
    );
    if (!childLabel || childLabel === "<p></p>") {
      childLabel = `Item ${index + 1}`;
    }
    const JsonFormsDispatchComponent = /* @__PURE__ */ jsx("div", { className: "array-item-content", children: /* @__PURE__ */ jsx(
      JsonFormsDispatch,
      {
        enabled,
        path: childPath,
        renderers,
        schema,
        uischema: foundUISchema || uischema,
        visible: false
      },
      childPath
    ) });
    const header = /* @__PURE__ */ jsx(
      SpectrumItemHeader,
      {
        childData,
        childLabel: customLabel || childLabel,
        customPickerEnabled: (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.picker,
        data: void 0,
        duplicateItem,
        enableDetailedView,
        expanded,
        setExpanded,
        index,
        jsonFormsDispatch: JsonFormsDispatchComponent,
        path,
        removeItem,
        replaceItem: replaceItemHandler,
        uischema,
        sortableHandleProps
      }
    );
    return /* @__PURE__ */ jsxs(
      View,
      {
        UNSAFE_className: `list-array-item ${expanded ? "expanded" : "collapsed"} ${noAccordion ? "no-accordion" : ""}`,
        borderColor: "dark",
        borderRadius: "medium",
        borderWidth: "thin",
        padding: "size-150",
        width: "100%",
        children: [
          header,
          expanded && !enableDetailedView && /* @__PURE__ */ jsx(View, { UNSAFE_className: "jsonforms-dispatch-wrapper", children: JsonFormsDispatchComponent }),
          enableDetailedView && /* @__PURE__ */ jsx(
            ModalItemAnimationWrapper,
            {
              enableDetailedView,
              expanded,
              setExpanded,
              isAnimating,
              path,
              setIsAnimating,
              children: expanded || isAnimating ? /* @__PURE__ */ jsxs(View, { UNSAFE_className: "jsonforms-dispatch-wrapper", children: [
                enableDetailedView && header,
                JsonFormsDispatchComponent
              ] }) : null
            }
          )
        ]
      }
    );
  }
);
SpectrumDnDArrayItemComponent.displayName = "SpectrumDnDArrayItemComponent";
const mapStateToSpectrumArrayItemProps = (state, ownProps) => {
  var _a, _b, _c, _d, _e, _f, _g;
  const { schema, path, index, uischema, uischemas } = ownProps;
  const childPath = composePaths(path, `${index}`);
  const childData = Resolve.data(getData(state), childPath);
  const dataAsLabel = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.dataAsLabel;
  let labelRecipe = "";
  if (dataAsLabel === void 0 || dataAsLabel === true) {
    if (schema == null ? void 0 : schema.oneOf) {
      const oneOfRenderInfos = React__default.useMemo(
        () => {
          var _a2;
          return (schema == null ? void 0 : schema.oneOf) ? createCombinatorRenderInfos(
            schema == null ? void 0 : schema.oneOf,
            (_a2 = state.jsonforms.core) == null ? void 0 : _a2.schema,
            "oneOf",
            uischema,
            path,
            uischemas
          ) : [];
        },
        [schema, (_b = state.jsonforms.core) == null ? void 0 : _b.schema, uischema, path, uischemas]
      );
      const schemaIndex = schemaIndexFromDiscriminator(
        schema,
        oneOfRenderInfos,
        childData
      );
      if (schemaIndex !== void 0) {
        labelRecipe = ((_d = (_c = oneOfRenderInfos[schemaIndex]) == null ? void 0 : _c.uischema) == null ? void 0 : _d.dataAsLabel) || getLabelProps((_e = oneOfRenderInfos[schemaIndex]) == null ? void 0 : _e.schema);
      }
    } else {
      labelRecipe = (uischema == null ? void 0 : uischema.dataAsLabel) || getLabelProps(schema);
    }
  } else if (dataAsLabel) {
    labelRecipe = dataAsLabel;
  }
  let childLabel = labelRecipe && extractLabel(childData, labelRecipe) || `Item ${index + 1}`;
  if ((_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.prependModelToLabel) {
    childLabel = `${(_g = childData == null ? void 0 : childData._model) == null ? void 0 : _g.title}: ${childLabel}`;
  }
  return {
    ...ownProps,
    childLabel,
    childData
  };
};
const ctxToSpectrumArrayItemProps = (ctx, ownProps) => mapStateToSpectrumArrayItemProps({ jsonforms: { ...ctx } }, ownProps);
const withContextToSpectrumArrayItemProps = (Component) => ({ ctx, props, sortableHandle }) => {
  const stateProps = ctxToSpectrumArrayItemProps(ctx, props);
  return /* @__PURE__ */ jsx(Component, { ...stateProps, ...sortableHandle });
};
const withJsonFormsSpectrumArrayItemProps = (Component) => withJsonFormsContext(withContextToSpectrumArrayItemProps(React__default.memo(Component)));
const SpectrumDnDArrayItemComponent$1 = withJsonFormsSpectrumArrayItemProps(
  withHandleChange(SpectrumDnDArrayItemComponentWithBreadcrumbs)
);
const COMPONENT_HEIGHT = 70;
const fn = (order, active = false) => (index) => active ? {
  y: order.indexOf(index) * COMPONENT_HEIGHT,
  duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 400,
  immediate: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? true : false,
  keys: false
} : {
  y: order.indexOf(index) * COMPONENT_HEIGHT,
  duration: {}.VITE_DISABLE_EDITOR_ANIMATIONS === "true" ? 0 : 400,
  immediate: true,
  keys: false
};
const addContainerStyle1 = {
  height: "8px",
  marginTop: "-8px",
  position: "relative",
  top: void 0
};
const addContainerStyle2 = {
  height: void 0,
  marginTop: void 0,
  position: "absolute",
  top: "-20px"
};
const DnDArray = ({
  data,
  enabled,
  dataReduce,
  addItemHandler,
  replaceItemHandler,
  path,
  renderers,
  schema,
  uischema,
  uischemas
}) => {
  var _a, _b;
  if (!data) {
    return null;
  }
  const sortModeDnD = ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.sortMode) !== "arrows" ? true : false;
  const [upOrDown, setUpOrDown] = React__default.useState("up");
  const [isMoving, setIsMoving] = React__default.useState(false);
  const [grabbedIndex, setGrabbedIndex] = React__default.useState(null);
  const [touchMovement, setTouchMovement] = React__default.useState(false);
  const grabbedIndexRef = React__default.useRef(null);
  const { breadcrumbs } = useBreadcrumbs();
  const order = React__default.useRef(
    data == null ? void 0 : data.map((_, index) => index)
  );
  const [springs, setSprings] = useSprings((data == null ? void 0 : data.length) ?? 0, fn(order.current));
  const sortableHandleRef = useSpringRef();
  const bind = useDrag(
    ({ args: [originalIndex], active, movement: [, y] }) => {
      if (originalIndex !== null && grabbedIndexRef.current !== null) {
        if (touchMovement) {
          setTouchMovement(false);
          setGrabbedIndex(null);
          grabbedIndexRef.current = null;
        }
        const curRow = clamp(
          Math.round((originalIndex * COMPONENT_HEIGHT + y) / COMPONENT_HEIGHT),
          0,
          (data == null ? void 0 : data.length) - 1
        );
        const newOrder = swap(
          order.current,
          order.current.indexOf(order.current[originalIndex]),
          order.current.indexOf(order.current[curRow])
        );
        setSprings.start(fn(newOrder, active));
        if (order.current.indexOf(order.current[originalIndex]) === order.current.indexOf(order.current[curRow]) || order.current === newOrder) {
          return;
        }
        if (!active) {
          finalChange(newOrder);
        }
      }
    },
    {
      pointer: { keys: false }
    }
  );
  const finalChange = React__default.useCallback(
    (newOrder) => {
      order.current = newOrder;
      const originalOrder = newOrder.every(
        (value, index, array) => !index || array[index - 1] < value
      );
      if (!originalOrder) {
        dataReduce(
          path,
          (currentDataAtPath) => currentDataAtPath.map(
            (_, index) => currentDataAtPath[newOrder[index]]
          )
        );
      }
      grabbedIndexRef.current = null;
      setSprings.start(fn(newOrder, false));
      setIsMoving(false);
    },
    [dataReduce, path, grabbedIndexRef, setSprings, setIsMoving]
  );
  let [keyboardClass, setKeyboardClass] = React__default.useState("");
  const move = React__default.useCallback(
    (direction, indexToMove) => {
      setIsMoving(true);
      let newOrder = [];
      let newGrabbedIndex = -1;
      if (direction === "up" && indexToMove > 0) {
        setKeyboardClass("keyboardUp");
        newGrabbedIndex = indexToMove - 1;
        newOrder = swap(
          order.current,
          order.current.indexOf(order.current[indexToMove]),
          order.current.indexOf(order.current[indexToMove - 1])
        );
        setSprings.start(fn(newOrder, true));
        setTimeout(() => {
          grabbedIndexRef.current = indexToMove - 1;
          finalChange(newOrder);
          setKeyboardClass("");
          grabbedIndexRef.current = indexToMove - 1;
        }, 500);
        setUpOrDown("up");
      } else if (direction === "down" && indexToMove < (data == null ? void 0 : data.length) - 1) {
        setKeyboardClass("keyboardDown");
        newGrabbedIndex = indexToMove + 1;
        newOrder = swap(
          order.current,
          order.current.indexOf(order.current[indexToMove]),
          order.current.indexOf(order.current[indexToMove + 1])
        );
        setSprings.start(fn(newOrder, true));
        setTimeout(() => {
          grabbedIndexRef.current = indexToMove + 1;
          finalChange(newOrder);
          setKeyboardClass("");
        }, 500);
        setUpOrDown("down");
      }
      setTimeout(() => {
        grabbedIndexRef.current = newGrabbedIndex;
        setGrabbedIndex(newGrabbedIndex);
      }, 500);
    },
    [
      setIsMoving,
      setKeyboardClass,
      setSprings,
      grabbedIndexRef,
      finalChange,
      setKeyboardClass,
      setUpOrDown,
      setGrabbedIndex
    ]
  );
  const duplicateItem = React__default.useCallback(
    (index) => {
      dataReduce(path, (existingData) => [
        ...existingData.slice(0, index),
        existingData[index],
        ...existingData.slice(index)
      ]);
    },
    [dataReduce]
  );
  React__default.useEffect(() => {
    order.current = data == null ? void 0 : data.map((_, index) => index);
    grabbedIndexRef.current = null;
    setSprings.start(fn(order.current, false));
  }, [data, order, grabbedIndexRef, setSprings]);
  const enableTouch = React__default.useCallback(
    (index) => {
      if (!sortModeDnD)
        return;
      grabbedIndexRef.current = index;
      setGrabbedIndex(index);
      setTouchMovement(true);
    },
    [sortModeDnD, grabbedIndexRef, setGrabbedIndex, setTouchMovement]
  );
  const addBetween = React__default.useCallback(
    (index, event) => {
      var _a2;
      const opacity = window.getComputedStyle(event.target).opacity;
      if (opacity !== "1") {
        return;
      }
      addItemHandler(index);
      (_a2 = event == null ? void 0 : event.target) == null ? void 0 : _a2.blur();
    },
    [addItemHandler]
  );
  const noDetailedViewIsExpanded = ((_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.enableDetailedView) === false && data.filter((_, i) => breadcrumbs.hasPrefix(`${path}.${i}`)).map((_, i) => i).length > 0;
  const dndStyle1 = React__default.useMemo(
    () => ({
      minHeight: COMPONENT_HEIGHT * data.length,
      height: "auto"
    }),
    [data.length]
  );
  const dndStyle2 = React__default.useMemo(
    () => ({
      minHeight: COMPONENT_HEIGHT * (data == null ? void 0 : data.length),
      height: COMPONENT_HEIGHT * (data == null ? void 0 : data.length)
    }),
    [data.length]
  );
  const hovered = { zIndex: 30 };
  const notHovered = { zIndex: 20 };
  const removeItem = React__default.useCallback(
    (indexToDelete) => {
      dataReduce(
        path,
        (existingData) => existingData.filter((_value, index) => index !== indexToDelete)
      );
    },
    [dataReduce]
  );
  const onBlur = React__default.useCallback(() => setGrabbedIndex(null), [setGrabbedIndex]);
  const onFocus = React__default.useCallback(
    (index) => grabbedIndexRef.current = index,
    [grabbedIndexRef]
  );
  const onKeyDown = React__default.useCallback(
    (e, index) => {
      var _a2, _b2;
      if (e.key === "ArrowUp") {
        setGrabbedIndex(index);
        move("up", index);
      } else if (e.key === "ArrowDown") {
        setGrabbedIndex(index);
        move("down", index);
      } else if (!sortModeDnD && (e.key === "Enter" || e.key === " ")) {
        setGrabbedIndex(index);
        const directionFromTargetId = (_b2 = (_a2 = document.activeElement) == null ? void 0 : _a2.id) == null ? void 0 : _b2.slice(0, -7).split("_").pop();
        move(directionFromTargetId, index);
      }
    },
    [setGrabbedIndex, move]
  );
  const onMouseEnter = React__default.useCallback(
    (index) => grabbedIndexRef.current = index,
    [grabbedIndexRef]
  );
  const onMouseLeave = React__default.useCallback(() => grabbedIndexRef.current = null, [grabbedIndexRef]);
  const onTouchMove = React__default.useCallback((index) => enableTouch(index), [enableTouch]);
  const sortableHandlePropsTrue = React__default.useMemo(
    () => ({
      dataLength: data.length,
      disabled: true,
      grabbedIndex,
      keyboardClass,
      move,
      onBlur,
      onFocus,
      onKeyDown,
      onMouseEnter,
      onMouseLeave,
      onTouchMove,
      sortableHandleRef,
      upOrDown,
      setGrabbedIndex
    }),
    [
      data.length,
      grabbedIndex,
      keyboardClass,
      move,
      onBlur,
      onFocus,
      onKeyDown,
      onMouseEnter,
      onMouseLeave,
      onTouchMove,
      sortableHandleRef,
      upOrDown,
      setGrabbedIndex
    ]
  );
  const sortableHandlePropsFalse = React__default.useMemo(
    () => ({
      dataLength: data.length,
      disabled: false,
      grabbedIndex,
      keyboardClass,
      move,
      onBlur,
      onFocus,
      onKeyDown,
      onMouseEnter,
      onMouseLeave,
      onTouchMove,
      sortableHandleRef,
      upOrDown,
      setGrabbedIndex
    }),
    [
      data.length,
      grabbedIndex,
      keyboardClass,
      move,
      onBlur,
      onFocus,
      onKeyDown,
      onMouseEnter,
      onMouseLeave,
      onTouchMove,
      sortableHandleRef,
      upOrDown,
      setGrabbedIndex
    ]
  );
  const modalItem = React__default.useCallback(
    (index, disabled = false) => /* @__PURE__ */ jsx(
      SpectrumDnDArrayItemComponent$1,
      {
        customLabel: getTextAreaLabel(data[index], uischema),
        duplicateItem,
        replaceItemHandler,
        enabled,
        index,
        path,
        removeItem,
        renderers,
        schema,
        uischema,
        uischemas,
        sortableHandleProps: disabled ? sortableHandlePropsFalse : sortableHandlePropsFalse
      }
    ),
    [
      data,
      enabled,
      path,
      renderers,
      schema,
      uischema,
      uischemas,
      keyboardClass,
      grabbedIndexRef,
      grabbedIndex,
      sortableHandlePropsTrue,
      sortableHandlePropsFalse
    ]
  );
  return /* @__PURE__ */ jsx("div", { style: noDetailedViewIsExpanded ? dndStyle1 : dndStyle2, className: "drag-and-drop-wrapper", children: springs == null ? void 0 : springs.map(({ y }, index) => /* @__PURE__ */ createElement(
    animated$1.div,
    {
      ...bind(index),
      key: `${path}_${index}`,
      style: {
        position: noDetailedViewIsExpanded ? void 0 : "absolute",
        y: noDetailedViewIsExpanded ? void 0 : y,
        zIndex: grabbedIndex === index ? 30 : 20
      },
      height: COMPONENT_HEIGHT + "px",
      className: "drag-and-drop-item"
    },
    /* @__PURE__ */ jsx(
      "div",
      {
        style: noDetailedViewIsExpanded ? addContainerStyle1 : addContainerStyle2,
        className: "add-container",
        children: /* @__PURE__ */ jsx(Button, { variant: "cta", onPress: (event) => addBetween(index, event), children: /* @__PURE__ */ jsx(Add, {}) })
      },
      `${path}_${index}_addBetween`
    ),
    /* @__PURE__ */ jsx(
      Flex,
      {
        direction: "row",
        alignItems: "stretch",
        flex: "auto inherit",
        UNSAFE_style: grabbedIndex === index ? hovered : notHovered,
        children: modalItem(index, isMoving || noDetailedViewIsExpanded)
      }
    )
  )) });
};
const SpectrumDnDArrayControlRenderer = ({
  data,
  enabled,
  handleChange,
  dataReduce,
  path,
  renderers,
  schema,
  uischema,
  uischemas = [],
  visible
}) => {
  var _a, _b;
  const { truncateBreadcrumbsAndAdd } = useBreadcrumbs();
  const controlElement = uischema;
  const labelDescription = Helpers.createLabelDescriptionFrom(controlElement, schema);
  const label = (labelDescription == null ? void 0 : labelDescription.show) ? (labelDescription == null ? void 0 : labelDescription.text) ?? "" : ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.label) ?? "";
  const expandNew = !((_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.noAccordion);
  const openPicker = React__default.useCallback(
    (index, replaceExisting) => {
      window.postMessage({
        type: CUSTOM_PICKER_OPEN,
        schema,
        current: {
          path,
          index,
          replaceExisting,
          data: replaceExisting ? data[index] : null
        }
      });
    },
    [path, schema, data]
  );
  const addItem = React__default.useCallback(
    (value, index) => {
      dataReduce(path, (currentArray) => {
        const existingArray = Array.isArray(currentArray) ? currentArray : [];
        return [...existingArray.slice(0, index), value, ...existingArray.slice(index)];
      });
    },
    [dataReduce]
  );
  const replaceItem = React__default.useCallback(
    (value, index) => {
      dataReduce(path, (currentArray) => {
        const existingArray = currentArray || [];
        return [...existingArray.slice(0, index), value, ...existingArray.slice(index + 1)];
      });
    },
    [dataReduce]
  );
  const addDefaultValue = React__default.useCallback(
    (index) => {
      var _a2;
      if (((_a2 = schema == null ? void 0 : schema.oneOf) == null ? void 0 : _a2.length) === 1) {
        addItem(createDefaultValue(schema == null ? void 0 : schema.oneOf[0]), index);
      } else {
        addItem(createDefaultValue(schema ?? {}), index);
      }
      if (expandNew) {
        truncateBreadcrumbsAndAdd(composePaths(path, String(index)));
      }
    },
    [addItem, truncateBreadcrumbsAndAdd, path, schema, uischema]
  );
  const addItemHandler = React__default.useCallback(
    (index) => {
      var _a2;
      if ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker) {
        openPicker(index, false);
      } else {
        addDefaultValue(index);
      }
    },
    [openPicker, addDefaultValue, uischema]
  );
  const pushItemHandler = React__default.useCallback(() => {
    var _a2;
    if ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker) {
      openPicker((data == null ? void 0 : data.length) ?? 0, false);
    } else {
      addDefaultValue((data == null ? void 0 : data.length) ?? 0);
    }
  }, [openPicker, addDefaultValue, uischema, data == null ? void 0 : data.length]);
  const replaceItemHandler = React__default.useCallback(
    (index) => {
      var _a2;
      if ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker) {
        openPicker(index, true);
      }
    },
    [openPicker, addDefaultValue, uischema]
  );
  const handleCustomPickerMessage = React__default.useCallback(
    (e) => {
      var _a2, _b2, _c, _d, _e, _f;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) === CUSTOM_PICKER_RETURN && ((_c = (_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.current) == null ? void 0 : _c.path) === path && ((_d = e == null ? void 0 : e.data) == null ? void 0 : _d.data)) {
        if ((_f = (_e = e == null ? void 0 : e.data) == null ? void 0 : _e.current) == null ? void 0 : _f.replaceExisting) {
          replaceItem(e.data.data, e.data.current.index);
        } else {
          addItem(e.data.data, e.data.current.index);
        }
        if (e.data.created) {
          truncateBreadcrumbsAndAdd(composePaths(path, String(e.data.current.index)));
        }
      }
    },
    [path, addItem, replaceItem, truncateBreadcrumbsAndAdd, uischema]
  );
  React__default.useEffect(() => {
    var _a2;
    if ((_a2 = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a2.picker) {
      window.addEventListener("message", handleCustomPickerMessage);
      return () => {
        window.removeEventListener("message", handleCustomPickerMessage);
      };
    }
  }, [handleCustomPickerMessage]);
  const handleInsertNewEditableComponentMessage = React__default.useCallback(
    (e) => {
      var _a2, _b2, _c;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) === INSERT_NEW_EDITABLE_COMPONENT && ((_c = (_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.payload) == null ? void 0 : _c.path) === path) {
        addItemHandler(e.data.payload.index);
      }
    },
    [path, addItemHandler]
  );
  React__default.useEffect(() => {
    window.addEventListener("message", handleInsertNewEditableComponentMessage);
    return () => {
      window.removeEventListener("message", handleInsertNewEditableComponentMessage);
    };
  }, [handleInsertNewEditableComponentMessage]);
  return visible ? /* @__PURE__ */ jsx(View, { id: "jsonforms-array-wrapper", children: /* @__PURE__ */ jsxs(Flex, { id: `spectrum-renderer-arrayContentWrapper_${path}`, direction: "column", children: [
    /* @__PURE__ */ jsx(Heading, { level: 4, children: label }),
    (data == null ? void 0 : data.length) ? /* @__PURE__ */ jsx(
      DnDArray,
      {
        data,
        enabled,
        handleChange,
        dataReduce,
        addItemHandler,
        replaceItemHandler,
        path,
        renderers,
        schema,
        uischema,
        uischemas
      }
    ) : /* @__PURE__ */ jsx(Text, { children: "No data" }),
    /* @__PURE__ */ jsx(AddItemButton, { path, addItemHandler: pushItemHandler })
  ] }) }) : null;
};
const SpectrumDnDArrayModalControlRenderer = withJsonFormsArrayControlProps(
  withHandleChange(withDataReduce(React__default.memo(SpectrumDnDArrayControlRenderer)))
);
const SpectrumDnDArrayModalControlTester = rankWith(
  5,
  and(
    uiTypeIs("Control"),
    schemaMatches((schema) => hasType(schema, "array") && !Array.isArray(schema.items))
  )
);
const SpectrumAnyOfRenderer = ({
  cells,
  enabled,
  indexOfFittingSchema,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas,
  visible
}) => {
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const [selectedAnyOf, setSelectedAnyOf] = React.useState(indexOfFittingSchema || 0);
  const handleChange = React.useCallback(
    (value) => setSelectedAnyOf(Number(value)),
    [setSelectedAnyOf]
  );
  const anyOf = "anyOf";
  let anyOfRenderInfos;
  if (schema == null ? void 0 : schema.anyOf) {
    anyOfRenderInfos = createCombinatorRenderInfos(
      schema.anyOf,
      rootSchema,
      anyOf,
      uischema,
      path,
      uischemas
    );
  }
  return /* @__PURE__ */ jsxs(View, { isHidden: !visible, UNSAFE_className: `anyof-renderer`, children: [
    /* @__PURE__ */ jsx(CombinatorProperties, { schema, combinatorKeyword: "anyOf", path }),
    anyOfRenderInfos && /* @__PURE__ */ jsxs(
      Tabs,
      {
        selectedKey: String(selectedAnyOf),
        onSelectionChange: handleChange,
        "aria-label": path,
        children: [
          /* @__PURE__ */ jsx(TabList, { children: anyOfRenderInfos == null ? void 0 : anyOfRenderInfos.map((anyOfRenderInfo, anyOfIndex) => /* @__PURE__ */ jsx(Item, { children: anyOfRenderInfo.label }, anyOfIndex)) }),
          /* @__PURE__ */ jsx(TabPanels, { children: anyOfRenderInfos == null ? void 0 : anyOfRenderInfos.map((anyOfRenderInfo, anyOfIndex) => /* @__PURE__ */ jsx(Item, { title: anyOfRenderInfo.label, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
            JsonFormsDispatch,
            {
              cells,
              enabled,
              path,
              renderers,
              schema: anyOfRenderInfo.schema,
              uischema: anyOfRenderInfo.uischema
            },
            anyOfIndex
          ) }) }, anyOfIndex)) })
        ]
      }
    )
  ] });
};
const SpectrumAnyOfRendererTester = rankWith(3, isAnyOfControl);
const SpectrumAnyOfRenderer$1 = withJsonFormsAnyOfProps(withHandleChange(SpectrumAnyOfRenderer));
const getNodeName$1 = (editor, tag) => {
  if (tag) {
    if (tag.startsWith("h") && tag.length === 2) {
      return "heading";
    } else if (tag === "blockquote") {
      return "blockquote";
    } else if (tag === "span") {
      return "span";
    } else {
      return "paragraph";
    }
  } else {
    if (editor.isActive("heading")) {
      return "heading";
    } else if (editor.isActive("blockquote")) {
      return "blockquote";
    } else if (editor.isActive("span")) {
      return "span";
    } else {
      return "paragraph";
    }
  }
};
function HeadingToolbarButtons({
  editor,
  readOnly,
  path
}) {
  const currentText = () => {
    if (editor.isActive("heading")) {
      "H" + editor.getAttributes("heading").level;
    } else if (editor.isActive("blockquote"))
      ;
    else
      ;
  };
  let options = [
    { name: "Paragraph" },
    { name: "H2" },
    { name: "H3" },
    { name: "H4" },
    { name: "H5" },
    { name: "H6" },
    { name: "Blockquote" }
  ];
  let [heading, setHeading] = React__default.useState(null);
  const pickerChange = (selected) => {
    setHeading(selected);
    switch (selected) {
      case "Paragraph":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "p"
        }).unsetBlockquote().run();
        break;
      case "H1":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h1",
          level: 1
        }).unsetBlockquote().run();
        break;
      case "H2":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class ?? void 0,
          tag: "h2",
          level: 2
        }).unsetBlockquote().run();
        break;
      case "H3":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h3",
          level: 3
        }).unsetBlockquote().run();
        break;
      case "H4":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h4",
          level: 4
        }).unsetBlockquote().run();
        break;
      case "H5":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h5",
          level: 5
        }).unsetBlockquote().run();
        break;
      case "H6":
        editor.chain().focus().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "h6",
          level: 6
        }).unsetBlockquote().run();
        break;
      case "Blockquote":
        editor.chain().focus().setParagraph().toggleNodeWithClass({
          class: editor.getAttributes(getNodeName$1(editor)).class,
          tag: "blockquote"
        }).run();
        break;
    }
  };
  React__default.useEffect(() => {
    setHeading(
      editor.isActive("heading") ? "H" + editor.getAttributes("heading").level : editor.isActive("blockquote") ? "Blockquote" : "Paragraph"
    );
  }, [editor, currentText]);
  return /* @__PURE__ */ jsx(Flex, { alignItems: "center", children: /* @__PURE__ */ jsx(
    Picker,
    {
      ...dataEditorPath(`${path}-heading-picker`),
      "aria-label": "Picker",
      label: false,
      items: options,
      selectedKey: heading,
      onSelectionChange: (selected) => pickerChange(selected),
      maxWidth: "size-1600",
      isDisabled: readOnly,
      children: (item) => /* @__PURE__ */ jsx(Item, { children: item.name }, item.name)
    }
  ) });
}
function TablePropertiesMenu({
  readOnly,
  editor,
  path
}) {
  const [open, setOpen] = React__default.useState(false);
  const [forceOpen, setForceOpen] = React__default.useState(false);
  React__default.useEffect(() => {
    if (forceOpen) {
      setForceOpen(false);
    }
  }, [forceOpen]);
  const tableAttributes = editor.getAttributes("table");
  const cellType = !isEmpty$1(editor.getAttributes("tableHeader")) ? "tableHeader" : "tableCell";
  const cellAttributes = editor.getAttributes(cellType);
  const updateAttributesOf = (element, object) => {
    editor.chain().updateAttributes(element, object).run();
  };
  const toggleStyle = (styleString, newStyle) => {
    let cssObj = cssToObject(styleString);
    let [name, value] = newStyle.replace(";", "").split(":");
    if (value.trim() === "unset") {
      delete cssObj[name];
      return objectToCss(cssObj);
    }
    cssObj = { ...cssObj, [name.trim()]: value.trim() };
    return objectToCss(cssObj);
  };
  const captionText = () => {
    var _a, _b, _c, _d, _e;
    const path2 = (_c = (_b = (_a = editor == null ? void 0 : editor.state) == null ? void 0 : _a.selection) == null ? void 0 : _b.$head) == null ? void 0 : _c.path;
    let tableNode;
    for (let i = 0; i < path2.length; i++) {
      if (((_e = (_d = path2[i]) == null ? void 0 : _d.type) == null ? void 0 : _e.name) === "table") {
        tableNode = path2[i];
        break;
      }
    }
    if (!tableNode) {
      return "";
    }
    const tableContent = tableNode.content.content;
    if (tableContent[0].type.name === "caption") {
      return tableContent[0].textContent;
    }
    return "";
  };
  return /* @__PURE__ */ jsxs(
    DialogTrigger,
    {
      type: "popover",
      isOpen: open || forceOpen,
      onOpenChange: (isOpen) => {
        if (!forceOpen) {
          setOpen(isOpen);
        }
      },
      children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            "aria-label": "tableProperties",
            isDisabled: readOnly,
            ...dataEditorPath(`${path}-table-menu-toggle-button`),
            children: /* @__PURE__ */ jsx(Properties, {})
          }
        ),
        /* @__PURE__ */ jsx(Dialog, { children: /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsxs(Tabs, { "aria-label": "Cell or Table Properties", children: [
          /* @__PURE__ */ jsxs(TabList, { children: [
            /* @__PURE__ */ createElement(Item, { ...dataEditorPath(`${path}-tab-cell-properties`), key: "cellProperties" }, "Cell Properties"),
            /* @__PURE__ */ createElement(Item, { ...dataEditorPath(`${path}-tab-table-properties`), key: "tableProperties" }, "Table Properties")
          ] }),
          /* @__PURE__ */ jsxs(TabPanels, { children: [
            /* @__PURE__ */ jsx(Item, { children: /* @__PURE__ */ jsxs(Flex, { direction: "column", gap: 10, children: [
              /* @__PURE__ */ jsxs(Flex, { alignItems: "center", gap: 10, children: [
                /* @__PURE__ */ jsx(
                  TextField,
                  {
                    ...dataEditorPath(`${path}-table-menu-cell-width`),
                    "aria-label": "width",
                    defaultValue: cellAttributes.width,
                    label: "Width",
                    onChange: (value) => updateAttributesOf(cellType, { width: value }),
                    contextualHelp: /* @__PURE__ */ jsx(ContextualHelp, { variant: "info", placement: "top start", children: /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: 'Width in pixels. For relative values add "%" e.g. "40%"' }) }) })
                  }
                ),
                /* @__PURE__ */ jsx(
                  TextField,
                  {
                    ...dataEditorPath(`${path}-table-menu-cell-height`),
                    "aria-label": "height",
                    defaultValue: cellAttributes.height,
                    label: "Height",
                    onChange: (value) => updateAttributesOf(cellType, { height: value }),
                    contextualHelp: /* @__PURE__ */ jsx(ContextualHelp, { variant: "info", placement: "top start", children: /* @__PURE__ */ jsx(Content, { children: /* @__PURE__ */ jsx(Text, { children: 'Width in pixels. For relative values add "%" e.g. "40%"' }) }) })
                  }
                )
              ] }),
              /* @__PURE__ */ jsxs(Flex, { alignItems: "center", justifyContent: "space-between", children: [
                /* @__PURE__ */ jsxs(
                  Picker,
                  {
                    ...dataEditorPath(`${path}-table-menu-cell-align`),
                    "aria-label": "horizontalAlign",
                    defaultSelectedKey: cellAttributes.style || "text-align: unset;",
                    label: "Horizontal Align",
                    marginEnd: 10,
                    onSelectionChange: (value) => updateAttributesOf(cellType, {
                      style: toggleStyle(cellAttributes.style, value)
                    }),
                    children: [
                      /* @__PURE__ */ jsx(Item, { children: "None" }, "text-align: unset;"),
                      /* @__PURE__ */ jsx(Item, { children: "Left" }, "text-align: left;"),
                      /* @__PURE__ */ jsx(Item, { children: "Center" }, "text-align: center;"),
                      /* @__PURE__ */ jsx(Item, { children: "Right" }, "text-align: right;")
                    ]
                  }
                ),
                /* @__PURE__ */ jsxs(
                  Picker,
                  {
                    ...dataEditorPath(`${path}-table-menu-cell-vertical-align`),
                    "aria-label": "verticalAlign",
                    defaultSelectedKey: cellAttributes.valign || "unset",
                    label: "Vertical Align",
                    onSelectionChange: (value) => updateAttributesOf(cellType, { valign: value }),
                    children: [
                      /* @__PURE__ */ jsx(Item, { children: "None" }, "unset"),
                      /* @__PURE__ */ jsx(Item, { children: "Top" }, "top"),
                      /* @__PURE__ */ jsx(Item, { children: "Middle" }, "middle"),
                      /* @__PURE__ */ jsx(Item, { children: "Bottom" }, "bottom"),
                      /* @__PURE__ */ jsx(Item, { children: "Baseline" }, "baseline")
                    ]
                  }
                )
              ] }),
              /* @__PURE__ */ jsxs(
                Picker,
                {
                  ...dataEditorPath(`${path}-table-menu-cell-type`),
                  label: "Cell Type",
                  "aria-label": "cellType",
                  defaultSelectedKey: cellType || "tableCell",
                  onSelectionChange: (value) => {
                    if (value !== cellType) {
                      editor.chain().toggleHeaderCell().run();
                    }
                  },
                  children: [
                    /* @__PURE__ */ jsx(Item, { children: "Data" }, "tableCell"),
                    /* @__PURE__ */ jsx(Item, { children: "Header" }, "tableHeader")
                  ]
                }
              ),
              cellType === "tableHeader" && /* @__PURE__ */ jsxs(Flex, { alignItems: "end", justifyContent: "space-between", children: [
                /* @__PURE__ */ jsx(
                  TextField,
                  {
                    ...dataEditorPath(`${path}-table-menu-cell-header-id`),
                    width: 150,
                    label: "Id",
                    "aria-label": "id",
                    defaultValue: cellAttributes.id,
                    onChange: (value) => updateAttributesOf(cellType, { id: value })
                  }
                ),
                /* @__PURE__ */ jsx(
                  Switch,
                  {
                    ...dataEditorPath(`${path}-table-menu-cell-header-hidden`),
                    "aria-label": "hiddenHeader",
                    onChange: (value) => {
                      updateAttributesOf(cellType, {
                        hiddenheader: value,
                        style: toggleStyle(
                          cellAttributes.style,
                          value ? "background-color: rgb(215,215,215);" : "background-color: unset;"
                        )
                      });
                    },
                    children: "Hidden Header"
                  }
                )
              ] }),
              /* @__PURE__ */ jsxs(
                Picker,
                {
                  ...dataEditorPath(`${path}-table-menu-cell-scope`),
                  label: "Scope",
                  "aria-label": "scope",
                  defaultSelectedKey: cellAttributes.scope || "none",
                  onSelectionChange: (value) => updateAttributesOf(cellType, { scope: value }),
                  children: [
                    /* @__PURE__ */ jsx(Item, { children: "Scope" }, "none"),
                    /* @__PURE__ */ jsx(Item, { children: "Column" }, "col"),
                    /* @__PURE__ */ jsx(Item, { children: "Row" }, "row")
                  ]
                }
              )
            ] }) }, "cellProperties"),
            /* @__PURE__ */ jsxs(Item, { children: [
              /* @__PURE__ */ jsxs(Flex, { gap: 20, children: [
                /* @__PURE__ */ jsxs(Flex, { direction: "column", gap: 10, width: "30%", wrap: "wrap", children: [
                  /* @__PURE__ */ jsx(
                    TextField,
                    {
                      ...dataEditorPath(`${path}-table-menu-table-width`),
                      label: "Width",
                      "aria-label": "width",
                      defaultValue: tableAttributes.width,
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { width: value })
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    TextField,
                    {
                      ...dataEditorPath(`${path}-table-menu-table-height`),
                      label: "Height",
                      "aria-label": "height",
                      defaultValue: tableAttributes.height,
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { height: value })
                    }
                  )
                ] }),
                /* @__PURE__ */ jsxs(Grid, { columns: ["1fr", "1fr"], gap: 10, alignItems: "end", width: "70%", children: [
                  /* @__PURE__ */ jsx(
                    NumberField,
                    {
                      ...dataEditorPath(`${path}-table-menu-table-cell-padding`),
                      label: "Cell Padding",
                      "aria-label": "cellPadding",
                      defaultValue: Number(tableAttributes.cellPadding),
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { cellPadding: value })
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    NumberField,
                    {
                      ...dataEditorPath(`${path}-table-menu-table-border`),
                      label: "Border",
                      "aria-label": "border",
                      defaultValue: Number(tableAttributes.border),
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { border: value })
                    }
                  ),
                  /* @__PURE__ */ jsx(
                    NumberField,
                    {
                      ...dataEditorPath(`${path}-table-menu-table-cell-spacing`),
                      label: "Cell Spacing",
                      "aria-label": "callSpacing",
                      defaultValue: Number(tableAttributes.cellSpacing),
                      width: "100%",
                      onChange: (value) => updateAttributesOf("table", { cellSpacing: value })
                    }
                  )
                ] })
              ] }),
              /* @__PURE__ */ jsx(
                TextField,
                {
                  ...dataEditorPath(`${path}-table-menu-table-caption`),
                  label: "Table Caption",
                  "aria-label": "tableCaption",
                  defaultValue: captionText(),
                  width: "100%",
                  onChange: (value) => {
                    if (value === "") {
                      setForceOpen(true);
                      editor.chain().removeCaption().run();
                    } else {
                      setForceOpen(true);
                      editor.chain().setCaption(value).run();
                    }
                  }
                }
              )
            ] }, "tableProperties")
          ] })
        ] }) }) })
      ]
    }
  );
}
function TableToolbarToggleButton({
  editor,
  readOnly,
  toolbarView,
  setShowTableControls,
  path
}) {
  if (toolbarView === "table") {
    return /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-edit-table`),
          onPress: () => {
            setShowTableControls(true);
          },
          "aria-label": "EditTable",
          isSelected: editor.isActive("EditTable"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableEdit, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Edit Table" })
    ] });
  }
  return /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
    /* @__PURE__ */ jsx(
      ToggleButton,
      {
        ...dataEditorPath(`${path}-create-table`),
        onPress: () => {
          editor.chain().focus().insertTable({ rows: 3, cols: 3, withHeaderRow: true }).run();
          setShowTableControls(true);
        },
        "aria-label": "createTable",
        isSelected: editor.isActive("createTable"),
        isDisabled: readOnly,
        children: /* @__PURE__ */ jsx(TableAdd, {})
      }
    ),
    /* @__PURE__ */ jsx(Tooltip, { children: "Create Table" })
  ] });
}
function TableToolbarButtons({
  editor,
  readOnly,
  setShowTableControls,
  path
}) {
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-insert-left`),
          onPress: () => {
            editor.chain().focus().addColumnBefore().run();
          },
          "aria-label": "insertLeft",
          isSelected: editor.isActive("insertLeft"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableColumnAddLeft, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Left" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-insert-right`),
          onPress: () => {
            editor.chain().focus().addColumnAfter().run();
          },
          "aria-label": "insertRight",
          isSelected: editor.isActive("insertRight"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableColumnAddRight, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Right" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-delete-column`),
          onPress: () => {
            editor.chain().focus().deleteColumn().run();
          },
          "aria-label": "deleteColumn",
          isSelected: editor.isActive("deleteColumn"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableColumnRemoveCenter, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Delete Column" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-insert-above`),
          onPress: () => {
            editor.chain().focus().addRowBefore().run();
          },
          "aria-label": "insertAbove",
          isSelected: editor.isActive("insertAbove"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowAddTop, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Above" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-insert-below`),
          onPress: () => {
            editor.chain().focus().addRowAfter().run();
          },
          "aria-label": "insertBelow",
          isSelected: editor.isActive("insertBelow"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowAddBottom, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Insert Below" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-delete-row`),
          onPress: () => {
            editor.chain().focus().deleteRow().run();
          },
          "aria-label": "deleteRow",
          isSelected: editor.isActive("deleteRow"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowRemoveCenter, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Delete Row" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-merge-cells`),
          onPress: () => {
            editor.chain().focus().mergeCells().run();
          },
          "aria-label": "mergeCells",
          isSelected: editor.isActive("mergeCells"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableMergeCells, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Merge Cells" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-split-cells`),
          onPress: () => {
            editor.chain().focus().splitCell().run();
          },
          "aria-label": "splitCell",
          isSelected: editor.isActive("splitCell"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TableRowSplit, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Split Cells" })
    ] }),
    /* @__PURE__ */ jsx(TablePropertiesMenu, { path, readOnly, editor }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-delete-table`),
          onPress: () => {
            editor.commands.deleteNode("table");
            setShowTableControls(false);
          },
          "aria-label": "deleteTable",
          isSelected: editor.isActive("deleteTable"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(Delete, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Delete Table" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-undo`),
          onPress: () => editor.chain().focus().undo().run(),
          "aria-label": "undo",
          isSelected: false,
          isDisabled: !editor.can().undo(),
          children: /* @__PURE__ */ jsx(Undo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Undo" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-redo`),
          onPress: () => editor.chain().focus().redo().run(),
          "aria-label": "redo",
          isSelected: false,
          isDisabled: !editor.can().redo(),
          UNSAFE_className: "last-toolbar-button",
          children: /* @__PURE__ */ jsx(Redo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Redo" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-table-close-table-editor`),
          onPress: () => {
            setShowTableControls(false);
          },
          "aria-label": "closeTableEditor",
          isSelected: editor.isActive("closeTableEditor"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(Close, {})
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Close Table Editor" })
    ] })
  ] });
}
function DefaultToobbarButtons({
  disableTables,
  editor,
  readOnly,
  setShowTableControls,
  showTableControls,
  toolbarView,
  path
}) {
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-bold`),
          onPress: () => editor.chain().focus().toggleBold().run(),
          "aria-label": "bold",
          isSelected: editor.isActive("bold"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TagBold, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Bold" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-italic`),
          onPress: () => editor.chain().focus().toggleItalic().run(),
          "aria-label": "italic",
          isSelected: editor.isActive("italic"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TagItalic, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Italic" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-underline`),
          onPress: () => editor.chain().focus().toggleUnderline().run(),
          "aria-label": "underline",
          isSelected: editor.isActive("underline"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TagUnderline, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Underlined" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-strike`),
          onPress: () => editor.chain().focus().toggleStrike().run(),
          "aria-label": "strike",
          isSelected: editor.isActive("strike"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextStrikethrough, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Text Strikethrough" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-align-left`),
          onPress: () => editor.chain().focus().setTextAlign("left").run(),
          "aria-label": "left aligned",
          isSelected: editor.isActive({ textAlign: "left" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignLeft, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align left" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-align-center`),
          onPress: () => editor.chain().focus().setTextAlign("center").run(),
          "aria-label": "Center aligned",
          isSelected: editor.isActive({ textAlign: "center" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignCenter, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align centered" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-align-right`),
          onPress: () => editor.chain().focus().setTextAlign("right").run(),
          "aria-label": "Right aligned",
          isSelected: editor.isActive({ textAlign: "right" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignRight, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align right" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-align-justify`),
          onPress: () => editor.chain().focus().setTextAlign("justify").run(),
          "aria-label": "Justify aligned",
          isSelected: editor.isActive({ textAlign: "justify" }),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextAlignJustify, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Align justified" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-superscript`),
          onPress: () => editor.chain().focus().toggleSuperscript().run(),
          "aria-label": "superscript",
          isSelected: editor.isActive("superscript"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextSuperscript, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Superscript" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-subscript`),
          onPress: () => editor.chain().focus().toggleSubscript().run(),
          "aria-label": "subscript",
          isSelected: editor.isActive("subscript"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextSubscript, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Subscript" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-bullet-list`),
          onPress: () => editor.chain().focus().toggleBulletList().run(),
          "aria-label": "bullettList",
          isSelected: editor.isActive("bulletList"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextBulleted, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Bullet List" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-toggle-ordered-list`),
          onPress: () => editor.chain().focus().toggleOrderedList().run(),
          "aria-label": "orderedList",
          isSelected: editor.isActive("orderedList"),
          isDisabled: readOnly,
          children: /* @__PURE__ */ jsx(TextNumbered, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Ordered List" })
    ] }),
    !disableTables && /* @__PURE__ */ jsx(
      TableToolbarToggleButton,
      {
        path,
        editor,
        readOnly,
        toolbarView,
        showTableControls,
        setShowTableControls
      }
    ),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-undo`),
          onPress: () => editor.chain().focus().undo().run(),
          "aria-label": "undo",
          isSelected: false,
          isDisabled: !editor.can().undo(),
          children: /* @__PURE__ */ jsx(Undo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Undo" })
    ] }),
    /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ToggleButton,
        {
          ...dataEditorPath(`${path}-redo`),
          onPress: () => editor.chain().focus().redo().run(),
          "aria-label": "redo",
          isSelected: false,
          isDisabled: !editor.can().redo(),
          UNSAFE_className: "last-toolbar-button",
          children: /* @__PURE__ */ jsx(Redo, { size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Redo" })
    ] })
  ] });
}
const AddClassButton = (props) => {
  var _a;
  const currentClass = props.editor.state.selection.$head.parent.attrs.class;
  const nodeItems = (_a = props == null ? void 0 : props.options) == null ? void 0 : _a.map((nodeClass) => {
    return {
      id: nodeClass == null ? void 0 : nodeClass.class,
      name: (nodeClass == null ? void 0 : nodeClass.name) ?? (nodeClass == null ? void 0 : nodeClass.class),
      active: currentClass == null ? void 0 : currentClass.includes(nodeClass == null ? void 0 : nodeClass.class)
    };
  });
  let [selectedClasses, setSelectedClasses] = React__default.useState(
    nodeItems.map((item) => item.id).filter((id) => {
      const item = nodeItems.find((item2) => item2.id === id);
      return item && item.active === true;
    })
  );
  const activeNodeOption = (selected) => {
    let selectedKey = selected == null ? void 0 : selected.currentKey;
    if ((selected == null ? void 0 : selected.currentKey) === void 0) {
      selectedKey = selectedClasses.filter((x) => ![...selected.keys()].includes(x))[0];
    }
    setSelectedClasses((prevSelectedClasses) => {
      if (prevSelectedClasses.includes(selectedKey)) {
        return prevSelectedClasses.filter((key) => key !== selectedKey);
      } else {
        return [...prevSelectedClasses, selectedKey];
      }
    });
    props.editor.chain().focus().toggleNodeWithClass({
      class: selectedKey == null ? void 0 : selectedKey.toString()
    }).run();
  };
  return /* @__PURE__ */ jsxs(MenuTrigger, { children: [
    /* @__PURE__ */ jsxs(
      ActionButton,
      {
        ...dataEditorPath(`${props.path}-class-toggle-${props.buttonText}`),
        UNSAFE_style: { paddingLeft: "10px" },
        children: [
          props.buttonText ?? "Add a Class",
          /* @__PURE__ */ jsx(ChevronDown, { size: "S" })
        ]
      }
    ),
    /* @__PURE__ */ jsx(
      Menu,
      {
        ...dataEditorPath(`${props.path}-class-menu-${props.buttonText}`),
        items: nodeItems,
        onSelectionChange: (selected) => activeNodeOption(selected),
        selectedKeys: selectedClasses,
        selectionMode: "multiple",
        children: (item) => /* @__PURE__ */ jsx(Item, { children: item.name }, item.id)
      }
    )
  ] });
};
const AddStyleButton = (props) => {
  var _a;
  const currentStyle = props.editor.state.selection.$head.parent.attrs.style;
  const nodeItems = (_a = props == null ? void 0 : props.options) == null ? void 0 : _a.map((nodeStyle) => {
    return {
      id: nodeStyle == null ? void 0 : nodeStyle.style,
      name: (nodeStyle == null ? void 0 : nodeStyle.name) ?? (nodeStyle == null ? void 0 : nodeStyle.style),
      active: currentStyle == null ? void 0 : currentStyle.includes(nodeStyle == null ? void 0 : nodeStyle.style)
    };
  });
  let [selectedStyles, setSelectedStyles] = React__default.useState(
    nodeItems.map((item) => item.id).filter((id) => {
      const item = nodeItems.find((item2) => item2.id === id);
      return item && item.active === true;
    })
  );
  const activeNodeOption = (selected) => {
    let selectedKey = selected == null ? void 0 : selected.currentKey;
    if ((selected == null ? void 0 : selected.currentKey) === void 0) {
      selectedKey = selectedStyles.filter((x) => ![...selected.keys()].includes(x))[0];
    }
    setSelectedStyles((prevSelectedStyles) => {
      if (prevSelectedStyles.includes(selectedKey)) {
        return prevSelectedStyles.filter((key) => key !== selectedKey);
      } else {
        return [...prevSelectedStyles, selectedKey];
      }
    });
    props.editor.chain().focus().toggleNodeWithStyle({
      style: selectedKey == null ? void 0 : selectedKey.toString()
    }).run();
  };
  return /* @__PURE__ */ jsxs(MenuTrigger, { children: [
    /* @__PURE__ */ jsxs(
      ActionButton,
      {
        ...dataEditorPath(`${props.path}-style-toggle-${props.buttonText}`),
        UNSAFE_style: { paddingLeft: "10px" },
        children: [
          props.buttonText ?? "Add a Style",
          /* @__PURE__ */ jsx(ChevronDown, { size: "S" })
        ]
      }
    ),
    /* @__PURE__ */ jsx(
      Menu,
      {
        ...dataEditorPath(`${props.path}-style-menu-${props.buttonText}`),
        items: nodeItems,
        onSelectionChange: (selected) => activeNodeOption(selected),
        selectedKeys: selectedStyles,
        selectionMode: "multiple",
        children: (item) => /* @__PURE__ */ jsx(Item, { children: item.name }, item.id)
      }
    )
  ] });
};
const TipTapToolbar = ({
  disableTables,
  editor,
  readOnly,
  uischema,
  toolbarView,
  path
}) => {
  var _a, _b, _c, _d, _e, _f;
  const [showTableControls, setShowTableControls] = useState(false);
  return /* @__PURE__ */ jsx(
    View,
    {
      borderWidth: "thin",
      borderColor: "dark",
      borderRadius: "regular",
      UNSAFE_className: "tiptap-toolbar",
      children: /* @__PURE__ */ jsxs(Flex, { gap: "size-25", margin: "size-100", wrap: true, children: [
        /* @__PURE__ */ jsx(HeadingToolbarButtons, { path, editor, readOnly }),
        ((_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.nodeClasses) && /* @__PURE__ */ jsx(
          AddClassButton,
          {
            path,
            options: (_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.nodeClasses,
            editor,
            buttonText: (_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.nodeClassButton
          }
        ),
        ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.nodeStyles) && /* @__PURE__ */ jsx(
          AddStyleButton,
          {
            path,
            options: (_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.nodeStyles,
            editor,
            buttonText: (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.nodeStyleButton
          }
        ),
        showTableControls && toolbarView === "table" ? /* @__PURE__ */ jsx(
          TableToolbarButtons,
          {
            path,
            editor,
            readOnly,
            toolbarView,
            showTableControls,
            setShowTableControls
          }
        ) : /* @__PURE__ */ jsx(
          DefaultToobbarButtons,
          {
            path,
            disableTables,
            editor,
            readOnly,
            uischema,
            toolbarView,
            showTableControls,
            setShowTableControls
          }
        )
      ] })
    }
  );
};
const removeWhiteSpace = (str) => {
  if (typeof str !== "string") {
    return void 0;
  } else {
    return str == null ? void 0 : str.replace(/\s+/g, " ").trim();
  }
};
const getNodeName = (editor, tag) => {
  if (tag) {
    if (tag.startsWith("h") && tag.length === 2) {
      return "heading";
    } else if (tag === "blockquote") {
      return "blockquote";
    } else if (tag === "span") {
      return "span";
    } else {
      return "paragraph";
    }
  } else {
    if (editor.isActive("heading")) {
      return "heading";
    } else if (editor.isActive("blockquote")) {
      return "blockquote";
    } else if (editor.isActive("span")) {
      return "span";
    } else {
      return "paragraph";
    }
  }
};
const getMarkName = (editor, tag) => {
  if (tag) {
    if (tag.startsWith("h") && tag.length === 2) {
      return "heading";
    } else if (tag === "blockquote") {
      return "blockquote";
    } else if (tag === "span") {
      return "span";
    } else {
      return "paragraph";
    }
  } else {
    if (editor.isActive("heading")) {
      return "heading";
    } else if (editor.isActive("blockquote")) {
      return "blockquote";
    } else if (editor.isActive("span")) {
      return "span";
    } else {
      return "paragraph";
    }
  }
};
const getTag = (editor) => {
  if (editor.isActive("heading")) {
    return `h${editor.getAttributes("heading").level}`;
  } else if (editor.isActive("blockquote")) {
    return "blockquote";
  } else if (editor.isActive("span")) {
    return "span";
  } else {
    return "p";
  }
};
const nodeWithClass = Node.create({
  name: "nodeWithClass",
  addOptions() {
    return {
      tag: "p",
      nodeName: "paragraph",
      classes: [""],
      styles: [""],
      level: 6,
      excludes: "nodeWithClass",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  content: "inline*",
  group: "block",
  defining: true,
  addAttributes() {
    return {
      level: {
        default: this.options.level,
        parseHTML: (element) => element.getAttribute("level"),
        renderHTML: (attributes) => {
          if (!attributes.level) {
            return {};
          }
          return {
            level: attributes.level
          };
        }
      },
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: this.options.styles[0],
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          if (!attributes.style) {
            return {};
          }
          return {
            style: attributes.style
          };
        }
      },
      tag: {
        default: "p",
        parseHTML: (element) => element.getAttribute("tag"),
        renderHTML: (attributes) => {
          if (!attributes.tag) {
            return {};
          }
          return {
            tag: attributes.tag
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag,
        getAttrs: (element) => {
          const hasClass = element.hasAttribute("class");
          if (!hasClass) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    var _a;
    const tag = (HTMLAttributes == null ? void 0 : HTMLAttributes.tag) || ((_a = this == null ? void 0 : this.options) == null ? void 0 : _a.tag);
    HTMLAttributes == null ? true : delete HTMLAttributes.tag;
    return [tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleNodeWithClass: (attributes) => ({ chain, editor }) => {
        const nodeName = getNodeName(editor, (attributes == null ? void 0 : attributes.tag) ?? getTag(editor));
        const currentClass = removeWhiteSpace(
          editor.getAttributes(nodeName).class ?? ""
        );
        const currClass = ` ${currentClass} `;
        const regex = new RegExp(`\\b${attributes.class}\\b`, "g");
        const newClass = currentClass ? removeWhiteSpace(currClass.replace(regex, "")) : void 0;
        let nodeClass = void 0;
        const isNewTag = attributes.tag && getTag(editor) !== attributes.tag;
        if (newClass !== currentClass && !isNewTag) {
          nodeClass = newClass ?? attributes.class;
        } else {
          if (isNewTag) {
            nodeClass = attributes.class;
          } else {
            nodeClass = removeWhiteSpace(
              `${currentClass ?? void 0} ${attributes.class ?? void 0}`
            );
          }
        }
        if (nodeClass === "") {
          nodeClass = void 0;
        }
        if (nodeName === "heading") {
          const level = attributes.level || editor.getAttributes(nodeName).level || this.options.level;
          return chain().setHeading({ level }).updateAttributes(nodeName, {
            class: nodeClass,
            level,
            style: editor.getAttributes(nodeName).style ?? void 0
          }).unsetBlockquote().run();
        } else if (nodeName === "blockquote") {
          return chain().setParagraph().setBlockquote().updateAttributes(nodeName, {
            class: nodeClass,
            style: editor.getAttributes(nodeName).style ?? void 0
          }).run();
        } else {
          return chain().setParagraph().updateAttributes(nodeName, {
            class: nodeClass,
            style: editor.getAttributes(nodeName).style ?? void 0
          }).unsetBlockquote().run();
        }
      }
    };
  }
});
const markWithClass = Mark.create({
  name: "markWithClass",
  addOptions() {
    return {
      tag: "p",
      markName: "paragraph",
      classes: [""],
      level: 6,
      excludes: "markWithClass",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  content: "inline*",
  group: "block",
  defining: true,
  addAttributes() {
    return {
      level: {
        default: this.options.level,
        rendered: false,
        parseHTML: (element) => element.getAttribute("level"),
        renderHTML: (attributes) => {
          if (!attributes.level) {
            return {};
          }
          return {
            level: attributes.level
          };
        }
      },
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      tag: {
        default: "p",
        parseHTML: (element) => element.getAttribute("tag"),
        renderHTML: (attributes) => {
          if (!attributes.tag) {
            return {};
          }
          return {
            tag: attributes.tag
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag,
        getAttrs: (element) => {
          const hasClass = element.hasAttribute("class");
          if (!hasClass) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    var _a;
    const tag = (HTMLAttributes == null ? void 0 : HTMLAttributes.tag) || ((_a = this == null ? void 0 : this.options) == null ? void 0 : _a.tag);
    HTMLAttributes == null ? true : delete HTMLAttributes.tag;
    return [tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleMarkWithClass: (attributes) => ({ chain, editor }) => {
        const markName = getMarkName(editor, (attributes == null ? void 0 : attributes.tag) ?? getTag(editor));
        const currentClass = removeWhiteSpace(
          editor.getAttributes(markName).class ?? ""
        );
        const currClass = ` ${currentClass} `;
        const regex = new RegExp(`\\b${attributes.class}\\b`, "g");
        const newClass = currentClass ? removeWhiteSpace(currClass.replace(regex, "")) : void 0;
        let markClass = void 0;
        const isNewTag = attributes.tag && getTag(editor) !== attributes.tag;
        if (newClass !== currentClass && !isNewTag) {
          markClass = newClass ?? attributes.class;
        } else {
          if (isNewTag) {
            markClass = attributes.class;
          } else {
            markClass = removeWhiteSpace(
              `${currentClass ?? void 0} ${attributes.class ?? void 0}`
            );
          }
        }
        if (markClass === "") {
          markClass = void 0;
        }
        if (markName === "heading") {
          const level = attributes.level || editor.getAttributes(markName).level || this.options.level;
          return chain().setHeading({ level }).updateAttributes(markName, {
            class: markClass,
            level
          }).unsetBlockquote().run();
        } else if (markName === "blockquote") {
          return chain().setParagraph().setBlockquote().updateAttributes(markName, {
            class: markClass
          }).run();
        } else {
          return chain().setParagraph().updateAttributes(markName, {
            class: markClass
          }).unsetBlockquote().run();
        }
      }
    };
  }
});
const markWithStyle = Mark.create({
  name: "markWithStyle",
  addOptions() {
    return {
      tag: "span",
      classes: [""],
      styles: [""],
      excludes: "markWithStyle",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: this.options.styles[0],
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          if (!attributes.style) {
            return {};
          }
          return {
            style: attributes.style
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag ?? "span",
        getAttrs: (element) => {
          const hasStyle = element.hasAttribute("style");
          if (!hasStyle) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    return [this.options.tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleMarkWithStyle: (attributes) => ({ chain, editor }) => {
        const currentStyle = removeWhiteSpace(
          editor.getAttributes("span").style ?? ""
        );
        const currStyle = ` ${currentStyle} `;
        let newStyle;
        if (typeof (attributes == null ? void 0 : attributes.style) === "string") {
          const regex = new RegExp(attributes.style.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), "g");
          newStyle = currentStyle ? removeWhiteSpace(currStyle.replace(regex, "")) : void 0;
        } else {
          newStyle = currentStyle ? removeWhiteSpace(currStyle) : void 0;
        }
        let markStyle = void 0;
        if (newStyle !== currentStyle) {
          markStyle = newStyle ?? (attributes == null ? void 0 : attributes.style);
        } else {
          markStyle = removeWhiteSpace(
            `${currentStyle ?? void 0} ${(attributes == null ? void 0 : attributes.style) ?? void 0}`
          );
        }
        if (markStyle === "") {
          markStyle = void 0;
        }
        return chain().toggleMark(this.name, {
          style: markStyle,
          class: editor.getAttributes("textStyle").class ?? void 0
        }).run();
      }
    };
  }
});
const nodeWithStyle = Node.create({
  name: "nodeWithStyle",
  addOptions() {
    return {
      tag: "p",
      nodeName: "paragraph",
      classes: [""],
      styles: [""],
      level: 6,
      excludes: "nodeWithStyle",
      HTMLAttributes: {},
      shortcuts: []
    };
  },
  content: "inline*",
  group: "block",
  defining: true,
  addAttributes() {
    return {
      level: {
        default: this.options.level,
        parseHTML: (element) => element.getAttribute("level"),
        renderHTML: (attributes) => {
          if (!attributes.level) {
            return {};
          }
          return {
            level: attributes.level
          };
        }
      },
      class: {
        default: this.options.classes[0],
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          if (!attributes.class) {
            return {};
          }
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: this.options.styles[0],
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          if (!attributes.style) {
            return {};
          }
          return {
            style: attributes.style
          };
        }
      },
      tag: {
        default: "p",
        parseHTML: (element) => element.getAttribute("tag"),
        renderHTML: (attributes) => {
          if (!attributes.tag) {
            return {};
          }
          return {
            tag: attributes.tag
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: this.options.tag,
        getAttrs: (element) => {
          const hasStyle = element.hasAttribute("style");
          if (!hasStyle) {
            return false;
          }
          return {};
        }
      }
    ];
  },
  renderHTML({ HTMLAttributes }) {
    var _a;
    const tag = (HTMLAttributes == null ? void 0 : HTMLAttributes.tag) || ((_a = this == null ? void 0 : this.options) == null ? void 0 : _a.tag);
    HTMLAttributes == null ? true : delete HTMLAttributes.tag;
    return [tag, mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  addCommands() {
    return {
      toggleNodeWithStyle: (attributes) => ({ chain, editor }) => {
        const nodeName = getNodeName(editor, (attributes == null ? void 0 : attributes.tag) ?? getTag(editor));
        const currentStyle = removeWhiteSpace(
          editor.getAttributes(nodeName).style ?? ""
        );
        const currStyle = ` ${currentStyle} `;
        let newStyle;
        if (typeof attributes.style === "string") {
          const regex = new RegExp(attributes.style.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), "g");
          newStyle = currentStyle ? removeWhiteSpace(currStyle.replace(regex, "")) : void 0;
        } else {
          newStyle = currentStyle ? removeWhiteSpace(currStyle) : void 0;
        }
        let nodeStyle = void 0;
        const isNewTag = attributes.tag && getTag(editor) !== attributes.tag;
        if (newStyle !== currentStyle && !isNewTag) {
          nodeStyle = newStyle ?? attributes.style;
        } else {
          if (isNewTag) {
            nodeStyle = attributes.style;
          } else {
            nodeStyle = removeWhiteSpace(
              `${currentStyle ?? void 0} ${attributes.style ?? void 0}`
            );
          }
        }
        if (nodeStyle === "") {
          nodeStyle = void 0;
        }
        if (nodeName === "heading") {
          const level = attributes.level || editor.getAttributes(nodeName).level || this.options.level;
          return chain().setHeading({ level }).updateAttributes(nodeName, {
            style: nodeStyle,
            level,
            class: editor.getAttributes(nodeName).class ?? void 0
          }).unsetBlockquote().run();
        } else if (nodeName === "blockquote") {
          return chain().setParagraph().setBlockquote().updateAttributes(nodeName, {
            style: nodeStyle,
            class: editor.getAttributes(nodeName).class ?? void 0
          }).run();
        } else {
          return chain().setParagraph().updateAttributes(nodeName, {
            style: nodeStyle,
            class: editor.getAttributes(nodeName).class ?? void 0
          }).unsetBlockquote().run();
        }
      }
    };
  }
});
const Caption = Node.create({
  name: "caption",
  group: "block",
  content: "inline*",
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  },
  parseHTML() {
    return [{ tag: "caption" }];
  },
  renderHTML({ node }) {
    return ["caption", node.attrs, 0];
  }
});
const CustomHeading = Heading$1.extend({
  addAttributes() {
    return {
      level: {
        default: 1,
        rendered: false
      },
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
const CustomParagraph = Paragraph.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        // Customize the HTML parsing (for example, to load the initial content)
        parseHTML: (element) => element.getAttribute("class"),
        // … and customize the HTML rendering.
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
const CustomSpan = TextStyle.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
const findCaption = (state) => {
  const $pos = state.selection.$anchor;
  for (let d = $pos.depth; d > 0; d--) {
    const node = $pos.node(d);
    if (node.type.name == "table") {
      let position = -1;
      state.doc.nodesBetween($pos.before(d), $pos.after(d), (node2, pos) => {
        if (node2.type.name == "caption") {
          position = pos;
        }
      });
      return position;
    }
  }
  return -1;
};
const findTable = (state) => {
  const path = state.selection.$anchor.path;
  let currNr = -1;
  for (let i = 0; i < path.length; i++) {
    if (typeof path[i] === "number") {
      currNr = path[i];
      continue;
    }
    if (path[i].type.name === "table") {
      break;
    }
  }
  return currNr >= 0 ? currNr : -2;
};
const CustomTable = Table.extend({
  content: "caption? tableBody",
  tableRole: "presentation",
  addCommands() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      removeCaption: () => ({ editor, state }) => {
        return editor.chain().focus((findCaption(state) || -2) + 1).deleteNode("caption").run();
      },
      setCaption: (value) => ({ editor, state }) => {
        const newCaption = { type: "caption", content: [{ type: "text", text: value }] };
        return editor.chain().focus((findCaption(state) || -2) + 1).deleteNode("caption").focus(findTable(state) + 1).insertContentAt(findTable(state) + 1, newCaption).focus((findCaption(state) || -2) + 1).run();
      }
    };
  },
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => {
          return element.getAttribute("class");
        },
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      },
      cellSpacing: {
        default: 0,
        rendered: true,
        parseHTML: (element) => element.getAttribute("cellspacing"),
        renderHTML: (attributes) => {
          return {
            cellSpacing: attributes.cellSpacing
          };
        }
      },
      cellPadding: {
        default: 1,
        rendered: true,
        parseHTML: (element) => element.getAttribute("cellpadding"),
        renderHTML: (attributes) => {
          return {
            cellPadding: attributes.cellPadding
          };
        }
      },
      border: {
        default: 1,
        rendered: true,
        parseHTML: (element) => element.getAttribute("border"),
        renderHTML: (attributes) => {
          return {
            border: attributes.border
          };
        }
      },
      height: {
        default: 100,
        rendered: true,
        parseHTML: (element) => element.getAttribute("height"),
        renderHTML: (attributes) => {
          return {
            height: attributes.height
          };
        }
      },
      width: {
        default: 100,
        rendered: true,
        parseHTML: (element) => element.getAttribute("width"),
        renderHTML: (attributes) => {
          return {
            width: attributes.width
          };
        }
      }
    };
  },
  renderHTML({ HTMLAttributes }) {
    return ["table", mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  }
});
const CustomTableBody = Node.create({
  name: "tableBody",
  group: "block+",
  content: "tableRow+",
  tableRole: "table",
  parseHTML() {
    return [{ tag: "tbody" }];
  },
  renderHTML({ node }) {
    return ["tbody", node.attrs, 0];
  }
});
const CustomTableCell = TableCell.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      },
      valign: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("valign"),
        renderHTML: (attributes) => {
          return {
            valign: attributes.valign
          };
        }
      },
      id: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("id"),
        renderHTML: (attributes) => {
          return {
            id: attributes.id
          };
        }
      },
      hiddenheader: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("hiddenheader"),
        renderHTML: (attributes) => {
          return {
            hiddenheader: attributes.hiddenheader
          };
        }
      },
      height: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("height"),
        renderHTML: (attributes) => {
          return {
            height: attributes.height
          };
        }
      },
      width: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("width"),
        renderHTML: (attributes) => {
          return {
            width: attributes.width
          };
        }
      }
    };
  }
});
const CustomTableHeader = TableHeader.extend({
  // content: 'block*',
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      },
      scope: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("scope"),
        renderHTML: (attributes) => {
          return {
            scope: attributes.scope
          };
        }
      },
      valign: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("valign"),
        renderHTML: (attributes) => {
          return {
            valign: attributes.valign
          };
        }
      },
      id: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("id"),
        renderHTML: (attributes) => {
          return {
            id: attributes.id
          };
        }
      },
      hiddenheader: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("hiddenheader"),
        renderHTML: (attributes) => {
          return {
            hiddenheader: attributes.hiddenheader
          };
        }
      },
      height: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("height"),
        renderHTML: (attributes) => {
          return {
            height: attributes.height
          };
        }
      },
      width: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("width"),
        renderHTML: (attributes) => {
          return {
            width: attributes.width
          };
        }
      }
    };
  }
});
const CustomTableRow = TableRow.extend({
  addAttributes() {
    var _a;
    return {
      ...(_a = this.parent) == null ? void 0 : _a.call(this),
      class: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("class"),
        renderHTML: (attributes) => {
          return {
            class: attributes.class
          };
        }
      },
      style: {
        default: null,
        rendered: true,
        parseHTML: (element) => element.getAttribute("style"),
        renderHTML: (attributes) => {
          return {
            style: attributes.style
          };
        }
      }
    };
  }
});
function EditorComponent({
  CallbackFunction,
  content,
  noToolbar = false,
  readOnly = false,
  returnMode = "html",
  disableTables = false,
  uischema,
  path
}) {
  const [toolbarView, setToolbarView] = React.useState("default");
  const basicExtensions = [
    Document,
    Text$1,
    CustomSpan,
    CustomParagraph,
    History,
    HardBreak,
    ListItem
  ];
  const extensions = [
    ...basicExtensions,
    Dropcursor,
    BulletList,
    Caption,
    Blockquote,
    Bold,
    CustomHeading,
    Code,
    CodeBlock,
    Highlight,
    HorizontalRule,
    Italic,
    Link,
    OrderedList,
    Strike,
    Subscript,
    Superscript,
    TypographyExtension,
    UnderlineExtension,
    nodeWithClass,
    markWithClass,
    markWithStyle,
    nodeWithStyle,
    Image.configure({
      inline: true,
      HTMLAttributes: {
        // AEM editor forces this size
        width: 240,
        height: 140
      }
    }),
    TextAlign.configure({
      types: ["heading", "paragraph"]
    }),
    Focus.configure({
      className: "has-focus",
      mode: "all"
    })
  ];
  const extensionsWithTables = [
    ...extensions,
    CustomTable,
    CustomTableBody,
    CustomTableCell,
    CustomTableHeader,
    CustomTableRow
  ];
  const editor = useEditor({
    editable: !readOnly,
    extensions: returnMode === "text" ? basicExtensions : disableTables ? extensions : extensionsWithTables,
    content: !noToolbar && (returnMode === "text" || returnMode === "markdown") ? content == null ? void 0 : content.replace(/\n/g, "<br />") : content,
    onSelectionUpdate({ transaction }) {
      if (noToolbar) {
        return;
      }
      const path2 = transaction.curSelection.$head.path;
      let isInTable = false;
      for (let i = 0; i < path2.length; i++) {
        const element = path2[i];
        if (typeof element === "number") {
          continue;
        }
        if (element.type.name === "table") {
          isInTable = true;
          break;
        }
      }
      setToolbarView(isInTable ? "table" : "default");
    }
  });
  const firstRender = React.useRef(true);
  React.useEffect(() => {
    if (firstRender.current) {
      firstRender.current = false;
      return;
    }
    if (returnMode === "text" || returnMode === "markdown") {
      CallbackFunction(editor == null ? void 0 : editor.getText());
    } else {
      CallbackFunction(editor == null ? void 0 : editor.getHTML());
    }
  }, [editor == null ? void 0 : editor.getHTML()]);
  if (!editor)
    return null;
  return /* @__PURE__ */ jsxs(Flex, { direction: "column", marginTop: "4px", ...dataEditorPath(path), children: [
    !noToolbar && /* @__PURE__ */ jsx(
      TipTapToolbar,
      {
        path,
        disableTables,
        editor,
        readOnly,
        toolbarView,
        uischema
      }
    ),
    /* @__PURE__ */ jsx(
      EditorContent,
      {
        editor,
        className: `${noToolbar ? "no-toolbar" : ""} ${readOnly ? "read-only" : ""}`
      }
    )
  ] });
}
const InputTipTapTextArea = React__default.memo(
  ({
    config,
    data,
    enabled = true,
    handleChange,
    label,
    noToolbar = false,
    path,
    returnMode,
    schema,
    uischema,
    visible
  }) => {
    if (!visible) {
      return null;
    }
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [editorContent, setEditorContent] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const callbackFunction = (editorContent2) => {
      setEditorContent(editorContent2);
    };
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, isHidden: !visible, children: [
      label && /* @__PURE__ */ jsx("label", { className: "spectrum-label", children: label }),
      ContextualHelpComponent(uischema, schema, config),
      /* @__PURE__ */ jsx(
        EditorComponent,
        {
          CallbackFunction: callbackFunction,
          path,
          content: editorContent,
          noToolbar: appliedUiSchemaOptions.noToolbar ?? noToolbar,
          readOnly: !enabled,
          returnMode: appliedUiSchemaOptions.returnMode ?? returnMode,
          uischema,
          disableTables: appliedUiSchemaOptions.disableTables
        }
      )
    ] });
  }
);
const BaseSpectrumInputControl = (props) => {
  const [focused, onFocus, onBlur] = useFocus();
  const { description, id, errors, uischema, visible, config, input, customError = false } = props;
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const InnerComponent = input;
  const isValid = errors.length === 0;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const showDescription = !isDescriptionHidden(
    appliedUiSchemaOptions.showUnfocusedDescription,
    description,
    focused,
    visible
  );
  const showErrors = !isValid && customError;
  return /* @__PURE__ */ jsx(
    "div",
    {
      onFocus,
      onBlur,
      hidden: visible === void 0 || visible === null ? false : !visible,
      id,
      children: /* @__PURE__ */ jsxs(Flex, { direction: "column", children: [
        /* @__PURE__ */ jsx(InnerComponent, { ...props, id: id && `${id}-input`, isValid }),
        customError && /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsx(Text, { children: showErrors ? errors : showDescription ? description : null }) })
      ] })
    }
  );
};
const SpectrumInputControl = React__default.memo(BaseSpectrumInputControl);
const SpectrumTipTapRenderer = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputTipTapTextArea });
};
const SpectrumTipTapRendererTester = rankWith(20, optionIs("richText", true));
const SpectrumTipTapRenderer$1 = withJsonFormsControlProps(withHandleChange(SpectrumTipTapRenderer));
const InputCodeMirror = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    label,
    path,
    schema,
    uischema,
    visible
  }) => {
    if (!visible) {
      return null;
    }
    let { colorScheme } = useProvider();
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const showSaveButton = appliedUiSchemaOptions.showSaveButton ?? false;
    const readOnly = appliedUiSchemaOptions.readOnly ?? schema.readOnly ?? false;
    const hideFormatButton = appliedUiSchemaOptions.hideFormatButton ?? false;
    const [value, setValue] = React__default.useState(data);
    const [initialValue, setInitialValue] = React__default.useState(data);
    const [cachedValue, setCachedValue] = React__default.useState(data);
    const err = getErr(value);
    const cachedErr = getErr(cachedValue);
    const saveAndFormat = () => {
      if (typeof cachedValue === "string") {
        handleChange(path, JSON.parse(cachedValue));
        setValue(JSON.parse(cachedValue));
      } else {
        handleChange(path, JSON.parse(JSON.stringify(cachedValue, circularReferenceReplacer())));
        setValue(JSON.parse(JSON.stringify(cachedValue, circularReferenceReplacer())));
      }
      setInitialValue(JSON.parse(JSON.stringify(JSON.parse(value), circularReferenceReplacer())));
    };
    const onChangeHandler = React__default.useCallback(
      (newValue, _viewUpdate) => {
        setCachedValue(newValue);
        setValue(newValue);
        if (!getErr(newValue) && !cachedErr && !showSaveButton) {
          handleChange(path, JSON.parse(newValue));
        }
      },
      [cachedValue]
    );
    function getErr(value2) {
      if (!value2) {
        return null;
      }
      try {
        if (typeof value2 === "string") {
          JSON.parse(value2);
        } else {
          JSON.parse(JSON.stringify(value2, circularReferenceReplacer()));
        }
        return null;
      } catch (err2) {
        return String(err2);
      }
    }
    return /* @__PURE__ */ jsxs(SpectrumProvider, { width: width2, isHidden: !visible, children: [
      label && /* @__PURE__ */ jsx(
        "label",
        {
          className: "spectrum-label",
          style: { display: "flex", paddingTop: 4, paddingBottom: 5 },
          children: label
        }
      ),
      /* @__PURE__ */ jsx(
        CodeMirror,
        {
          value: JSON.stringify(initialValue, circularReferenceReplacer(), 2) || "",
          onChange: onChangeHandler,
          extensions: err || cachedErr ? [json(), linter(jsonParseLinter()), lintGutter()] : [json()],
          className: `spectrum-codemirror ${enabled ? "" : "read-only"}`,
          theme: colorScheme === "dark" ? "dark" : "light",
          editable: !readOnly && enabled,
          ...dataEditorPath(path)
        }
      ),
      !hideFormatButton && !readOnly && enabled && /* @__PURE__ */ jsx(View, { paddingTop: "size-50", children: /* @__PURE__ */ jsx(
        Button,
        {
          variant: "cta",
          onPress: saveAndFormat,
          isDisabled: !!err || !!cachedErr || JSON.stringify(value) === JSON.stringify(initialValue),
          ...dataEditorPath(`${path}-formatButton`),
          children: showSaveButton ? "Save" : "Format"
        }
      ) })
    ] });
  }
);
const SpectrumCodeMirror = (props) => {
  return /* @__PURE__ */ jsx(InputCodeMirror, { ...props, isValid: true });
};
const SpectrumCodeMirrorTester = rankWith(8, optionIs("codeMirror", true));
const SpectrumCodeMirror$1 = withJsonFormsControlProps(withHandleChange(SpectrumCodeMirror));
const SpectrumAllOfRenderer = ({
  cells,
  enabled,
  path,
  renderers,
  rootSchema,
  schema,
  uischema,
  uischemas,
  visible
}) => {
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const delegateUISchema = findMatchingUISchema(uischemas)(schema, uischema.scope, path);
  if (delegateUISchema) {
    return /* @__PURE__ */ jsx(View, { isHidden: !visible, children: /* @__PURE__ */ jsx(
      JsonFormsDispatch,
      {
        cells,
        enabled,
        path,
        renderers,
        schema,
        uischema: delegateUISchema
      }
    ) });
  }
  let allOfRenderInfos;
  if (schema == null ? void 0 : schema.allOf) {
    allOfRenderInfos = createCombinatorRenderInfos(
      schema.allOf,
      rootSchema,
      "allOf",
      uischema,
      path,
      uischemas
    );
  }
  return /* @__PURE__ */ jsx(View, { isHidden: !visible, children: allOfRenderInfos == null ? void 0 : allOfRenderInfos.map((allOfRenderInfo, allOfIndex) => /* @__PURE__ */ jsx(
    JsonFormsDispatch,
    {
      schema: allOfRenderInfo.schema,
      uischema: allOfRenderInfo.uischema,
      path,
      renderers,
      cells
    },
    allOfIndex
  )) });
};
const SpectrumAllOfRendererTester = rankWith(4, isAllOfControl);
const SpectrumAllOfRenderer$1 = withJsonFormsAllOfProps(withHandleChange(SpectrumAllOfRenderer));
const renderChildren = (layout, schema, styleProps, path, enabled) => {
  if (isEmpty(layout.elements)) {
    return [];
  }
  const { renderers, cells } = useJsonForms();
  return layout.elements.map((child, index) => {
    const style = typeof styleProps === "function" ? styleProps(index) : styleProps;
    return /* @__PURE__ */ jsx(View, { ...style, children: /* @__PURE__ */ jsx(
      JsonFormsDispatch,
      {
        renderers,
        cells,
        uischema: child,
        schema,
        path,
        enabled
      }
    ) }, `${path}-${index}`);
  });
};
const SpectrumGroupLayoutTester = rankWith(1, uiTypeIs("Group"));
const SpectrumGroupLayoutRenderer = ({
  enabled,
  path,
  schema,
  uischema,
  visible
}) => {
  if (!visible) {
    return null;
  }
  const group = uischema;
  return /* @__PURE__ */ jsxs(
    View,
    {
      borderColor: "dark",
      borderRadius: "medium",
      borderWidth: "thin",
      isHidden: visible === void 0 || visible === null ? false : !visible,
      padding: "size-250",
      children: [
        !isEmpty(group.label) ? /* @__PURE__ */ jsx(Heading, { level: 4, margin: 0, children: group.label }) : "",
        !isEmpty(group.label) ? /* @__PURE__ */ jsx(Divider, { size: "M", marginTop: "size-150", marginBottom: "size-200" }) : "",
        /* @__PURE__ */ jsx("div", { style: { boxSizing: "content-box" }, children: /* @__PURE__ */ jsx(Content, { children: renderChildren(group, schema, {}, path, enabled) }) })
      ]
    }
  );
};
const SpectrumGroupLayout = withJsonFormsLayoutProps(SpectrumGroupLayoutRenderer);
const SpectrumLayout = ({ children, visible, ...flexProps }) => {
  return /* @__PURE__ */ jsx(
    Flex,
    {
      isHidden: visible === void 0 || visible === null ? false : !visible,
      gap: "size-100",
      ...flexProps,
      wrap: true,
      children
    }
  );
};
const SpectrumHorizontalLayoutTester = rankWith(
  1,
  uiTypeIs("HorizontalLayout")
);
const SpectrumHorizontalLayoutRenderer = ({
  schema,
  uischema,
  enabled,
  visible,
  path
}) => {
  var _a;
  const horizontalLayout = uischema;
  const spacing = ((_a = horizontalLayout.options) == null ? void 0 : _a.spacing) ?? [];
  const direction = "row";
  const childrenStyles = (i) => ({
    flexGrow: spacing[i] || 1,
    maxWidth: "100%",
    flexBasis: 0
  });
  return /* @__PURE__ */ jsx(
    SpectrumLayout,
    {
      direction,
      visible,
      enabled,
      path,
      uischema,
      schema,
      children: renderChildren(horizontalLayout, schema, childrenStyles, path, enabled)
    }
  );
};
const SpectrumHorizontalLayout = withJsonFormsLayoutProps(SpectrumHorizontalLayoutRenderer);
const SpectrumVerticalLayoutTester = rankWith(1, uiTypeIs("VerticalLayout"));
const SpectrumVerticalLayoutRenderer = ({
  enabled,
  path,
  schema,
  uischema,
  visible
}) => {
  const verticalLayout = uischema;
  const direction = "column";
  const childrenStyles = {
    flexGrow: 1,
    maxWidth: "100%",
    flexBasis: 0
  };
  return /* @__PURE__ */ jsx(
    SpectrumLayout,
    {
      direction,
      enabled,
      path,
      schema,
      uischema,
      visible,
      children: renderChildren(verticalLayout, schema, childrenStyles, path, enabled)
    }
  );
};
const SpectrumVerticalLayout = withJsonFormsLayoutProps(SpectrumVerticalLayoutRenderer);
const isSingleLevelCategorization = and(
  uiTypeIs("Categorization"),
  (uischema) => {
    const categorization = uischema;
    return categorization.elements && categorization.elements.length > 0 && categorization.elements.reduce((acc, e) => acc && e.type === "Category", true);
  }
);
const SpectrumCategorizationRendererTester = rankWith(
  1,
  isSingleLevelCategorization
);
const extractScopesAsPaths = (node) => {
  if (node == null ? void 0 : node.elements) {
    return node.elements.flatMap(extractScopesAsPaths);
  } else if (node == null ? void 0 : node.scope) {
    return [node.scope.replaceAll(/#?\/properties\//g, ".").replaceAll(/\//g, ".")];
  }
};
const SpectrumCategorizationRenderer = (props) => {
  var _a;
  const { data, path, schema, uischema, visible, enabled, ajv } = props;
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const categorization = uischema;
  const categories = categorization.elements.filter(
    (category, _index) => isVisible(category, data, "", ajv)
  );
  const { breadcrumbs } = useBreadcrumbs();
  const shortestOutstandingBreadcrumb = breadcrumbs.hasPrefix(path) ? (_a = breadcrumbs.keys().filter((breadcrumbPath) => breadcrumbPath.startsWith(path)).map((breadcrumbPath) => breadcrumbPath.slice(path.length)).filter((breadcrumbPath) => breadcrumbPath[0] === ".").sort((x, y) => x.length - y.length)) == null ? void 0 : _a[0] : void 0;
  const defaultOpenTab = (shortestOutstandingBreadcrumb ? categories.findIndex(
    (category) => extractScopesAsPaths(category).find(
      (scopeAsPath) => scopeAsPath === shortestOutstandingBreadcrumb
    )
  ) || 0 : 0).toString();
  const [tab, setTab] = React__default.useState(defaultOpenTab);
  React__default.useEffect(() => {
    const handleTabEditableMessage = (event) => {
      if (event.data.type !== "editableClickTabSwitch" || event.data.path !== path) {
        return;
      }
      const firstPropertyOfInnerPath = event.data.innerCfPath.split(".")[1];
      const indexToOpen = categories.findIndex((categoryObj) => {
        return categoryObj.elements.some((el) => el.key === firstPropertyOfInnerPath);
      });
      setTab(indexToOpen.toString());
      window.requestAnimationFrame(() => {
        window.requestAnimationFrame(() => {
          window.requestAnimationFrame(() => {
            const inputToFocus = document.querySelector(`input[data-editor-path='${event.data.path + event.data.innerCfPath}'], textarea[data-editor-path='${event.data.path + event.data.innerCfPath}'], div[data-editor-path='${event.data.path + event.data.innerCfPath}'] > div > div.ProseMirror`);
            if (inputToFocus) {
              const endPos = inputToFocus.value.length;
              inputToFocus.setSelectionRange(endPos, endPos);
              inputToFocus.focus();
            }
          });
        });
      });
    };
    window.addEventListener("message", handleTabEditableMessage);
    return () => window.removeEventListener("message", handleTabEditableMessage);
  }, [setTab]);
  return /* @__PURE__ */ jsx(View, { isHidden: !visible, children: /* @__PURE__ */ jsxs(
    Tabs,
    {
      "aria-label": "Categorization",
      isDisabled: enabled === void 0 ? false : !enabled,
      defaultSelectedKey: defaultOpenTab,
      selectedKey: tab,
      onSelectionChange: setTab,
      children: [
        /* @__PURE__ */ jsx(TabList, { children: categories == null ? void 0 : categories.map((category, index) => {
          return /* @__PURE__ */ jsx(
            Item,
            {
              ...dataEditorPath(
                `${path}-${(category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`}-tabButton`
              ),
              children: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`
            },
            index
          );
        }) }),
        /* @__PURE__ */ jsx(TabPanels, { children: categories == null ? void 0 : categories.map((category, index) => /* @__PURE__ */ jsx(Item, { title: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
          SpectrumVerticalLayout,
          {
            uischema: {
              type: "VerticalLayout",
              elements: category.elements ?? []
            },
            schema,
            path,
            direction: "column",
            enabled: enabled === void 0 ? true : enabled,
            visible: visible === void 0 ? true : visible
          }
        ) }) }, index)) })
      ]
    }
  ) });
};
const SpectrumCategorizationRenderer$1 = withJsonFormsLayoutProps(withAjvProps(SpectrumCategorizationRenderer));
const SpectrumCategorizationStepperRendererTester = rankWith(
  2,
  and(uiTypeIs("Categorization"), categorizationHasCategory, optionIs("variant", "stepper"))
);
const SpectrumCategorizationStepperRenderer = (props) => {
  const { data, ajv, path, schema, visible, enabled, uischema, config } = props;
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const [step, setStep] = React__default.useState(0);
  const selectStep = (selectedItem) => {
    setStep(Number(selectedItem));
  };
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const categorization = uischema;
  const categories = categorization.elements.filter(
    (value, _index) => isVisible(value, data, "", ajv)
  );
  return /* @__PURE__ */ jsxs(Flex, { direction: "column", isHidden: !visible, UNSAFE_className: "categorization-stepper", children: [
    /* @__PURE__ */ jsxs(
      Tabs,
      {
        "aria-label": "Categorization with Stepper",
        isDisabled: enabled === void 0 ? false : !enabled,
        selectedKey: String(step),
        onSelectionChange: selectStep,
        children: [
          /* @__PURE__ */ jsx(TabList, { children: categories.map((category, index) => /* @__PURE__ */ jsx(Item, { children: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}` }, index)) }),
          /* @__PURE__ */ jsx(TabPanels, { children: categories.map((category, index) => /* @__PURE__ */ jsx(Item, { title: (category == null ? void 0 : category.label) ?? (category == null ? void 0 : category.i18n) ?? `Category ${index + 1}`, children: /* @__PURE__ */ jsx(Content, { margin: "size-160", children: /* @__PURE__ */ jsx(
            SpectrumVerticalLayout,
            {
              uischema: {
                type: "VerticalLayout",
                elements: category.elements ?? []
              },
              schema,
              path,
              direction: "column",
              enabled: enabled === void 0 ? true : enabled,
              visible: visible === void 0 ? true : visible
            }
          ) }) }, index)) })
        ]
      }
    ),
    Boolean(appliedUiSchemaOptions.showNavButtons) ? /* @__PURE__ */ jsxs(ButtonGroup, { marginX: "size-160", marginBottom: "size-160", flex: "auto", align: "end", children: [
      /* @__PURE__ */ jsx(Button, { variant: "secondary", isDisabled: step <= 0, onPress: () => selectStep(step - 1), children: "Previous" }),
      /* @__PURE__ */ jsx(
        Button,
        {
          variant: "primary",
          isDisabled: step >= categories.length - 1,
          onPress: () => selectStep(step + 1),
          children: "Next"
        }
      )
    ] }) : /* @__PURE__ */ jsx(Fragment, {})
  ] });
};
const SpectrumCategorizationStepperRenderer$1 = withJsonFormsLayoutProps(withAjvProps(SpectrumCategorizationStepperRenderer));
const SpectrumLabelRendererTester = rankWith(1, uiTypeIs("Label"));
const SpectrumLabelRenderer = ({
  uischema,
  visible
}) => {
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const labelElement = uischema;
  const isHidden = !visible;
  return /* @__PURE__ */ jsx(Text, { isHidden, children: labelElement.text !== void 0 && labelElement.text !== null && labelElement.text });
};
const SpectrumLabelRenderer$1 = withJsonFormsLayoutProps(SpectrumLabelRenderer);
const textUnsafeStyle = {
  position: "absolute",
  direction: "rtl",
  opacity: 0.7,
  bottom: -8,
  left: 0,
  fontSize: "12px",
  height: 18,
  textOverflow: "ellipsis",
  overflow: "hidden",
  whiteSpace: "nowrap"
};
function FragmentReferenceHeader({
  data,
  expanded,
  setExpanded,
  isDetailedViewHeader,
  label,
  removeItem,
  replaceItem,
  uischema,
  path
}) {
  var _a, _b, _c, _d, _e, _f, _g;
  const { getAemCfEditorUrl } = useRenderersConfig();
  const noData = !data;
  const [deleteModalOpen, setDeleteModalOpen] = React__default.useState(false);
  const aemPath = data == null ? void 0 : data._path;
  const aemUrl = getAemCfEditorUrl ? getAemCfEditorUrl(aemPath) : void 0;
  const actionMenuTriggered = React__default.useCallback(
    (key) => {
      switch (key) {
        case "clear":
          setDeleteModalOpen(true);
          break;
        case "openaem":
          window.open(getAemCfEditorUrl(aemPath), "_blank");
      }
    },
    [setDeleteModalOpen]
  );
  const pathFilter = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.pathFilter;
  let displayPath = "";
  if (typeof pathFilter === "string") {
    displayPath = ((_b = data == null ? void 0 : data._path) == null ? void 0 : _b.replace(pathFilter, "")) || "";
  } else {
    displayPath = ((_c = data == null ? void 0 : data._path) == null ? void 0 : _c.split("/").slice(3).join("/")) || "";
    if (displayPath) {
      displayPath = `/${displayPath}`;
    }
  }
  const [durationBeforeDelete, setDurationBeforeDelete] = React__default.useState(0);
  const onPressStartHandler = React__default.useCallback(() => {
    if (expanded) {
      setExpanded(false, true);
      setDurationBeforeDelete(700);
    }
  }, [setExpanded, setDurationBeforeDelete]);
  const onPressEndHandler = React__default.useCallback(() => {
    setDeleteModalOpen(false);
    setTimeout(() => {
      if (removeItem) {
        removeItem();
      }
    }, durationBeforeDelete);
  }, [setDeleteModalOpen, removeItem, durationBeforeDelete]);
  const imageSrc = typeof ((_d = uischema == null ? void 0 : uischema.options) == null ? void 0 : _d.dataAsImage) === "number" && data ? Object.values(data)[(_e = uischema == null ? void 0 : uischema.options) == null ? void 0 : _e.dataAsImage] : findValue(data, (_f = uischema == null ? void 0 : uischema.options) == null ? void 0 : _f.dataAsImage) ?? void 0;
  const showMediaPreview = (_g = uischema == null ? void 0 : uischema.options) == null ? void 0 : _g.mediaPreview;
  const actionMenuItems = React__default.useMemo(
    () => [
      { key: "clear", name: `Clear`, icon: /* @__PURE__ */ jsx(Delete, { size: "S" }) },
      aemPath && aemUrl && { key: "openaem", name: "Open in AEM", icon: /* @__PURE__ */ jsx(OpenIn, { size: "S" }) }
    ],
    []
  );
  return /* @__PURE__ */ jsx(View, { "aria-selected": expanded, UNSAFE_className: "spectrum-array-item-header", children: /* @__PURE__ */ jsxs(Flex, { direction: "row", margin: "size-50", justifyContent: "space-between", alignItems: "center", children: [
    /* @__PURE__ */ jsxs(
      ActionButton,
      {
        flex: "1 1 auto",
        isQuiet: true,
        onPress: () => setExpanded(!expanded, true),
        "aria-label": `expand-item-${label}`,
        isDisabled: noData,
        ...dataEditorPath(path),
        children: [
          imageSrc && showMediaPreview && /* @__PURE__ */ jsx(
            "img",
            {
              src: imageSrc,
              height: isDetailedViewHeader ? "45" : "50",
              alt: "Preview Picture",
              style: {
                aspectRatio: "1/1",
                objectFit: "cover",
                marginRight: "10px",
                marginLeft: "2px",
                marginTop: isDetailedViewHeader ? "10px" : "0px"
              }
            }
          ),
          (data == null ? void 0 : data._path) && displayPath ? /* @__PURE__ */ jsxs(Text, { UNSAFE_style: textUnsafeStyle, UNSAFE_className: "spectrum-array-item-path", children: [
            "‎",
            displayPath
          ] }) : null,
          /* @__PURE__ */ jsx(
            Text,
            {
              UNSAFE_className: "spectrum-array-item-name",
              UNSAFE_style: {
                transform: (data == null ? void 0 : data._path) && displayPath ? "translateY(-20%)" : ""
              },
              children: label
            }
          )
        ]
      }
    ),
    /* @__PURE__ */ jsx(View, { children: noData ? /* @__PURE__ */ jsx(Flex, { gap: "size-0", children: /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
      /* @__PURE__ */ jsx(
        ActionButton,
        {
          onPress: replaceItem,
          isQuiet: true,
          "aria-label": `change-reference-${label}`,
          ...dataEditorPath(`change-reference-${path}`),
          children: /* @__PURE__ */ jsx(FolderSearch, { "aria-label": "Change Reference", size: "S" })
        }
      ),
      /* @__PURE__ */ jsx(Tooltip, { children: "Change Content Fragment Reference" })
    ] }) }) : /* @__PURE__ */ jsxs(Flex, { gap: "size-0", children: [
      /* @__PURE__ */ jsx(
        ActionMenu,
        {
          align: "end",
          items: actionMenuItems,
          onAction: actionMenuTriggered,
          isQuiet: true,
          children: (item) => /* @__PURE__ */ jsxs(Item, { textValue: `${item == null ? void 0 : item.name}-item-${label}`, children: [
            /* @__PURE__ */ jsx(Text, { children: item == null ? void 0 : item.name }),
            (item == null ? void 0 : item.icon) ?? null
          ] }, item == null ? void 0 : item.key)
        }
      ),
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            onPress: replaceItem,
            isQuiet: true,
            "aria-label": `change-reference-${label}`,
            ...dataEditorPath(`change-reference-${path}`),
            children: /* @__PURE__ */ jsx(FolderSearch, { "aria-label": "Change Reference", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: "Change Content Fragment Reference" })
      ] }),
      /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(
          ActionButton,
          {
            onPress: () => setExpanded(!expanded, true),
            isQuiet: true,
            "aria-label": `expand-item-${label}`,
            ...dataEditorPath(`${path}-iconButton`),
            children: expanded ? /* @__PURE__ */ jsx(Close, { "aria-label": "Close", size: "S" }) : /* @__PURE__ */ jsx(Edit, { "aria-label": "Edit", size: "S" })
          }
        ),
        /* @__PURE__ */ jsx(Tooltip, { children: expanded ? "Close" : "Edit" })
      ] }),
      /* @__PURE__ */ jsx(
        DeleteDialog,
        {
          cancelBtnText: "Cancel",
          confirmBtnText: "Clear",
          contentText: "Are you sure you want to clear this item?",
          deleteModalOpen,
          headingText: "Clear Item?",
          onPressEndHandler,
          onPressStartHandler,
          setDeleteModalOpen
        }
      )
    ] }) })
  ] }) });
}
const FragmentReference = React__default.memo(
  ({
    data,
    path,
    label,
    schema,
    uischema,
    allowedSchemas,
    handleChange,
    enabled,
    picker
  }) => {
    var _a, _b, _c;
    const dataAsLabel = (uischema == null ? void 0 : uischema.dataAsLabel) || getLabelProps(schema);
    let dataLabel = void 0;
    if (dataAsLabel) {
      dataLabel = extractLabel(data, dataAsLabel);
    }
    label = label || dataLabel || ((_a = data == null ? void 0 : data._metadata) == null ? void 0 : _a.stringMetadata.find((item) => item.name === "title").value) || ((_b = data == null ? void 0 : data._model) == null ? void 0 : _b.title) || (uischema == null ? void 0 : uischema.label) || "Linked item (no suitable label found)";
    const [isAnimating, setIsAnimating] = React__default.useState(false);
    const { breadcrumbs, addBreadcrumb, truncateBreadcrumbsAtParent } = useBreadcrumbs();
    const expanded = breadcrumbs.hasPrefix(path);
    const setExpanded = React__default.useCallback(
      (desiredState, isDetailedView = true) => {
        if (desiredState) {
          addBreadcrumb({
            path,
            name: String(label) || null,
            crxPath: data == null ? void 0 : data._path,
            usesDetailedView: isDetailedView
          });
        } else {
          truncateBreadcrumbsAtParent(path);
        }
      },
      [path, label, addBreadcrumb, truncateBreadcrumbsAtParent, breadcrumbs]
    );
    React__default.useEffect(() => {
      if (breadcrumbs.hasPrefix(path)) {
        setExpanded(true, true);
      }
    }, [breadcrumbs]);
    const replaceItemHandler = () => {
      window.postMessage({
        type: CUSTOM_PICKER_OPEN,
        schema: allowedSchemas,
        current: {
          path,
          data
        }
      });
    };
    const handleCustomPickerMessage = (e) => {
      var _a2, _b2, _c2, _d;
      if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) === CUSTOM_PICKER_RETURN && ((_c2 = (_b2 = e == null ? void 0 : e.data) == null ? void 0 : _b2.current) == null ? void 0 : _c2.path) === path && ((_d = e == null ? void 0 : e.data) == null ? void 0 : _d.data)) {
        handleChange(path, e.data.data);
      }
    };
    React__default.useEffect(() => {
      if (picker) {
        window.addEventListener("message", handleCustomPickerMessage);
      }
      return () => {
        if (picker) {
          window.removeEventListener("message", handleCustomPickerMessage);
        }
      };
    }, [data]);
    const removeItem = React__default.useCallback(() => handleChange(path, null), [handleChange]);
    const header = (isDetailedViewHeader) => /* @__PURE__ */ jsx(
      FragmentReferenceHeader,
      {
        customPickerEnabled: picker,
        data,
        expanded,
        setExpanded,
        isDetailedViewHeader,
        label,
        path,
        removeItem,
        replaceItem: replaceItemHandler,
        uischema
      }
    );
    const { renderers, cells } = useJsonForms();
    return /* @__PURE__ */ jsxs(
      View,
      {
        UNSAFE_className: `list-array-item enableDetailedView ${expanded ? "expanded" : "collapsed"} ${((_c = uischema == null ? void 0 : uischema.options) == null ? void 0 : _c.noAccordion) ? "no-accordion" : ""}`,
        borderWidth: "thin",
        borderColor: "dark",
        borderRadius: "medium",
        padding: "size-150",
        width: "100%",
        children: [
          header(false),
          /* @__PURE__ */ jsx(
            ModalItemAnimationWrapper,
            {
              expanded,
              setExpanded,
              header: header(true),
              isAnimating,
              path,
              setIsAnimating,
              elements: /* @__PURE__ */ jsx(
                JsonFormsDispatch,
                {
                  renderers,
                  cells,
                  uischema,
                  schema,
                  path,
                  enabled
                }
              )
            }
          )
        ]
      }
    );
  }
);
const FragmentReference$1 = withHandleChange(FragmentReference);
const SpectrumFragmentReferenceControl = React__default.memo(
  ({
    data,
    enabled,
    handleChange,
    label,
    path,
    renderers,
    rootSchema,
    schema,
    uischema,
    uischemas,
    visible
  }) => {
    var _a, _b;
    const oneOfRenderInfos = (schema == null ? void 0 : schema.oneOf) ? createCombinatorRenderInfos(schema == null ? void 0 : schema.oneOf, rootSchema, "oneOf", uischema, path, uischemas) : [
      {
        schema,
        uischema: findUISchema(uischemas, schema, uischema.scope, path, void 0, uischema),
        label
      }
    ];
    let indexFromDiscriminator = 0;
    const discriminatingProperty = (_a = schema.discriminator) == null ? void 0 : _a.propertyName;
    if (discriminatingProperty) {
      const discriminatorValues = oneOfRenderInfos == null ? void 0 : oneOfRenderInfos.map(
        (info2) => {
          var _a2, _b2;
          return (_b2 = (_a2 = info2.schema.properties) == null ? void 0 : _a2[discriminatingProperty]) == null ? void 0 : _b2.const;
        }
      );
      indexFromDiscriminator = discriminatorValues == null ? void 0 : discriminatorValues.indexOf(data == null ? void 0 : data[discriminatingProperty]);
    }
    const info = oneOfRenderInfos[indexFromDiscriminator > 0 ? indexFromDiscriminator : 0];
    return /* @__PURE__ */ jsxs(View, { children: [
      /* @__PURE__ */ jsx(Flex, { direction: "row", justifyContent: "space-between", children: /* @__PURE__ */ jsx(Heading, { level: 4, children: label }) }),
      /* @__PURE__ */ jsx(Flex, { direction: "column", gap: "size-100", children: /* @__PURE__ */ jsx(Flex, { direction: "row", alignItems: "stretch", flex: "auto inherit", children: /* @__PURE__ */ jsx(
        FragmentReference$1,
        {
          data,
          enabled,
          path,
          renderers,
          schema: info.schema,
          allowedSchemas: oneOfRenderInfos.map((info2) => info2.schema),
          uischema: info.uischema,
          visible,
          handleChange,
          picker: ((_b = uischema == null ? void 0 : uischema.options) == null ? void 0 : _b.picker) ?? true
        }
      ) }) })
    ] });
  }
);
const withContextToControlProps = (Component) => function WithContextToControlProps({ ctx, props }) {
  const controlProps = ctxToControlProps(ctx, props);
  const dispatchProps = ctxDispatchToControlProps(ctx.dispatch);
  const uischemas = ctx.uischemas;
  return /* @__PURE__ */ jsx(Component, { ...props, ...controlProps, ...dispatchProps, uischemas });
};
const withJsonFormsProps = (Component, memoize = true) => withJsonFormsContext(
  withContextToControlProps(memoize ? React__default.memo(Component) : Component)
);
const SpectrumFragmentReferenceControl$1 = withJsonFormsProps(withHandleChange(SpectrumFragmentReferenceControl));
const SpectrumFragmentReferenceControlTester = rankWith(
  10,
  and(isControl, optionIs("fragmentReference", true))
);
const EnumTagGroup = React__default.memo(
  ({ appliedUiSchemaOptions, data, handleChange, options, path }) => {
    const clearButtonText = typeof appliedUiSchemaOptions.clearButton === "string" ? appliedUiSchemaOptions.clearButton : appliedUiSchemaOptions.clearButton ? "Clear" : void 0;
    const deleteTag = (value) => {
      const [tagToDelete] = value;
      handleChange(
        path,
        data.filter((_item, index) => index !== parseInt(tagToDelete))
      );
    };
    return /* @__PURE__ */ jsx(
      TagGroup,
      {
        items: data,
        onRemove: deleteTag,
        "aria-label": "TagGroup",
        maxRows: appliedUiSchemaOptions.maxRows ?? 1,
        actionLabel: clearButtonText,
        onAction: () => handleChange(path, []),
        children: data == null ? void 0 : data.map((item, index) => {
          const option = options == null ? void 0 : options.find((option2) => option2.value === item);
          if (option)
            return /* @__PURE__ */ jsx(Item, { children: option.label }, index);
        })
      }
    );
  }
);
const PickerOrComboBox = React__default.memo(
  ({
    appliedUiSchemaOptions,
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    options,
    path,
    required,
    schema,
    uischema
  }) => {
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const dataIndex = options == null ? void 0 : options.findIndex((option) => option.value === data);
    const [searchTerm, setSearchTerm] = React__default.useState("");
    const [value, setValue] = React__default.useState(
      dataIndex !== void 0 ? dataIndex == null ? void 0 : dataIndex.toString() : null
    );
    const [key, setKey] = React__default.useState(0);
    let items = options == null ? void 0 : options.map((item, index) => ({ ...item, index: index.toString() }));
    const handleOnChange = (myValue) => {
      const valueIndex = parseInt(myValue);
      setValue(valueIndex == null ? void 0 : valueIndex.toString());
      handleChange(path, items == null ? void 0 : items[valueIndex].value);
      setKey(key + 1);
    };
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleOnChange(schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    const searchedOptions = items == null ? void 0 : items.filter((item) => {
      return item.label.toLowerCase().includes(searchTerm.toLowerCase());
    });
    const isDisabled = !enabled;
    if (appliedUiSchemaOptions.autocomplete === false) {
      return /* @__PURE__ */ jsx(
        Picker,
        {
          align: appliedUiSchemaOptions.align ?? "start",
          "aria-label": label ?? "picker",
          autoFocus: appliedUiSchemaOptions.focus,
          contextualHelp: ContextualHelpComponent(uischema, schema, config),
          description: appliedUiSchemaOptions.description ?? false,
          errorMessage: appliedUiSchemaOptions.errorMessage ?? false,
          id,
          isDisabled,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isRequired: required,
          items,
          label: label || "Enum Picker",
          menuWidth: appliedUiSchemaOptions.menuWidth ?? false,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
          onSelectionChange: handleOnChange,
          placeholder: appliedUiSchemaOptions.placeholder,
          selectedKey: value,
          width: width2,
          ...dataEditorPath(path),
          children: (item) => /* @__PURE__ */ jsx(Item, { children: item.label }, item.index)
        }
      );
    } else {
      return /* @__PURE__ */ jsx(
        ComboBox,
        {
          allowsCustomValue: appliedUiSchemaOptions.allowsCustomValue ?? false,
          "aria-label": label ?? "combobox",
          autoFocus: appliedUiSchemaOptions.focus,
          contextualHelp: ContextualHelpComponent(uischema, schema, config),
          items: searchedOptions,
          description: appliedUiSchemaOptions.description ?? false,
          errorMessage: appliedUiSchemaOptions.errorMessage ?? false,
          id,
          isDisabled,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? (schema == null ? void 0 : schema.readOnly) ?? false,
          isRequired: required,
          label: label || "Enum ComboBox",
          menuTrigger: appliedUiSchemaOptions.menuTrigger ?? "input",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
          onInputChange: setSearchTerm,
          onSelectionChange: handleOnChange,
          onOpenChange: (isOpen) => {
            if (isOpen)
              setSearchTerm("");
          },
          selectedKey: value,
          shouldFocusWrap: appliedUiSchemaOptions.shouldFocusWrap ?? false,
          width: width2,
          ...dataEditorPath(path),
          children: (item) => /* @__PURE__ */ jsx(Item, { children: item.label }, item.index)
        },
        `${id}-${key}`
      );
    }
  }
);
const PickerOrComboBoxArray = React__default.memo(
  ({
    appliedUiSchemaOptions,
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    options,
    path,
    required,
    schema,
    uischema
  }) => {
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const maxOptions = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.maxOptions) ?? Infinity;
    const showAllOptions = appliedUiSchemaOptions.showAllOptions ?? false;
    const [searchTerm, setSearchTerm] = React__default.useState("");
    const [key, setKey] = React__default.useState(0);
    const filteredOptions = options == null ? void 0 : options.filter((option) => {
      return !(data == null ? void 0 : data.includes(option == null ? void 0 : option.value));
    });
    let items = maxOptions > 1 ? filteredOptions == null ? void 0 : filteredOptions.map((item, index) => ({ ...item, index: index.toString() })) : options == null ? void 0 : options.map((item, index) => ({ ...item, index: index.toString() }));
    const handleOnChange = (myValue) => {
      var _a;
      const valueIndex = parseInt(myValue);
      if (maxOptions === 1) {
        handleChange(path, [(_a = items == null ? void 0 : items.at(valueIndex)) == null ? void 0 : _a.value]);
      } else {
        if (!((data == null ? void 0 : data.indexOf(items == null ? void 0 : items[valueIndex].value)) >= 0)) {
          if (data) {
            handleChange(path, [...data, items == null ? void 0 : items[valueIndex].value]);
          } else {
            handleChange(path, [items == null ? void 0 : items[valueIndex].value]);
          }
        }
      }
      setKey(key + 1);
    };
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleOnChange(schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    const searchedOptions = items == null ? void 0 : items.filter((item) => {
      return item.label.toLowerCase().includes(searchTerm.toLowerCase());
    });
    const allOptionsActive = maxOptions > 1 && !showAllOptions && !(filteredOptions == null ? void 0 : filteredOptions.length);
    const isDisabled = allOptionsActive || maxOptions > 1 && maxOptions <= ((data == null ? void 0 : data.length) || 0) || enabled !== void 0 && !enabled;
    if (appliedUiSchemaOptions.autocomplete === false) {
      return /* @__PURE__ */ jsx(
        Picker,
        {
          align: appliedUiSchemaOptions.align ?? "start",
          "aria-label": label ?? "picker",
          autoFocus: appliedUiSchemaOptions.focus,
          contextualHelp: ContextualHelpComponent(uischema, schema, config),
          description: appliedUiSchemaOptions.description ?? false,
          errorMessage: appliedUiSchemaOptions.errorMessage ?? false,
          id,
          isDisabled,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isRequired: required,
          items,
          label: label || "Enum Picker",
          menuWidth: appliedUiSchemaOptions.menuWidth ?? false,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
          onSelectionChange: handleOnChange,
          placeholder: appliedUiSchemaOptions.placeholder,
          selectedKey: maxOptions === 1 ? options == null ? void 0 : options.findIndex((option) => option.value === (data == null ? void 0 : data[0])).toString() : null,
          width: width2,
          ...dataEditorPath(path),
          children: (item) => /* @__PURE__ */ jsx(Item, { children: item.label }, item.index)
        }
      );
    } else {
      return /* @__PURE__ */ jsx(
        ComboBox,
        {
          allowsCustomValue: appliedUiSchemaOptions.allowsCustomValue ?? false,
          "aria-label": label ?? "combobox",
          autoFocus: appliedUiSchemaOptions.focus,
          contextualHelp: ContextualHelpComponent(uischema, schema, config),
          items: searchedOptions,
          description: appliedUiSchemaOptions.description ?? false,
          errorMessage: appliedUiSchemaOptions.errorMessage ?? false,
          id,
          isDisabled,
          isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? (schema == null ? void 0 : schema.readOnly) ?? false,
          isRequired: required,
          label: label || "Enum ComboBox",
          menuTrigger: appliedUiSchemaOptions.menuTrigger ?? "input",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
          onInputChange: setSearchTerm,
          onSelectionChange: handleOnChange,
          onOpenChange: (isOpen) => {
            if (isOpen)
              setSearchTerm("");
          },
          selectedKey: maxOptions === 1 && (data == null ? void 0 : data.length) ? options == null ? void 0 : options.findIndex((option) => option.value === (data == null ? void 0 : data[0])).toString() : null,
          shouldFocusWrap: appliedUiSchemaOptions.shouldFocusWrap ?? false,
          width: width2,
          ...dataEditorPath(path),
          children: (item) => /* @__PURE__ */ jsx(Item, { children: item.label }, item.index)
        },
        `${id}-${key}`
      );
    }
  }
);
const InputEnum = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    options,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const maxOptions = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.maxOptions) ?? Infinity;
    const isArray2 = (schema == null ? void 0 : schema.type) === "array";
    return /* @__PURE__ */ jsx(Fragment, { children: isArray2 ? /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx(
        PickerOrComboBoxArray,
        {
          appliedUiSchemaOptions,
          config,
          data,
          enabled,
          handleChange,
          id,
          label,
          options,
          path,
          required,
          schema,
          uischema
        }
      ),
      maxOptions > 1 && /* @__PURE__ */ jsx(
        EnumTagGroup,
        {
          appliedUiSchemaOptions,
          data,
          handleChange,
          options,
          path,
          ...dataEditorPath(path)
        }
      )
    ] }) : /* @__PURE__ */ jsx(
      PickerOrComboBox,
      {
        appliedUiSchemaOptions,
        config,
        data,
        enabled,
        handleChange,
        id,
        label,
        options,
        path,
        required,
        schema,
        uischema
      }
    ) });
  }
);
const InputInteger = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = schema.maximum;
    let minValue = schema.minimum;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const stepValue = appliedUiSchemaOptions.step ?? 1;
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(
      NumberField,
      {
        "aria-label": "integerfield" + label,
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        decrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Decrement -${stepValue}`,
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(minValue, maxValue),
        formatOptions: appliedUiSchemaOptions.formatOptions ?? false,
        hideStepper: appliedUiSchemaOptions.hideStepper ?? false,
        id,
        incrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Increment +${stepValue}`,
        isDisabled: enabled === void 0 ? false : !enabled,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        maxValue: schema.maximum,
        maxWidth: "100%",
        minValue: schema.minimum,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange: (value) => handleChange(path, value),
        step: stepValue,
        validationState: isValid ? "valid" : "invalid",
        value: data ?? schema.default,
        width: width2,
        ...dataEditorPath(path)
      }
    );
  }
);
const InputNumber = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    let maxValue = schema.maximum;
    let minValue = schema.minimum;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const stepValue = appliedUiSchemaOptions.step ?? 0.1;
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
    }, [schema == null ? void 0 : schema.default]);
    return /* @__PURE__ */ jsx(
      NumberField,
      {
        "aria-label": "numberfield" + label,
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        decrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Decrement -${stepValue}`,
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? valueErrorMessage(minValue, maxValue),
        formatOptions: appliedUiSchemaOptions.formatOptions ?? false,
        hideStepper: appliedUiSchemaOptions.hideStepper ?? false,
        id,
        incrementAriaLabel: appliedUiSchemaOptions.incrementAriaLabel ?? `Increment +${stepValue}`,
        isDisabled: enabled === void 0 ? false : !enabled,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        maxValue: schema.maximum,
        maxWidth: "100%",
        minValue: schema.minimum,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange: (value) => handleChange(path, value),
        step: stepValue,
        validationState: isValid ? "valid" : "invalid",
        value: data ?? schema.default,
        width: width2,
        ...dataEditorPath(path)
      }
    );
  }
);
const InputSlider = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    label,
    path,
    schema,
    uischema,
    visible
  }) => {
    if (!visible) {
      return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
    }
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const [inputSlider, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? (schema == null ? void 0 : schema.minimum),
      data,
      path
    );
    return /* @__PURE__ */ jsx(
      Slider,
      {
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        fillOffset: appliedUiSchemaOptions.fillOffset ?? false,
        formatOptions: appliedUiSchemaOptions.formatOptions ?? false,
        getValueLabel: appliedUiSchemaOptions.getValueLabel ? (value) => `${value} ${appliedUiSchemaOptions.getValueLabel}` : void 0,
        isDisabled: enabled === void 0 ? false : !enabled,
        isFilled: appliedUiSchemaOptions.isFilled ?? false,
        isHidden: !visible,
        label,
        maxValue: schema.maximum,
        minValue: schema.minimum,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        onChange,
        orientation: appliedUiSchemaOptions.orientation ?? "horizontal",
        showValueLabel: appliedUiSchemaOptions.showValueLabel ?? true,
        step: schema.multipleOf || 1,
        trackGradient: appliedUiSchemaOptions.trackGradient ?? false,
        value: inputSlider,
        width: width2,
        ...dataEditorPath(path)
      }
    );
  }
);
const InputSwitch = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    let [isSelected, setSelected] = React__default.useState(data ?? (schema == null ? void 0 : schema.default) ?? false);
    React__default.useEffect(() => {
      handleChange(path, isSelected);
    }, [isSelected]);
    return /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx(
        Switch,
        {
          autoFocus: appliedUiSchemaOptions.focus,
          id,
          isDisabled: enabled === void 0 ? false : !enabled,
          isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
          isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
          isSelected,
          onChange: setSelected,
          width: width2,
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          ...dataEditorPath(path),
          children: label
        }
      ),
      appliedUiSchemaOptions.description ? /* @__PURE__ */ jsx("div", { style: { fontStyle: "italic" }, children: appliedUiSchemaOptions.description }) : null,
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const InputText = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    var _a;
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const minLength = (schema == null ? void 0 : schema.minLength) ?? appliedUiSchemaOptions.minLength ?? (required ? 1 : 0);
    const maxLength = (schema == null ? void 0 : schema.maxLength) ?? appliedUiSchemaOptions.maxLength;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const format = appliedUiSchemaOptions.format ?? void 0;
    const customFormat = appliedUiSchemaOptions.customFormat ?? void 0;
    const [inputText, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const isValidText = isValidCheck(
      inputText,
      data,
      minLength,
      maxLength,
      isValid,
      customFormat,
      format
    );
    const idlePostMessage = (_a = uischema == null ? void 0 : uischema.options) == null ? void 0 : _a.idlePostMessage;
    const sendMessage = React__default.useCallback(() => {
      const message = {
        type: "assetPickerOpen",
        jsonFormsPath: path
        /* rootPath: 'x_rootPath',
        selectedPath: '_path', */
      };
      const targetOrigin = "*";
      window.postMessage(message, targetOrigin);
    }, [path]);
    const assetPickerCloseHandler = React__default.useCallback(
      (e) => {
        var _a2, _b;
        if (((_a2 = e == null ? void 0 : e.data) == null ? void 0 : _a2.type) && ((_b = e == null ? void 0 : e.data) == null ? void 0 : _b.type) === "assetPickerClose") {
          if (e.data.jsonFormsPath !== path)
            return;
          onChange(e.data.selectedPath);
        }
      },
      [path]
    );
    React__default.useEffect(() => {
      window.addEventListener("message", assetPickerCloseHandler);
      return () => {
        window.removeEventListener("message", assetPickerCloseHandler);
      };
    }, [path]);
    const firstRender = React__default.useRef(true);
    if (idlePostMessage) {
      React__default.useEffect(() => {
        if (firstRender.current) {
          firstRender.current = false;
          return;
        }
        const delayDebounceFn = setTimeout(() => {
          sendMessage();
        }, 3e3);
        return () => clearTimeout(delayDebounceFn);
      }, [inputText]);
    }
    React__default.useEffect(() => {
      onChange(data);
    }, [data]);
    return /* @__PURE__ */ jsx(
      TextField,
      {
        "aria-label": label ? label : "textfield",
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? patternErrorMessage(
          inputText ?? data,
          customFormat ?? format,
          minLength,
          maxLength ?? void 0
        ),
        id: id && `${id}-input`,
        inputMode: appliedUiSchemaOptions.inputMode ?? "none",
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        maxLength: appliedUiSchemaOptions.maxLength ?? void 0,
        minLength: appliedUiSchemaOptions.minLength ?? void 0,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange: (input) => {
          onChange(input);
        },
        pattern: appliedUiSchemaOptions.pattern ?? customFormat ?? format ?? void 0,
        type: format ?? "text",
        validationState: isValidText ? "valid" : "invalid",
        value: inputText,
        width: width2,
        ...dataEditorPath(path)
      }
    );
  }
);
const InputTextArea = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    isValid,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const minLength = (schema == null ? void 0 : schema.minLength) ?? appliedUiSchemaOptions.minLength ?? (required ? 1 : 0);
    const maxLength = (schema == null ? void 0 : schema.maxLength) ?? appliedUiSchemaOptions.maxLength;
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const format = appliedUiSchemaOptions.format ?? void 0;
    const customFormat = appliedUiSchemaOptions.customFormat ?? void 0;
    const minHeight = appliedUiSchemaOptions.minHeight || "130px";
    const maxHeight = appliedUiSchemaOptions.maxHeight || "320px";
    const textAreaRef = React__default.useRef(null);
    const [inputText, onChange] = useDebouncedChange(
      handleChange,
      (schema == null ? void 0 : schema.default) ?? "",
      data,
      path
    );
    const isValidCheck2 = React__default.useMemo(() => {
      const value = inputText ?? data;
      const valueLength = value.length;
      if (isValidPattern(inputText, customFormat ?? format) && valueLength >= minLength || maxLength && valueLength <= maxLength) {
        return true;
      }
      return false;
    }, [inputText, minLength, maxLength, isValid]);
    React__default.useEffect(() => {
      if (!data && (schema == null ? void 0 : schema.default)) {
        handleChange(path, schema.default);
      }
      if (textAreaRef.current) {
        const textAreaDomNode = textAreaRef.current.UNSAFE_getDOMNode().getElementsByTagName("textarea")[0];
        textAreaDomNode.style.maxHeight = maxHeight;
        textAreaDomNode.style.minHeight = minHeight;
      }
    }, [!data, schema == null ? void 0 : schema.default]);
    React__default.useEffect(() => {
      onChange(data);
    }, [data]);
    return /* @__PURE__ */ jsx(
      TextArea,
      {
        ref: textAreaRef,
        "aria-label": label ? label : "textarea",
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        description: appliedUiSchemaOptions.description ?? false,
        errorMessage: appliedUiSchemaOptions.errorMessage ?? patternErrorMessage(
          inputText ?? data,
          customFormat ?? format,
          minLength,
          maxLength ?? void 0
        ),
        id: id && `${id}-input`,
        inputMode: appliedUiSchemaOptions.inputMode ?? "none",
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        maxLength: appliedUiSchemaOptions.maxLength ?? void 0,
        minLength: appliedUiSchemaOptions.minLength ?? void 0,
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        onChange,
        pattern: appliedUiSchemaOptions.pattern ?? customFormat ?? format ?? void 0,
        type: appliedUiSchemaOptions.format ?? "text",
        validationState: isValidCheck2 ? "valid" : "invalid",
        value: inputText,
        width: width2,
        ...dataEditorPath(path)
      }
    );
  }
);
const prependZero = (number) => number.toString().padStart(2, "0");
const InputTime = React__default.memo(
  ({
    config,
    data,
    enabled,
    handleChange,
    id,
    label,
    path,
    required,
    schema,
    uischema
  }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
    const onChange = React__default.useCallback(
      (dateTime) => {
        handleChange(
          path,
          [
            prependZero(dateTime.hour),
            prependZero(dateTime.minute),
            prependZero(dateTime.second)
          ].join(":")
        );
      },
      [handleChange, path]
    );
    const ampm = (appliedUiSchemaOptions == null ? void 0 : appliedUiSchemaOptions.ampm) ? 12 : 24;
    return /* @__PURE__ */ jsx(SpectrumProvider, { width: width2, locale: appliedUiSchemaOptions.locale ?? "gregory", children: /* @__PURE__ */ jsx(
      TimeField,
      {
        autoFocus: appliedUiSchemaOptions.focus,
        contextualHelp: ContextualHelpComponent(uischema, schema, config),
        granularity: appliedUiSchemaOptions.granularity ?? "minute",
        hideTimeZone: appliedUiSchemaOptions.hideTimeZone ?? true,
        hourCycle: ampm,
        id,
        isDisabled: enabled === void 0 ? false : !enabled,
        isQuiet: appliedUiSchemaOptions.isQuiet ?? false,
        isReadOnly: appliedUiSchemaOptions.readonly ?? schema.readOnly ?? false,
        isRequired: required,
        label,
        minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
        necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? false,
        width: width2,
        minValue: appliedUiSchemaOptions.minValue ? parseTime(appliedUiSchemaOptions.minValue) : void 0,
        maxValue: appliedUiSchemaOptions.maxValue ? parseTime(appliedUiSchemaOptions.maxValue) : void 0,
        value: data ? parseTime(data) : null,
        onChange,
        ...dataEditorPath(path)
      }
    ) });
  }
);
const Label = React__default.memo(({ config, uischema }) => {
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
  const heading = appliedUiSchemaOptions.heading ?? false;
  const headingLevel = appliedUiSchemaOptions.headingLevel ?? 2;
  const content = appliedUiSchemaOptions.content ?? false;
  return /* @__PURE__ */ jsxs(Flex, { direction: "column", alignItems: "stretch", flex: "auto inherit", width: width2, children: [
    heading && /* @__PURE__ */ jsx(Heading, { level: headingLevel, children: heading }),
    content && /* @__PURE__ */ jsx(Content, { children: content })
  ] });
});
const MediaPreview = React__default.memo(
  ({ config, data, uischema, schema }) => {
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    return /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsxs(
        Flex,
        {
          alignItems: appliedUiSchemaOptions.alignItems ?? "start",
          direction: appliedUiSchemaOptions.flex ?? "column",
          gap: appliedUiSchemaOptions.gap ?? "size-0",
          marginTop: appliedUiSchemaOptions.marginTop ?? "size-100",
          minWidth: appliedUiSchemaOptions.minWidth ?? "size-2000",
          children: [
            /* @__PURE__ */ jsx(
              "img",
              {
                src: data,
                height: appliedUiSchemaOptions.height ?? "auto",
                width: appliedUiSchemaOptions.width ?? "auto",
                style: {
                  maxWidth: appliedUiSchemaOptions.maxWidth ?? "100%",
                  maxHeight: appliedUiSchemaOptions.maxHeight ?? "70vh",
                  objectFit: "scale-down"
                }
              }
            ),
            appliedUiSchemaOptions.description === true ? data.alt : appliedUiSchemaOptions.description ?? null
          ]
        }
      ),
      ContextualHelpComponent(uischema, schema, config)
    ] });
  }
);
const SpectrumBooleanButtonCell = (props) => /* @__PURE__ */ jsx(InputBooleanButton, { ...props });
const SpectrumBooleanButtonCellTester = rankWith(
  4,
  and(isBooleanControl, optionIs("button", true))
);
const SpectrumBooleanButtonCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumBooleanButtonCell));
const SpectrumBooleanCell = (props) => {
  const { data, id, enabled, uischema, path, handleChange, config } = props;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const autoFocus = !!appliedUiSchemaOptions.focus;
  const isSelected = !!data;
  const width2 = appliedUiSchemaOptions.trim ? void 0 : "100%";
  return /* @__PURE__ */ jsx(
    Switch,
    {
      isSelected,
      onChange: (selected) => handleChange(path, selected),
      id,
      isDisabled: enabled === void 0 ? false : !enabled,
      autoFocus,
      width: width2,
      "aria-label": props.children ? void 0 : path,
      children: props.children
    }
  );
};
const SpectrumBooleanCellTester = rankWith(
  3,
  and(isBooleanControl, optionIs("switch", true))
);
const SpectrumBooleanCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumBooleanCell));
const SpectrumCheckboxCell = (props) => /* @__PURE__ */ jsx(InputCheckbox, { ...props });
const SpectrumCheckboxCellTester = rankWith(2, isBooleanControl);
const SpectrumCheckboxCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumCheckboxCell));
const SpectrumEnumCell = (props) => /* @__PURE__ */ jsx(InputEnum, { ...props });
const SpectrumEnumCellTester = rankWith(2, isEnumControl);
const SpectrumEnumCell$1 = withJsonFormsEnumCellProps(withHandleChange(SpectrumEnumCell));
const SpectrumIntegerCell = (props) => /* @__PURE__ */ jsx(InputInteger, { ...props });
const SpectrumIntegerCellTester = rankWith(2, isIntegerControl);
const SpectrumIntegerCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumIntegerCell));
const SpectrumNumberCell = (props) => /* @__PURE__ */ jsx(InputNumber, { ...props });
const SpectrumNumberCellTester = rankWith(2, isNumberControl);
const SpectrumNumberCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumNumberCell));
const SpectrumSliderCell = (props) => /* @__PURE__ */ jsx(InputSlider, { ...props });
const SpectrumSliderCellTester = rankWith(4, isRangeControl);
const SpectrumSliderCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumSliderCell));
const SpectrumSwitchCell = (props) => /* @__PURE__ */ jsx(InputSwitch, { ...props });
const SpectrumSwitchCellTester = rankWith(
  3,
  and(isBooleanControl, optionIs("toggle", true))
);
const SpectrumSwitchCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumSwitchCell));
const SpectrumTextAreaCell = (props) => /* @__PURE__ */ jsx(InputTextArea, { ...props });
const SpectrumTextAreaCellTester = rankWith(2, isMultiLineControl);
const SpectrumTextAreaCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumTextAreaCell));
const SpectrumTextCell = (props) => /* @__PURE__ */ jsx(InputText, { ...props });
const SpectrumTextCellTester = rankWith(1, isStringControl);
const SpectrumTextCell$1 = withJsonFormsCellProps(withHandleChange(SpectrumTextCell));
const CustomizableCells = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  SpectrumBooleanButtonCell,
  SpectrumBooleanCell,
  SpectrumCheckboxCell,
  SpectrumEnumCell,
  SpectrumIntegerCell,
  SpectrumNumberCell,
  SpectrumSliderCell,
  SpectrumSwitchCell,
  SpectrumTextAreaCell,
  SpectrumTextCell
}, Symbol.toStringTag, { value: "Module" }));
const SpectrumEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const SpectrumEnumControlTester = rankWith(7, isEnumControl);
const SpectrumEnumControl$1 = withJsonFormsEnumProps(withHandleChange(SpectrumEnumControl));
const InputControl = ({
  cells,
  config,
  description,
  errors,
  id,
  path,
  rootSchema,
  schema,
  uischema,
  visible
}) => {
  if (!visible) {
    return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
  }
  const [focused, onFocus, onBlur] = useFocus();
  const classNames = {
    wrapper: "control",
    description: "input-description"
  };
  const isValid = errors.length === 0;
  const divClassNames = `validation  ${isValid ? classNames.description : "validation_error"}`;
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  const showDescription = !isDescriptionHidden(
    visible,
    description,
    focused,
    appliedUiSchemaOptions.showUnfocusedDescription
  );
  const cell = maxBy(cells, (r) => r.tester(uischema, schema, rootSchema));
  if (cell === void 0 || cell.tester(uischema, schema, rootSchema) === NOT_APPLICABLE) {
    console.warn("No applicable cell found.", uischema, schema);
    return null;
  } else {
    return /* @__PURE__ */ jsx(
      "div",
      {
        className: classNames.wrapper,
        hidden: !visible,
        onFocus,
        onBlur,
        id,
        children: /* @__PURE__ */ jsxs(Flex, { direction: "column", children: [
          /* @__PURE__ */ jsx(DispatchCell, { uischema, schema, path, id: id && `${id}-input` }),
          /* @__PURE__ */ jsx("div", { className: divClassNames, children: /* @__PURE__ */ jsx(Text, { children: !isValid ? errors : showDescription ? description : null }) })
        ] })
      }
    );
  }
};
const inputControlTester = rankWith(1, isControl);
const InputControl$1 = withJsonFormsControlProps(withHandleChange(InputControl));
const MediaPreviewControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: MediaPreview });
const MediaPreviewControlTester = rankWith(4, optionIs("mediaPreview", true));
const MediaPreviewControl$1 = withJsonFormsControlProps(withHandleChange(MediaPreviewControl));
const findEnumSchema = (schemas) => schemas.find((s) => s.enum !== void 0 && (s.type === "string" || s.type === void 0));
const findTextSchema = (schemas) => schemas.find((s) => s.type === "string" && s.enum === void 0);
const SpectrumAnyOfStringOrEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const hasEnumAndText = (schemas) => {
  const enumSchema = findEnumSchema(schemas);
  const stringSchema = findTextSchema(schemas);
  const remainingSchemas = schemas.filter((s) => s !== enumSchema || s !== stringSchema);
  const wrongType = remainingSchemas.find((s) => s.type && s.type !== "string");
  return enumSchema && stringSchema && !wrongType;
};
const simpleAnyOf = and(
  uiTypeIs("Control"),
  schemaMatches((schema) => (schema == null ? void 0 : schema.hasOwnProperty("anyOf")) && hasEnumAndText(schema == null ? void 0 : schema.anyOf))
);
const SpectrumAnyOfStringOrEnumControlTester = rankWith(5, simpleAnyOf);
const SpectrumAnyOfStringOrEnumControl$1 = withJsonFormsEnumProps(withHandleChange(SpectrumAnyOfStringOrEnumControl));
const SpectrumBooleanControl = ({
  config,
  data,
  enabled,
  errors,
  handleChange,
  id,
  label,
  path,
  rootSchema,
  schema,
  uischema,
  visible
}) => {
  return /* @__PURE__ */ jsxs("div", { children: [
    /* @__PURE__ */ jsx(
      SpectrumBooleanCell,
      {
        config,
        data,
        enabled,
        errors,
        handleChange,
        id: id && `${id}-input`,
        isValid: isEmpty(errors),
        path,
        rootSchema,
        schema,
        uischema,
        visible
      }
    ),
    label
  ] });
};
const SpectrumBooleanControlTester = rankWith(
  3,
  and(isBooleanControl, optionIs("switch", true))
);
const SpectrumBooleanControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumBooleanControl));
const SpectrumBooleanButtonControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputBooleanButton });
const SpectrumBooleanButtonControlTester = rankWith(
  4,
  and(isBooleanControl, optionIs("button", true))
);
const SpectrumBooleanButtonControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumBooleanButtonControl));
const SpectrumCheckboxControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputCheckbox });
const SpectrumCheckboxControlTester = rankWith(2, isBooleanControl);
const SpectrumCheckboxControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumCheckboxControl));
const SpectrumSwitchControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputSwitch });
const SpectrumSwitchControlTester = rankWith(
  3,
  and(isBooleanControl, optionIs("toggle", true))
);
const SpectrumSwitchControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumSwitchControl));
const SpectrumIntegerControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputInteger });
const SpectrumIntegerControlTester = rankWith(3, isIntegerControl);
const SpectrumIntegerControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumIntegerControl));
const SpectrumRadioGroup = (props) => {
  const { config, handleChange, label, options, path, required, uischema, visible } = props;
  if (!visible) {
    return null;
  }
  const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
  return /* @__PURE__ */ jsx(View, { isHidden: visible === void 0 || visible === null ? false : !visible, children: options && /* @__PURE__ */ jsx(
    RadioGroup,
    {
      "aria-label": "radiogroup" + props.data,
      isEmphasized: appliedUiSchemaOptions.isEmphasized ?? false,
      isRequired: required,
      label,
      labelAlign: appliedUiSchemaOptions.labelAlign ?? "start",
      labelPosition: appliedUiSchemaOptions.labelPosition ?? "top",
      necessityIndicator: appliedUiSchemaOptions.necessityIndicator ?? null,
      onChange: (ev) => handleChange(path, ev),
      orientation: appliedUiSchemaOptions.orientation ?? "vertical",
      value: props.data,
      ...dataEditorPath(path),
      children: options == null ? void 0 : options.map((option) => /* @__PURE__ */ jsx(Radio, { value: option.value, ...dataEditorPath(option.value), children: option.label }, option.label))
    }
  ) });
};
const SpectrumRadioGroupControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumRadioGroup, { ...props });
};
const SpectrumRadioGroupControlTester = rankWith(
  20,
  and(isEnumControl, optionIs("format", "radio"))
);
const SpectrumRadioGroupControl$1 = withJsonFormsEnumProps(withHandleChange(SpectrumRadioGroupControl));
const SpectrumNumberControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputNumber });
const SpectrumNumberControlTester = rankWith(3, isNumberControl);
const SpectrumNumberControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumNumberControl));
const SpectrumOneOfEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const SpectrumOneOfEnumControlTester = rankWith(5, isOneOfEnumControl);
const SpectrumOneOfEnumControl$1 = withJsonFormsOneOfEnumProps(withHandleChange(SpectrumOneOfEnumControl));
const SpectrumMultiOneOfEnumControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputEnum });
};
const isMultiOneOfEnumControl = and(
  uiTypeIs("Control"),
  schemaTypeIs("array"),
  schemaMatches(
    (schema) => {
      var _a, _b;
      return (_b = (_a = schema == null ? void 0 : schema.items) == null ? void 0 : _a.oneOf) == null ? void 0 : _b.every((s) => s.const !== void 0);
    }
  )
);
const isMultiEnumControl = and(
  uiTypeIs("Control"),
  schemaTypeIs("array"),
  schemaMatches((schema) => {
    var _a, _b;
    return ((_a = schema == null ? void 0 : schema.items) == null ? void 0 : _a.type) === "string" && isArray((_b = schema == null ? void 0 : schema.items) == null ? void 0 : _b.enum);
  })
);
const SpectrumMultiOneOfEnumControlTester = rankWith(
  5,
  or(isMultiOneOfEnumControl, isMultiEnumControl)
);
const SpectrumMultiOneOfEnumControl$1 = withJsonFormsMultiEnumProps(withHandleChange(SpectrumMultiOneOfEnumControl));
const SpectrumOneOfRadioGroupControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumRadioGroup, { ...props });
};
const SpectrumOneOfRadioGroupControlTester = rankWith(
  20,
  and(isOneOfEnumControl, optionIs("format", "radio"))
);
const SpectrumOneOfRadioGroupControl$1 = withJsonFormsOneOfEnumProps(withHandleChange(SpectrumOneOfRadioGroupControl));
const SpectrumSliderControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputSlider });
const SpectrumSliderControlTester = rankWith(4, isRangeControl);
const SpectrumSliderControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumSliderControl));
const SpectrumTextAreaControl = (props) => {
  return /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputTextArea });
};
const SpectrumTextAreaControlTester = rankWith(5, isMultiLineControl);
const SpectrumTextAreaControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTextAreaControl));
const SpectrumTextControl = (props) => {
  var _a;
  const uiOptions = (_a = props == null ? void 0 : props.uischema) == null ? void 0 : _a.options;
  const isInputContentReference = (uiOptions == null ? void 0 : uiOptions.assetPicker) ?? (uiOptions == null ? void 0 : uiOptions.buttons) ?? false;
  return /* @__PURE__ */ jsx(
    SpectrumInputControl,
    {
      ...props,
      input: isInputContentReference ? InputContentReference : InputText
    }
  );
};
const SpectrumTextControlTester = rankWith(4, isStringControl);
const SpectrumTextControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTextControl));
const SpectrumLabelControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: Label });
const SpectrumLabelControlTester = rankWith(5, uiTypeIs("label"));
const SpectrumLabelControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumLabelControl));
const SpectrumContentReferenceControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputContentReference });
const SpectrumContentReferenceControlTester = rankWith(
  10,
  and(isControl, optionIs("contentReference", true))
);
const SpectrumContentReferenceControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumContentReferenceControl));
const SpectrumDateControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputDate });
const SpectrumDateControlTester = rankWith(5, isDateControl);
const SpectrumDateControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumDateControl));
const SpectrumDateTimeControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputDateTime });
const SpectrumDateTimeControlTester = rankWith(5, isDateTimeControl);
const SpectrumDateTimeControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumDateTimeControl));
const SpectrumTimeControl = (props) => /* @__PURE__ */ jsx(SpectrumInputControl, { ...props, input: InputTime });
const SpectrumTimeControlTester = rankWith(5, isTimeControl);
const SpectrumTimeControl$1 = withJsonFormsControlProps(withHandleChange(SpectrumTimeControl));
const ListWithDetailMasterItem = React__default.memo(
  ({ childLabel, handleSelect, index, path, removeItem, selected }) => {
    const [deleteIndex, setdeleteIndex] = React__default.useState(0);
    const [open, setOpen] = React__default.useState(false);
    const handleClose = React__default.useCallback(() => setOpen(false), [setOpen]);
    const itemLabel = childLabel === "" || !childLabel ? `Item ${index + 1}` : childLabel;
    const setOpenAndsetDeleteIndex = (index2) => {
      setOpen(true);
      setdeleteIndex(index2);
    };
    const deleteItem = (path2) => {
      handleClose();
      removeItem(path2, deleteIndex)();
    };
    return /* @__PURE__ */ jsx("div", { className: "list-with-detail-master-item-row", "aria-selected": selected, children: /* @__PURE__ */ jsxs(Flex, { direction: "row", margin: "size-50", justifyContent: "space-between", alignItems: "center", children: [
      /* @__PURE__ */ jsx(View, { UNSAFE_className: "list-with-detail-master-item-number", children: /* @__PURE__ */ jsx(Text, { children: index + 1 }) }),
      /* @__PURE__ */ jsx(
        ActionButton,
        {
          flex: "auto",
          isQuiet: true,
          onPress: handleSelect(index),
          "aria-label": `select-item-${itemLabel}`,
          children: /* @__PURE__ */ jsx(Text, { UNSAFE_style: { textAlign: "left", maxWidth: "30ch" }, children: itemLabel })
        }
      ),
      /* @__PURE__ */ jsxs(View, { children: [
        /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
          /* @__PURE__ */ jsx(
            ActionButton,
            {
              onPress: () => setOpenAndsetDeleteIndex(index),
              "aria-label": `delete-item-${itemLabel}`,
              children: /* @__PURE__ */ jsx(Delete, { "aria-label": "Delete", size: "S" })
            }
          ),
          /* @__PURE__ */ jsx(Tooltip, { children: "Delete" })
        ] }),
        /* @__PURE__ */ jsx(DialogContainer, { onDismiss: handleClose, children: open && /* @__PURE__ */ jsxs(Dialog, { children: [
          /* @__PURE__ */ jsx(Heading, { children: "Delete Item?" }),
          /* @__PURE__ */ jsx(Divider, {}),
          /* @__PURE__ */ jsx(Content, { children: "Are you sure you wish to delete this item?" }),
          /* @__PURE__ */ jsxs(ButtonGroup, { children: [
            /* @__PURE__ */ jsx(Button, { variant: "secondary", onPress: handleClose, children: "Cancel" }),
            /* @__PURE__ */ jsx(Button, { variant: "cta", onPress: () => deleteItem(path), autoFocus: true, children: "Delete" })
          ] })
        ] }) })
      ] })
    ] }) });
  }
);
const ListWithDetailMasterItem$1 = withJsonFormsMasterListItemProps(ListWithDetailMasterItem);
const ArrayLayoutToolbar = React__default.memo(
  ({ label, errors, addItem, path, createDefault }) => {
    return /* @__PURE__ */ jsxs(Flex, { direction: "row", alignItems: "center", children: [
      /* @__PURE__ */ jsx(Heading, { level: 4, children: label }),
      /* @__PURE__ */ jsx(View, { marginEnd: "auto", children: errors.length !== 0 && /* @__PURE__ */ jsx(ErrorIndicator, { errors }) }),
      /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsxs(TooltipTrigger, { delay: settings.toolTipDelay, children: [
        /* @__PURE__ */ jsx(Button, { "aria-label": "add", onPress: addItem(path, createDefault()), variant: "primary", children: /* @__PURE__ */ jsx(Add, { "aria-label": "Add", size: "S" }) }),
        /* @__PURE__ */ jsx(Tooltip, { children: `Add to ${label}` })
      ] }) })
    ] });
  }
);
const SpectrumListWithDetailRenderer = React__default.memo(
  ({
    addItem,
    cells,
    config,
    data,
    enabled,
    errors,
    path,
    removeItems,
    renderers,
    required = false,
    schema,
    uischema,
    uischemas = [],
    visible
  }) => {
    if (!visible) {
      return /* @__PURE__ */ jsx("div", { hidden: true, className: "jsonForms-hidden" });
    }
    const [selectedIndex, setSelectedIndex] = React__default.useState(void 0);
    const handleRemoveItem = React__default.useCallback(
      (p, value) => () => {
        setSelectedIndex(void 0);
        if (removeItems) {
          removeItems(p, [value])();
        }
      },
      [removeItems]
    );
    const handleListItemClick = React__default.useCallback(
      (index) => () => setSelectedIndex(index),
      [setSelectedIndex]
    );
    const handleCreateDefaultValue = React__default.useCallback(
      () => createDefaultValue(schema ?? {}),
      [createDefaultValue]
    );
    const foundUISchema = findUISchema(
      uischemas,
      schema,
      uischema.scope,
      path,
      void 0,
      uischema
    );
    const appliedUiSchemaOptions = merge({}, config, uischema == null ? void 0 : uischema.options);
    const addItemAndSelectNewItem = (p, v) => () => {
      addItem(p, v)();
      setSelectedIndex(data);
    };
    return /* @__PURE__ */ jsxs(View, { isHidden: !visible, children: [
      /* @__PURE__ */ jsx(
        ArrayLayoutToolbar,
        {
          addItem: addItemAndSelectNewItem,
          createDefault: handleCreateDefaultValue,
          errors,
          label: computeLabel(
            (schema == null ? void 0 : schema.title) ?? (schema == null ? void 0 : schema.default),
            required,
            appliedUiSchemaOptions.hideRequiredAsterisk
          ),
          path
        }
      ),
      /* @__PURE__ */ jsxs(Flex, { direction: "row", children: [
        /* @__PURE__ */ jsx(Flex, { direction: "column", marginY: "size-200", marginEnd: "size-200", children: data > 0 ? Array.from(Array(data)).map((_, index) => /* @__PURE__ */ jsx(
          ListWithDetailMasterItem$1,
          {
            handleSelect: handleListItemClick,
            index,
            path,
            removeItem: handleRemoveItem,
            schema,
            selected: selectedIndex === index,
            enabled,
            translations: {}
          },
          index
        )) : /* @__PURE__ */ jsx(View, { children: /* @__PURE__ */ jsx("p", { children: "No data" }) }) }),
        /* @__PURE__ */ jsx(View, { flex: "auto", children: selectedIndex !== void 0 ? /* @__PURE__ */ jsx(
          JsonFormsDispatch,
          {
            cells,
            enabled,
            path: composePaths(path, `${selectedIndex}`),
            renderers,
            schema,
            uischema: foundUISchema,
            visible
          }
        ) : /* @__PURE__ */ jsx(Heading, { level: 4, children: "No Selection" }) })
      ] })
    ] });
  }
);
const SpectrumListWithDetailTester = rankWith(4, uiTypeIs("ListWithDetail"));
const SpectrumListWithDetailRenderer$1 = withJsonFormsArrayLayoutProps(withHandleChange(SpectrumListWithDetailRenderer));
const SpectrumRenderers = [
  { tester: inputControlTester, renderer: InputControl$1 },
  { tester: MediaPreviewControlTester, renderer: MediaPreviewControl$1 },
  {
    tester: SpectrumListWithDetailTester,
    renderer: SpectrumListWithDetailRenderer$1
  },
  {
    tester: SpectrumAnyOfStringOrEnumControlTester,
    renderer: SpectrumAnyOfStringOrEnumControl$1
  },
  { tester: SpectrumBooleanControlTester, renderer: SpectrumBooleanControl$1 },
  {
    tester: SpectrumBooleanButtonControlTester,
    renderer: SpectrumBooleanButtonControl$1
  },
  { tester: SpectrumCheckboxControlTester, renderer: SpectrumCheckboxControl$1 },
  { tester: SpectrumSwitchControlTester, renderer: SpectrumSwitchControl$1 },
  { tester: SpectrumDateControlTester, renderer: SpectrumDateControl$1 },
  { tester: SpectrumDateTimeControlTester, renderer: SpectrumDateTimeControl$1 },
  { tester: SpectrumEnumControlTester, renderer: SpectrumEnumControl$1 },
  {
    tester: SpectrumOneOfEnumControlTester,
    renderer: SpectrumOneOfEnumControl$1
  },
  {
    tester: SpectrumMultiOneOfEnumControlTester,
    renderer: SpectrumMultiOneOfEnumControl$1
  },
  { tester: SpectrumIntegerControlTester, renderer: SpectrumIntegerControl$1 },
  {
    tester: SpectrumRadioGroupControlTester,
    renderer: SpectrumRadioGroupControl$1
  },
  { tester: SpectrumNumberControlTester, renderer: SpectrumNumberControl$1 },
  { tester: SpectrumTextAreaControlTester, renderer: SpectrumTextAreaControl$1 },
  { tester: SpectrumTextControlTester, renderer: SpectrumTextControl$1 },
  { tester: SpectrumLabelControlTester, renderer: SpectrumLabelControl$1 },
  {
    tester: SpectrumContentReferenceControlTester,
    renderer: SpectrumContentReferenceControl$1
  },
  { tester: SpectrumTimeControlTester, renderer: SpectrumTimeControl$1 },
  {
    tester: SpectrumDnDArrayModalControlTester,
    renderer: SpectrumDnDArrayModalControlRenderer
  },
  { tester: SpectrumLabelRendererTester, renderer: SpectrumLabelRenderer$1 },
  {
    tester: SpectrumCategorizationRendererTester,
    renderer: SpectrumCategorizationRenderer$1
  },
  {
    tester: SpectrumCategorizationStepperRendererTester,
    renderer: SpectrumCategorizationStepperRenderer$1
  },
  { tester: SpectrumObjectControlTester, renderer: SpectrumObjectRenderer$1 },
  {
    tester: SpectrumOneOfRadioGroupControlTester,
    renderer: SpectrumOneOfRadioGroupControl$1
  },
  {
    tester: SpectrumOneOfRendererTester,
    renderer: SpectrumOneOfRenderer$1
  },
  {
    tester: SpectrumAnyOfRendererTester,
    renderer: SpectrumAnyOfRenderer$1
  },
  {
    tester: SpectrumTipTapRendererTester,
    renderer: SpectrumTipTapRenderer$1
  },
  {
    tester: SpectrumCodeMirrorTester,
    renderer: SpectrumCodeMirror$1
  },
  {
    tester: SpectrumAllOfRendererTester,
    renderer: SpectrumAllOfRenderer$1
  },
  {
    tester: SpectrumSliderControlTester,
    renderer: SpectrumSliderControl$1
  },
  { tester: SpectrumGroupLayoutTester, renderer: SpectrumGroupLayout },
  {
    tester: SpectrumFragmentReferenceControlTester,
    renderer: SpectrumFragmentReferenceControl$1
  },
  { tester: SpectrumVerticalLayoutTester, renderer: SpectrumVerticalLayout },
  {
    tester: SpectrumHorizontalLayoutTester,
    renderer: SpectrumHorizontalLayout
  }
];
const SpectrumCells = [
  { tester: SpectrumBooleanCellTester, cell: SpectrumBooleanCell$1 },
  { tester: SpectrumBooleanButtonCellTester, cell: SpectrumBooleanButtonCell$1 },
  { tester: SpectrumCheckboxCellTester, cell: SpectrumCheckboxCell$1 },
  { tester: SpectrumSwitchCellTester, cell: SpectrumSwitchCell$1 },
  { tester: SpectrumEnumCellTester, cell: SpectrumEnumCell$1 },
  { tester: SpectrumIntegerCellTester, cell: SpectrumIntegerCell$1 },
  { tester: SpectrumNumberCellTester, cell: SpectrumNumberCell$1 },
  { tester: SpectrumSliderCellTester, cell: SpectrumSliderCell$1 },
  { tester: SpectrumTextAreaCellTester, cell: SpectrumTextAreaCell$1 },
  { tester: SpectrumTextCellTester, cell: SpectrumTextCell$1 }
];
export {
  ASSET_PICKER_OPEN,
  ASSET_PICKER_RETURN,
  Breadcrumbs,
  BreadcrumbsContext,
  BreadcrumbsProvider,
  CUSTOM_PICKER_OPEN,
  CUSTOM_PICKER_RETURN,
  CustomizableCells as Customizable,
  DeleteDialog,
  DetectKeyboardUser,
  EnumTagGroup,
  ErrorIndicator,
  INSERT_NEW_EDITABLE_COMPONENT,
  InputControl$1 as InputControl,
  LoadingSpinner,
  MediaPreviewControl$1 as MediaPreviewControl,
  MediaPreviewControlTester,
  ModalItemAnimationWrapper,
  PickerOrComboBox,
  PickerOrComboBoxArray,
  RenderersConfigContextProvider,
  SpectrumAllOfRenderer$1 as SpectrumAllOfRenderer,
  SpectrumAllOfRendererTester,
  SpectrumAnyOfRenderer$1 as SpectrumAnyOfRenderer,
  SpectrumAnyOfRendererTester,
  SpectrumAnyOfStringOrEnumControl$1 as SpectrumAnyOfStringOrEnumControl,
  SpectrumAnyOfStringOrEnumControlTester,
  SpectrumBooleanButtonCell$1 as SpectrumBooleanButtonCell,
  SpectrumBooleanButtonCellTester,
  SpectrumBooleanButtonControl$1 as SpectrumBooleanButtonControl,
  SpectrumBooleanButtonControlTester,
  SpectrumBooleanCell$1 as SpectrumBooleanCell,
  SpectrumBooleanCellTester,
  SpectrumBooleanControl$1 as SpectrumBooleanControl,
  SpectrumBooleanControlTester,
  SpectrumCategorizationRenderer$1 as SpectrumCategorizationRenderer,
  SpectrumCategorizationRendererTester,
  SpectrumCategorizationStepperRenderer$1 as SpectrumCategorizationStepperRenderer,
  SpectrumCategorizationStepperRendererTester,
  SpectrumCells,
  SpectrumCheckboxCell$1 as SpectrumCheckboxCell,
  SpectrumCheckboxCellTester,
  SpectrumCheckboxControl$1 as SpectrumCheckboxControl,
  SpectrumCheckboxControlTester,
  SpectrumCodeMirror$1 as SpectrumCodeMirror,
  SpectrumCodeMirrorTester,
  SpectrumContentReferenceControl$1 as SpectrumContentReferenceControl,
  SpectrumContentReferenceControlTester,
  SpectrumDateControl$1 as SpectrumDateControl,
  SpectrumDateControlTester,
  SpectrumDateTimeControl$1 as SpectrumDateTimeControl,
  SpectrumDateTimeControlTester,
  SpectrumDnDArrayModalControlRenderer as SpectrumDnDArrayModalControl,
  SpectrumDnDArrayModalControlTester,
  SpectrumEnumCell$1 as SpectrumEnumCell,
  SpectrumEnumCellTester,
  SpectrumEnumControl$1 as SpectrumEnumControl,
  SpectrumEnumControlTester,
  SpectrumFragmentReferenceControl$1 as SpectrumFragmentReferenceControl,
  SpectrumFragmentReferenceControlTester,
  SpectrumGroupLayout,
  SpectrumGroupLayoutTester,
  SpectrumHorizontalLayout,
  SpectrumHorizontalLayoutTester,
  SpectrumIntegerCell$1 as SpectrumIntegerCell,
  SpectrumIntegerCellTester,
  SpectrumIntegerControl$1 as SpectrumIntegerControl,
  SpectrumIntegerControlTester,
  SpectrumLabelControl$1 as SpectrumLabelControl,
  SpectrumLabelControlTester,
  SpectrumLabelRenderer$1 as SpectrumLabelRenderer,
  SpectrumLabelRendererTester,
  SpectrumListWithDetailRenderer$1 as SpectrumListWithDetailRenderer,
  SpectrumListWithDetailTester,
  SpectrumMultiOneOfEnumControl$1 as SpectrumMultiOneOfEnumControl,
  SpectrumMultiOneOfEnumControlTester,
  SpectrumNumberCell$1 as SpectrumNumberCell,
  SpectrumNumberCellTester,
  SpectrumNumberControl$1 as SpectrumNumberControl,
  SpectrumNumberControlTester,
  SpectrumObjectControlTester,
  SpectrumObjectRenderer$1 as SpectrumObjectRenderer,
  SpectrumOneOfEnumControl$1 as SpectrumOneOfEnumControl,
  SpectrumOneOfEnumControlTester,
  SpectrumOneOfRadioGroupControl$1 as SpectrumOneOfRadioGroupControl,
  SpectrumOneOfRadioGroupControlTester,
  SpectrumOneOfRenderer$1 as SpectrumOneOfRenderer,
  SpectrumOneOfRendererTester,
  SpectrumRadioGroupControl$1 as SpectrumRadioGroupControl,
  SpectrumRadioGroupControlTester,
  SpectrumRenderers,
  SpectrumSliderCell$1 as SpectrumSliderCell,
  SpectrumSliderCellTester,
  SpectrumSliderControl$1 as SpectrumSliderControl,
  SpectrumSliderControlTester,
  SpectrumSwitchCell$1 as SpectrumSwitchCell,
  SpectrumSwitchCellTester,
  SpectrumSwitchControl$1 as SpectrumSwitchControl,
  SpectrumSwitchControlTester,
  SpectrumTextAreaCell$1 as SpectrumTextAreaCell,
  SpectrumTextAreaCellTester,
  SpectrumTextAreaControl$1 as SpectrumTextAreaControl,
  SpectrumTextAreaControlTester,
  SpectrumTextCell$1 as SpectrumTextCell,
  SpectrumTextCellTester,
  SpectrumTextControl$1 as SpectrumTextControl,
  SpectrumTextControlTester,
  SpectrumTimeControl$1 as SpectrumTimeControl,
  SpectrumTimeControlTester,
  SpectrumTipTapRenderer$1 as SpectrumTipTapRenderer,
  SpectrumTipTapRendererTester,
  SpectrumVerticalLayout,
  SpectrumVerticalLayoutTester,
  allCopiesReducer,
  allCopiesUpdater,
  areEqual,
  checkIfUserIsOnMobileDevice,
  circularReferenceReplacer,
  cssToObject,
  dataEditorPath,
  findValue,
  focusFirstUsableInput,
  hasPositiveOption,
  inputControlTester,
  isEmpty,
  isISODate,
  isValidCheck,
  isValidPattern,
  lengthErrorMessage,
  objectToCss,
  patternErrorMessage,
  resolveSubSchemas,
  settings,
  useBreadcrumbs,
  useDebouncedChange,
  useFocus,
  useRenderersConfig,
  valueErrorMessage,
  withAjvProps,
  withDataReduce,
  withHandleChange,
  withJsonFormsArrayControlProps
};
